# GenericSchur

<!-- ![Lifecycle](https://img.shields.io/badge/lifecycle-experimental-orange.svg) -->
![Lifecycle](https://img.shields.io/badge/lifecycle-maturing-blue.svg)<!--
![Lifecycle](https://img.shields.io/badge/lifecycle-stable-green.svg)
![Lifecycle](https://img.shields.io/badge/lifecycle-retired-orange.svg)
![Lifecycle](https://img.shields.io/badge/lifecycle-archived-red.svg)
![Lifecycle](https://img.shields.io/badge/lifecycle-dormant-blue.svg) -->
[![GitHub CI Build Status](https://github.com/RalphAS/GenericSchur.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/RalphAS/GenericSchur.jl/actions/workflows/CI.yml)
[![codecov.io](http://codecov.io/github/RalphAS/GenericSchur.jl/coverage.svg?branch=master)](http://codecov.io/github/RalphAS/GenericSchur.jl?branch=master)
[![Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://RalphAS.github.io/GenericSchur.jl/dev)

## Eigen-analysis of matrices with generic floating-point element types in Julia

The Schur decomposition is the workhorse for eigensystem analysis of
dense matrices. The diagonal eigen-decomposition of normal
(especially Hermitian) matrices is an important special case,
but for non-normal matrices the Schur form is often more useful.

The purpose of this package is to extend the `schur!` and related
functions of the standard library to number types not handled by
LAPACK, such as `Complex{BigFloat}, Complex{Float128}` (from
Quadmath.jl), etc.  For these, the `schur!`, `eigvals!`, and `eigen!`
functions in the `LinearAlgebra` standard library are overloaded here,
and may be accessed through the usual `schur`, `eigvals`, and `eigen`
wrappers. For example:

```julia
A = BigFloat.(your_matrix_generator())
S = schur(A)
```
The result `S` is a `LinearAlgebra.Schur` object, with the properties `T`,
`Z=vectors`, and `values`.

The unexported `gschur` and `gschur!` functions are available for types
normally handled by the LAPACK wrappers in `LinearAlgebra`.

### Hermitian matrices

For these the Schur decomposition is a full diagonalization. This package provides
this for real symmetric and complex Hermitian matrices. Currently the QR iteration
and divide-and-conquer algorithms are implemented for the final reduction.

### Complex non-Hermitian matrices

For square matrices of complex element type,
this package provides a full Schur decomposition:
```julia
A::StridedMatrix{C} where {C <: Complex} == Z * T * adjoint(Z)
```
where `T` is upper-triangular and `Z` is unitary, both with the same element
type as `A`. (See below for real matrices.)

The algorithm is essentially the unblocked, serial, single-shift Francis (QR)
scheme used in the complex LAPACK routines. Balancing is also available.

### Eigenvectors

Right and left eigenvectors are available from Schur factorizations,
using

```julia
S = schur(A)
VR = eigvecs(S)
VL = eigvecs(S,left=true)
```

#### Normalization

As of v0.4, eigenvectors as returned from our `eigen` and `eigvecs` methods
for the standard problem have unit Euclidean norm. This accords with the
current (undocumented) behavior of `LinearAlgebra` methods. (Previously a
convention based on low-level LAPACK routines was used here.)

### Real decompositions

A quasi-triangular "real Schur" decomposition of real matrices is also
provided:
```julia
A::StridedMatrix{R} where {R <: Real} == Z * T * transpose(Z)
```
where `T` is quasi-upper-triangular and `Z` is orthogonal, both with the
same element type as `A`.  This is what you get by invoking the above-mentioned
functions with matrix arguments whose element type `T <: Real`.
The result is in standard form, so
pair-blocks (and therefore rank-2 invariant subspaces) should be fully resolved.

One can convert a standard quasi-triangular real `Schur`
into a complex `Schur` with the `triangularize` function provided here.

## Balancing

The accuracy of eigenvalues and eigenvectors may be improved for some
matrices by use of a similarity transform which reduces the matrix
norm.  This is done by default in the `eigen!` method, and may also be
handled explicitly via the `balance!` function provided here:
```julia
Ab, B = balance!(copy(A))
S = schur(Ab)
v = eigvecs(S)
lmul!(B, v) # to get the eigenvectors of A
```
More details are in the function docstring. Although the balancing function
also does permutations to isolate trivial subspaces, the Schur routines do not
yet exploit this opportunity for reduced workload.

## Subspaces, condition, and all that.

Methods for reordering a Schur decomposition (`ordschur`) and computing
condition numbers (`eigvalscond`) and subspace separation (`subspacesep`)
are provided.
Tests to date suggest that behavior is similar
to the LAPACK routines on which the implementation is based.


## Generalized eigensystems

Methods for the generalized eigenvalue problem (matrix pencils) are provided,
as extensions of `schur!(A,B)` from LinearAlgebra.
The algorithms are translated from LAPACK, but this implementation has
had limited testing. (Note that it is easy to check the decomposition
of a particular case ex post facto.)

Corresponding functions for reordering (via `ordschur`) and
condition estimation (`eigvalscond`) are provided.
Tests to date suggest that behavior is similar to LAPACK.

Left and right eigenvectors of real and complex generalized problems are available with
`eigvecs(S::GeneralizedSchur; left::Bool)`.

These vectors currently have a peculiar normalization intended to be compatible with LAPACK
conventions.

## Acknowledgements

This package includes many translations from
[LAPACK](http://www.netlib.org/lapack/index.html) code, and
incorporates or elaborates a few methods from Andreas Noack's
[GenericLinearAlgebra.jl](http://github.com/JuliaLinearAlgebra/GenericLinearAlgebra.jl)
package.

# This file is part of GenericSchur.jl, released under the MIT "Expat" license
# Portions derived from LAPACK, see below.

# Eigenvectors

"""
geigvecs(S; left::Bool = false)

Compute eigenvectors from a Schur (or generalized Schur) decomposition `S`.
Left eigenvectors are produced if so specified, otherwise right ones.
"""
function geigvecs(S::Schur{T}; left::Bool = false) where {T <: STypes}
    if left
        v = _gleigvecs!(S.T, S.Z)
    else
        v = _geigvecs!(S.T, S.Z)
    end
    _enormalize!(v)
    return v
end

function geigvecs(
        S::GeneralizedSchur{T}; left::Bool = false
    ) where {T <: STypes}
    if left
        v = _gleigvecs(S.S, S.T, S.Q)
    else
        v = _geigvecs(S.S, S.T, S.Z)
    end
    # CHECKME: Euclidean norm differs from LAPACK, so wait for upstream.
    # _enormalize!(v)
    return v
end

# note that we avoid method ambiguity by distinguishing between _geigvecs! and _geigvecs

"""
`_geigvecs!(T[,Z])`

Compute right eigenvectors of an upper triangular matrix `T`.
If another matrix `Z` is provided, multiply by it to get eigenvectors of `Zᵀ T Z`.
Typically `T` and `Z` are components of a Schur decomposition.
Temporarily mutates `T` if `eltype(T)` is complex.
"""
function _geigvecs!(
        TT::StridedMatrix{T},
        Z::StridedMatrix{T} = Matrix{T}(undef, 0, 0)
    ) where {T <: Complex}
    # based on LAPACK::ztrevc
    # Copyright:
    # Univ. of Tennessee
    # Univ. of California Berkeley
    # Univ. of Colorado Denver
    # NAG Ltd.
    n = size(TT, 1)
    RT = real(T)
    ulp = eps(RT)
    # Note: LAPACK has
    #   smallnum = safemin(RT) * (n / ulp)
    # but that makes no sense to me and breaks some tests
    smallnum = safemin(RT) * n
    vectors = Matrix{T}(undef, n, n)
    v = zeros(T, n)

    # save diagonal since we modify it to avoid copies
    tdiag = diag(TT)

    # We use the 1-norms of the strictly upper part of TT columns
    # to avoid overflow
    tnorms = zeros(RT, n)
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            tnorms[j] += abs(TT[i, j])
        end
    end

    for ki in n:-1:1
        smin = max(ulp * abs1(TT[ki, ki]), smallnum)
        #
        # (T[1:k,1:k]-λI) x = b
        # where k=kᵢ-1

        v[1] = one(T) # for ki=1
        @inbounds for k in 1:(ki - 1)
            v[k] = -TT[k, ki]
        end
        @inbounds for k in 1:(ki - 1)
            TT[k, k] -= TT[ki, ki]
            (abs1(TT[k, k]) < smin) && (TT[k, k] = smin)
        end
        if ki > 1
            vscale = _usolve!(TT, ki - 1, v, view(tnorms, 1:(ki - 1)))
            v[ki] = vscale
        else
            vscale = one(RT)
        end
        if size(Z, 1) > 0
            # This is done here to avoid allocating a work matrix
            # and to exploit the subspace property to reduce work.
            # Using a work matrix would allow for level-3 ops (cf. ztrevc3).
            @inbounds for j in 1:n
                vectors[j, ki] = vscale * Z[j, ki]
                for i in 1:(ki - 1)
                    vectors[j, ki] += Z[j, i] * v[i]
                end
            end
        else
            @inbounds for j in 1:ki
                vectors[j, ki] = v[j]
            end
            vectors[(ki + 1):n, ki] .= zero(T)
        end

        # normalize
        t0 = abs1(vectors[1, ki])
        @inbounds for i in 2:n
            t0 = max(t0, abs1(vectors[i, ki]))
        end
        remax = one(RT) / t0
        @inbounds for i in 1:n
            vectors[i, ki] *= remax
        end

        # restore diagonal
        @inbounds for k in 1:(ki - 1)
            TT[k, k] = tdiag[k]
        end
    end

    return vectors
end

function _geigvecs!(
        T::StridedMatrix{Ty},
        Z::StridedMatrix{Ty} = Matrix{Ty}(undef, 0, 0)
    ) where {Ty <: Real}
    # based on LAPACK::dtrevc
    # Copyright:
    # Univ. of Tennessee
    # Univ. of California Berkeley
    # Univ. of Colorado Denver
    # NAG Ltd.
    n = size(T, 1)
    ulp = eps(Ty)
    # CHECKME: LAPACK has this but the (1/ulp) factor may break some tests
    smallnum = safemin(Ty) * (n / ulp)
    bignum = (1 - ulp) / smallnum
    vectors = zeros(complex(Ty), n, n)
    one_t = one(Ty)
    zero_t = zero(Ty)
    have_Z = size(Z, 1) > 0
    # workspace
    v = zeros(complex(Ty), n)
    vt1 = zeros(complex(Ty), 1)
    vt2 = zeros(complex(Ty), 2)
    tnorms = zeros(Ty, n)

    # We use the 1-norms of the strictly upper part of T columns
    # to avoid overflow
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            tnorms[j] += abs(T[i, j])
        end
    end

    ip = 0 # 0:real, -1,1:first, second in complex pair

    # m, isel (from LAPACK logic) are kept for possible implementation of subset selection
    m = n
    isel = m

    for ki in n:-1:1
        if ip == 1
            ip = 0
            if have_Z
                vectors[:, ki] .= conj.(vectors[:, ki + 1])
            else
                vectors[:, isel + 1] .= conj.(vectors[:, isel + 2])
            end
            continue
        end
        if (ki > 1) && (T[ki, ki - 1] != 0)
            ip = -1
        end
        wr = T[ki, ki]
        wi = ip == 0 ? zero(Ty) : sqrt(abs(T[ki, ki - 1])) * sqrt(abs(T[ki - 1, ki]))
        smin = max(ulp * (abs(wr) + abs(wi)), smallnum)

        if ip == 0
            # right real eigvec

            # (T[1:k,1:k]-λI) x = b
            # where k=kᵢ-1

            # form right hand side
            v[ki] = one_t
            v[1:(ki - 1)] .= -T[1:(ki - 1), ki]
            jnxt = ki - 1
            for j in (ki - 1):-1:1
                j > jnxt && continue
                j1 = j
                j2 = j
                if (j > 1) && (T[j, j - 1] != 0)
                    j1 = j - 1
                    jnxt = j - 2
                end
                if j1 == j2
                    # 1x1 block
                    vt1[1] = v[j]
                    vscale, x, t1 = _xsolve(
                        one_t, view(T, j:j, j:j), [one_t],
                        wr + 0im, vt1, smin
                    )
                    # scale to avoid overflow
                    if (t1 > one_t) && tnorms[j] > bignum / t1
                        x[1] /= t1
                        vscale /= t1
                    end
                    if vscale != one_t
                        v[1:ki] .*= vscale
                    end
                    v[j] = x[1]
                    # update rhs
                    for i in 1:(j - 1)
                        v[i] = v[i] - x[1] * T[i, j]
                    end
                else
                    # 2x2 block
                    vt2 .= v[(j - 1):j]
                    vscale, x, t1 = _xsolve(
                        one_t, view(T, (j - 1):j, (j - 1):j), [one_t, one_t],
                        wr + 0im, vt2, smin
                    )
                    if (t1 > one_t)
                        β = max(tnorms[j - 1], tnorms[j])
                        if β > bignum / t1
                            x[1] /= t1
                            x[2] /= t1
                            vscale /= t1
                        end
                    end
                    if vscale != one_t
                        rmul!(view(v, 1:ki), vscale)
                    end
                    v[j - 1] = x[1]
                    v[j] = x[2]
                    for i in 1:(j - 2)
                        v[i] = (v[i] - x[1] * T[i, j - 1] - x[2] * T[i, j])
                    end
                end
            end # j loop
            if !have_Z
                vscale = one_t / maximum(abs, view(v, 1:ki))
                vectors[1:ki, isel] .= vscale * v[1:ki]
            else
                if ki == 1
                    vectors[:, ki] .= Z[:, ki]
                else
                    # LAPACK overwrites Z, so just adds to the existing vector
                    # corresponding to the unit entry; we start from scratch.
                    mul!(view(vectors, :, ki), view(Z, :, 1:ki), view(v, 1:ki))
                    vscale = one_t / maximum(abs, view(vectors, :, ki))
                    vectors[:, ki] .*= vscale
                end
            end
        else
            # complex right eigvec
            # initial solve (corner)
            if abs(T[ki - 1, ki]) >= abs(T[ki, ki - 1])
                v[ki - 1] = one_t
                v[ki] = im * wi / T[ki - 1, ki]
            else
                v[ki - 1] = -wi / T[ki, ki - 1]
                v[ki] = im * one_t
            end
            # form RHS
            for i in 1:(ki - 2)
                v[i] = (
                    -real(v[ki - 1]) * T[i, ki - 1]
                        - im * imag(v[ki]) * T[i, ki]
                )
            end
            # vi[1:ki - 2] .=  -vi[ki] * T[1:ki - 2, ki]
            # solve upper quasi-triangular system
            jnxt = ki - 2
            for j in (ki - 2):-1:1
                (j > jnxt) && continue
                j1 = j
                j2 = j
                jnxt = j - 1
                if (j > 1) && (T[j, j - 1] != 0)
                    j1 = j - 1
                    jnxt = j - 2
                end
                if j1 == j2
                    # 1x1 diagonal block
                    vt1[1] = v[j]
                    vscale, x, t1 = _xsolve(
                        one_t, view(T, j:j, j:j), [one_t],
                        wr + im * wi, vt1, smin
                    )
                    # scale to avoid overflow
                    if (t1 > one_t) && tnorms[j] > bignum / t1
                        x[1] /= t1
                        vscale /= t1
                    end
                    if vscale != one_t
                        v[1:ki] .*= vscale
                        # vi[1:ki] .*= vscale
                    end
                    v[j] = x[1]
                    # update rhs
                    v[1:(j - 1)] .= v[1:(j - 1)] - x[1] * T[1:(j - 1), j]
                else
                    # 2x2 block
                    vt2 .= v[(j - 1):j]
                    vscale, x, t1 = _xsolve(
                        one_t, view(T, (j - 1):j, (j - 1):j), [one_t, one_t],
                        wr + im * wi, vt2, smin
                    )
                    if (t1 > one_t)
                        β = max(tnorms[j - 1], tnorms[j])
                        if β > bignum / t1
                            x[1] /= t1
                            x[2] /= t1
                            vscale /= t1
                        end
                    end
                    if vscale != one_t
                        rmul!(view(v, 1:ki), vscale)
                    end
                    v[j - 1] = x[1]
                    v[j] = x[2]
                    v[1:(j - 2)] .= (
                        v[1:(j - 2)] - x[1] * T[1:(j - 2), j - 1]
                            - x[2] * T[1:(j - 2), j]
                    )
                end
            end # j loop
            if !have_Z
                # conj since we do the second one first
                vectors[1:ki, isel] .= conj.(v[1:ki])
                t1 = zero_t
                for k in 1:ki
                    t1 = max(t1, abs1(vectors[k, isel]))
                end
                t1 = one_t / t1
                rmul!(view(vectors, 1:ki, isel), t1)
            else
                mul!(view(vectors, :, ki), view(Z, :, 1:ki), view(v, 1:ki))
                vscale = one_t / maximum(abs, view(vectors, :, ki))
                vectors[:, ki] .= vscale .* conj.(vectors[:, ki])
            end
        end # ip branches
        isel -= (ip == 0) ? 1 : 2
        if ip == -1
            ip = 1
        end
    end # ki loop

    return vectors
end

"""
`_gleigvecs!(T[,Z])`

Compute left eigenvectors of an upper triangular matrix `T`.
If another matrix `Z` is provided, multiply by it to get eigenvectors of `Zᵀ T Z`.
Typically `T` and `Z` are components of a Schur decomposition.
Temporarily mutates `T` if `eltype(T)` is complex.
"""
function _gleigvecs!(
        TT::StridedMatrix{T},
        Z::StridedMatrix{T} = Matrix{T}(undef, 0, 0)
    ) where {T <: Complex}
    # based on LAPACK::ztrevc
    # Copyright:
    # Univ. of Tennessee
    # Univ. of California Berkeley
    # Univ. of Colorado Denver
    # NAG Ltd.
    n = size(TT, 1)
    RT = real(T)
    ulp = eps(RT)
    # replaces LAPACK's smallnum = safemin(RT) * (n / ulp)
    smallnum = safemin(RT) * n
    vectors = Matrix{T}(undef, n, n)
    v = zeros(T, n)

    # save diagonal since we modify it to avoid copies
    tdiag = diag(TT)

    # we use the 1-norm of strictly upper part of TT
    # cols to control overflow
    tnorms = zeros(RT, n)
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            tnorms[j] += abs1(TT[i, j])
        end
    end

    # logic from ztrevc
    for ki in 1:n
        smin = max(ulp * abs1(TT[ki, ki]), smallnum)

        # form RHS
        @inbounds for k in (ki + 1):n
            v[k] = -conj(TT[ki, k])
        end
        v[1:ki] .= zero(T)
        # solve (T[ki+1:n,ki+1:n] - T[ki,ki])ᴴ x = σ v
        @inbounds for k in (ki + 1):n
            TT[k, k] -= TT[ki, ki]
            (abs1(TT[k, k]) < smin) && (TT[k, k] = smin)
        end
        if ki < n
            vscale = _cusolve!(
                view(TT, (ki + 1):n, (ki + 1):n), n - ki,
                view(v, (ki + 1):n), tnorms
            )
            v[ki] = vscale
        else
            v[n] = one(T)
            vscale = one(RT)
        end
        if size(Z, 1) > 0
            # This is done here to avoid allocating a work matrix
            # and to exploit the subspace property to reduce work.
            # Using a work matrix would allow for level-3 ops (cf. ztrevc3).
            @inbounds for j in 1:n
                vectors[j, ki] = vscale * Z[j, ki]
                for i in (ki + 1):n
                    vectors[j, ki] += Z[j, i] * v[i]
                end
            end
        else
            @inbounds for j in ki:n
                vectors[j, ki] = v[j]
            end
            vectors[1:(ki - 1), ki] .= zero(T)
        end

        # normalize
        t0 = abs1(vectors[1, ki])
        @inbounds for i in 2:n
            t0 = max(t0, abs1(vectors[i, ki]))
        end
        remax = one(RT) / t0
        @inbounds for i in 1:n
            vectors[i, ki] *= remax
        end

        # restore diagonal
        @inbounds for k in (ki + 1):n
            TT[k, k] = tdiag[k]
        end
    end

    return vectors
end

function _gleigvecs!(
        T::StridedMatrix{Ty},
        Z::StridedMatrix{Ty} = Matrix{Ty}(undef, 0, 0)
    ) where {Ty <: Real}
    # based on LAPACK::dtrevc
    # Copyright:
    # Univ. of Tennessee
    # Univ. of California Berkeley
    # Univ. of Colorado Denver
    # NAG Ltd.
    n = size(T, 1)
    ulp = eps(Ty)
    # CHECKME: LAPACK has this but the (1/ulp) factor may break some tests
    smallnum = safemin(Ty) * (n / ulp)
    bignum = (1 - ulp) / smallnum
    vectors = zeros(complex(Ty), n, n)
    one_t = one(Ty)
    zero_t = zero(Ty)
    have_Z = size(Z, 1) > 0
    # workspace
    v = zeros(complex(Ty), n)
    vt1 = zeros(complex(Ty), 1)
    vt2 = zeros(complex(Ty), 2)
    tnorms = zeros(Ty, n)

    # We use the 1-norms of the strictly upper part of T columns
    # to avoid overflow
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            tnorms[j] += abs(T[i, j])
        end
    end

    ip = 0 # 0:real, -1,1:first, second in complex pair

    # m, isel (from LAPACK logic) are kept for possible implementation of subset selection
    # m = n
    isel = 1

    for ki in 1:n
        if ip == -1
            ip = 0
            if have_Z
                vectors[:, ki] .= conj.(vectors[:, ki - 1])
            else
                vectors[:, isel - 1] .= conj.(vectors[:, isel - 2])
            end
            continue
        end
        if (ki < n) && (T[ki + 1, ki] != 0)
            ip = 1
        end
        wr = T[ki, ki]
        wi = ip == 0 ? zero_t : sqrt(abs(T[ki, ki + 1])) * sqrt(abs(T[ki + 1, ki]))
        smin = max(ulp * (abs(wr) + abs(wi)), smallnum)

        if ip == 0
            # left real eigvec
            #
            # (T[k:n,k:n]-λI) x = b
            # where k=kᵢ+1

            # form right hand side
            v[ki] = one_t
            v[(ki + 1):n] .= -T[ki, (ki + 1):n]
            vmax = one_t
            vcrit = bignum
            jnxt = ki + 1
            for j in (ki + 1):n
                j < jnxt && continue
                j1 = j
                j2 = j
                jnxt = j + 1
                if (j < n) && (T[j + 1, j] != 0)
                    j2 = j + 1
                    jnxt = j + 2
                end
                if j1 == j2
                    # 1x1 block
                    if tnorms[j] > vcrit
                        # scale to avoid overflow
                        t1 = 1 / vmax
                        rmul!(view(v, ki:n), t1)
                        vmax = one_t
                        vcrit = bignum
                    end
                    vt1[1] = v[j] - dot(view(T, (ki + 1):(j - 1), j), view(v, (ki + 1):(j - 1)))
                    vscale, x, _ = _xsolve(
                        one_t, view(T, j:j, j:j), [one_t],
                        wr + 0im, vt1, smin
                    )
                    if vscale != one_t
                        rmul!(view(v, ki:n), vscale)
                    end
                    v[j] = x[1]
                    vmax = max(abs(v[j]), vmax)
                    vcrit = bignum / vmax
                else
                    # 2x2 block
                    β = max(tnorms[j + 1], tnorms[j])
                    if β > vcrit
                        t1 = one_t / vmax
                        rmul!(view(v, ki:n), t1)
                        vmax = one_t
                        vcrit = bignum
                    end
                    vt2 .= (
                        v[j:(j + 1)]
                            - view(T, (ki + 1):(j - 1), j:(j + 1))' * view(v, (ki + 1):(j - 1))
                    )
                    vscale, x, t1 = _xsolve(
                        one_t, view(T, j:(j + 1), j:(j + 1))',
                        [one_t, one_t], wr + 0im, vt2, smin
                    )
                    # @show norm(T[j-1:j,j-1:j]*x - wr * x - v[j-1:j])
                    if vscale != one_t
                        rmul!(view(v, ki:n), vscale)
                    end
                    v[j] = x[1]
                    v[j + 1] = x[2]
                    vmax = max(abs(v[j]), abs(v[j + 1]), vmax)
                    vcrit = bignum / vmax
                end
            end # j loop
            if !have_Z
                vscale = one_t / maximum(abs, view(v, ki:n))
                vectors[ki:n, isel] .= vscale * v[ki:n]
                # vectors[1:ki - 1, isel] .= zero_t
            else
                if ki == n
                    vectors[:, ki] .= Z[:, ki]
                else
                    # LAPACK overwrites Z, so just adds to the vector corresponding to the unit entry
                    mul!(view(vectors, :, ki), view(Z, :, ki:n), view(v, ki:n))
                    vscale = one_t / maximum(abs, view(vectors, :, ki))
                    vectors[:, ki] .*= vscale
                end
            end
        else
            # complex right eigvec
            # initial solve (corner)
            if abs(T[ki, ki + 1]) >= abs(T[ki + 1, ki])
                v[ki] = wi / T[ki, ki + 1]
                v[ki + 1] = im * one_t
            else
                v[ki] = one_t
                v[ki + 1] = -im * wi / T[ki + 1, ki]
            end
            # form RHS
            for i in (ki + 2):n
                v[i] = (
                    -real(v[ki]) * T[ki, i]
                        - im * imag(v[ki + 1]) * T[ki + 1, i]
                )
            end
            # solve upper quasi-triangular system
            vmax = one_t
            vcrit = bignum
            jnxt = ki + 2
            for j in (ki + 1):n
                (j < jnxt) && continue
                j1 = j
                j2 = j
                jnxt = j + 1
                if (j < n) && (T[j + 1, j] != 0)
                    j1 = j + 1
                    jnxt = j + 2
                end
                if j1 == j2
                    # 1x1 diagonal block
                    if tnorms[j] > vcrit
                        # scale to avoid overflow
                        t1 = one_t / vmax
                        rmul!(view(v, ki:n), t1)
                        vmax = one_t
                        vcrit = bignum
                    end
                    vt1[1] = v[j] - dot(view(T, (ki + 2):(j - 1), j), view(v, (ki + 2):(j - 1)))
                    vscale, x, t1 = _xsolve(
                        one_t, view(T, j:j, j:j), [one_t],
                        wr - im * wi, vt1, smin
                    )

                    if vscale != one_t
                        rmul!(view(v, ki:n), vscale)
                    end
                    v[j] = x[1]
                    vmax = max(abs1(v[j]), vmax)
                    vcrit = bignum / vmax
                else
                    # 2x2 block
                    β = max(tnorms[j - 1], tnorms[j])
                    if β > vcrit
                        t1 = one_t / vmax
                        rmul!(view(v, ki:n), t1)
                        vmax = one_t
                        vcrit = bignum
                    end
                    vt2 .= (
                        v[j:(j + 1)]
                            - view(T, (ki + 2):(j - 1), j:(j + 1))' * view(v, (ki + 2):(j - 1))
                    )
                    vscale, x, t1 = _xsolve(
                        one_t, view(T, j:(j + 1), j:(j + 1))',
                        [one_t, one_t], wr - im * wi, vt2, smin
                    )
                    if vscale != one_t
                        rmul!(view(v, ki:n), vscale)
                    end
                    v[j] = x[1]
                    v[j + 1] = x[2]
                    vmax = max(abs1(x[1]), abs1(x[2]), vmax)
                    vcrit = bignum / vmax
                end
            end # j loop
            if !have_Z
                vectors[ki:n, isel] .= v[ki:n]
                t1 = zero_t
                for k in ki:n
                    t1 = max(t1, abs1(vectors[k, isel]))
                end
                t1 = one_t / t1
                rmul!(view(vectors, ki:n, isel), t1)
            else
                mul!(view(vectors, :, ki), view(Z, :, ki:n), view(v, ki:n))
                vscale = one_t / maximum(abs, view(vectors, :, ki))
                vectors[:, ki] .*= vscale
            end
        end # ip branches
        isel += (ip == 0) ? 1 : 2
        if ip == 1
            ip = -1
        end
    end # ki loop

    return vectors
end

"""
`_geigvecs(S, T [,Z])`

Compute right eigenvectors of a matrix pair `S, T` where `S` is [quasi-]upper triangular
and `T` is upper triangular.
If another matrix `Z` is provided, multiply by it to get eigenvectors of
`Qᵀ S Z` and `Qᵀ T Z`.
Typically `S`, `T` and `Z` are components of a generalized Schur decomposition.
"""
function _geigvecs end

"""
`_gleigvecs(S, T [,Z])`

Compute left eigenvectors of a matrix pair `S, T` where `S` is [quasi-]upper triangular
and `T` is upper triangular.
If another matrix `Z` is provided, multiply by it to get eigenvectors of
`Qᵀ S Z` and `Qᵀ T Z`.
Typically `S`, `T` and `Z` are components of a generalized Schur decomposition.
"""
function _gleigvecs end

# right eigenvectors, complex generalized case
function _geigvecs(
        S::StridedMatrix{T}, P::StridedMatrix{T},
        Z::StridedMatrix{T} = Matrix{T}(undef, 0, 0)
    ) where {T <: Complex}
    # translated from LAPACK::ztgevc
    # Copyright:
    # Univ. of Tennessee
    # Univ. of California Berkeley
    # Univ. of Colorado Denver
    # NAG Ltd.
    n = size(S, 1)
    RT = real(T)
    ulp = eps(RT)
    safmin = safemin(RT)
    smallnum = safmin * (n / ulp)
    bigx = one(RT) / smallnum
    bignum = one(RT) / (n * safmin)

    vectors = Matrix{T}(undef, n, n)
    v = zeros(T, n)
    if size(Z, 1) > 0
        v2 = zeros(T, n)
    else
        v2 = nothing
    end

    # We use the 1-norms of the strictly upper part of S, P columns
    # to avoid overflow
    anorm = abs1(S[1, 1])
    bnorm = abs1(P[1, 1])
    snorms = zeros(RT, n)
    pnorms = zeros(RT, n)
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            snorms[j] += abs1(S[i, j])
            pnorms[j] += abs1(P[i, j])
        end
        anorm = max(anorm, snorms[j] + abs1(S[j, j]))
        bnorm = max(bnorm, pnorms[j] + abs1(P[j, j]))
    end
    ascale = one(RT) / max(anorm, safmin)
    bscale = one(RT) / max(bnorm, safmin)

    idx = n + 1
    for ki in n:-1:1
        idx -= 1
        if abs1(S[ki, ki]) <= safmin && abs(real(P[ki, ki])) <= safmin
            # singular pencil; return unit eigenvector
            vectors[:, idx] .= zero(T)
            vectors[idx, idx] = one(T)
        else
            # compute coeffs a,b in (a A - b B) x = 0
            t = 1 / max(
                abs1(S[ki, ki]) * ascale,
                abs(real(P[ki, ki])) * bscale, safmin
            )
            sα = (t * S[ki, ki]) * ascale
            sβ = (t * real(P[ki, ki])) * bscale
            acoeff = sβ * ascale
            bcoeff = sα * bscale
            # scale to avoid underflow

            lsa = abs(sβ) >= safmin && abs(acoeff) < smallnum
            lsb = abs1(sα) >= safmin && abs1(bcoeff) < smallnum
            s = one(RT)
            if lsa
                s = (smallnum / abs(sβ)) * min(anorm, bigx)
            end
            if lsb
                s = max(s, (smallnum / abs1(sα)) * min(bnorm, bigx))
            end
            if lsa || lsb
                s = min(
                    s, 1 / (
                        safmin * max(
                            one(RT), abs(acoeff),
                            abs1(bcoeff)
                        )
                    )
                )
                if lsa
                    acoeff = ascale * (s * sβ)
                else
                    acoeff *= s
                end
                if lsb
                    bcoeff = bscale * (s * sα)
                else
                    bcoeff *= s
                end
            end
            aca = abs(acoeff)
            acb = abs1(bcoeff)
            xmax = one(RT)
            v .= zero(T)
            dmin = max(ulp * aca * anorm, ulp * acb * bnorm, safmin)

            # triangular solve of (a A - b B) x = 0, columnwise
            # v[1:j-1] contains sums w
            # v[j+1:ki] contains x

            v[1:(ki - 1)] .= acoeff * S[1:(ki - 1), ki] - bcoeff * P[1:(ki - 1), ki]
            v[ki] = one(T)

            for j in (ki - 1):-1:1
                # form x[j] = -v[j] / d
                # with scaling and perturbation
                d = acoeff * S[j, j] - bcoeff * P[j, j]
                if abs1(d) <= dmin
                    d = complex(dmin)
                end
                if abs1(d) < one(RT)
                    if abs1(v[j]) >= bignum * abs1(d)
                        t = 1 / abs1(v[j])
                        v[1:ki] *= t
                    end
                end
                v[j] = -v[j] / d
                if j > 1
                    # w = w + x[j] * (a S[:,j] - b P[:,j]) with scaling

                    if abs1(v[j]) > one(RT)
                        t = 1 / abs1(v[j])
                        if aca * snorms[j] + acb * pnorms[j] >= bignum * t
                            v[1:ki] *= t
                        end
                    end
                    ca = acoeff * v[j]
                    cb = bcoeff * v[j]
                    v[1:(j - 1)] += ca * S[1:(j - 1), j] - cb * P[1:(j - 1), j]
                end
            end # for j (solve loop)
            if size(Z, 1) > 0
                mul!(v2, Z, v)
                v, v2 = v2, v
                iend = n
            else
                iend = ki
            end

            xmax = zero(RT)
            for jr in 1:iend
                xmax = max(xmax, abs1(v[jr]))
            end
            if xmax > safmin
                t = 1 / xmax
                vectors[1:iend, idx] .= t * v[1:iend]
            else
                iend = 0
            end
            vectors[(iend + 1):n, idx] .= zero(T)
        end # nonsingular branch
    end # index loop

    return vectors
end # function

# left eigenvectors, complex generalized case
function _gleigvecs(
        S::StridedMatrix{T}, P::StridedMatrix{T},
        Z::StridedMatrix{T} = Matrix{T}(undef, 0, 0)
    ) where {T <: Complex}
    # translated from LAPACK::ztgevc
    # Copyright:
    # Univ. of Tennessee
    # Univ. of California Berkeley
    # Univ. of Colorado Denver
    # NAG Ltd.
    n = size(S, 1)
    RT = real(T)
    ulp = eps(RT)
    safmin = safemin(RT)
    smallnum = safmin * (n / ulp)
    bigx = one(RT) / smallnum
    bignum = one(RT) / (n * safmin)

    vectors = Matrix{T}(undef, n, n)
    v = zeros(T, n)
    if size(Z, 1) > 0
        v2 = zeros(T, n)
    else
        v2 = nothing
    end

    # We use the 1-norms of the strictly upper part of S, P columns
    # to avoid overflow
    anorm = abs1(S[1, 1])
    bnorm = abs1(P[1, 1])
    snorms = zeros(RT, n)
    pnorms = zeros(RT, n)
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            snorms[j] += abs1(S[i, j])
            pnorms[j] += abs1(P[i, j])
        end
        anorm = max(anorm, snorms[j] + abs1(S[j, j]))
        bnorm = max(bnorm, pnorms[j] + abs1(P[j, j]))
    end
    ascale = one(RT) / max(anorm, safmin)
    bscale = one(RT) / max(bnorm, safmin)

    idx = 0
    for je in 1:n
        idx += 1
        if abs1(S[je, je]) <= safmin && abs(real(P[je, je])) <= safmin
            # singular pencil; return unit eigenvector
            vectors[:, idx] .= zero(T)
            vectors[idx, idx] = one(T)
        else
            # compute coeffs a,b in y' (a A - b B) = 0
            t = 1 / max(
                abs1(S[je, je]) * ascale,
                abs(real(P[je, je])) * bscale, safmin
            )
            sα = (t * S[je, je]) * ascale
            sβ = (t * real(P[je, je])) * bscale
            acoeff = sβ * ascale
            bcoeff = sα * bscale
            # scale to avoid underflow

            lsa = abs(sβ) >= safmin && abs(acoeff) < smallnum
            lsb = abs1(sα) >= safmin && abs1(bcoeff) < smallnum
            s = one(RT)
            if lsa
                s = (smallnum / abs(sβ)) * min(anorm, bigx)
            end
            if lsb
                s = max(s, (smallnum / abs1(sα)) * min(bnorm, bigx))
            end
            if lsa || lsb
                s = min(
                    s, 1 / (
                        safmin * max(
                            one(RT), abs(acoeff),
                            abs1(bcoeff)
                        )
                    )
                )
                if lsa
                    acoeff = ascale * (s * sβ)
                else
                    acoeff *= s
                end
                if lsb
                    bcoeff = bscale * (s * sα)
                else
                    bcoeff *= s
                end
            end
            aca = abs(acoeff)
            acb = abs1(bcoeff)
            xmax = one(RT)
            v .= zero(T)
            v[je] = one(T)
            dmin = max(ulp * aca * anorm, ulp * acb * bnorm, safmin)

            # triangular solve of (a A - b B)' y = 0
            v[je] = one(T)

            for j in (je + 1):n
                # compute ∑  (s Sₖⱼ - b Pₖⱼ)' x
                t = 1 / xmax
                if aca * snorms[j] + acb * pnorms[j] > bignum * t
                    v[je:(j - 1)] *= t
                    xmax = one(RT)
                end
                suma = zero(T)
                sumb = zero(T)
                for jr in je:(j - 1)
                    suma += conj(S[jr, j]) * v[jr]
                    sumb += conj(P[jr, j]) * v[jr]
                end
                sumx = acoeff * suma - conj(bcoeff) * sumb

                # form x[j] = -sumx / (a Sⱼⱼ - b Pⱼⱼ)
                # with scaling and perturbation
                d = conj(acoeff * S[j, j] - bcoeff * P[j, j])
                if abs1(d) <= dmin
                    d = complex(dmin)
                end
                if abs1(d) < one(RT)
                    if abs1(sumx) >= bignum * abs1(d)
                        t = 1 / abs1(sumx)
                        v[je:(j - 1)] *= t
                        xmax *= t
                        sumx *= t
                    end
                end
                v[j] = -sumx / d
                xmax = max(xmax, abs1(v[j]))
            end # for j (solve loop)
            if size(Z, 1) > 0
                mul!(v2, Z, v)
                v, v2 = v2, v
                ibegin = 1
            else
                ibegin = je
            end

            xmax = zero(RT)
            for jr in ibegin:n
                xmax = max(xmax, abs1(v[jr]))
            end
            if xmax > safmin
                t = 1 / xmax
                vectors[ibegin:n, idx] .= t * v[ibegin:n]
            else
                ibegin = n + 1
            end
            vectors[1:(ibegin - 1), idx] .= zero(T)
        end # nonsingular branch
    end # index loop

    return vectors
end

# right eigenvectors of real generalized Schur
function _geigvecs(
        S::StridedMatrix{Ty}, P::StridedMatrix{Ty},
        Z::StridedMatrix{Ty} = Matrix{Ty}(undef, 0, 0)
    ) where {Ty <: Real}
    # translated from LAPACK::dtgevc
    # Copyright:
    # Univ. of Tennessee
    # Univ. of California Berkeley
    # Univ. of Colorado Denver
    # NAG Ltd.
    n = size(S, 1)
    ulp = eps(Ty)
    safmin = safemin(Ty)
    smallnum = safmin * (n / ulp)
    bigx = one(Ty) / smallnum
    bignum = one(Ty) / (n * safmin)
    safety = Ty(100)

    vectors = Matrix{Complex{Ty}}(undef, n, n)
    v = zeros(Complex{Ty}, n)
    # v is WORK(2n+1:4n)

    # We use the 1-norms of the strictly upper part of S, P columns
    # to avoid overflow
    Anorm = abs(S[1, 1])
    Bnorm = abs(P[1, 1])
    Snorms = zeros(Ty, n)
    Pnorms = zeros(Ty, n)
    # Snorms and Pnorms are WORK[1:n] and WORK[n+1:2n]
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            Snorms[j] += abs(S[i, j])
            Pnorms[j] += abs(P[i, j])
        end
        Anorm = max(Anorm, Snorms[j] + abs(S[j, j]))
        Bnorm = max(Bnorm, Pnorms[j] + abs(P[j, j]))
    end
    ascale = one(Ty) / max(Anorm, safmin)
    bscale = one(Ty) / max(Bnorm, safmin)
    idx = n + 1
    inpair = false
    for je in n:-1:1
        if inpair
            inpair = false
            continue
        end
        nw = 1
        if je > 1
            if S[je, je - 1] != 0
                inpair = true
                nw = 2
            end
        end
        if !inpair
            if abs(S[je, je]) <= safmin && abs(P[je, je]) <= safmin
                # singular pencil; return unit eigenvector
                idx -= 1
                vectors[:, idx] .= zero(Ty)
                vectors[idx, idx] = one(Ty)
                continue
            end

            # real eigenvalue
            # compute coeffs a,b in (a A - b B) x = 0
            t = 1 / max(
                abs(S[je, je]) * ascale,
                abs(P[je, je]) * bscale, safmin
            )
            sαr = (t * S[je, je]) * ascale
            sβ = (t * P[je, je]) * bscale
            a = sβ * ascale
            br = sαr * bscale
            bi = zero(Ty)

            # scale to avoid underflow

            lsa = abs(sβ) >= safmin && abs(a) < smallnum
            lsb = abs(sαr) >= safmin && abs(br) < smallnum
            s = one(Ty)
            if lsa
                s = (smallnum / abs(sβ)) * min(Anorm, bigx)
            end
            if lsb
                s = max(s, (smallnum / abs(sαr)) * min(Bnorm, bigx))
            end
            if lsa || lsb
                s = min(s, 1 / (safmin * max(one(Ty), abs(a), abs(br))))
                if lsa
                    a = ascale * (s * sβ)
                else
                    a *= s
                end
                if lsb
                    br = bscale * (s * sαr)
                else
                    br *= s
                end
            end
            aa = abs(a)
            ba = abs(br)
            v .= zero(Complex{Ty})
            v[je] = one(Ty)
            xmax = one(Ty)
            for jr in 1:(je - 1)
                v[jr] = br * P[jr, je] - a * S[jr, je]
            end
        else
            # complex eigenvalue
            scale1, _, wr1, _, wi = _ggs_2x2(
                view(S, (je - 1):je, (je - 1):je),
                view(P, (je - 1):je, (je - 1):je), safmin * safety
            )
            a = scale1
            br = wr1
            bi = wi
            if bi == 0
                throw(
                    ErrorException(
                        "algorithm error: real eigval encountered "
                            * lazy"when complex expected at $je"
                    )
                )
            end
            # scale to avoid over/underflow
            aa = abs(a)
            ba = abs(br) + abs(bi)
            scale = one(Ty)
            if aa * ulp < safmin && aa >= safmin
                scale = (safmin / ulp) / aa
            end
            if ba * ulp < safmin && ba >= safmin
                scale = max(scale, (safmin / ulp) / ba)
            end
            if safmin * aa > ascale
                scale = ascale / (safmin * aa)
            end
            if safmin * ba > bscale
                scale = min(scale, bscale / (safmin * ba))
            end
            if scale != one(Ty)
                a *= scale
                aa = abs(a)
                br *= scale
                bi *= scale
                ba = abs(br) + abs(bi)
            end
            v .= zero(Ty)
            t1 = a * S[je, je - 1]
            t2r = a * S[je, je] - br * P[je, je]
            t2i = -bi * P[je, je]
            if abs(t1) > abs(t2r) + abs(t2i)
                v[je] = one(Ty)
                v[je - 1] = - (t2r + im * t2i) / t1
            else
                v[je - 1] = one(Ty)
                t1 = a * S[je - 1, je]
                v[je] = (
                    (br * P[je - 1, je - 1] - a * S[je - 1, je - 1]) / t1
                        + im * bi * P[je - 1, je - 1] / t1
                )
            end
            xmax = max(
                abs(real(v[je])) + abs(imag(v[je])),
                abs(real(v[je - 1])) + abs(imag(v[je - 1]))
            )
            ca = a * v[je - 1]
            cb = (br + im * bi) * v[je - 1]
            c2a = a * v[je]
            c2b = (br + im * bi) * v[je]
            for jr in 1:(je - 2)
                v[jr] = -ca * S[jr, je - 1] + cb * P[jr, je - 1] - c2a * S[jr, je] + c2b * P[jr, je]
            end
        end
        dmin = max(ulp * aa * Anorm, ulp * ba * Bnorm, safmin)
        # columnwise triangular solve of (a A - b B) x = 0
        in2x2 = false
        for j in (je - nw):-1:1
            if !in2x2 && j > 1 && S[j, j - 1] != 0
                in2x2 = true
                continue
            end
            if in2x2
                na = 2
                Bdiag = [P[j, j], P[j + 1, j + 1]]
            else
                na = 1
                Bdiag = [P[j, j]]
            end
            jx = j + na - 1
            scale, xsum, t1 = _xsolve(
                a, view(S, j:jx, j:jx), Bdiag, br + im * bi, view(v, j:jx),
                dmin
            )
            if scale < one(Ty)
                v[1:je] .= scale * v[1:je]
            end
            xmax = max(scale * xmax, t1)
            v[j:jx] .= xsum
            # w += xⱼ * (a * S[:,j] - b * P[:,j]) with scaling
            if j > 1
                # check whether scaling is needed for xsum
                xscale = one(Ty) / max(one(Ty), xmax)
                t1 = max(t1, aa * Snorms[j] + ba * Pnorms[j])
                if in2x2
                    t1 = max(t1, aa * Snorms[j + 1] + ba * Pnorms[j + 1])
                end
                t1 = max(t1, aa, ba)
                if t1 > bignum * xscale
                    v[1:je] .= xscale * v[1:je]
                    xmax *= xscale
                end
                # compute contributions from off-diagonals of columns j:jx to sums
                for ja in 1:na
                    ca = a * v[j + ja - 1]
                    cb = (br + im * bi) * v[j + ja - 1]
                    v[1:(j - 1)] .= v[1:(j - 1)] - ca * S[1:(j - 1), j + ja - 1] + cb * P[1:(j - 1), j + ja - 1]
                end
            end
            in2x2 = false
        end # j loop
        # copy eigvec, backtransforming if needed
        idx -= nw
        if size(Z, 1) > 0
            mul!(view(vectors, :, idx), Z, v)
            iend = n
        else
            vectors[:, idx] .= v
            iend = je
        end
        # scale eigvec
        for j in 1:iend
            xmax = max(xmax, abs1(vectors[j, idx]))
        end
        if xmax > safmin
            xscale = one(Ty) / xmax
            vectors[1:iend, idx] .= xscale * vectors[1:iend, idx]
        end
        if inpair
            vectors[:, idx + 1] .= conj.(vectors[:, idx])
        end
    end # je loop
    return vectors
end

# left eigenvectors of real generalized Schur
function _gleigvecs(
        S::StridedMatrix{Ty}, P::StridedMatrix{Ty},
        Q::StridedMatrix{Ty} = Matrix{Ty}(undef, 0, 0)
    ) where {Ty <: Real}
    n = size(S, 1)
    ulp = eps(Ty)
    safmin = safemin(Ty)
    smallnum = safmin * (n / ulp)
    bigx = one(Ty) / smallnum
    bignum = one(Ty) / (n * safmin)
    safety = Ty(100)

    vectors = Matrix{Complex{Ty}}(undef, n, n)
    v = zeros(Complex{Ty}, n)
    # v is WORK(2n+1:4n)

    # We use the 1-norms of the strictly upper part of S, P columns
    # to avoid overflow
    Anorm = abs(S[1, 1])
    Bnorm = abs(P[1, 1])
    Snorms = zeros(Ty, n)
    Pnorms = zeros(Ty, n)
    # Snorms and Pnorms are WORK[1:n] and WORK[n+1:2n]
    @inbounds for j in 2:n
        for i in 1:(j - 1)
            Snorms[j] += abs(S[i, j])
            Pnorms[j] += abs(P[i, j])
        end
        Anorm = max(Anorm, Snorms[j] + abs(S[j, j]))
        Bnorm = max(Bnorm, Pnorms[j] + abs(P[j, j]))
    end
    ascale = one(Ty) / max(Anorm, safmin)
    bscale = one(Ty) / max(Bnorm, safmin)
    idx = 0
    inpair = false
    for je in 1:n
        if inpair
            inpair = false
            continue
        end
        nw = 1
        if je < n
            if S[je + 1, je] != 0
                inpair = true
                nw = 2
            end
        end
        if !inpair
            if abs(S[je, je]) <= safmin && abs(P[je, je]) <= safmin
                # singular pencil; return unit eigenvector
                idx += 1
                vectors[:, idx] .= zero(Ty)
                vectors[idx, idx] = one(Ty)
                continue
            end

            # real eigenvalue
            # compute coeffs a,b in (a A - b B) x = 0
            t = 1 / max(
                abs(S[je, je]) * ascale,
                abs(P[je, je]) * bscale, safmin
            )
            sαr = (t * S[je, je]) * ascale
            sβ = (t * P[je, je]) * bscale
            a = sβ * ascale
            br = sαr * bscale
            bi = zero(Ty)

            # scale to avoid underflow

            lsa = abs(sβ) >= safmin && abs(a) < smallnum
            lsb = abs(sαr) >= safmin && abs(br) < smallnum
            s = one(Ty)
            if lsa
                s = (smallnum / abs(sβ)) * min(Anorm, bigx)
            end
            if lsb
                s = max(s, (smallnum / abs(sαr)) * min(Bnorm, bigx))
            end
            if lsa || lsb
                s = min(s, 1 / (safmin * max(one(Ty), abs(a), abs(br))))
                if lsa
                    a = ascale * (s * sβ)
                else
                    a *= s
                end
                if lsb
                    br = bscale * (s * sαr)
                else
                    br *= s
                end
            end
            aa = abs(a)
            ba = abs(br)
            v .= zero(Complex{Ty})
            v[je] = one(Ty)
            xmax = one(Ty)
        else
            # complex eigenvalue
            scale1, _, wr1, _, wi = _ggs_2x2(
                view(S, je:(je + 1), je:(je + 1)),
                view(P, je:(je + 1), je:(je + 1)), safmin * safety
            )
            a = scale1
            br = wr1
            bi = -wi
            if bi == 0
                throw(
                    ErrorException(
                        "algorithm error: real eigval encountered" *
                            lazy"when complex expected at $je"
                    )
                )
            end
            # scale to avoid over/underflow
            aa = abs(a)
            ba = abs(br) + abs(bi)
            scale = one(Ty)
            if aa * ulp < safmin && aa >= safmin
                scale = (safmin / ulp) / aa
            end
            if ba * ulp < safmin && ba >= safmin
                scale = max(scale, (safmin / ulp) / ba)
            end
            if safmin * aa > ascale
                scale = ascale / (safmin * aa)
            end
            if safmin * ba > bscale
                scale = min(scale, bscale / (safmin * ba))
            end
            if scale != one(Ty)
                a *= scale
                aa = abs(a)
                br *= scale
                bi *= scale
                ba = abs(br) + abs(bi)
            end
            # first two components of eigenvector
            v .= zero(Ty)
            t1 = a * S[je + 1, je]
            t2r = a * S[je, je] - br * P[je, je]
            t2i = -bi * P[je, je]
            if abs(t1) > abs(t2r) + abs(t2i)
                v[je] = one(Ty)
                v[je + 1] = - (t2r + im * t2i) / t1
            else
                v[je + 1] = one(Ty)
                t1 = a * S[je, je + 1]
                v[je] = (
                    (br * P[je + 1, je + 1] - a * S[je + 1, je + 1]) / t1
                        + im * bi * P[je + 1, je + 1] / t1
                )
            end
            xmax = max(
                abs(real(v[je])) + abs(imag(v[je])),
                abs(real(v[je + 1])) + abs(imag(v[je + 1]))
            )
        end
        dmin = max(ulp * aa * Anorm, ulp * ba * Bnorm, safmin)
        # columnwise triangular solve of (a A - b B) x = 0
        in2x2 = false
        for j in (je + nw):n
            if in2x2
                in2x2 = false
                continue
            end
            if j < n && S[j + 1, j] != 0
                in2x2 = true
                na = 2
                Bdiag = [P[j, j], P[j + 1, j + 1]]
            else
                na = 1
                Bdiag = [P[j, j]]
            end
            # check whether scaling is needed for dot products
            xscale = one(Ty) / max(one(Ty), xmax)
            t1 = max(Snorms[j], Pnorms[j], aa * Snorms[j] + ba * Snorms[j])
            if in2x2
                t1 = max(
                    t1, Snorms[j + 1], Pnorms[j + 1],
                    aa * Snorms[j + 1] + ba * Snorms[j + 1]
                )
            end
            if t1 > bignum * xscale
                v[je:(j - 1)] .= v[je:(j - 1)] * xscale
                xmax *= xscale
            end
            # compute dot products
            sum_S = zeros(Complex{Ty}, na)
            sum_P = zeros(Complex{Ty}, na)
            jx = j + na - 1
            for jr in je:(j - 1)
                sum_S += S[jr, j:jx] .* v[jr]
                sum_P += P[jr, j:jx] .* v[jr]
            end
            spsum = -a * sum_S + (br + im * bi) * sum_P
            scale, y, t1 = _xsolve(a, view(S', j:jx, j:jx), Bdiag, br + im * bi, spsum, dmin)
            v[j:jx] .= y
            if scale < one(Ty)
                v[je:(j - 1)] .= scale * v[je:(j - 1)]
                xmax *= scale
            end
            xmax = max(xmax, t1)
        end # j loop
        # copy eigvec, backtransforming if needed
        idx += 1
        if size(Q, 1) > 0
            mul!(view(vectors, :, idx), Q, v)
            ibegin = 1
        else
            vectors[:, idx] .= v
            ibegin = je
        end
        # scale eigvec
        xmax = zero(Ty)
        for j in ibegin:n
            xmax = max(xmax, abs1(vectors[j, idx]))
        end
        if xmax > safmin
            xscale = one(Ty) / xmax
            vectors[ibegin:n, idx] .= xscale * vectors[ibegin:n, idx]
        end
        if inpair
            vectors[:, idx + 1] .= conj.(vectors[:, idx])
        end
        idx += nw - 1
    end # je loop
    return vectors
end

# This file is part of GenericSchur.jl, released under the MIT "Expat" license
# Portions derived from LAPACK, see below.

# Real Schur decomposition (QZ algorithm) for generalized eigen-problems

# decomposition is A = Q S Z', B = Q T Z'

# similar to LAPACK dgges.
# TODO: consolidate w/ complex version if possible.
function ggschur!(
        A::StridedMatrix{Ty}, B::StridedMatrix{Ty};
        wantQ::Bool = true, wantZ::Bool = true,
        scale::Bool = true,
        kwargs...
    ) where {Ty <: Real}

    n = checksquare(A)
    nb = checksquare(B)
    if nb != n
        throw(ArgumentError("matrices must have the same sizes"))
    end

    if scale
        scaleA, cscale, anrm = _scale!(A)
        scaleB, cscaleb, bnrm = _scale!(B)
    else
        scaleA = false
        scaleB = false
        cscale = cscaleb = anrm = bnrm = one(Ty)
    end
    # maybe balance here

    bqr = qr!(B)
    # apply bqr.Q to A
    lmul!(bqr.Q', A)
    if wantQ
        Q = Matrix(bqr.Q)
    else
        Q = Matrix{Ty}(undef, 0, 0)
    end
    if wantZ
        Z = Matrix{Ty}(I, n, n)
    else
        Z = Matrix{Ty}(undef, 0, 0)
    end

    # materializing R may waste memory; can we rely on storage in modified B?
    A, B, Q, Z = _hessenberg!(A, bqr.R, Q, Z)
    α, β, S, T, Q, Z = _gqz!(A, B, Q, Z, true)

    # TODO if balancing, unbalance Q, Z

    if scaleA
        safescale!(S, cscale, anrm)
        safescale!(α, cscale, anrm)
    end
    if scaleB
        safescale!(T, cscaleb, bnrm)
        safescale!(β, cscaleb, bnrm)
    end

    return GeneralizedSchur(S, T, α, β, Q, Z)
end

const _RG2X2_SAFETY = 100

# translated from dhgeqz (LAPACK)
function _gqz!(
        H::StridedMatrix{T}, B::StridedMatrix{T}, Q, Z, wantSchur;
        ilo = 1, ihi = size(H, 1), maxiter = 100 * (ihi - ilo + 1)
    ) where {T <: Real}
    n = checksquare(H)
    wantQ = !isempty(Q)
    wantZ = !isempty(Z)

    α = Vector{complex(T)}(undef, n)
    β = Vector{T}(undef, n)

    ulp = eps(T)
    safmin = safemin(T)
    safmax = one(T) / safmin
    safety = T(_RG2X2_SAFETY)
    anorm = norm(view(H, ilo:ihi, ilo:ihi), 2) # Frobenius
    bnorm = norm(view(B, ilo:ihi, ilo:ihi), 2) # Frobenius
    atol = max(safmin, ulp * anorm)
    btol = max(safmin, ulp * bnorm)
    ascale = one(T) / max(safmin, anorm)
    bscale = one(T) / max(safmin, bnorm)

    # set trivial trailing eigvals
    for j in (ihi + 1):n
        if B[j, j] < 0
            if wantSchur
                H[1:j, j] .= -H[1:j, j]
                B[1:j, j] .= -B[1:j, j]
            else
                H[j, j] = -H[j, j]
                B[j, j] = -B[j, j]
            end
            if wantZ
                Z[1:n, j] .= -Z[1:n, j]
            end
        end
        α[j] = H[j, j]
        β[j] = B[j, j]
    end

    ifirst = ilo
    ilast = ihi

    if wantSchur
        ifirstm, ilastm = 1, n
    else
        ifirstm, ilastm = ilo, ihi
    end

    shiftcount = 0
    eshift = zero(T)
    v = zeros(T, 3) # used for reflectors below

    for it in 1:maxiter
        @mydebug println("iteration $it ilast=$ilast")

        # Split H if possible
        # Use 2 tests:
        # 1: H[j,j-1] == 0 || j=ilo
        # 2: B[j,j] = 0

        br = _deflatec_unknown
        if ilast == ilo
            br = _deflatec_normal
        elseif (
                abs(H[ilast, ilast - 1]) < max(
                    safmin,
                    ulp * (
                        abs(H[ilast, ilast])
                            + abs(H[ilast - 1, ilast - 1])
                    )
                )
            )
            H[ilast, ilast - 1] = 0
            br = _deflatec_normal
            @mydebug println("trivial split at $ilast")
        end

        if br == _deflatec_unknown
            if abs(B[ilast, ilast]) <= btol
                B[ilast, ilast] = 0
                br = _deflatec_inf
                @mydebug println("split on singular entry in B at $ilast")
            else
                # general case
                for j in (ilast - 1):-1:ilo
                    # Test 1
                    have_H_0sd = false
                    if j == ilo
                        have_H_0sd = true
                    else
                        if abs(H[j, j - 1]) <= atol
                            H[j, j - 1] = 0
                            have_H_0sd = true
                        end
                    end
                    # Test 2
                    if abs(B[j, j]) < btol
                        B[j, j] = 0
                        # Test 1a: check for 2 consec. small subdiags in H
                        have2_H_0sd = false
                        if !have_H_0sd
                            t = abs(H[j, j - 1])
                            t2 = abs(H[j, j])
                            tr = max(t, t2)
                            if tr < 1 && tr != 0
                                t = t / tr
                                t2 = t2 / tr
                            end
                            have2_H_0sd = (
                                t * (ascale * abs(H[j + 1, j]))
                                    <= t2 * (ascale * atol)
                            )
                        end
                        # if both tests pass, split 1x1 block off top
                        # if remaining leading diagonal elt vanishes, iterate
                        if have_H_0sd || have2_H_0sd
                            @mydebug println("split on singular entry in B at $j")
                            for jch in j:(ilast - 1)
                                # G,r = givens(H[jch,jch],H[jch+1,jch],jch,jch+1)
                                c, s, r = givensAlgorithm(H[jch, jch], H[jch + 1, jch])
                                G = Givens(jch, jch + 1, c, s)
                                H[jch, jch] = r
                                H[jch + 1, jch] = 0
                                lmul!(G, view(H, :, (jch + 1):ilastm))
                                lmul!(G, view(B, :, (jch + 1):ilastm))
                                if wantQ
                                    rmul!(Q, G')
                                end
                                if have2_H_0sd
                                    H[jch, jch - 1] *= c
                                end
                                have2_H_0sd = false
                                if abs(B[jch + 1, jch + 1]) > btol
                                    if jch + 1 >= ilast
                                        br = _deflatec_normal
                                        break
                                    else
                                        ifirst = jch + 1
                                        br = _deflatec_none
                                        break
                                    end
                                end
                                @mydebug println("  another at $(jch + 1)")
                                B[jch + 1, jch + 1] = 0
                            end # jch loop
                            if br == _deflatec_unknown
                                br = _deflatec_inf
                            end
                            break
                        else
                            # only test 2 passed: chase 0 to B[ilast,ilast]
                            # then process as above
                            @mydebug println("chase singular entry in B at $j")
                            for jch in j:(ilast - 1)
                                G, r = givens(
                                    B[jch, jch + 1], B[jch + 1, jch + 1],
                                    jch, jch + 1
                                )
                                B[jch, jch + 1] = r
                                B[jch + 1, jch + 1] = 0
                                if jch < ilastm - 1
                                    lmul!(G, view(B, :, (jch + 2):ilastm))
                                end
                                lmul!(G, view(H, :, (jch - 1):ilastm))
                                if wantQ
                                    rmul!(Q, G')
                                end
                                G, r = givens(
                                    H[jch + 1, jch], H[jch + 1, jch - 1],
                                    jch, jch - 1
                                )
                                H[jch + 1, jch] = r
                                H[jch + 1, jch - 1] = 0
                                rmul!(view(H, ifirstm:jch, :), G')
                                rmul!(view(B, ifirstm:(jch - 1), :), G')
                                if wantZ
                                    rmul!(Z, G')
                                end
                            end # jch loop
                            br = _deflatec_inf
                            break
                        end # if have_H_0sd || have2_H_0sd
                    elseif have_H_0sd # not tiny B[j,j]
                        ifirst = j
                        @mydebug (ifirst > ilo) && println("nonsingular split at $ifirst")
                        br = _deflatec_none
                        break
                    end # if B[j,j] tiny
                    # neither test passed; try next j
                end # j loop (40)
                if br == _deflatec_unknown
                    error("algorithmic failure: splitting drop-through assumed impossible")
                end
            end # if B[ilast,ilast] tiny
            if br == _deflatec_inf
                # B[ilast,ilast] = 0; clear H[ilast,ilast-1] to split off 1x1
                G, r = givens(H[ilast, ilast], H[ilast, ilast - 1], ilast, ilast - 1)
                H[ilast, ilast] = r
                H[ilast, ilast - 1] = 0
                rmul!(view(H, ifirstm:(ilast - 1), :), G')
                rmul!(view(B, ifirstm:(ilast - 1), :), G')
                # Puzzlement: The last line seems to miss a row, but if we do
                #   rmul!(view(B,ifirstm:ilast,:),G')
                # instead, we get consistent B decomp at the cost
                # of introducing a subdiagonal which is never cleared
                if wantZ
                    rmul!(Z, G')
                end
                br = _deflatec_normal
            end
        end # if not a trivial split
        if br == _deflatec_normal
            # found or made zero subdiag H[ilast, ilast-1]:
            @mydebug println("deflating $ilast")
            # standardize B, set α,β
            if B[ilast, ilast] < 0
                if wantSchur
                    H[ifirstm:ilast, ilast] .= -H[ifirstm:ilast, ilast]
                    B[ifirstm:ilast, ilast] .= -B[ifirstm:ilast, ilast]
                else
                    H[ilast, ilast] = -H[ilast, ilast]
                    B[ilast, ilast] = -B[ilast, ilast]
                end
                if wantZ
                    Z[:, ilast] .= -Z[:, ilast]
                end
            end

            α[ilast] = H[ilast, ilast]
            β[ilast] = B[ilast, ilast]

            # advance to next block or exit if done with core blocks
            ilast -= 1
            if ilast < ilo
                break
            end
            shiftcount = 0
            eshift = zero(T)
            if !wantSchur
                ilastm = ilast
                if ifirstm > ilast
                    ifirstm = ilo
                end
            end
            continue # iteration loop
        end # br == _deflatec_normal branch

        @mydebug begin
            @assert br == _deflatec_none
        end

        # QZ step
        # This iteration involves block ifirst:ilast, assumed nonempty
        if !wantSchur
            ifirstm = ifirst
        end

        # Compute shift
        shiftcount += 1
        # At this point ifirst < ilast and diagonal elts of B in that block
        # are all nontrivial.

        if shiftcount % 10 != 0
            # Wilkinson shift, i.e. eigenvalue of last 2x2 block of
            # A B⁻¹ nearest to last elt

            s1, s2, wr, wr2, wi = _ggs_2x2(
                view(H, (ilast - 1):ilast, (ilast - 1):ilast),
                view(B, (ilast - 1):ilast, (ilast - 1):ilast),
                safmin * safety
            )
            if (
                    abs((wr / s1) * B[ilast, ilast] - H[ilast, ilast])
                        > abs((wr2 / s2) * B[ilast, ilast] - H[ilast, ilast])
                )
                wr, wr2 = wr2, wr
                s1, s2 = s2, s1
            end

        else
            # exceptional shift
            # "Chosen for no particularly good reason" (LAPACK)
            if maxiter * safmin * abs(H[ilast, ilast - 1]) < abs(B[ilast - 1, ilast - 1])
                eshift = H[ilast, ilast - 1] / B[ilast - 1, ilast - 1]
            else
                eshift += 1 / (safmin * maxiter)
            end
            s1 = T(1)
            wr = eshift
            wi = T(0)
        end


        if wi == 0
            # real shift; logic (approx) equiv to zhgeqz
            @mydebug println(
                "QZ $ifirst:$ilast w/ shift $wr"
                    * "(exc)"^(shiftcount % 10 == 0)
            )

            # fiddle with shift to avoid overflow
            t = min(ascale, one(T)) * (safmax / 2)
            scale = s1 > t ? t / s1 : one(T)
            t = min(bscale, one(T)) * (safmax / 2)
            if abs(wr) > t
                scale = min(scale, t / abs(wr))
            end
            s1 *= scale
            wr *= scale

            # check for two consecutive small subdiagonals
            _istart = -1 # dummy init i.l.o. local _istart
            gotit = false
            for j in (ilast - 1):-1:(ifirst + 1)
                _istart = j
                t = abs(s1 * H[j, j - 1])
                t2 = abs(s1 * H[j, j] - wr * B[j, j])
                tr = max(t, t2)
                if tr < 1 && tr != 0
                    t /= tr
                    t2 /= tr
                end
                if abs((ascale * H[j + 1, j]) * t) <= ascale * atol * t2
                    gotit = true
                    break
                end
            end
            if !gotit
                _istart = ifirst
            end

            # implicit single-shift qz sweep
            f1 = s1 * H[_istart, _istart] - wr * B[_istart, _istart]
            g2 = s1 * H[_istart + 1, _istart]
            c, s, t3 = givensAlgorithm(f1, g2)
            for j in _istart:(ilast - 1)
                if j > _istart
                    c, s, r = givensAlgorithm(H[j, j - 1], H[j + 1, j - 1])
                    H[j, j - 1] = r
                    H[j + 1, j - 1] = 0
                end
                G = Givens(j, j + 1, T(c), s)
                lmul!(G, view(H, :, j:ilastm))
                lmul!(G, view(B, :, j:ilastm))
                if wantQ
                    rmul!(Q, G')
                end
                c, s, r = givensAlgorithm(B[j + 1, j + 1], B[j + 1, j])
                B[j + 1, j + 1] = r
                B[j + 1, j] = 0
                G = Givens(j, j + 1, T(c), s)
                rmul!(view(H, ifirstm:min(j + 2, ilast), :), G)
                rmul!(view(B, ifirstm:j, :), G)
                if wantZ
                    rmul!(Z, G)
                end
            end
        else # shift is complex
            @mydebug println("QZ $ifirst:$ilast w/ shift $wr + $wi im")
            # Francis double shift
            # dhgeqz notes that this should work with real shifts if block is at least 3x3,
            # but might fail in 2x2 case
            if ilast == ifirst + 1
                # Special case: 2x2 block w/ complex eigenvectors

                # step 1: standardize (diagonalize B block)
                # Note ordering gotcha: fn returns ssmin,ssmax,...
                # We want largest s.v. in first slot.
                b22, b11, sr, cr, sl, cl = _gsvd_2x2(view(B, ifirst:ilast, ifirst:ilast))
                if b11 < 0
                    cr = -cr
                    sr = -sr
                    b11 = -b11
                    b22 = -b22
                end
                Gl = Givens(ifirst, ilast, cl, sl)
                Gr = Givens(ifirst, ilast, cr, sr)
                lmul!(Gl, view(H, :, ifirst:ilastm))
                rmul!(view(H, ifirstm:ilast, :), Gr')
                if ilast < ilastm
                    lmul!(Gl, view(B, :, (ilast + 1):ilastm))
                end
                if ifirstm < ifirst
                    rmul!(view(B, ifirstm:(ifirst - 1), :), Gr')
                end
                # these might conceivably be correct
                if wantQ
                    rmul!(Q, Gl')
                end
                if wantZ
                    rmul!(Z, Gr')
                end

                B[ilast - 1, ilast - 1] = b11
                B[ilast - 1, ilast] = 0
                B[ilast, ilast - 1] = 0
                B[ilast, ilast] = b22
                if b22 < 0
                    H[ifirstm:ilast, ilast] .= - H[ifirstm:ilast, ilast]
                    B[ifirstm:ilast, ilast] .= - B[ifirstm:ilast, ilast]
                    if wantZ
                        Z[1:n, ilast] .= -Z[1:n, ilast]
                    end
                    b22 = - b22
                end
                # step 2: compute α, β
                s1, _, wr, _, wi = _ggs_2x2(
                    view(H, (ilast - 1):ilast, (ilast - 1):ilast),
                    view(B, (ilast - 1):ilast, (ilast - 1):ilast),
                    safmin * safety
                )
                if wi == 0 # perturbation put shift back on real line
                    @mydebug println("backtracking to real shift")
                    @mydebug begin
                        @show eigvals(
                            view(H, (ilast - 1):ilast, (ilast - 1):ilast),
                            view(B, (ilast - 1):ilast, (ilast - 1):ilast)
                        )
                    end
                    # go back for another single shift
                    continue
                end
                s1inv = 1 / s1
                a11 = H[ilast - 1, ilast - 1]
                a21 = H[ilast, ilast - 1]
                a12 = H[ilast - 1, ilast]
                a22 = H[ilast, ilast]

                # complex Givens on right
                # assume some elt of sA-wB > unfl
                c11r = s1 * a11 - wr * b11
                c11i = -wi * b11
                c12 = s1 * a12
                c21 = s1 * a21
                c22r = s1 * a22 - wr * b22
                c22i = -wi * b22
                if abs(c11r) + abs(c11i) + abs(c12) > abs(c21) + abs(c22r) + abs(c22i)
                    t1 = hypot(c12, c11r, c11i)
                    cz = c12 / t1
                    szr = -c11r / t1
                    szi = -c11i / t1
                else
                    cz = hypot(c22r, c22i)
                    if cz <= safmin
                        cz = zero(T)
                        szr = one(T)
                        szi = zero(T)
                    else
                        tr = c22r / cz
                        ti = c22i / cz
                        t1 = hypot(cz, c21)
                        cz /= t1
                        szr = -c21 * tr / t1
                        szi = c21 * ti / t1
                    end
                end
                # Givens on left
                an = abs(a11) + abs(a12) + abs(a21) + abs(a22)
                bn = abs(b11) + abs(b22)
                wabs = abs(wr) + abs(wi)
                if s1 * an > wabs * bn
                    cq = cz * b11
                    sqr = szr * b22
                    sqi = -szi * b22
                else
                    a1r = cz * a11 + szr * a12
                    a1i = szi * a12
                    a2r = cz * a21 + szr * a22
                    a2i = szi * a22
                    cq = hypot(a1r, a1i)
                    if cq <= safmin
                        cq = zero(T)
                        sqr = one(T)
                        sqi = zero(T)
                    else
                        tr = a1r / cq
                        ti = a1i / cq
                        sqr = tr * a2r + ti * a2i
                        sqi = ti * a2r - tr * a2i
                    end
                end
                t1 = hypot(cq, sqr, sqi)
                cq /= t1
                sqr /= t1
                sqi /= t1
                # compute diagonal elts of QBZ
                tr = sqr * szr - sqi * szi
                ti = sqr * szi + sqi * szr
                b1r = cq * cz * b11 + tr * b22
                b1i = ti * b22
                b1a = hypot(b1r, b1i)
                b2r = cq * cz * b22 + tr * b11
                b2i = -ti * b11
                b2a = hypot(b2r, b2i)
                # standardize
                @mydebug println("deflating complex pair")
                β[ilast - 1] = b1a
                β[ilast] = b2a
                α[ilast - 1] = (complex(wr, wi) * b1a) * s1inv
                α[ilast] = (complex(wr, -wi) * b2a) * s1inv
                ilast = ifirst - 1
                if ilast < ilo # done with core block
                    break
                end
                # reset counters and go on to next block
                shiftcount = 0
                eshift = zero(T)
                if !wantSchur
                    ilastm = ilast
                    if ifirstm > ilast
                        ifirstm = ilo
                    end
                end
            else
                # usual case: 3x3 or larger
                # use Francis implicit double shift

                # eigval eqn is ω^2 - c ω + d = 0
                # compute first column of (AB⁻¹)² - c AB⁻¹ + d
                # assuming block is at least 3x3
                ad11 = (ascale * H[ilast - 1, ilast - 1]) / (bscale * B[ilast - 1, ilast - 1])
                ad21 = (ascale * H[ilast, ilast - 1]) / (bscale * B[ilast - 1, ilast - 1])
                ad12 = (ascale * H[ilast - 1, ilast]) / (bscale * B[ilast, ilast])
                ad22 = (ascale * H[ilast, ilast]) / (bscale * B[ilast, ilast])
                u12 = B[ilast - 1, ilast] / B[ilast, ilast]
                ad11l = (ascale * H[ifirst, ifirst]) / (bscale * B[ifirst, ifirst])
                ad21l = (ascale * H[ifirst + 1, ifirst]) / (bscale * B[ifirst, ifirst])
                ad12l = (ascale * H[ifirst, ifirst + 1]) / (bscale * B[ifirst + 1, ifirst + 1])
                ad22l = (ascale * H[ifirst + 1, ifirst + 1]) / (bscale * B[ifirst + 1, ifirst + 1])
                ad32l = (ascale * H[ifirst + 2, ifirst + 1]) / (bscale * B[ifirst + 1, ifirst + 1])
                u12l = B[ifirst, ifirst + 1] / B[ifirst + 1, ifirst + 1]

                v[1] = (
                    (ad11 - ad11l) * (ad22 - ad11l) - ad12 * ad21 + ad21 * u12 * ad11l
                        + (ad12l - ad11l * u12l) * ad21l
                )
                v[2] = (
                    (
                        (ad22l - ad11l) - ad21l * u12l - (ad11 - ad11l) - (ad22 - ad11l)
                            + ad21 * u12
                    )
                ) * ad21l
                v[3] = ad32l * ad21l
                _istart = ifirst

                τ = _reflector!(v)
                v[1] = one(T)
                # sweep
                for j in _istart:(ilast - 2)
                    if j > _istart
                        v .= H[j:(j + 2), j - 1]
                        τ = _reflector!(v)
                        H[j, j - 1] = v[1]
                        v[1] = one(T)
                        H[(j + 1):(j + 2), j - 1] .= zero(T)
                    end
                    t2 = τ * v[2]
                    t3 = τ * v[3]
                    for jc in j:ilastm
                        t1 = H[j, jc] + v[2] * H[j + 1, jc] + v[3] * H[j + 2, jc]
                        H[j, jc] -= t1 * τ
                        H[j + 1, jc] -= t1 * t2
                        H[j + 2, jc] -= t1 * t3
                        t1 = B[j, jc] + v[2] * B[j + 1, jc] + v[3] * B[j + 2, jc]
                        B[j, jc] -= t1 * τ
                        B[j + 1, jc] -= t1 * t2
                        B[j + 2, jc] -= t1 * t3
                    end
                    if wantQ
                        for jr in 1:n
                            t1 = Q[jr, j] + v[2] * Q[jr, j + 1] + v[3] * Q[jr, j + 2]
                            Q[jr, j] -= t1 * τ
                            Q[jr, j + 1] -= t1 * t2
                            Q[jr, j + 2] -= t1 * t3
                        end
                    end
                    # zero j-th column of B
                    # swap rows to pivot
                    pivot = false
                    t1 = max(abs(B[j + 1, j + 1]), abs(B[j + 1, j + 2]))
                    t2 = max(abs(B[j + 2, j + 1]), abs(B[j + 2, j + 2]))
                    if max(t1, t2) < safmin
                        scale = zero(T)
                        u1 = one(T)
                        u2 = zero(T)
                    else
                        if t1 >= t2
                            w11 = B[j + 1, j + 1]
                            w21 = B[j + 2, j + 1]
                            w12 = B[j + 1, j + 2]
                            w22 = B[j + 2, j + 2]
                            u1 = B[j + 1, j]
                            u2 = B[j + 2, j]
                        else
                            w21 = B[j + 1, j + 1]
                            w11 = B[j + 2, j + 1]
                            w22 = B[j + 1, j + 2]
                            w12 = B[j + 2, j + 2]
                            u2 = B[j + 1, j]
                            u1 = B[j + 2, j]
                        end
                        if abs(w12) > abs(w11)
                            pivot = true
                            w11, w12 = w12, w11
                            w21, w22 = w22, w21
                        end
                        # LU factor
                        t1 = w21 / w11
                        u2 -= t1 * u1
                        w22 -= t1 * w12
                        w21 = zero(T)
                        # compute scale
                        scale = one(T)
                        if abs(w22) < safmin
                            scale = zero(T)
                        else
                            if abs(w22) < abs(u2)
                                scale = abs(w22 / u2)
                            end
                            if abs(w11) < abs(u1)
                                scale = min(scale, abs(w11 / u1))
                            end
                            # solve
                            u2 = (scale * u2) / w22
                            u1 = (scale * u1 - w12 * u2) / w11
                        end
                    end
                    if pivot
                        u1, u2 = u2, u1
                    end
                    # Householder vector
                    t1 = hypot(scale, u1, u2)
                    τ = one(T) + scale / t1
                    vs = -one(T) / (scale + t1)
                    v[1] = one(T)
                    v[2] = vs * u1
                    v[3] = vs * u2
                    t2 = τ * v[2]
                    t3 = τ * v[3]
                    for jr in ifirstm:min(j + 3, ilast)
                        t1 = H[jr, j] + v[2] * H[jr, j + 1] + v[3] * H[jr, j + 2]
                        H[jr, j] -= t1 * τ
                        H[jr, j + 1] -= t2 * t1
                        H[jr, j + 2] -= t3 * t1
                    end
                    for jr in ifirstm:(j + 2)
                        t1 = B[jr, j] + v[2] * B[jr, j + 1] + v[3] * B[jr, j + 2]
                        B[jr, j] -= t1 * τ
                        B[jr, j + 1] -= t2 * t1
                        B[jr, j + 2] -= t3 * t1
                    end
                    if wantZ
                        for jr in 1:n
                            t1 = Z[jr, j] + v[2] * Z[jr, j + 1] + v[3] * Z[jr, j + 2]
                            Z[jr, j] -= t1 * τ
                            Z[jr, j + 1] -= t2 * t1
                            Z[jr, j + 2] -= t3 * t1
                        end
                    end
                    B[(j + 1):(j + 2), j] .= zero(T)
                end # sweep

                # use Givens rotations for last elements
                # rotations from left
                j = ilast - 1
                c, s, r = givensAlgorithm(H[j, j - 1], H[j + 1, j - 1])
                H[j, j - 1] = r
                H[j + 1, j - 1] = zero(T)
                for jc in j:ilastm
                    t1 = c * H[j, jc] + s * H[j + 1, jc]
                    H[j + 1, jc] = -s * H[j, jc] + c * H[j + 1, jc]
                    H[j, jc] = t1
                    t2 = c * B[j, jc] + s * B[j + 1, jc]
                    B[j + 1, jc] = -s * B[j, jc] + c * B[j + 1, jc]
                    B[j, jc] = t2
                end
                if wantQ
                    for jr in 1:n
                        t1 = c * Q[jr, j] + s * Q[jr, j + 1]
                        Q[jr, j + 1] = -s * Q[jr, j] + c * Q[jr, j + 1]
                        Q[jr, j] = t1
                    end
                end
                # rotations from left
                c, s, r = givensAlgorithm(B[j + 1, j + 1], B[j + 1, j])
                B[j + 1, j + 1] = r
                B[j + 1, j] = zero(T)
                for jr in ifirstm:ilast
                    t1 = c * H[jr, j + 1] + s * H[jr, j]
                    H[jr, j] = -s * H[jr, j + 1] + c * H[jr, j]
                    H[jr, j + 1] = t1
                end
                for jr in ifirstm:(ilast - 1)
                    t1 = c * B[jr, j + 1] + s * B[jr, j]
                    B[jr, j] = -s * B[jr, j + 1] + c * B[jr, j]
                    B[jr, j + 1] = t1
                end
                if wantZ
                    for jr in 1:n
                        t1 = c * Z[jr, j + 1] + s * Z[jr, j]
                        Z[jr, j] = -s * Z[jr, j + 1] + c * Z[jr, j]
                        Z[jr, j + 1] = t1
                    end
                end

            end # 2x2 vs larger block branches
        end # single/double shift branches

        if it >= maxiter
            throw(UnconvergedException("iteration limit $maxiter reached"))
        end
    end # iteration loop

    # set eigenvalues for trivial leading part
    for j in 1:(ilo - 1)
        if B[j, j] < 0
            if wantSchur
                H[1:j, j] .= -H[1:j, j]
                B[1:j, j] .= -B[1:j, j]
            else
                H[j, j] = -H[j, j]
                B[j, j] = -B[j, j]
            end
            if wantZ
                Z[1:n, j] .= -Z[1:n, j]
            end
        end
        α[j] = H[j, j]
        β[j] = B[j, j]
    end

    return α, β, H, B, Q, Z
end

"""
`scale1, scale2, wr1, wr2, wi = _ggs_2x2(A,B,safemin)`

Compute eigenvalues of real generalized 2x2 problem (A - w B) with scaling to avoid
over-/underflow. Actual eigvals are `(wr1 + im * wi) / scale1` etc.
B must be upper triangular. See LAPACK dlag2 for other constraints on A,B.
"""
function _ggs_2x2(A::AbstractMatrix{T}, B, safmin) where {T <: AbstractFloat}
    # translation of LAPACK dlag2
    rtmin = sqrt(safmin)
    rtmax = one(T) / rtmin
    safmax = one(T) / safmin
    fuzzy1 = one(T) + sqrt(sqrt(eps(one(T)))) / 10

    anorm = max(abs(A[1, 1]) + abs(A[2, 1]), abs(A[1, 2]) + abs(A[2, 2]), safmin)
    ascale = one(T) / anorm
    a11 = ascale * A[1, 1]
    a12 = ascale * A[1, 2]
    a21 = ascale * A[2, 1]
    a22 = ascale * A[2, 2]

    # perturb to avoid singularity if needed
    b11 = B[1, 1]
    b12 = B[1, 2]
    b22 = B[2, 2]
    bmin = rtmin * max(abs(b11), abs(b12), abs(b22), rtmin)
    if abs(b11) < bmin
        b11 = b11 < 0 ? -bmin : bmin
    end
    if abs(b22) < bmin
        b22 = b22 < 0 ? -bmin : bmin
    end
    bnorm = max(abs(b11), abs(b12) + abs(b22), safmin)
    bsize = max(abs(b11), abs(b22))
    bscale = one(T) / bsize
    b11 *= bscale
    b12 *= bscale
    b22 *= bscale
    # use method of C van Loan for larger eigval
    binv11 = one(T) / b11
    binv22 = one(T) / b22
    s1 = a11 * binv11
    s2 = a22 * binv22
    if abs(s1) <= abs(s2)
        as12 = a12 - s1 * b12
        as22 = a22 - s1 * b22
        ss = a21 * (binv11 * binv22)
        abi22 = as22 * binv22 - ss * b12
        pp = abi22 / 2
        shift = s1
    else
        as12 = a12 - s2 * b12
        as11 = a11 - s2 * b11
        ss = a21 * (binv11 * binv22)
        abi22 = -ss * b12
        pp = (as11 * binv11 + abi22) / 2
        shift = s2
    end
    qq = ss * as12
    if abs(pp * rtmin) >= one(T)
        discr = (rtmin * pp)^2 + qq * safmin
        r = sqrt(abs(discr)) * rtmax
    else
        if pp^2 + abs(qq) <= safmin
            discr = (rtmax * pp)^2 + qq * safmax
            r = sqrt(abs(discr)) * rtmin
        else
            discr = pp^2 + qq
            r = sqrt(abs(discr))
        end
    end
    if discr >= 0 || r == 0
        sm = pp + (pp < 0 ? -r : r)
        df = pp - (pp < 0 ? -r : r)
        wbig = shift + sm
        wsmall = shift + df
        if abs(wbig) / 2 > max(abs(wsmall), safmin)
            wdet = (a11 * a22 - a12 * a21) * (binv11 * binv22)
            wsmall = wdet / wbig
        end
        if pp > abi22
            wr1 = min(wbig, wsmall)
            wr2 = max(wbig, wsmall)
        else
            wr2 = min(wbig, wsmall)
            wr1 = max(wbig, wsmall)
        end
        wi = zero(T)
    else
        # complex
        wr1 = shift + pp
        wr2 = wr1
        wi = r
    end

    # final scaling
    c1 = bsize * (safmin * max(one(T), ascale))
    c2 = safmin * max(one(T), bnorm)
    c3 = bsize * safmin
    if (ascale <= one(T)) && (bsize <= one(T))
        c4 = min(one(T), (ascale / safmin) * bsize)
    else
        c4 = one(T)
    end
    if (ascale <= one(T)) || (bsize <= one(T))
        c5 = min(one(T), ascale * bsize)
    else
        c5 = one(T)
    end
    wabs = abs(wr1) + abs(wi)
    wsize = max(safmin, c1, fuzzy1 * (wabs * c2 + c3), min(c4, max(wabs, c5) / 2))
    if wsize != one(T)
        wscale = one(T) / wsize
        if wsize > one(T)
            scale1 = (max(ascale, bsize) * wscale) * min(ascale, bsize)
        else
            scale1 = (min(ascale, bsize) * wscale) * max(ascale, bsize)
        end
        wr1 *= wscale
        if wi != zero(T)
            wi *= wscale
            wr2 = wr1
            scale2 = scale1
        end
    else
        scale1 = ascale * bsize
        scale2 = scale1
    end
    if wi == 0
        wsize = max(safmin, c1, fuzzy1 * (abs(wr2) * c2 + c3), min(c4, max(abs(wr2), c5) / 2))
        if wsize != one(T)
            wscale = one(T) / wsize
            if wsize > one(T)
                scale2 = (max(ascale, bsize) * wscale) * min(ascale, bsize)
            else
                scale2 = (min(ascale, bsize) * wscale) * max(ascale, bsize)
            end
            wr2 *= wscale
        else
            scale2 = ascale * bsize
        end
    end
    return scale1, scale2, wr1, wr2, wi
end

# SVD of real upper triangular 2x2 matrix
# translation of LAPACK dlasv2
function _gsvd_2x2(A::AbstractMatrix{T}) where {T <: AbstractFloat}
    ft = A[1, 1]
    gt = A[1, 2]
    ht = A[2, 2]
    fa = abs(ft)
    ha = abs(ht)
    pmax = 1
    swap = ha > fa
    if swap
        pmax = 3
        ft, ht = ht, ft
        fa, ha = ha, fa
    end
    ga = abs(gt)

    if ga == 0
        # diagonal matrix
        ssmin = ha
        ssmax = fa
        clt = one(T)
        crt = one(T)
        slt = zero(T)
        srt = zero(T)
    else
        ga_small = true
        if ga > fa
            pmax = 2
            if (fa / ga) < eps(one(T))
                # very large ga
                ga_small = false
                ssmax = ga
                ssmin = (ha > one(T)) ? (fa / (ga / ha)) : ((fa / ha) * ha)
                clt = one(T)
                slt = ht / gt
                srt = one(T)
                crt = ft / gt
            end
        end
        if ga_small
            # normal case
            d = fa - ha
            # handle infinite ft or ht
            l = (d == fa) ? one(T) : (d / fa)
            m = gt / ft
            t = 2 - l
            # note that 0 ≤ l ≤ 1 and abs(m) ≤ 1/ϵ
            mm = m * m
            tt = t * t
            s = sqrt(tt + mm)
            r = (l == 0) ? abs(m) : sqrt(l * l + mm)
            a = (s + r) / 2
            # note that 1 ≤ s ≤ 1 + 1/ϵ and 0 ≤ r ≤ 1 + 1/ϵ and a ≤ 1 + abs(m)
            ssmin = ha / a
            ssmax = fa * a
            if mm == 0
                # very tiny m
                if l == 0
                    t = copysign(T(2), ft) * copysign(one(T), gt)
                else
                    t = gt / copysign(d, ft) + m / t
                end
            else
                t = (m / (s + t) + m / (r + l)) * (one(T) + a)
            end
            l = sqrt(t * t + T(4))
            crt = T(2) / l
            srt = t / l
            clt = (crt + srt * m) / a
            slt = (ht / ft) * srt / a
        end
    end
    if swap
        csl, snl = srt, crt
        csr, snr = slt, clt
    else
        csl, snl = clt, slt
        csr, snr = crt, srt
    end
    if pmax == 1
        tsgn = copysign(one(T), csr) * copysign(one(T), csl) * copysign(one(T), A[1, 1])
    elseif pmax == 2
        tsgn = copysign(one(T), snr) * copysign(one(T), csl) * copysign(one(T), A[1, 2])
    else # pmax == 3
        tsgn = copysign(one(T), snr) * copysign(one(T), snl) * copysign(one(T), A[2, 2])
    end
    ssmax = copysign(ssmax, tsgn)
    ssmin = copysign(ssmin, tsgn * copysign(one(T), A[1, 1]) * copysign(one(T), A[2, 2]))
    return ssmin, ssmax, snr, csr, snl, csl
end

# Pirated methods
# This is the main public interface of the package for most users.
# Non-mutating Wrappers like `schur` and `eigvals` should just work.

# Some other stdlib functions (e.g., lmul!) are extended, but either non-piratically
# or with explicit qualification.

function LinearAlgebra.schur!(A::StridedMatrix{T}; kwargs...) where {T <: STypes}
    return gschur!(A; kwargs...)
end
function LinearAlgebra.schur!(
        A::StridedMatrix{T}, B::StridedMatrix{T}; kwargs...
    ) where {T <: STypes}
    return ggschur!(A, B; kwargs...)
end

function LinearAlgebra.eigvals!(
        A::StridedMatrix{T};
        sortby::Union{Function, Nothing} = eigsortby, kwargs...
    ) where {T <: STypes}
    S = gschur!(A; wantZ = false, kwargs...)
    if sortby !== nothing
        return sorteig!(S.values, sortby)
    else
        return S.values
    end
end

"""
    eigvecs(S::Schur; left=false) -> Matrix
    eigvecs(S::GeneralizedSchur; left=false) -> Matrix

Compute right or left eigenvectors from a Schur decomposition.
Eigenvectors are returned as columns of a matrix, ordered to match `S.values`.

For standard Schur, the returned eigenvectors have unit Euclidean norm, and the largest
elements are real.

For generalized Schur, each vector is scaled so the largest element `vⱼ`
satisfies `abs(real(vⱼ)) + abs(imag(vⱼ)) = 1` (a convention from LAPACK).
"""
function LinearAlgebra.eigvecs(
        S::Schur{Complex{T}}; left::Bool = false
    ) where {T <: AbstractFloat}
    if left
        v = _gleigvecs!(S.T, S.Z)
    else
        v = _geigvecs!(S.T, S.Z)
    end
    _enormalize!(v)
    return v
end

function LinearAlgebra.eigvecs(
        S::GeneralizedSchur{T}; left::Bool = false
    ) where {T <: STypes}
    if left
        v = _gleigvecs(S.S, S.T, S.Q)
    else
        v = _geigvecs(S.S, S.T, S.Z)
    end
    # CHECKME: Euclidean norm differs from LAPACK, so wait for upstream.
    # _enormalize!(v)
    return v
end

function LinearAlgebra.eigen!(
        A::StridedMatrix{T}; permute::Bool = true, scale::Bool = true,
        sortby::Union{Function, Nothing} = eigsortby, kwargs...
    ) where {T <: STypes}
    n = checksquare(A)
    if permute || scale
        A, B = balance!(A, scale = scale, permute = permute)
    end
    if T <: Real
        S = triangularize(schur(A))
        VT = Complex{T}
    else
        S = schur(A)
        VT = T
    end
    if isempty(kwargs)
        v = _geigvecs!(S.T, S.Z)
        if permute || scale
            lmul!(B, v)
        end
        _enormalize!(v)
        if sortby !== nothing
            return LinearAlgebra.Eigen(sorteig!(S.values, v, sortby)...)
        else
            return LinearAlgebra.Eigen(S.values, v)
        end
    end

    # recip. cond. nr. needs both sets of eigvecs
    # but compute it for BALANCED forms for consistency
    do_vr = get(kwargs, :jvr, true) || get(kwargs, :jce, false)
    if do_vr
        v = _geigvecs!(S.T, S.Z)
    else
        v = zeros(VT, 0, 0)
    end
    do_vl = get(kwargs, :jvl, false) || get(kwargs, :jce, false)
    if do_vl
        vl = _gleigvecs!(S.T, S.Z)
    else
        vl = zeros(VT, 0, 0)
    end

    do_econd = get(kwargs, :jce, false)
    rconde = zeros(real(T), do_econd ? n : 0)
    if do_econd
        for j in 1:n
            vlj = view(vl, :, j)
            vrj = view(v, :, j)
            rconde[j] = abs(dot(vlj, vrj)) / norm(vlj) / norm(vrj)
        end
        if !get(kwargs, :jvr, true)
            v = zeros(VT, 0, 0)
        end
        if !get(kwargs, :jvl, true)
            vl = zeros(VT, 0, 0)
        end
    end

    if get(kwargs, :jvr, true)
        if permute || scale
            lmul!(B, v)
        end
        _enormalize!(v)
    end
    if get(kwargs, :jvl, true)
        if permute || scale
            ldiv!(B, vl)
        end
        _enormalize!(vl)
    end

    do_vcond = get(kwargs, :jcv, false)
    rcondv = zeros(real(T), do_vcond ? n : 0)
    if do_vcond
        # warning: this is very expensive
        Ttmp = similar(S.T)
        sel = falses(n)
        for j in 1:n
            copyto!(Ttmp, S.T)
            Stmp = Schur(Ttmp, similar(S.Z, 0, 0), copy(S.values))
            sel[j] = true
            ordschur!(Stmp, sel)
            sel[j] = false
            if do_econd
                rconde[j] = eigvalscond(Stmp, 1)
            end
            if do_vcond
                rcondv[j] = subspacesep(Stmp, 1)
            end
        end
    end
    if sortby !== nothing
        return LinearAlgebra.Eigen(sorteig!(S.values, v, sortby, vl, rconde, rcondv)...)
    else
        return LinearAlgebra.Eigen(S.values, v, vl, false, rconde, rcondv)
    end
end

# 
function LinearAlgebra.eigen!(
        A::RealHermSymComplexHerm{<:STypes, <:StridedMatrix};
        alg::Algorithm = QRIteration(),
        sortby::Union{Function, Nothing} = nothing
    )
    return geigen!(A, alg; sortby = (sortby === nothing ? identity : sortby))
end

function LinearAlgebra.eigvals!(
        A::RealHermSymComplexHerm{<:STypes, <:StridedMatrix};
        alg::Algorithm = QRIteration(),
        sortby::Union{Function, Nothing} = nothing
    )
    return geigvals!(A, alg; sortby = (sortby === nothing ? identity : sortby))
end

function LinearAlgebra.eigen!(
        A::SymTridiagonal{<:AbstractFloat};
        alg::Algorithm = QRIteration(),
        sortby::Union{Function, Nothing} = nothing
    )
    return geigen!(A, alg; sortby = (sortby === nothing ? identity : sortby))
end

function LinearAlgebra.eigvals!(
        A::SymTridiagonal{<:AbstractFloat};
        alg::Algorithm = QRIteration(),
        kwargs...
    )
    return geigvals!(A, alg; kwargs...)
end

# Some variants should be defined here for logical coherence, but not until
# we've registered nontrivial implementations.

# stdlib only provides not-in-place wrappers for Ty <: BlasFloat
# We are only claiming extension to STypes here
function LinearAlgebra._ordschur(
        T::StridedMatrix{Ty},
        Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector}
    ) where {Ty <: STypes}
    return LinearAlgebra._ordschur!(copy(T), copy(Z), select)
end

function LinearAlgebra._ordschur(
        S::StridedMatrix{Ty}, T::StridedMatrix{Ty},
        Q::StridedMatrix{Ty}, Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector}
    ) where {Ty <: STypes}
    return LinearAlgebra._ordschur!(copy(S), copy(T), copy(Q), copy(Z), select)
end

function LinearAlgebra._ordschur!(
        T::StridedMatrix{Ty},
        Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector}
    ) where {Ty <: STypes}
    return gordschur!(T, Z, select)
end

function LinearAlgebra._ordschur!(
        S::StridedMatrix{Ty}, T::StridedMatrix{Ty},
        Q::StridedMatrix{Ty}, Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector}
    ) where {Ty <: STypes}
    return gordschur!(S, T, Q, Z, select)
end

# CHECKME: is there a good reason to include these?
LinearAlgebra.hessenberg!(A::StridedMatrix{<:STypes}) = _hessenberg!(A)

using LinearAlgebra: RealHermSymComplexHerm
# this should be S <: StridedMatrix, but for stdlib foolishness
function LinearAlgebra.hessenberg!(Ah::RealHermSymComplexHerm{<:STypes, <:AbstractMatrix})
    return _hehessenberg!(Hermitian(Ah), Val(Symbol(Ah.uplo)))
end

using Documenter, GenericSchur, LinearAlgebra

makedocs(
    modules = [GenericSchur],
    sitename = "GenericSchur.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://RalphAS.github.io/GenericSchur.jl",
        assets=String[],
    ),
    pages = ["Overview" => "index.md",
             "Library" => "library.md"
             ]
)

deploydocs(repo = "github.com/RalphAS/GenericSchur.jl")

# Hessenberg factorization

function _hessenberg!(A::StridedMatrix{T}) where {T}
    n = LinearAlgebra.checksquare(A)
    τ = Vector{T}(undef, n - 1)
    xwrk = Vector{T}(undef, n)
    for i in 1:(n - 1)
        xi = view(A, (i + 1):n, i)
        t = _reflector!(xi)
        H = Householder{T, typeof(xi)}(view(A, (i + 2):n, i), t)
        τ[i] = H.τ
        lmul!(H', view(A, (i + 1):n, (i + 1):n))
        # rmul!(view(A, :, i + 1:n), H)
        rmul!(view(A, :, (i + 1):n), H, xwrk)
    end
    return Hessenberg(A, τ)
end

function _hessenberg!(Ah::Union{Hermitian{T}, Symmetric{T}}) where {T <: Real}
    return _hehessenberg!(Hermitian(Ah), Val(Symbol(Ah.uplo)))
end
function _hessenberg!(Ah::Hermitian{T}) where {T <: Complex}
    return _hehessenberg!(Ah, Val(Symbol(Ah.uplo)))
end

function _hehessenberg!(Ah::Hermitian{T}, ::Val{:L}) where {T}
    # based on LAPACK zhetd2
    A = Ah.data
    n = LinearAlgebra.checksquare(A)
    τ = Vector{T}(undef, n - 1)
    d = zeros(real(T), n)
    e = zeros(real(T), n - 1)
    A[1, 1] = real(A[1, 1])
    for i in 1:(n - 1)
        # reflector to annihilate A[i+2:n,i]
        ξ = view(A, (i + 1):n, i)
        τi = _reflector!(ξ)
        e[i] = real(A[i + 1, i])
        if !iszero(τi)
            ξ[1] = one(T)
            # store x = τᵢ A ξ in tail of τ
            w = view(τ, i:(n - 1))
            mul!(w, Hermitian(view(A, (i + 1):n, (i + 1):n), :L), ξ, τi, false)
            # compute w = ξ - (τᵢ/2) (xᴴ ξ) ξ
            α = - (τi / 2) * dot(w, ξ)
            w .= w .+ α .* ξ
            # apply transformation as rank-2 update
            rank2update!(view(A, (i + 1):n, (i + 1):n), -1, ξ, w, Val(:L))
        else
            A[i + 1, i + 1] = real(A[i + 1, i + 1])
        end
        A[i + 1, i] = e[i]
        d[i] = real(A[i, i])
        τ[i] = τi
    end
    d[n] = real(A[n, n])
    return Hessenberg(A, τ, SymTridiagonal(d, e), Ah.uplo)
end

function _hehessenberg!(Ah::Hermitian{T}, ::Val{:U}) where {T}
    # based on LAPACK zhetd2
    A = Ah.data
    n = LinearAlgebra.checksquare(A)
    τ = Vector{T}(undef, n - 1)
    d = zeros(real(T), n)
    e = zeros(real(T), n - 1)
    A[n, n] = real(A[n, n])
    xi = zeros(T, n)
    for i in (n - 1):-1:1
        # reflector to annihilate A[1:i-1,i+1]
        xi[1] = A[i, i + 1]
        xi[2:i] .= A[1:(i - 1), i + 1]
        ξ = view(xi, 1:i)
        τi = _reflector!(ξ)
        e[i] = real(xi[1])
        A[1:(i - 1), i + 1] .= xi[2:i]
        if !iszero(τi)
            A[i, i + 1] = one(T)
            ξ = view(A, 1:i, i + 1)
            # store x = τᵢ A ξ in head of τ
            w = view(τ, 1:i)
            mul!(w, Hermitian(view(A, 1:i, 1:i), :U), ξ, τi, false)
            # compute w = ξ - (τᵢ/2) (xᴴ ξ) ξ
            α = - (τi / 2) * dot(w, ξ)
            w .= w .+ α .* ξ
            # apply transformation as rank-2 update
            rank2update!(view(A, 1:i, 1:i), -1, ξ, w, Val(:U))
        else
            A[i, i] = real(A[i, i])
        end
        A[i, i + 1] = e[i]
        d[i + 1] = real(A[i + 1, i + 1])
        τ[i] = τi
    end
    d[1] = real(A[1, 1])
    return Hessenberg(A, τ, SymTridiagonal(d, e), Ah.uplo)
end

function rank2update!(A::StridedMatrix, α::Number, x::AbstractVector, y::AbstractVector, ::Val{:U})
    n = length(x)
    for j in 1:n
        if iszero(x[j]) && iszero(y[j])
            A[j, j] = real(A[j, j])
        else
            t1 = α * conj(y[j])
            t2 = conj(α * x[j])
            for i in 1:(j - 1)
                A[i, j] += x[i] * t1 + y[i] * t2
            end
            A[j, j] = real(A[j, j]) + real(x[j] * t1 + y[j] * t2)
        end
    end
    return
end
function rank2update!(A::StridedMatrix, α::Number, x::AbstractVector, y::AbstractVector, ::Val{:L})
    n = length(x)
    for j in 1:n
        if iszero(x[j]) && iszero(y[j])
            A[j, j] = real(A[j, j])
        else
            t1 = α * conj(y[j])
            t2 = conj(α * x[j])
            A[j, j] = real(A[j, j]) + real(x[j] * t1 + y[j] * t2)
            for i in (j + 1):n
                A[i, j] += x[i] * t1 + y[i] * t2
            end
        end
    end
    return
end

using LinearAlgebra: QRPackedQ
function _materializeQ(H::Hessenberg{T}) where {T}
    if H.uplo == 'L'
        return _materializeQ(H, Val(:L))
    else
        return _materializeQ(H, Val(:U))
    end
end

function _materializeQ!(Q::AbstractMatrix, H::Hessenberg{T}, Zwrk) where {T}
    if H.uplo == 'L'
        return _materializeQ!(Q, H, Val(:L), Zwrk)
    else
        # return _materializeQ!(Q, H, Val(:U), Zwrk)
        throw(ArgumentError("only implemented for H.uplo='L'"))
    end
end

function _materializeQ(H::Hessenberg{T}, ::Val{:L}) where {T}
    H.uplo == 'L' || throw(ArgumentError("method is inconsistent with uplo != 'L'"))
    A = copy(H.Q.factors)
    n = checksquare(A)
    # shift reflectors one column rightwards
    @inbounds for j in n:-1:2
        A[1:(j - 1), j] .= zero(T)
        for i in (j + 1):n
            A[i, j] = A[i, j - 1]
        end
    end
    A[2:n, 1] .= zero(T)
    A[1, 1] = one(T)
    Q1 = QRPackedQ(view(A, 2:n, 2:n), H.Q.τ)
    A[2:n, 2:n] .= Matrix{T}(Q1)
    return A
end

function _materializeQ!(Q, H::Hessenberg{T}, ::Val{:L}, Atmp) where {T}
    H.uplo == 'L' || throw(ArgumentError("method is inconsistent with uplo != 'L'"))
    if Atmp != nothing
        A = Atmp
    else
        A = similar(H.Q.factors)
    end
    copyto!(A, H.Q.factors)
    n = checksquare(A)
    nq = checksquare(Q)
    nq == n || throw(ArgumentError("Q must have same size as factors in H"))
    # shift reflectors one column rightwards
    @inbounds for j in n:-1:2
        A[1:(j - 1), j] .= zero(T)
        for i in (j + 1):n
            A[i, j] = A[i, j - 1]
        end
    end
    Q[2:n, 1] .= zero(T)
    Q[1, 1] = one(T)
    Q1 = QRPackedQ(view(A, 2:n, 2:n), H.Q.τ)
    Q[2:n, 2:n] .= zero(T)
    @inbounds for j in 2:n
        Q[j, j] = one(T)
    end
    lmul!(Q1, view(Q, 2:n, 2:n))
    return Q
end

# alas, stdlib has no QLPackedQ
function _materializeQ(H::Hessenberg{T}, ::Val{:U}) where {T}
    H.uplo == 'U' || throw(ArgumentError("method is inconsistent with uplo != 'U'"))
    A = copy(H.Q.factors)
    n = checksquare(A)
    # shift reflectors one column leftwards
    @inbounds for j in 1:(n - 1)
        for i in 1:(j - 1)
            A[i, j] = A[i, j + 1]
        end
        A[j:n, j] .= zero(T)
    end
    A[1:(n - 1), n] .= zero(T)
    A[n, n] = one(T)
    w = zeros(T, n - 1)
    for i in 1:(n - 1)
        A[i, i] = one(T)
        τi = H.τ[i]
        v = view(A, 1:i, i)
        # w = A[1:i,1:i-1]' * v
        for j in 1:(i - 1)
            w[j] = dot(view(A, 1:i, j), v)
        end
        # A[1:i,1:i-1] .-= τi * v * w'
        for j in 1:(i - 1)
            t = τi * w[j]'
            for k in 1:i
                A[k, j] -= v[k] * t
            end
        end
        A[1:(i - 1), i] *= -τi
        A[i, i] = one(T) - τi
        A[(i + 1):n, i] .= zero(T)
    end
    return A
end

module GSTest
using GenericSchur
using GenericSchur: geigvecs
using Test
using Random
using LinearAlgebra
using LinearAlgebra.BLAS: BlasFloat

include("TMGlib.jl")
using .TMGlib

using Aqua

const piracy = GenericSchur._get_piracy()

_vbst = parse(Int, get(ENV, "TEST_VERBOSITY", "0"))
const verbosity = Ref(_vbst)

env_seed = parse(Int, get(ENV, "TEST_RESEED_RNG", "-1"))
if env_seed >= 0
    let seed = (env_seed > 0) ? env_seed : round(Int, 1024 * rand(RandomDevice()))
        @info "rng seed is $seed"
        Random.seed!(seed)
    end
end

include("testfuncs.jl")

@testset "real nonsymmetric EP" verbose = true include("real.jl")

@testset "complex nonsymmetric EP" verbose = true include("complex.jl")

@testset "generalized EP" verbose = true include("generalized.jl")

@testset "Hermitian EP" verbose = true include("symtridiag.jl")
@testset "balancing" verbose = true include("balance.jl")

@testset "reordering Schur" verbose = true include("ordschur.jl")
@testset "reordering generalized Schur" verbose = true include("gordschur.jl")

@testset "error handling" verbose = true include("errors.jl")

@testset "wrappers" verbose = true include("wrappers.jl")

@testset "Aqua" verbose = true Aqua.test_all(GenericSchur; piracies = !piracy)

end # module

@testset "selected errors" begin
    n = 5
    A = diagm(-1 => fill(-1.0 + 1.0im, n - 1)) + triu(rand(n, n))
    H = Hessenberg(A, zeros(n - 1))
    @test_throws ArgumentError GenericSchur.gschur!(H)

    A = triu(rand(n, n), -1)
    H = Hessenberg(A, zeros(n - 1))
    Z = rand(n - 1, n - 1)
    @test_throws DimensionMismatch GenericSchur.gschur!(H, Z)

    @test_throws DimensionMismatch GenericSchur.gschur!(rand(5, 4))
    @test_throws DimensionMismatch GenericSchur.gschur!(rand(ComplexF64, 5, 4))
end

if piracy
    # make sure our pirates aren't called for inappropriate eltypes
    @testset "letter of marque" begin
        # WARNING: These depend on absence of surprises in stdlib. Revise as needed.
        A = rand(Int, 4, 4)
        @test_throws MethodError schur!(A)
        A = rand(Int, 4, 4) + im * rand(Int, 4, 4)
        @test_throws MethodError schur!(A)
        A = rand(1:10, 4, 4) .// rand(1:10, 4, 4)
        @test_throws MethodError schur!(A)
        @test_throws MethodError hessenberg!(A)
    end
end

module TMGlib
# wrap some routines from the LAPACK test matrix generator library
export latme!, latmr!

using LinearAlgebra
using LinearAlgebra: BlasInt, checksquare
using LinearAlgebra.BLAS: @blasfunc

# CHECKME: routines linked here are included in many BLAS/LAPACK distributions
# (OpenBLAS, MKL), but do we need to allow for others?

const liblapack = Base.liblapack_name

const latm_modes = Dict(
    :specified => 0, :clustered_small => 1,
    :clustered_large => 2, :exponential => 3,
    :arithmetic => 4, :random_log => 5, :random => 6
)

function _check_iseed(iseed::Vector{T}) where {T <: Integer}
    if length(iseed) < 4
        throw(ArgumentError("iseed must have (at least) 4 elements"))
    end
    if any(iseed .< 0) || any(iseed .> 4095)
        throw(ArgumentError("iseed entries must be in 0:4095"))
    end
    isodd(iseed[4]) || throw(ArgumentError("iseed[4] must be odd"))
    return nothing
end

"""
construct a random non-symmetric square matrix with specified eigenvalues

`latme!(A::Matrix{<:BlasFloat}, anorm::Real, imode::Int, rcond::Real,
simrcond::Real = 1.0;
iseed::Vector{BlasInt} = [2518, 3899, 995, 397],
kl::Int = size(A,2), ku::Int = size(A,2),
dist::AbstractChar = 'D', rsign::Bool = true,
upper::Bool = true, simtrans::Bool = true,
simmode::Int = 4, d::Vector, ds::Vector)`

- `imode`: 1 - clustered small, 2 - clustered large, 3 - exponential,
     4 - arithmetic, 5 - random log, 6 - random (<0 for reversed order),
     0 - eigenvalues explicitly specified in `d`.
- `rcond`: ratio of extreme eigenvalue magnitudes.
- `anorm`: if positive, finally scale the matrix so its maximum-element-norm is `anorm`.
- `kl,ku`: lower and upper bandwidths
- If `upper`, fill the upper triangle (make result non-normal).
- If `rsign`, eigenvalues have random signs (real) or angles (complex).
- If `simtrans`, apply a similarity transform with singular values
      specified by `simmode, simrcond, ds`, similarly to `imode, rcond, d`.

- `dist`: character key for distribution to be sampled: `'U'` - uniform(0,1),
   `'S'` - symmetric uniform(-1,1), `'N'` - normal, `'D'` - uniform on complex unit disk.
"""
function latme! end

for (fname, elty, relty) in (
        (:zlatme_, :ComplexF64, :Float64),
        (:clatme_, :ComplexF32, :Float32),
    )
    @eval begin
        function latme!(
                A::Matrix{$elty}, anorm::Real, imode::Int, rcond::Real,
                simrcond::Real = 1.0;
                iseed::Vector{BlasInt} = BlasInt[2518, 3899, 995, 397],
                kl::Int = size(A, 2), ku::Int = size(A, 2),
                dist::AbstractChar = 'D', rsign::Bool = true,
                upper::Bool = true, simtrans::Bool = true,
                simmode::Int = 4,
                dmax::$elty = one($elty),
                d::Vector{$elty} = Vector{$elty}(undef, size(A, 2)),
                ds::Vector{$relty} = Vector{$relty}(undef, size(A, 2))
            )
            n = size(A, 2)
            lda = size(A, 1)

            if imode == 0
                (length(d) == n) || throw(ArgumentError("imode = 0 needs explicit d of length n"))
                if simtrans
                    (length(ds) == n) || throw(ArgumentError("imode = 0 needs explicit ds of length n"))
                end
            end
            (dist ∈ ['D', 'U', 'S', 'N']) || throw(ArgumentError("allowed values of dist are 'D','U','S', and 'N'"))

            _check_iseed(iseed)
            work = Vector{$elty}(undef, 3 * n)
            info = Ref{BlasInt}(0)

            ccall(
                (@blasfunc($fname), liblapack), Cvoid,
                (
                    Ref{BlasInt}, # n
                    Ref{UInt8}, # dist
                    Ptr{BlasInt}, # iseed
                    Ptr{$elty}, # d(w)
                    Ref{BlasInt}, # mode
                    Ref{$relty}, # cond
                    Ref{$elty}, # dmax
                    Ref{UInt8}, # rsign
                    Ref{UInt8}, # upper
                    Ref{UInt8}, # sim
                    Ptr{$relty}, # ds(w)
                    Ref{BlasInt}, # modes
                    Ref{$relty}, # conds
                    Ref{BlasInt}, # kl
                    Ref{BlasInt}, # ku
                    Ref{$relty}, # anorm
                    Ptr{$elty}, # A
                    Ref{BlasInt}, # lda
                    Ptr{$elty}, # work(w)
                    Ptr{BlasInt}, # info(w)
                    Clong, Clong, Clong, Clong, # char lengths
                ),
                n, dist, iseed, d, imode, rcond, dmax,
                rsign ? 'T' : 'F', upper ? 'T' : 'F', simtrans ? 'T' : 'F',
                ds, simmode, simrcond, kl, ku, anorm, A, lda, work, info, 1, 1, 1, 1
            )
            (info[] == 0) || error("info = $(info[]) from latme!")
            return A, d, ds, iseed
        end
    end
end

# Note LAPACK routine has different arg list for the real versions:
for (fname, celty, elty) in (
        (:dlatme_, :ComplexF64, :Float64),
        (:slatme_, :ComplexF32, :Float32),
    )
    @eval begin
        function latme!(
                A::Matrix{$elty}, anorm::Real, imode::Int, rcond::Real,
                simrcond::Real = 1.0;
                iseed::Vector{BlasInt} = BlasInt[2518, 3899, 995, 397],
                kl::Int = size(A, 2), ku::Int = size(A, 2),
                dist::AbstractChar = 'S', rsign::Bool = true,
                upper::Bool = true, simtrans::Bool = true,
                simmode::Int = 4,
                dmax::$elty = one($elty),
                d = nothing,
                ds::Vector{$elty} = Vector{$elty}(undef, size(A, 2))
            )
            n = size(A, 2)
            lda = size(A, 1)

            d1 = Vector{$elty}(undef, size(A, 2))

            if imode == 0
                (d isa Vector) || throw(ArgumentError("imode = 0 needs vector d"))
                (length(d) == n) || throw(ArgumentError("imode = 0 needs explicit d of length n"))
                if simtrans
                    (length(ds) == n) || throw(ArgumentError("imode = 0 needs explicit ds of length n"))
                end
            end
            (dist ∈ ['U', 'S', 'N']) || throw(ArgumentError("allowed values of dist are 'U','S', and 'N'"))

            _check_iseed(iseed)
            work = Vector{$elty}(undef, 3 * n)
            info = Ref{BlasInt}(0)

            # if specifying eigenvalues
            #           EI is CHARACTER*1 array, dimension ( N )
            #            If MODE is 0, and EI(1) is not ' ' (space character),
            #            this array specifies which elements of D (on input) are
            #            real eigenvalues and which are the real and imaginary parts
            #            of a complex conjugate pair of eigenvalues.  The elements
            #            of EI may then only have the values 'R' and 'I'.  If
            #            EI(j)='R' and EI(j+1)='I', then the j-th eigenvalue is
            #            CMPLX( D(j) , D(j+1) ), and the (j+1)-th is the complex
            #            conjugate thereof.  If EI(j)=EI(j+1)='R', then the j-th
            #            eigenvalue is D(j) (i.e., real).  EI(1) may not be 'I',
            #            nor may two adjacent elements of EI both have the value 'I'.
            #            If MODE is not 0, then EI is ignored.  If MODE is 0 and
            #            EI(1)=' ', then the eigenvalues will all be real.

            if imode == 0
                if eltype(d) <: Real
                    ei = UInt8[' ']
                    d1 .= d[1:n]
                else
                    ei = Vector{UInt8}(undef, n)
                    ie = 1
                    id = 1
                    while id <= n
                        ei[ie] = 'R'
                        d1[ie] = real(d[id])
                        ie += 1
                        if imag(d[id]) != 0
                            if d[id + 1] != conj(d[id])
                                throw(ArgumentError("conjugate pairs in d must be adjacent"))
                            end
                            ei[ie] = 'I'
                            d1[ie] = imag(d[id])
                            ie += 1
                            id += 1
                        end
                        id += 1
                    end
                end
            else
                ei = UInt8[' ']
            end

            ccall(
                (@blasfunc($fname), liblapack), Cvoid,
                (
                    Ref{BlasInt}, # n
                    Ref{UInt8}, # dist
                    Ptr{BlasInt}, # iseed
                    Ptr{$elty}, # d(w)
                    Ref{BlasInt}, # mode
                    Ref{$elty}, # cond
                    Ref{$elty}, # dmax
                    Ref{UInt8}, # ei
                    Ref{UInt8}, # rsign
                    Ref{UInt8}, # upper
                    Ref{UInt8}, # sim
                    Ptr{$elty}, # ds(w)
                    Ref{BlasInt}, # modes
                    Ref{$elty}, # conds
                    Ref{BlasInt}, # kl
                    Ref{BlasInt}, # ku
                    Ref{$elty}, # anorm
                    Ptr{$elty}, # A
                    Ref{BlasInt}, # lda
                    Ptr{$elty}, # work(w)
                    Ptr{BlasInt}, # info(w)
                    Clong, Clong, Clong, Clong, Clong, # char lengths
                ),
                n, dist, iseed, d1, imode, rcond, dmax, ei,
                rsign ? 'T' : 'F', upper ? 'T' : 'F', simtrans ? 'T' : 'F',
                ds, simmode, simrcond, kl, ku, anorm, A, lda, work, info,
                1, 1, 1, 1, 1
            )
            (info[] == 0) || error("info = $(info[]) from latme!")
            return A, d1, ds, iseed
        end
    end
end

"""
construct a random matrix of various types

latmr!(A::Matrix{T<:BLAStype}, anorm::Real, imode::Int, rcond::Real,
                rcondr::Real = 1.0, rcondl::Real = 1.0;
                sym::AbstractChar = 'N',
                iseed::Vector{BlasInt} = [2518, 3899, 995, 397],
                kl::Int = size(A,2), ku::Int = size(A,2),
                dist::AbstractChar = 'D', rsign::Bool = true,
                grade::AbstractChar = 'N', model::Int = 4, moder::Int = 4,
                pivtng::AbstractChar = 'N', ipivot::Vector{BlasInt} = BlasInt[],
                sparse::Real = 0.0,
                pack::AbstractChar = 'N',
                d::Vector, dl::Vector, dr::Vector
                )

- `imode`: 1 - clustered small, 2 - clustered large, 3 - exponential,
       4 - arithmetic, 5 - random log, 6 - random (<0 for reversed order),
       0 - eigenvalues explicitly specified in `d`.
- `sym`: `'S'` - symmetric, `'H'` - Hermitian, `'N'` - nonsymmetric
- `rcond`: ratio of extreme diagonal elements
- `kl,ku`: lower and upper bandwidths
- `sparse`: fraction to be nulled out
- `dist`: character key for distribution to be sampled: `'U'` - uniform(0,1),
   `'S'` - symmetric uniform(-1,1), `'N'` - normal, `'D'` - uniform on complex unit disk.
- `grade`: `'N'` - do not grade, otherwise a key for pre/postmultiplication with
      `Diagonal(dl), Diagonal(dr)`.
"""
function latmr! end

for (fname, elty, relty) in (
        (:zlatmr_, :ComplexF64, :Float64),
        (:clatmr_, :ComplexF32, :Float32),
        (:dlatmr_, :Float64, :Float64),
        (:slatmr_, :Float32, :Float32),
    )
    @eval begin
        function latmr!(
                A::Matrix{$elty}, anorm::Real, imode::Int, rcond::Real,
                rcondr::Real = 1.0, rcondl::Real = 1.0;
                sym::AbstractChar = 'N',
                iseed::Vector{BlasInt} = BlasInt[2518, 3899, 995, 397],
                kl::Int = size(A, 2), ku::Int = size(A, 2),
                dist::AbstractChar = $elty <: Complex ? 'D' : 'S',
                rsign::Bool = true,
                grade::AbstractChar = 'N', mode_l::Int = 1, mode_r::Int = 1,
                pivtng::AbstractChar = 'N',
                ipivot::Vector{BlasInt} = Vector{BlasInt}(undef, size(A, 2)),
                sparse::Real = 0.0,
                pack::AbstractChar = 'N',
                dmax = one($elty),
                d = Vector{$elty}(undef, size(A, 2)),
                dl = Vector{$relty}(undef, size(A, 2)),
                dr = Vector{$relty}(undef, size(A, 2))
            )
            n = size(A, 2)
            lda = size(A, 1)
            m = lda # CHECKME: is it worth generalizing?

            _check_iseed(iseed)

            iwork = Vector{BlasInt}(undef, max(m, n))
            info = Ref{BlasInt}(0)

            #=
            println("zlatmr arg list:")
            println(
                  " m $m, n $n, dist $dist, iseed $iseed, sym $sym, d $d, imode $imode, rcond $rcond, dmax $dmax,
                  rsign $(rsign ? 'T' : 'F'), grade $grade, dl $dl, mode_l $mode_l, rcondl $rcondl,
                  dr $dr, mode_r $mode_r, rcondr $rcondr, pivtng $pivtng, ipivot $ipivot,
                  kl $kl, ku $ku, sparse $sparse, anorm $anorm, pack $pack, A, lda $lda")
=#
            ccall(
                (@blasfunc($fname), liblapack), Cvoid,
                (
                    Ref{BlasInt}, # m
                    Ref{BlasInt}, # n
                    Ref{UInt8}, # dist
                    Ptr{BlasInt}, # iseed
                    Ref{UInt8}, # sym
                    Ptr{$elty}, # d(w)
                    Ref{BlasInt}, # mode
                    Ref{$relty}, # cond
                    Ref{$elty}, # dmax
                    Ref{UInt8}, # rsign
                    Ref{UInt8}, # grade
                    Ptr{$relty}, # dl(w)
                    Ref{BlasInt}, # mode_l
                    Ref{$relty}, # condl
                    Ptr{$relty}, # dr(w)
                    Ref{BlasInt}, # mode_r
                    Ref{$relty}, # condr
                    Ref{UInt8}, # pivtng
                    Ptr{BlasInt}, # ipivot
                    Ref{BlasInt}, # kl
                    Ref{BlasInt}, # ku
                    Ref{$relty}, # sparse
                    Ref{$relty}, # anorm
                    Ref{UInt8}, # pack
                    Ptr{$elty}, # A
                    Ref{BlasInt}, # lda
                    Ptr{BlasInt}, # iwork(w)
                    Ptr{BlasInt}, # info(w)
                    Clong, Clong, Clong, Clong, Clong, Clong,
                ),
                m, n, dist, iseed, sym, d, imode, rcond, dmax,
                rsign ? 'T' : 'F', grade, dl, mode_l, rcondl,
                dr, mode_r, rcondr, pivtng, ipivot,
                kl, ku, sparse, anorm, pack, A, lda, iwork, info,
                1, 1, 1, 1, 1, 1
            )
            (info[] == 0) || error("info = $(info[]) from latmr")
            return A, d, dl, dr, iseed
        end
    end
end

"""
construct sets of matrices satisfying a generalized Sylvester system

`A R - L B = C; D R - L E = F`

and diagonalization conditions.
"""
function latm5! end

for (fname, elty, relty) in (
        (:zlatm5_, :ComplexF64, :Float64),
        (:clatm5_, :ComplexF32, :Float32),
        (:dlatm5_, :Float64, :Float64),
        (:slatm5_, :Float32, :Float32),
    )
    @eval begin
        function latm5!(
                prtype::Integer, A::StridedArray{$elty}, B::StridedArray{$elty},
                C::StridedArray{$elty}, D::StridedArray{$elty}, E::StridedArray{$elty},
                F::StridedArray{$elty}, R::StridedArray{$elty}, L::StridedArray{$elty},
                alpha, qblocka, qblockb
            )
            m = checksquare(A)
            lda = m
            n = checksquare(B)
            ldb = n
            # FIXME: ensure D is mxm, E is nxn; C,F,R,L are mxn
            ldd, dle = m, n
            ldc, ldf, ldr, ldl = m, m, m, m
            return ccall(
                (@blasfunc($fname), liblapack), Cvoid,
                (
                    Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                    Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                    Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                    Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                    Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                    Ref{$relty}, Ref{BlasInt}, Ref{BlasInt},
                ),
                prtype, m, n,
                A, max(1, stride(A, 2)), B, max(1, stride(B, 2)),
                C, max(1, stride(C, 2)), D, max(1, stride(D, 2)),
                E, max(1, stride(E, 2)), F, max(1, stride(F, 2)),
                R, max(1, stride(R, 2)), L, max(1, stride(L, 2)),
                alpha, qblocka, qblockb
            )
        end
    end
end

end # module

module GenericSchur

# These are introduced here.
export balance!, eigvalscond, subspacesep, triangularize

VERSION >= v"1.11.0-DEV.469" && eval(
    Meta.parse(
        """
        public
        gschur!,
        ggschur!,
        geigen!,
        geigvals!,
        gordschur!,
        geigvecs,
        set_piracy!,
        UnconvergedException,
        IllConditionException,
        Balancer
        """
    )
)

const STypes = Union{AbstractFloat, Complex{T} where {T <: AbstractFloat}}

using LinearAlgebra
using LinearAlgebra: checksquare, eigsortby, givensAlgorithm, sorteig!
using LinearAlgebra: Algorithm, Givens, QRIteration, RealHermSymComplexHerm
using Printf

using Base: require_one_based_indexing

"""
    UnconvergedException

Exception thrown when an iterative algorithm does not converge within the allowed
number of steps.
"""
struct UnconvergedException <: Exception
    msg::String
end
function Base.showerror(io::IO, e::UnconvergedException)
    print(io, "Convergence failure; $(e.msg)")
    return
end

"""
    IllConditionException

Exception thrown when argument matrix or matrices are too ill-conditioned
for the requested operation. The `index` field may indicate the block
where near-singularity was detected.
"""
struct IllConditionException <: Exception
    index::Int
end

@static if VERSION >= v"1.6"
    using Preferences
end

# use explicit UUIDs in Preferences calls to placate JETLS
using UUIDs: UUID

# In order to make the API consistent over versions,
# we define these even when they are no-ops.
@static if VERSION >= v"1.6"
    function _get_piracy()
        _piracy_s = load_preference(
            UUID("c145ed77-6b09-5dd9-b285-bf645a82121e"),
            "piracy", "true"
        )
        if _piracy_s == "true"
            _piracy = true
        elseif _piracy_s == "false"
            _piracy = false
        else
            @error("Invalid piracy preference; must be \"true\" or \"false\"")
            _piracy = true
        end
        return _piracy
    end
else
    _get_piracy() = true
end

const piracy = _get_piracy()

"""
    set_piracy!(::Bool)

Convenience wrapper for determining whether piratical `LinearAlgebra` methods will
be implemented by `GenericSchur` for future Julia sessions. Uses `Preferences`.
"""
function set_piracy!(v::Bool)
    @static if VERSION >= v"1.6"
        p = _get_piracy()
        set_preferences!(
            UUID("c145ed77-6b09-5dd9-b285-bf645a82121e"),
            "piracy" => v ? "true" : "false"
        )
        if v != p
            @info("Piracy setting changed; restart Julia for this to take effect!")
        end
    else
        v || @error("piracy is obligatory for Julia versions < v1.6")
    end
    return nothing
end

if piracy
    include("pirates.jl")
end

############################################################################
# Internal implementations follow

"""
geigen!(A, alg=QRIteration(); sortby=eigsortby) -> E::Eigen

Computes the eigen-decomposition of a Hermitian (or real symmetric) matrix `A`
using a generic implementation.
Currently `alg` may be `QRIteration()` or `DivideAndConquer()`.
Otherwise, similar to `LinearAlgebra.eigen!`.
"""
function geigen!(
        A::RealHermSymComplexHerm{<:STypes, <:StridedMatrix},
        alg::Algorithm = QRIteration();
        sortby::Union{Function, Nothing} = eigsortby
    )
    H = hessenberg!(A)
    V = _materializeQ(H)
    S = gschur!(H, V, alg)
    λ = S.values
    return LinearAlgebra.Eigen(sorteig!(λ, V, sortby)...)
end

function geigvals!(
        A::RealHermSymComplexHerm{<:STypes, <:StridedMatrix},
        alg::Algorithm = QRIteration();
        sortby::Union{Function, Nothing} = eigsortby
    )
    H = hessenberg!(A)
    S = gschur!(H, nothing, alg)
    λ = S.values
    return sorteig!(λ, sortby)
end

# fallback methods; only some algorithms have selection capability

function geigen!(
        A::RealHermSymComplexHerm{<:STypes, <:StridedMatrix},
        irange::UnitRange,
        alg::Algorithm = QRIteration(); kwargs...
    )
    throw(ArgumentError("eigenvalue selection is not implemented for $alg"))
end
function geigen!(
        A::RealHermSymComplexHerm{<:STypes, <:StridedMatrix},
        vl::Real, vu::Real,
        alg::Algorithm = QRIteration(); kwargs...
    )
    throw(ArgumentError("eigenvalue selection is not implemented for $alg"))
end

# debugging stuff
macro mydebug(expr)
    return nothing
end

function _fmt_nr(z::Complex)
    s = @sprintf("%10.3e%+10.3eim", reim(z)...)
    return s
end
function _fmt_nr(x::Real)
    s = @sprintf("%10.3e", x)
    return s
end

include("util.jl")
include("hessenberg.jl")

_getdata(H::Hessenberg) = H.H.data

include("householder.jl")
include("balance.jl")

# portions translated from LAPACK::zlahqr
# LAPACK Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.
function gschur!(
        H::Hessenberg{Complex{RT}}, Z = nothing;
        maxiter = 100 * size(H, 1), maxinner = 30 * size(H, 1),
        checksd = true, kwargs...
    ) where {RT <: AbstractFloat}
    T = Complex{RT}
    n = size(H, 1)
    istart = 1
    iend = n
    w = Vector{T}(undef, n)
    HH = _getdata(H)

    if checksd
        for j in 1:(n - 1)
            isreal(HH[j + 1, j]) || throw(ArgumentError("algorithm assumes real subdiagonal"))
        end
    end

    ulp = eps(RT)
    smallnum = safemin(RT) * (n / ulp)
    rzero = zero(RT)
    half = 1 / RT(2)
    threeq = 3 / RT(4)
    v2 = zeros(T, 2)

    for j in 1:(n - 1)
        HH[(j + 2):n, j] .= zero(T)
    end

    # iteration count
    it = 0

    @inbounds while iend >= 1
        # key for comparison to zlahqr:
        # I => iend
        # L => istart
        # K => _istart + 1
        istart = 1
        for its in 0:maxinner
            it += 1
            if it > maxiter
                throw(UnconvergedException("iteration limit $maxiter reached"))
            end

            # Determine if the matrix splits.
            # Find lowest positioned subdiagonal "zero" if any; reset istart if found.
            for _istart in (iend - 1):-1:istart
                if abs1(HH[_istart + 1, _istart]) <= smallnum
                    istart = _istart + 1
                    @mydebug println(
                        "Split1! at istart = $istart, subdiag is ",
                        _fmt_nr(HH[istart, istart - 1])
                    )
                    break
                end
                # deflation criterion from Ahues & Tisseur (LAWN 122, 1997)
                tst = abs1(HH[_istart, _istart]) + abs1(HH[_istart + 1, _istart + 1])
                if tst == 0
                    if (_istart - 1 >= 1)
                        tst += abs(real(HH[_istart, _istart - 1]))
                    end
                    if (_istart + 2 <= n)
                        tst += abs(real(HH[_istart + 2, _istart + 1]))
                    end
                end
                if abs(real(HH[_istart + 1, _istart])) <= ulp * tst
                    ab = max(
                        abs1(HH[_istart + 1, _istart]),
                        abs1(HH[_istart, _istart + 1])
                    )
                    ba = min(
                        abs1(HH[_istart + 1, _istart]),
                        abs1(HH[_istart, _istart + 1])
                    )
                    aa = max(
                        abs1(HH[_istart + 1, _istart + 1]),
                        abs1(HH[_istart, _istart] - HH[_istart + 1, _istart + 1])
                    )
                    bb = min(
                        abs1(HH[_istart + 1, _istart + 1]),
                        abs1(HH[_istart, _istart] - HH[_istart + 1, _istart + 1])
                    )
                    s = aa + ab
                    if ba * (ab / s) <= max(smallnum, ulp * (bb * (aa / s)))
                        istart = _istart + 1
                        @mydebug println(
                            "Split2! at istart = $istart, subdiag is ",
                            _fmt_nr(HH[istart, istart - 1])
                        )
                        break
                    end
                end
            end # check for split

            if istart > 1
                # clean up
                HH[istart, istart - 1] = zero(T)
            end

            # if block size is one we deflate
            if istart >= iend
                iend -= 1
                @mydebug println("Bottom deflation! Block size is one. New iend is $iend")
                break # from "inner" loop
            end

            # select shift
            # exceptional shift logic adapted from LAPACK zlahqr
            if its % 30 == 10
                s = threeq * abs(real(HH[istart + 1, istart]))
                t = s + HH[istart, istart]
            elseif its % 30 == 20
                s = threeq * abs(real(HH[iend, iend - 1]))
                t = s + HH[iend, iend]
            else
                # Wilkinson's shift
                t = HH[iend, iend]
                u = sqrt(HH[iend - 1, iend]) * sqrt(HH[iend, iend - 1])
                s = abs1(u)
                if s ≠ rzero
                    x = half * (HH[iend - 1, iend - 1] - t)
                    sx = abs1(x)
                    s = max(s, abs1(x))
                    y = s * sqrt((x / s)^2 + (u / s)^2)
                    if sx > rzero
                        if real(x / sx) * real(y) + imag(x / sx) * imag(y) < rzero
                            y = -y
                        end
                    end
                    t -= u * (u / (x + y))
                end
            end # shift selection

            # run a QR iteration
            # following zlahqr, only use single-shift
            singleShiftQR!(HH, Z, t, istart, iend, v2)

        end # inner loop
    end # outer loop
    w = diag(HH)
    return Schur(triu(HH), Z === nothing ? Matrix{T}(undef, 0, 0) : Z, w)
end

"""
gschur(A::StridedMatrix) -> F::Schur

Computes the Schur factorization of matrix `A` using a generic implementation.
See `LinearAlgebra.schur` for usage.
"""
gschur(A::StridedMatrix{T}; kwargs...) where {T} = gschur!(Matrix(A); kwargs...)

"""
gschur!(A::StridedMatrix) -> F::Schur

Destructive version of `gschur` (q.v.).
"""
function gschur!(
        A::StridedMatrix{Complex{T}}; wantZ::Bool = true, scale::Bool = true,
        kwargs...
    ) where {T <: AbstractFloat}
    n = checksquare(A)
    if scale
        scaleA, cscale, anrm = _scale!(A)
    else
        scaleA = false
    end
    H = _hessenberg!(A)
    if wantZ
        Z = _materializeQ(H)
        S = gschur!(H, Z; checksd = false, kwargs...)
    else
        S = gschur!(H; checksd = false, kwargs...)
    end
    if scaleA
        safescale!(S.T, cscale, anrm)
        S.values .= diag(S.T, 0)
    end
    return S
end

function singleShiftQR!(HH::StridedMatrix{T}, Z, shift::Number, istart::Integer, iend::Integer, v) where {T <: Complex}
    n = size(HH, 1)
    ulp = eps(real(eltype(HH)))

    @mydebug dcheck = DebugCompare(Z * HH * Z', "decomp error")

    # key:
    # istart => L
    # iend => I
    # istart1 => M

    # look for two consecutive small subdiagonals
    istart1 = -1
    h11s = zero(eltype(HH))
    h21 = zero(real(eltype(HH)))
    flag = false
    @inbounds for mm in (iend - 1):-1:(istart + 1)
        # determine the effect of starting the single-shift Francis
        # iteration at row mm: see if this would make HH[mm,mm-1] tiny.
        h11 = HH[mm, mm]
        h22 = HH[mm + 1, mm + 1]
        h11s = h11 - shift
        h21 = real(HH[mm + 1, mm]) # for reflector
        s = abs1(h11s) + abs(h21)
        h11s /= s
        h21 /= s
        v .= (h11s, T(h21))
        h10 = real(HH[mm, mm - 1])
        if abs(h10) * abs(h21) <= ulp * (abs1(h11s) * (abs1(h11) + abs1(h22)))
            istart1 = mm
            flag = true
            break
        end
    end
    @inbounds begin
        if !flag
            istart1 = istart
            h11 = HH[istart, istart]
            h22 = HH[istart + 1, istart + 1]
            h11s = h11 - shift
            h21 = real(HH[istart + 1, istart])
            s = abs1(h11s) + abs(h21)
            h11s /= s
            h21 /= s
            v .= (h11s, T(h21))
        end
    end
    @mydebug println(
        "QR sweep $(istart1):$(iend) shift ", _fmt_nr(shift),
        " subdiag ", _fmt_nr(HH[iend, iend - 1])
    )

    @inbounds for k in istart1:(iend - 1)
        if k > istart1
            # prepare to chase bulge
            v .= (HH[k, k - 1], HH[k + 1, k - 1])
            # else
            #    use v from above to create a bulge
        end
        τ1 = _reflector!(v)
        # τ1 = LinearAlgebra.reflector!(v)
        if k > istart1
            HH[k, k - 1] = v[1]
            HH[k + 1, k - 1] = zero(T)
        end
        v2 = v[2]
        τ2 = real(τ1 * v2)
        # lmul!(R,view(HH,:,k:n))
        for j in k:n
            ss = τ1' * HH[k, j] + τ2 * HH[k + 1, j]
            HH[k, j] -= ss
            HH[k + 1, j] -= ss * v2
        end
        # rmul!(view(HH,1:min(iend,k+2),:),R)
        for j in 1:min(k + 2, iend)
            ss = τ1 * HH[j, k] + τ2 * HH[j, k + 1]
            HH[j, k] -= ss
            HH[j, k + 1] -= ss * v2'
        end
        if !(Z === nothing)
            # rmul!(Z,R)
            for j in 1:n
                ss = τ1 * Z[j, k] + τ2 * Z[j, k + 1]
                Z[j, k] -= ss
                Z[j, k + 1] -= ss * v2'
            end
        end
        if (k == istart1) && (istart1 > istart)
            # If the QR step started at a row below istart because two consecutive
            # small subdiagonals were found, extra scaling must be performed
            # to ensure reality of HH[istart1,istart1-1]
            t = one(T) - τ1
            t /= abs(t)
            HH[istart1 + 1, istart1] *= t'
            if istart1 + 2 <= iend
                HH[istart1 + 2, istart1 + 1] *= t
            end
            for j in istart1:iend
                if j != istart1 + 1
                    if n > j
                        HH[j, (j + 1):n] *= t
                    end
                    HH[1:(j - 1), j] *= t'
                    if !(Z === nothing)
                        Z[1:n, j] *= t'
                    end
                end
            end
        end
        @mydebug dcheck(Z * HH * Z', " QR k=$k")
    end
    # ensure reality of tail
    @inbounds begin
        t = HH[iend, iend - 1]
        if imag(t) != 0
            rt = abs(t)
            HH[iend, iend - 1] = rt
            t /= rt
            if n > iend
                HH[iend, (iend + 1):n] *= t'
            end
            HH[1:(iend - 1), iend] *= t
            if !(Z === nothing)
                Z[1:n, iend] *= t
            end
        end
    end
    #    @mydebug dcheck(Z*HH*Z', " QR post")
    @mydebug println()
    return HH
end

# based on LAPACK dlahqr
"""
gschur!(H::Hessenberg, Z) -> F::Schur

Compute the Schur decomposition of a Hessenberg matrix.  Subdiagonals of `H` must be real.
If `Z` is provided, it is updated with the unitary transformations of the decomposition.
"""
function gschur!(
        H::Hessenberg{T}, Z::Union{Nothing, AbstractMatrix} = nothing;
        tol = eps(real(T)),
        maxiter = 100 * size(H, 1), standardize::Union{Nothing, Bool} = nothing,
        kwargs...
    ) where {T <: AbstractFloat}
    if !(standardize === nothing)
        @warn "obsolete keyword `standardize` in gschur!" maxlog = 1
    end
    n = size(H, 1)
    if !(Z === nothing)
        size(Z, 2) == n || throw(DimensionMismatch("second dimension of Z must match H"))
    end
    istart = 1
    iend = n
    HH = _getdata(H)
    triu!(HH, -1)
    w = Vector{Complex{T}}(undef, n)
    iwcur = n
    function putw!(w, z, iw)
        w[iw] = z
        return iw - 1
    end

    smallnum = floatmin(T) * (n / eps(T))
    threeq = 3 / T(4)
    m7_16 = -7 / T(16)
    v3 = zeros(T, 3)
    H2 = zeros(T, 2, 2)

    # iteration count
    iter = 0

    # Main loop.
    @inbounds while iend >= 1
        # eigenvalues in diagonal entries iend+1:n have converged.
        istart = 1
        iterqr = 0
        deflate = false
        while true
            iter += 1
            if iter > maxiter
                throw(UnconvergedException("iteration limit $maxiter reached"))
            end

            # istart => L
            # iend => I

            # Determine if the matrix splits.
            split = false
            for k in iend:-1:(istart + 1)
                if abs(HH[k, k - 1]) < smallnum
                    split = true
                else
                    Hkk = HH[k, k]
                    Hkm1km1 = HH[k - 1, k - 1]
                    t = abs(Hkm1km1) + abs(Hkk)
                    if t == 0
                        if k > 2
                            t += abs(HH[k - 1, k - 2])
                        end
                        if k + 1 <= n
                            t += abs(HH[k + 1, k])
                        end
                    end
                    # conservative deflation criterion from Ahues & Tisseur
                    aHkkm1 = abs(HH[k, k - 1])
                    if aHkkm1 <= t * eps(T)
                        aHkm1k = abs(HH[k - 1, k])
                        ab = max(aHkkm1, aHkm1k)
                        ba = min(aHkkm1, aHkm1k)
                        aa = max(abs(Hkk), abs(Hkm1km1 - Hkk))
                        bb = min(abs(Hkk), abs(Hkm1km1 - Hkk))
                        s = aa + bb
                        if ba * (ab / s) <= max(smallnum, eps(T) * (bb * (aa / s)))
                            split = true
                        end
                    end
                end
                if split
                    istart = k
                    @mydebug println(
                        "Split at $istart, subdiagonal element is ",
                        _fmt_nr(HH[istart, istart - 1])
                    )
                    break
                end
            end
            if !split
                istart = 1
            end
            if istart > 1
                HH[istart, istart - 1] = zero(T)
            end
            if istart >= iend - 1
                deflate = true
                break
            end

            # run a QR iteration
            iterqr += 1
            if iterqr == 10
                # exceptional shift from top
                s = abs(HH[istart + 1, istart]) + abs(HH[istart + 2, istart + 1])
                H11 = threeq * s + HH[istart, istart]
                H12 = m7_16 * s
                H21 = s
                H22 = H11
            elseif iterqr == 20
                # exceptional shift from bottom
                s = abs(HH[iend, iend - 1]) + abs(HH[iend - 1, iend - 2])
                H11 = threeq * s + HH[iend, iend]
                H12 = m7_16 * s
                H21 = s
                H22 = H11
            else
                # Francis' double shift (i.e. 2nd degree Rayleigh quotient)
                H11 = HH[iend - 1, iend - 1]
                H21 = HH[iend, iend - 1]
                H12 = HH[iend - 1, iend]
                H22 = HH[iend, iend]
            end
            s = abs(H11) + abs(H12) + abs(H21) + abs(H22)
            if s == 0
                r1r, r2r, r1i, r2i = zero(T), zero(T), zero(T), zero(T)
            else
                H11 /= s
                H12 /= s
                H21 /= s
                H22 /= s
                tr = (H11 + H22) / T(2)
                d = (H11 - tr) * (H22 - tr) - H12 * H21
                rtd = sqrt(abs(d))
                if d >= 0
                    # conjugate pair
                    r1r = tr * s
                    r2r = r1r
                    r1i = rtd * s
                    r2i = -r1i
                else
                    # duplicate real shifts
                    r1r = tr + rtd
                    r2r = tr - rtd
                    if abs(r1r - H22) <= abs(r2r - H22)
                        r1r *= s
                        r2r = r1r
                    else
                        r2r *= s
                        r1r = r2r
                    end
                    r1i, r2i = zero(T), zero(T)
                end
            end
            doubleShiftQR!(HH, Z, complex(r1r, r1i), complex(r2r, r2i), istart, iend, v3)
        end
        if deflate && (istart >= iend)
            # if block size is one we deflate
            thisw = HH[iend, iend]
            iwcur = putw!(w, thisw, iwcur)
            iend = istart - 1
            @mydebug println("Deflate one. New iend is $iend. w=", _fmt_nr(thisw))
        elseif deflate && (istart + 1 == iend)
            # and the same for a 2x2 block
            copyto!(H2, view(HH, (iend - 1):iend, (iend - 1):iend))
            G2, w1, w2 = _gs2x2!(H2, iend)
            iwcur = putw!(w, w2, iwcur)
            iwcur = putw!(w, w1, iwcur)
            lmul!(G2, view(HH, :, istart:n))
            rmul!(view(HH, 1:iend, :), G2')
            copyto!(view(HH, (iend - 1):iend, (iend - 1):iend), H2) # clean
            if iend > 2
                HH[iend - 1, iend - 2] = 0
            end
            Z === nothing || rmul!(Z, G2')
        end
        iend = istart - 1
        @mydebug begin
            println(
                "Deflate two. New iend is $iend w1=", _fmt_nr(w1),
                " w2=", _fmt_nr(w2)
            )
        end
    end

    TT = triu(HH, -1)
    return _schurtyped(TT, Z === nothing ? similar(TT, 0, 0) : Z, w)
end

# this should not be needed, but at some point it helped for type stability
if VERSION < v"1.8"
    @inline _schurtyped(T::TM, Z::TM, w::Tw) where {TM <: AbstractMatrix{Te}, Tw} where {Te} = Schur{Te, TM}(T, Z, w)
else
    @inline _schurtyped(T::TM, Z::TM, w::Tw) where {TM <: AbstractMatrix{Te}, Tw} where {Te} = Schur{Te, TM, Tw}(T, Z, w)
end

# compute Schur decomposition of real 2x2 in standard form
# return corresponding Givens and eigenvalues
# Translated from LAPACK::dlanv2
# Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.
function _gs2x2!(H2::StridedMatrix{T}, jj) where {T <: Real}
    a, b, c, d = H2[1, 1], H2[1, 2], H2[2, 1], H2[2, 2]
    sgn(x) = (x < 0) ? -one(T) : one(T) # fortran sign differs from Julia
    half = one(T) / 2
    small = 4eps(T) # how big discriminant must be for easy reality check
    if c == 0
        cs = one(T)
        sn = zero(T)
    elseif b == 0
        # swap rows/cols
        cs = zero(T)
        sn = one(T)
        a, b, c, d = d, -c, zero(T), a
    elseif ((a - d) == 0) && (b * c < 0)
        # nothing to do
        cs = one(T)
        sn = zero(T)
    else
        asubd = a - d
        p = half * asubd
        bcmax = max(abs(b), abs(c))
        bcmis = min(abs(b), abs(c)) * sgn(b) * sgn(c)
        scale = max(abs(p), bcmax)
        z = (p / scale) * p + (bcmax / scale) * bcmis
        # if z is of order machine accuracy: postpone decision
        if z >= small
            # real eigenvalues
            z = p + sqrt(scale) * sqrt(z) * sgn(p)
            a = d + z
            d -= (bcmax / z) * bcmis
            τ = hypot(c, z)
            cs = z / τ
            sn = c / τ
            b -= c
            c = zero(T)
        else
            # complex or almost equal real eigenvalues
            σ = b + c
            τ = hypot(σ, asubd)
            cs = sqrt(half * (one(T) + abs(σ) / τ))
            sn = -(p / (τ * cs)) * sgn(σ)
            # apply rotations
            aa = a * cs + b * sn
            bb = -a * sn + b * cs
            cc = c * cs + d * sn
            dd = -c * sn + d * cs
            a = aa * cs + cc * sn
            b = bb * cs + dd * sn
            c = -aa * sn + cc * cs
            d = -bb * sn + dd * cs
            midad = half * (a + d)
            a = midad
            d = a
            if (c != 0)
                if (b != 0)
                    if b * c >= 0
                        # real eigenvalues
                        sab = sqrt(abs(b))
                        sac = sqrt(abs(c))
                        p = sab * sac * sgn(c)
                        τ = one(T) / sqrt(abs(b + c))
                        a = midad + p
                        d = midad - p
                        b -= c
                        c = 0
                        cs1 = sab * τ
                        sn1 = sac * τ
                        cs, sn = cs * cs1 - sn * sn1, cs * sn1 + sn * cs1
                    end
                else
                    b, c = -c, zero(T)
                    cs, sn = -sn, cs
                end
            end
        end
    end

    if c == 0
        w1, w2 = a, d
    else
        rti = sqrt(abs(b)) * sqrt(abs(c))
        w1 = a + rti * im
        w2 = d - rti * im
    end
    H2[1, 1], H2[1, 2], H2[2, 1], H2[2, 2] = a, b, c, d
    G = Givens(jj - 1, jj, cs, sn)
    return G, w1, w2
end

function gschur!(
        A::StridedMatrix{T}; wantZ::Bool = true, scale::Bool = true,
        Zarg::Union{Nothing, Matrix{T}} = nothing,
        Zwrk::Union{Nothing, Matrix{T}} = nothing,
        kwargs...
    ) where {T <: AbstractFloat}
    checksquare(A)
    if scale
        scaleA, cscale, anrm = _scale!(A)
    else
        scaleA = false
        anrm = cscale = one(T)
    end
    H = _hessenberg!(A)
    if wantZ
        if Zarg !== nothing
            # defer argument checks to callee
            Z = _materializeQ!(Zarg, H, Zwrk)
        else
            Z = _materializeQ(H)
        end
        S = gschur!(H, Z; kwargs...)
    else
        S = gschur!(H; kwargs...)
    end
    if scaleA
        safescale!(S.T, cscale, anrm)
        safescale!(S.values, cscale, anrm)
    end
    return S
end

function doubleShiftQR!(
        H::StridedMatrix{T}, Z, shift1, shift2,
        istart::Integer, iend::Integer, v
    ) where {T <: Real}
    n = size(H, 1)
    @mydebug dcheck = DebugCompare(Z * H * Z', "decomp error")

    i1 = 1
    i2 = n
    r1r, r1i = reim(shift1)
    r2r, r2i = reim(shift2)
    v .= zero(T)
    # look for two consecutive small subdiagonals
    mx = istart
    @inbounds for m in (iend - 2):-1:istart
        # Determine whether starting double-shift QR iteration
        # at row m would make H[m,m-1] negligible.
        # Use scaling to avoid over/underflow.
        H21s = H[m + 1, m]
        s = abs(H[m, m] - r2r) + abs(r2i) + abs(H21s)
        H21s /= s
        v[1] = H21s * H[m, m + 1] +
            (H[m, m] - r1r) * ((H[m, m] - r2r) / s) - r1i * (r2i / s)
        v[2] = H21s * (H[m, m] + H[m + 1, m + 1] - r1r - r2r)
        v[3] = H21s * H[m + 2, m + 1]
        s = abs(v[1]) + abs(v[2]) + abs(v[3]) # sum(abs.(v))
        v ./= s
        if (m > istart) && (
                abs(H[m, m - 1]) * (abs(v[2]) + abs(v[3])) <=
                    eps(T) * abs(v[1]) *
                    (abs(H[m - 1, m - 1]) + abs(H[m, m]) + abs(H[m + 1, m + 1]))
            )
            mx = m
            break
        end
    end
    @mydebug println(
        "QR sweep $mx:$iend, shifts ", _fmt_nr(shift1), " ", _fmt_nr(shift2),
        " subdiags ", _fmt_nr(H[iend - 1, iend - 2]), " ", _fmt_nr(H[iend, iend - 1])
    )
    @inbounds for k in mx:(iend - 1)
        # first iteration creates a bulge using reflection based on v
        # subsequent iterations use reflections to restore Hessenberg form
        # in column k-1
        nr = min(3, iend - k + 1) # order of G
        if k > mx
            # v[1:nr] .= H[k:k+nr-1,k-1] # allocates
            for ii in 0:(nr - 1)
                v[1 + ii] = H[k + ii, k - 1]
            end
        end
        @mydebug println(" nr=$nr v=$v ")
        τ1 = _reflector!(view(v, 1:nr))
        if k > mx
            H[k, k - 1] = v[1]
            H[k + 1, k - 1] = zero(T)
            if k < iend - 1
                H[k + 2, k - 1] = zero(T)
            end
        elseif mx > istart
            # avoid problems when v[2] and v[3] underflow
            H[k, k - 1] *= (one(T) - τ1)
        end
        v2 = v[2]
        τ2 = τ1 * v2
        if nr == 3
            v3 = v[3]
            τ3 = τ1 * v3
            # apply G from left; transform H[:,k:i2]
            for j in k:i2
                ss = H[k, j] + v2 * H[k + 1, j] + v3 * H[k + 2, j]
                H[k, j] -= ss * τ1
                H[k + 1, j] -= ss * τ2
                H[k + 2, j] -= ss * τ3
            end
            # apply G from right; transform H[i1:min(k+3,iend),:]
            for j in i1:min(k + 3, iend)
                ss = H[j, k] + v2 * H[j, k + 1] + v3 * H[j, k + 2]
                H[j, k] -= ss * τ1
                H[j, k + 1] -= ss * τ2
                H[j, k + 2] -= ss * τ3
            end
            if !(Z === nothing)
                for j in 1:size(Z, 1)
                    ss = Z[j, k] + v2 * Z[j, k + 1] + v3 * Z[j, k + 2]
                    Z[j, k] -= ss * τ1
                    Z[j, k + 1] -= ss * τ2
                    Z[j, k + 2] -= ss * τ3
                end
            end
        elseif nr == 2
            # apply G from left; transform H[:,k:i2]
            for j in k:i2
                ss = H[k, j] + v2 * H[k + 1, j]
                H[k, j] -= ss * τ1
                H[k + 1, j] -= ss * τ2
            end
            # apply G from right; transform H[i1:iend,:]
            for j in i1:iend
                ss = H[j, k] + v2 * H[j, k + 1]
                H[j, k] -= ss * τ1
                H[j, k + 1] -= ss * τ2
            end
            if !(Z === nothing)
                for j in 1:size(Z, 1)
                    ss = Z[j, k] + v2 * Z[j, k + 1]
                    Z[j, k] -= ss * τ1
                    Z[j, k + 1] -= ss * τ2
                end
            end
        end
        @mydebug dcheck(Z * H * Z', " QR k=$k ")
    end # k loop
    @mydebug println()
    return
end

include("vectors.jl")
include("triang.jl")

include("symtridiag.jl")
include("symtri_dc.jl")

include("norm1est.jl")
include("sylvester.jl")

include("generalized.jl")
include("rgeneralized.jl")
include("gsylvester.jl")

include("rordschur.jl")
include("ordschur.jl")
include("gcondition.jl")

end # module

# routine tests for wrappers
# This section is just to check existence and sanity of methods.
# Serious accuracy verification is elsewhere.

using LinearAlgebra
using LinearAlgebra: eigsortby, sorteig!
using Test
using GenericSchur

# allow for different phase factors and perhaps ordering
# v1 is the reference value against which we are checking v2
function _chkeigvecs(
        v1::AbstractMatrix{Tref}, v2::AbstractMatrix{T},
        isnrml, sameorder = true
    ) where {Tref, T}
    m, n = size(v2)
    if isnrml
        @test norm(v2' * v2 - I) < 50 * n * eps(real(T))
    end
    tmat = v1' * v2
    zT = zero(real(T))
    nvecs_ok = 0
    Tcheck = (precision(real(Tref)) < precision(real(T))) ? real(Tref) : real(T)
    myeps = eps(Tcheck)
    for j in 1:m
        # largest and next-largest projections
        if sameorder
            p1 = abs(tmat[j, j])
            tmat[j, j] = 0
            p2 = maximum(abs.(tmat[:, j]))
        else
            p1, p2 = zT, zT
            for i in 1:m
                ta = abs(tmat[i, j])
                if ta > p1
                    p1 = ta
                elseif ta > p2
                    p2 = ta
                end
            end
        end
        δ = abs(p1 - 1)
        ok = (δ < sqrt(myeps))
        if (verbosity[] > 0) && (δ > 100 * myeps)
            @warn "vector projection error is $δ angle $(acos(clamp(p1, 0, 1)))"
        end
        if isnrml
            ok &= (abs(p2) < sqrt(myeps))
        end
        nvecs_ok += ok
    end
    @test nvecs_ok == m
    return
end

function _chkrcond(x, y, rtol, atol = 1.0e3 * eps(eltype(x)))
    ok = true
    for (xi, yi) in zip(x, y)
        x1 = clamp(xi, 0, 1)
        y1 = clamp(yi, 0, 1)
        if abs(x1 - y1) > rtol * abs(y1) + atol
            ok = false
        end
    end
    if (verbosity[] > 0 && !ok) || (verbosity[] > 1)
        if !ok
            @warn "rcond mismatch (trial, ref, ratio): "
        else
            @info "rcond comparison (trial, ref, ratio): "
        end
        display(hcat(x, y, x ./ y))
        println()
    end
    return ok
end

revsort(λ::Real) = -λ
revsort(λ::Complex) = (-real(λ), -imag(λ))

if piracy
    let T = BigFloat
        n = 10
        # FIXME: should protect against accidental poor condition
        A = rand(T, n, n)
        for (w, f) in zip([:bare, :hermitian, :symmetric], [identity, Hermitian, Symmetric])
            @testset "wrappers $w $T" begin
                Awrk = f(A)
                E = eigen(Awrk, sortby = eigsortby)
                @test norm(Awrk * E.vectors - E.vectors * Diagonal(E.values)) < sqrt(eps(T))
                v = eigvecs(Awrk, sortby = eigsortby)
                _chkeigvecs(E.vectors, v, w != :bare)
                λ = eigvals(Awrk, sortby = eigsortby)
                if (verbosity[] > 0) && (! (λ ≈ E.values))
                    @warn "eigval order comparison (eigvals, eigen, diff): "
                    display(hcat(λ, E.values, λ .- E.values))
                    println()
                end
                @test λ ≈ E.values
                Er = eigen(Awrk, sortby = revsort)
                vr = eigvecs(Awrk, sortby = revsort)
                λr = eigvals(Awrk, sortby = revsort)
                @test Er.values ≈ reverse(E.values)
                @test λr ≈ reverse(λ)
                for j in 1:n
                    @test vr[:, j] ≈ v[:, n + 1 - j]
                end
                # verify default sorting
                if w in (:hermitian, :symmetric)
                    Er = eigen(Awrk)
                    λr = eigvals(Awrk)
                    @test issorted(Er.values)
                    @test issorted(λr)
                end
            end
            As = SymTridiagonal(rand(T,n), rand(T,n-1))
            E = eigen(As)
            λ = eigvals(As)
            @test issorted(E.values)
            @test issorted(λ)
            Er = eigen(As, sortby=revsort)
            λr = eigvals(As, sortby=revsort)
            @test Er.values ≈ reverse(E.values)
            @test λr ≈ reverse(λ)
        end
    end

    let T = Complex{BigFloat}
        n = 10
        # FIXME: should protect against accidental poor condition
        A = rand(T, n, n)
        for (w, f) in zip([:bare, :hermitian], [identity, Hermitian])
            @testset "wrappers $w $T" begin
                Awrk = f(A)
                E = eigen(Awrk, sortby = eigsortby)
                @test norm(Awrk * E.vectors - E.vectors * Diagonal(E.values)) < sqrt(eps(real(T)))
                v = eigvecs(Awrk, sortby = eigsortby)
                _chkeigvecs(E.vectors, v, w != :bare)
                λ = eigvals(Awrk, sortby = eigsortby)
                @test λ ≈ E.values
                if (verbosity[] > 0) && (! (λ ≈ E.values))
                    @warn "eigval order comparison (eigvals, eigen, diff): "
                    display(hcat(λ, E.values, λ .- E.values))
                    println()
                end
                if w == :hermitian
                    Er = eigen(Awrk)
                    λr = eigvals(Awrk)
                    @test issorted(Er.values)
                    @test issorted(λr)
                end
            end
        end
    end


    # This section tests compatibility with Julia PR #38483 which was reverted.
    # It should be rewritten but is kept to facilitate study of questionable cases.
    if ((VERSION > v"1.7.0-DEV.976") && (VERSION < v"1.7.0-beta3.37"))
        for (T, Tref) in ((Complex{BigFloat}, ComplexF64), (BigFloat, Float64))
            @testset "extended eigen() $T" begin
                n = 10
                Aref = rand(Tref, n, n)
                A = T.(Aref)
                old = precision(real(T))
                @assert old >= 53
                if T <: Real
                    Eref1 = eigen(Aref, jvl = true)
                    # we convert to complex for condition nrs, so this is a fairer check
                    Eref2 = eigen(Aref .+ 0im, jvl = true, jce = true, jcv = true)
                else
                    Eref1 = eigen(Aref, jvl = true, jce = true, jcv = true)
                    Eref2 = Eref1
                end
                setprecision(real(T), 53) do
                    E = eigen(A, jvl = true, jce = true, jcv = true)
                    @test norm(E.vectorsl' * A - Diagonal(E.values) * E.vectorsl') < sqrt(eps(real(T)))
                    if verbosity[] > 0
                        @info "eigval comparison (trial, ref, diff): "
                        display(hcat(E.values, Eref1.values, E.values .- Eref1.values))
                        println()
                    end
                    @test sorteig!(E.values) ≈ sorteig!(Eref1.values)
                    # stdlib inverts condition nrs for real matrices (WTF?)
                    # if we switch to the real forms, we would need this:
                    # rconde = (Tref <: Real) ? (1.0 ./ Eref1.rconde) : Eref1.rconde
                    # rcondv = (Tref <: Real) ? (1.0 ./ Eref1.rcondv) : Eref1.rcondv
                    rconde = Eref2.rconde
                    rcondv = Eref2.rcondv
                    @test _chkrcond(E.rconde, rconde, 0.1)
                    # CHECKME: we should not need to be so lenient.
                    # The nasty cases are not common (empirically 1 vector in < 10% of 10x10),
                    # but nightlys on Github are good at finding them.
                    # This accuracy is sufficient for typical applications.
                    @test _chkrcond(E.rcondv, rcondv, 5.0)
                    _chkeigvecs(Eref1.vectors, E.vectors, false)
                    _chkeigvecs(Eref1.vectorsl, E.vectorsl, false)
                end
            end
        end
    end

    # We shouldn't test StdLib code here, so no BlasFloat.
    @testset "vector normalization $T" for T in (BigFloat, Complex{BigFloat})
        m = round(-log10(eps(real(T))) / 3)
        A = T.([1 0 10.0^(-2m); 1 1 10.0^(-m); 10.0^(2m) 10.0^m 1])
        E, V = eigen!(copy(A), scale = true)
        tol = 10
        u = eps(real(T))
        n = size(A, 1)
        for j in 1:n
            v = V[:, j]
            @test abs(norm(v, 2) - 1) / (n * u) < tol
        end
    end

end

function checkord(A::Matrix{Ty}, tol = 10) where {Ty <: Complex}
    n = size(A, 1)
    ulp = eps(real(Ty))

    S = GenericSchur.gschur(A)
    T2 = copy(S.T)
    Z2 = copy(S.Z)
    select = fill(true, n)
    for i in 1:(n >> 1)
        select[i] = false
    end
    T2, Z2, w = GenericSchur.gordschur!(T2, Z2, select)

    # usual tests for Schur
    @test all(tril(T2, -1) .== 0)
    @test norm(Z2 * T2 * Z2' - A) / (n * norm(A) * ulp) < tol
    @test norm(I - Z2 * Z2') / (n * ulp) < tol

    # make sure we got the ones we asked for
    nwanted = count(select)
    wwanted = [S.values[j] for j in 1:n if select[j]]
    errs = zeros(nwanted)
    for i in 1:nwanted
        w = T2[i, i]
        errs[i] = minimum(abs.(wwanted .- w)) / (ulp + abs(w))
    end
    @test all(errs .< tol)
    return
end

using LinearAlgebra.LAPACK: BlasInt, trsen!

function checkecond(A::Matrix{T}, nsub = 3) where {T}
    n = size(A, 1)
    select = fill(false, n)
    inds = rand(1:n, nsub)
    for i in inds
        select[i] = true
    end
    S = GenericSchur.gschur(A)

    @assert real(T) <: BlasFloat
    T1 = copy(S.T)
    Z1 = copy(S.Z)
    fselect = BlasInt.([x ? 1 : 0 for x in select])
    T1, Z1, _, s1, sep1 = trsen!('B', 'V', fselect, T1, Z1)

    S2 = ordschur(S, select)
    s2 = eigvalscond(S2, count(select))
    sep2 = subspacesep(S2, count(select))

    @test s1 ≈ s2
    @test sep1 ≈ sep2
    return
end

for Ty in [Complex{Float64}]
    @testset "ordschur $Ty" begin
        n = 32
        A = rand(Ty, n, n)
        checkord(A)
    end
    @testset "subspace condition $Ty" begin
        n = 32
        A = rand(Ty, n, n)
        checkecond(A)
    end
end

function checkord(A::Matrix{Ty}, tol = 10) where {Ty <: Real}
    n = size(A, 1)
    ulp = eps(real(Ty))

    S = GenericSchur.gschur(A)
    wv = S.values
    # cases to try: 2 reals, 1 complex pair, 1 real & 1 pair, 2 pairs
    nr = [2, 0, 1, 0]
    ni = [0, 2, 2, 4]
    for icase in 1:4
        T2 = copy(S.T)
        Z2 = copy(S.Z)
        select = fill(false, n)
        i = n + 1
        nr_needed = nr[icase]
        ni_needed = ni[icase]
        while (nr_needed + ni_needed > 0) && i > 2
            i -= 1
            if nr_needed > 0
                if imag(wv[i]) == 0
                    select[i] = true
                    nr_needed -= 1
                end
            end
            if ni_needed > 0
                iwi = imag(wv[i])
                if (abs(iwi) > 1000ulp) && (imag(wv[i - 1]) == -iwi)
                    select[i] = true
                    select[i - 1] = true
                    ni_needed -= 2
                    i -= 1
                end
            end
        end
        if nr_needed + ni_needed > 0
            @warn "failed to find acceptable subset (class $icase) for checking ordschur"
            continue
        end
        T2, Z2, wv2 = GenericSchur.gordschur!(T2, Z2, select)

        # usual tests for Schur
        @test all(tril(T2, -2) .== 0)
        @test norm(Z2 * T2 * Z2' - A) / (n * norm(A) * ulp) < tol
        @test norm(I - Z2 * Z2') / (n * ulp) < tol
        @test checkeigvals(T2, wv2, tol)

        # make sure we got the ones we asked for
        nwanted = count(select)
        wwanted = [S.values[j] for j in 1:n if select[j]]
        errs = zeros(nwanted)
        wscale = maximum(abs, wv2)
        for i in 1:nwanted
            w = wv2[i]
            # CHECKME: is there a better choice of normalization for small w?
            errs[i] = minimum(abs.(wwanted .- w)) / (ulp + wscale)
        end
        if verbosity[] > 2
            println("wanted, got")
            display(hcat(wwanted, [wv[i] for i in 1:nwanted]))
            println()
        end
        @test all(errs .< tol)
    end
    return
end

for Ty in [Float64, BigFloat]
    @testset "ordschur $Ty" begin
        # should be big enough to be nearly certain of meaningful selection
        n = 20
        A = rand(Ty, n, n)
        checkord(A)
    end
end

# Check that 2x2 diagonal blocks have standard form.
# This requires that tiny values have been cleaned out.
function checkblocks(A::StridedMatrix; debug = false)
    n = size(A, 1)
    isok = true
    for j in 1:(n - 1)
        if A[j + 1, j] != 0
            isok &= (A[j, j] == A[j + 1, j + 1])
            isok &= (A[j, j + 1] != 0)
            isok &= (sign(A[j, j + 1]) * sign(A[j + 1, j]) < 0) # signs must differ (overflow?)
        end
        if debug && !isok
            print("problem block: ", A[j:(j + 1), j:(j + 1)])
            (A[j, j] == A[j + 1, j + 1]) || print(" diag")
            (A[j, j + 1] != 0) || print(" 0_super")
            (sign(A[j, j + 1]) * sign(A[j + 1, j]) < 0) || print(" trail_sign")
            println()
            return false
        end
    end
    return isok
end

function schurtest(
        A::Matrix{T}, tol; normal = false, baddec = false, vecs = true,
    ) where {T <: Real}
    n = size(A, 1)
    ulp = eps(T)
    # WARNING: if using wrappers, schur() uses eigtype(),
    # which promotes ComplexF16 to ComplexF32
    S = GenericSchur.gschur(A)
    # test 1: S.T is upper quasi-triangular
    @test all(tril(S.T, -2) .== 0)
    # check complex 2x2 blocks
    @test checkblocks(S.T)
    # test 2: norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    if baddec
        @test_broken norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    else
        @test norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    end
    # test 3: S.Z is orthogonal: norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - S.Z * S.Z') / (n * ulp) < tol
    # test 4: S.values are e.v. of T
    @test checkeigvals(S.T, S.values, tol)

    # It is tempting to check eigenvalues against LAPACK eigvals(A)
    # for suitable types, but the comparison is misleading without
    # detailed analysis because many of the test matrices are severly
    # non-normal.

    if normal
        # verify that Schur "diagonalizes" normal matrices
        # necessary but not really sufficient (complex blocks)
        @test norm(triu(S.T, 2)) / (n * norm(A) * ulp) < tol
        # TODO: in this case comparison to LAPACK eigenvalues is legit
    end
    vtol = tol
    if vecs
        vectest(A, S, tol, normal = normal)
    end

    Sc = triangularize(S)

    # test 1: S.T is upper triangular
    @test all(tril(Sc.T, -1) .== 0)
    # test 2: norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    @test norm(A - Sc.Z * Sc.T * Sc.Z') / (n * norm(A) * ulp) < tol
    # test 3: S.Z is unitary: norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - Sc.Z * Sc.Z') / (n * ulp) < tol
    # test 4: S.values are e.v. of T
    @test all(csort(Sc.values) .== csort(diag(Sc.T)))
    return
end

function hesstest(A::Matrix{T}, tol) where {T <: Real}
    n = size(A, 1)
    ulp = eps(real(T))
    H = invoke(
        GenericSchur._hessenberg!,
        Tuple{StridedMatrix{Ty}} where {Ty},
        copy(A)
    )
    Q = GenericSchur._materializeQ(H)
    if VERSION < v"1.3"
        HH = triu(H.data, -1)
    else
        HH = H.H
        # test 1: H.H is upper triangular
        @test all(tril(HH, -2) .== 0)
    end
    # test 2: norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    decomp_err = norm(A - Q * HH * Q') / (n * norm(A) * ulp)
    @test decomp_err < tol
    # test 3: S.Z is orthogonal: norm(I - S.Z * S.Z') / (n * ulp) < tol
    orth_err = norm(I - Q * Q') / (n * ulp)
    @test orth_err < tol
    return
end

Random.seed!(1234)

# Don't try BigFloat here because its floatmin is perverse.
@testset "Hessenberg $T" for T in [Float64, Float16]
    n = 32
    tol = 10
    A = rand(T, n, n)
    hesstest(A, tol)
    # exercise some underflow-related logic
    s = 100 * floatmin(real(T))
    Asmall = s * A
    hesstest(Asmall, tol)
    s = floatmax(real(T)) / 100
    Abig = s * A
    hesstest(Abig, tol)
end

@testset "group $T" for T in [BigFloat, Float16]
    unfl = floatmin(T)
    ovfl = one(T) / unfl
    ulp = eps(T)
    ulpinv = one(T) / ulp
    rtulp = sqrt(ulp)
    rtulpi = one(T) / rtulp

    ens = [4, 32]
    @testset "random general" begin
        for n in ens
            A = rand(T, n, n)
            schurtest(A, 10)
        end
    end
    @testset "random orthogonal" begin
        for n in ens
            A = rando(T, n)
            schurtest(A, 10, normal = true)
        end
    end

end # group testset

@testset "Godunov" begin
    # Set precision fine enough for eigval condition to apply,
    # but not fine enough to make it a slam-dunk.
    setprecision(BigFloat, 80) do
        A, v, econd = godunov(BigFloat)
        S = GenericSchur.gschur(A)
        δ = norm(S.Z * S.T * S.Z' - A)
        @test δ < 100 * eps(big(1.0)) * norm(A)
        t = 3 * δ * econd
        @test isapprox(csort(S.values), v, atol = t)
        if piracy
            vnew = eigvals(A)
            @test isapprox(csort(vnew), v, atol = t)
        end
    end
end

@testset "group $T" for T in [Float64, Float32]

    unfl = floatmin(T)
    ovfl = one(T) / unfl
    ulp = eps(T)
    ulpinv = one(T) / ulp
    rtulp = sqrt(ulp)
    rtulpi = one(T) / rtulp

    # sizes of matrices to test
    ens = [4, 32]

    itypemax = 10
    # On author's dev system, tests pass with tol=5 for most and 6 for all,
    # but generalization is risky.
    # (LAPACK uses 20, FWIW.)
    tols = fill(20, itypemax)

    simrconds = [1.0, rtulpi, 0.0]
    magns = [1.0, ovfl * ulp, unfl * ulpinv]

    @testset "Jordan" begin
        itype = 3
        kmagn = [1]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                anorm = magns[kmagn[j]]
                A = diagm(1 => ones(T, n - 1)) + anorm * I
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "general, ev specified" begin
        itype = 6
        kmagn = [1, 1, 1, 1, 1, 1, 1, 1, 2, 3]
        kmode = [4, 3, 1, 5, 4, 3, 1, 5, 5, 5]
        kconds = [1, 1, 1, 1, 2, 2, 2, 2, 2, 2]
        nj = length(kmode)
        for n in ens
            for j in 1:nj
                #               CALL DLATME( N, 'S', ISEED, WORK, IMODE, COND, CONE,
                #     $                      ' ', 'T', 'T', 'T', RWORK, 4, CONDS, N, N, ANORM,
                #     $                      A, LDA, WORK( 2*N+1 ), IINFO )
                A = zeros(T, n, n)
                simrcond = simrconds[kconds[j]]
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = ulpinv
                verbosity[] > 1 &&
                    println("latme: n=$n $anorm, $imode, $rcond, $simrcond")
                latme!(A, anorm, imode, rcond, simrcond)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "diagonal, random ev" begin
        itype = 7
        kmode = [6]
        kmagn = [1]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                #           CALL ZLATMR( N, N, 'D', ISEED, 'N', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, 0, 0,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                A = zeros(T, n, n)
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = 1.0
                latmr!(A, anorm, imode, rcond, kl = 0, ku = 0)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "symmetric, random ev" begin
        itype = 8
        kmagn = [1]
        kmode = [6]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                # note sym='H'
                #           CALL ZLATMR( N, N, 'D', ISEED, 'H', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, N, N,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                A = zeros(T, n, n)
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = 1.0
                latmr!(A, anorm, imode, rcond, sym = 'H', kl = n, ku = n)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "general, random ev" begin
        itype = 9
        kmagn = [1, 2, 3]
        # kmode = [4,3,1] # data statement is a lie
        kmode = [6, 6, 6]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                #           CALL ZLATMR( N, N, 'D', ISEED, 'N', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, N, N,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                # zdrves zeros first 2 rows/cols & last row w/o explanation
                # presumably to test balancing, which we don't do, so skip it.
                A = zeros(T, n, n)
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = 1.0
                (verbosity[] > 1) &&
                    println("latmr: n=$n $anorm, $imode, $rcond")
                latmr!(A, anorm, imode, rcond)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "triangular, random ev" begin
        # trivial, not even run in zdrves
        itype = 10
        kconds = [1]
        kmagn = [1]
        kmode = [1]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                # note: kl=0
                #           CALL ZLATMR( N, N, 'D', ISEED, 'N', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, N, 0,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                #
                A = zeros(T, n, n)
                imode = 6
                anorm = magns[kmagn[j]]
                rcond = 1.0
                latmr!(A, anorm, imode, rcond, kl = 0)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "tiny, almost degenerate" begin
        λ1, λ2 = (one(T) + 2eps(T), one(T) - 2eps(T))
        B = diagm(0 => [λ1, λ2]) + (eps(T) / 4) * rand(T, 2, 2)
        G, w1, w2 = GenericSchur._gs2x2!(B, 3)
        @test abs(max(w1, w2) - λ1) < 2eps(T)
        @test abs(min(w1, w2) - λ2) < 2eps(T)
    end
end # group testset

# This file is part of GenericSchur.jl, released under the MIT "Expat" license
# Portions derived from LAPACK, see below.

"""
gordschur!(F::Schur, select) -> Schur
gordschur!(F::GeneralizedSchur, select) -> GeneralizedSchur

Reorder a Schur decomposition so that the eigenvalues and subspaces corresponding to
indices set to `true` in the Boolean vector (or `BitVector`) `select` are first. Uses a
generic implementation.  C.f. `LinearAlgebra.ordschur!`.
"""
function gordschur!(F::Schur, select::Union{Vector{Bool}, BitVector})
    T, Z, λ = gordschur!(F.T, F.Z, select)
    return Schur(T, Z, λ)
end
function gordschur!(F::GeneralizedSchur, select::Union{Vector{Bool}, BitVector})
    S, T, α, β, Q, Z = gordschur!(F.S, F.T, F.Q, F.Z, select)
    return GeneralizedSchur(S, T, α, β, Q, Z)
end

# invariant subspace computations using complex Schur decompositions

function gordschur!(
        T::StridedMatrix{Ty},
        Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector}
    ) where {Ty <: Complex}
    # suppress most checks since this is an internal function expecting
    # components of a Schur object
    n = size(T, 1)
    ks = 0
    for k in 1:n
        if select[k]
            ks += 1
            if k != ks
                _trexchange!(T, Z, k, ks)
            end
        end
    end
    triu!(T)
    return T, Z, diag(T)
end

"""
`_trexchange!(T,Z,iold,inew)`

Given an upper triangular T and unitary Z, reorder `T` by a unitary similarity
transformation so that `T[iold,iold]`
is moved to `T[inew,inew]`. Also right-multiply `Z` by the same transformation.
"""
function _trexchange!(T::AbstractMatrix{Ty}, Z, iold, inew) where {Ty <: Complex}
    # this is Algorithm 7.6.1 in Golub & van Loan 4th ed.
    n = size(T, 1)
    if (n < 1) || (iold == inew)
        return
    end
    if iold < inew
        krange = iold:(inew - 1)
    else
        krange = (iold - 1):-1:inew
    end
    for k in krange
        Tkk = T[k, k]
        Tpp = T[k + 1, k + 1]
        G, _ = givens(T[k, k + 1], Tpp - Tkk, k, k + 1)
        if k + 1 <= n
            lmul!(G, T)
        end
        rmul!(T, adjoint(G))
        isempty(Z) || rmul!(Z, adjoint(G))
    end
    return
end

# eigvalscond and subspacesep are derived from LAPACK's ztrsen.
# LAPACK is released under a BSD license, and is
# Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.

"""
    eigvalscond(S::Schur,nsub::Integer) => Real

Estimate the reciprocal of the condition number of the `nsub` leading
eigenvalues of `S`. (Use `ordschur` to move a subspace of interest
to the front of `S`.)

See the LAPACK User's Guide for details of interpretation.
"""
function eigvalscond(S::Schur{Ty}, nsub) where {Ty}
    n = size(S.T, 1)
    # solve T₁₁ R - R T₂₂ = σ T₁₂
    R = S.T[1:nsub, (nsub + 1):n] # copy
    R, scale = trsylvester!(
        view(S.T, 1:nsub, 1:nsub), view(S.T, (nsub + 1):n, (nsub + 1):n),
        R
    )
    rnorm = norm(R) # Frobenius norm, as desired
    s = (rnorm > 0) ?
        scale / (sqrt(scale * scale / rnorm + rnorm) * sqrt(rnorm)) :
        one(real(Ty))
    return s
end

"""
    subspacesep(S::Schur,nsub::Integer) => Real

Estimate the reciprocal condition of the separation angle for the
invariant subspace corresponding
to the leading block of size `nsub` of a Schur decomposition.
(Use `ordschur` to move a subspace of interest
to the front of `S`.)

See the LAPACK User's Guide for details of interpretation.
"""
function subspacesep(S::Schur{Ty}, nsub) where {Ty}
    n = size(S.T, 1)
    scale = one(real(Ty))
    function f(X)
        # solve T₁₁ R - R T₂₂ = σ X
        R, s = trsylvester!(
            view(S.T, 1:nsub, 1:nsub),
            view(S.T, (nsub + 1):n, (nsub + 1):n),
            reshape(X, nsub, n - nsub)
        )
        scale = s
        return R
    end
    function fH(X)
        # solve T₁₁ᴴ R - R T₂₂ᴴ = σ X
        R, s = adjtrsylvester!(
            view(S.T, 1:nsub, 1:nsub),
            view(S.T, (nsub + 1):n, (nsub + 1):n),
            reshape(X, nsub, n - nsub)
        )
        scale = s
        return R
    end
    est = norm1est!(f, fH, zeros(Ty, nsub * (n - nsub)))
    return scale / est
end

# Reordering generalized Schur decompositions, Complex element type

function gordschur!(
        S::StridedMatrix{Ty}, T::StridedMatrix{Ty},
        Q::StridedMatrix{Ty}, Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector};
        scale::Bool = true
    ) where {Ty <: Complex}
    n = size(S, 1)
    if scale
        scaleA, cscale, anrm = _scale!(S)
        scaleB, cscaleb, bnrm = _scale!(T)
    else
        scaleA = false
        scaleB = false
        cscale = cscaleb = anrm = bnrm = one(real(Ty))
    end
    ks = 0
    for k in 1:n
        if select[k]
            ks += 1
            if k != ks
                _trexchange!(S, T, Q, Z, k, ks)
            end
        end
    end
    if scaleA
        safescale!(S, cscale, anrm)
    end
    if scaleB
        safescale!(T, cscaleb, bnrm)
    end
    triu!(S)
    triu!(T)
    return S, T, diag(S), diag(T), Q, Z
end

"""
`_trexchange!(A,B,Q,Z,iold,inew)`

Move location `iold` to `inew` in a generalized Schur decomposition by unitary
transformations.
"""
function _trexchange!(A::AbstractMatrix{Ty}, B, Q, Z, iold, inew) where {Ty <: Complex}
    if iold < inew
        icur = iold
        while icur < inew
            _trexch2!(A, B, Q, Z, icur)
            icur += 1
        end
        icur -= 1
    else
        @mydebug println("reverse swap $iold with $inew")
        icur = iold - 1
        while icur >= inew
            _trexch2!(A, B, Q, Z, icur)
            icur -= 1
        end
        icur += 1
    end
    return nothing
end

"""
`_trexch2!(A,B,Q,Z,j1)`

swap adjacent 1x1 blocks in UT pair (A,B) via unitary equivalence transform
apply same transform to associated Q,Z
"""
function _trexch2!(
        A::AbstractMatrix{Ty}, B, Q, Z, j1;
        require_strong = true, throws = true
    ) where {Ty <: STypes}
    # based on ztgex2
    # copy the block to try the swap
    S = A[j1:(j1 + 1), j1:(j1 + 1)]
    T = B[j1:(j1 + 1), j1:(j1 + 1)]
    # compute threshold for acceptance
    Tr = real(Ty)
    smlnum = safemin(Tr) / eps(Tr)
    W = hcat(S, T)
    sa = _safe_fnorm(vec(W))
    thresh = max(Tr(20) * eps(Tr) * sa, smlnum)

    # compute Givens rotations which would swap blocks
    # and tentatively do it
    f = S[2, 2] * T[1, 1] - T[2, 2] * S[1, 1]
    g = S[2, 2] * T[1, 2] - T[2, 2] * S[1, 2]
    sa = abs(S[2, 2]) * abs(T[1, 1])
    sb = abs(S[1, 1]) * abs(T[2, 2])
    if f == 0 && g == 0
        cz, sz = zero(Ty), one(Ty)
    else
        cz, sz, _ = givensAlgorithm(g, f)
    end
    Gz1 = Givens(1, 2, Ty(cz), -sz)
    rmul!(S, adjoint(Gz1))
    rmul!(T, adjoint(Gz1))
    if sa >= sb
        fq, gq = S[1, 1], S[2, 1]
    else
        fq, gq = T[1, 1], T[2, 1]
    end
    if sz != 0 && fq == 0 && gq == 0
        # patch for continuity (edge case, not handled thus in LAPACK)
        # CHECKME: the condition may not be optimal
        cq, sq = zero(Ty), one(Ty)
    else
        cq, sq, _ = givensAlgorithm(fq, gq)
    end
    Gq1 = Givens(1, 2, Ty(cq), sq)
    lmul!(Gq1, S)
    lmul!(Gq1, T)
    # weak stability test: subdiags <= O( ϵ norm((S,T),"F"))
    ws = abs(S[2, 1]) + abs(T[2, 1])
    @mydebug println("  weak test: subdiag norm = $ws")
    weak_ok = ws <= thresh

    if !weak_ok
        @mydebug println("  failed weak stability test")
        throws && throw(IllConditionException(j1))
        return false
    end

    if require_strong
        # Strong stability test
        # Supposedly equiv. to
        # |[A-Qᴴ*S*Z, B-Qᴴ*T*Z]| <= O(1) ϵ |[A,B]| in F-norm
        Ss = copy(S)
        Ts = copy(T)
        Gz2 = Givens(1, 2, Ty(cz), sz)
        rmul!(Ss, adjoint(Gz2))
        rmul!(Ts, adjoint(Gz2))
        Gq2 = Givens(1, 2, Ty(cq), -sq)
        lmul!(Gq2, Ss)
        lmul!(Gq2, Ts)
        Ss .-= A[j1:(j1 + 1), j1:(j1 + 1)]
        Ts .-= B[j1:(j1 + 1), j1:(j1 + 1)]
        W = hcat(Ss, Ts)
        ss = _safe_fnorm(vec(W))
        @mydebug println("  strong test resid=$ss [thresh=$thresh]")
        strong_ok = ss <= thresh
        if !strong_ok
            @mydebug println("  failed strong stability test")
            throws && throw(IllConditionException(j1))
            return false
        end
    end

    Gz = Givens(j1, j1 + 1, Ty(cz), -sz)
    rmul!(A, adjoint(Gz))
    rmul!(B, adjoint(Gz))
    Gq = Givens(j1, j1 + 1, Ty(cq), sq)
    lmul!(Gq, A)
    lmul!(Gq, B)
    A[j1 + 1, j1] = zero(Ty)
    B[j1 + 1, j1] = zero(Ty)
    rmul!(Z, adjoint(Gz))
    rmul!(Q, adjoint(Gq))
    return true
end

# This file is part of GenericSchur.jl, released under the MIT "Expat" license

# The methods in this file are derived from LAPACK's ztgsyl etc.
# LAPACK is released under a BSD license, and is
# Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.

# Note: since this is based on the routines for complex types,
# several methods are hard-coded with 2x2 blocks

"""
    trsylvester!(A,B,C,D,E,F) => R, L, σ

solve the generalized Sylvester equation ``A R - L B = σ C``
``D R - L E = σ F``
given upper triangular and square `A,B,D` and `E`.
Overwrites `C` and `F`
with `R` and `L`, and sets `σ` to avoid overflow.
"""
function trsylvester!(
        A::StridedMatrix{T}, B::StridedMatrix{T},
        C::StridedVecOrMat{T},
        D::StridedMatrix{T}, E::StridedMatrix{T},
        F::StridedVecOrMat{T}
    ) where {T}
    m = checksquare(A)
    n = checksquare(B)
    ((size(C, 1) == m) && (size(C, 2) == n)) || throw(
        DimensionMismatch(
            "dimensions of C $(size(C)) must match A, ($m,$m), and B, ($n,$n)"
        )
    )
    m1 = checksquare(D)
    n1 = checksquare(E)
    (m1 == m && n1 == n) || throw(
        DimensionMismatch(
            "dimensions of D and E must match A and B"
        )
    )
    ((size(F, 1) == m) && (size(F, 2) == n)) || throw(
        DimensionMismatch(
            "dimensions of F $(size(F)) must match A, ($m,$m), and B, ($n,$n)"
        )
    )

    rtyone = one(real(T))
    scale = rtyone
    # ztgsyl notes:
    # ijob 0: solve only; 1: solve & look-ahead dif; 2: solve & 1-est dif
    #      3: only look-ahead dif; 4: only 1-est dif
    # ifunc 1: look-ahead, 2: 1-est; else 0 (reset for 2-pass cases)
    #      ifunc => ijob in ztgsy2
    # isolve 2: solve and (some) dif; else 1
    # if solving:
    #   solve for C,F
    # if dif:
    #   if solving, save C,F
    #   zero out C,F
    #   call solver w/ ifunc
    #   if solving, restore C,F
    perturbed = false
    for j in 1:n
        for i in m:-1:1
            # build 2x2 problem
            Z = [A[i, i] -B[j, j]; D[i, i] -E[j, j]]
            rhs = [C[i, j]; F[i, j]]
            x, scale, perturbed = _safe_lu_solve!(Z, rhs)
            C[i, j] = x[1]
            F[i, j] = x[2]
            if scale != 1
                for k in 1:n
                    lmul!(view(C, 1:m, k), scale)
                    lmul!(view(F, 1:m, k), scale)
                end
            end
            # substitute R[i,j], L[i,j] into remaining eq
            if i > 1
                α = -x[1]
                C[1:(i - 1), j] .+= α * A[1:(i - 1), i]
                F[1:(i - 1), j] .+= α * D[1:(i - 1), i]
            end
            if j < n
                α = x[2]
                C[i, (j + 1):n] .+= α * B[j, (j + 1):n]
                F[i, (j + 1):n] .+= α * E[j, (j + 1):n]
            end
        end
    end
    return C, F, scale, perturbed
end

"""
    adjtrsylvester!(A,B,C,D,E,F) => X, σ

solve a generalized adjoint Sylvester equation ``Aᴴ X + Dᴴ Y = σ C``,
 ``X Bᴴ + Y Eᴴ = -σ F``,
for upper triangular `A, B, D,` and `E`, overwriting `C` and `F`
and setting `σ` to avoid overflow.
"""
function adjtrsylvester!(
        A::StridedMatrix{T}, B::StridedMatrix{T},
        C::StridedVecOrMat{T},
        D::StridedMatrix{T}, E::StridedMatrix{T},
        F::StridedVecOrMat{T}
    ) where {T}
    m = checksquare(A)
    n = checksquare(B)
    ((size(C, 1) == m) && (size(C, 2) == n)) || throw(
        DimensionMismatch(
            "dimensions of C $(size(C)) must match A, ($m,$m), and B, ($n,$n)"
        )
    )
    m1 = checksquare(D)
    n1 = checksquare(E)
    (m1 == m && n1 == n) || throw(
        DimensionMismatch(
            "dimensions of D and E must match A and B"
        )
    )
    ((size(F, 1) == m) && (size(F, 2) == n)) || throw(
        DimensionMismatch(
            "dimensions of F $(size(F)) must match A, ($m,$m), and B, ($n,$n)"
        )
    )

    scale = one(real(T))
    perturbed = false
    for i in 1:m
        for j in n:-1:1
            # build 2x2 problem
            Z = [A[i, i]' D[i, i]'; -B[j, j]' -E[j, j]']
            rhs = [C[i, j]; F[i, j]]
            x, scale, perturbed = _safe_lu_solve!(Z, rhs)
            C[i, j] = x[1]
            F[i, j] = x[2]
            if scale != 1
                for k in 1:n
                    lmul!(view(C, 1:m, k), scale)
                    lmul!(view(F, 1:m, k), scale)
                end
            end
            # substitute R[i,j], L[i,j] into remaining eq
            for jj in 1:(j - 1)
                F[i, jj] += x[1] * B[jj, j]' + x[2] * E[jj, j]'
            end
            for ii in (i + 1):m
                C[ii, j] -= x[1] * A[i, ii]' + x[2] * D[i, ii]'
            end
        end
    end
    return C, F, scale, perturbed
end

function schurtest(A::Matrix{T}, tol; normal = false) where {T <: Complex}
    n = size(A, 1)
    ulp = eps(real(T))
    # warning: if we use a wrapper, schur() applies eigtype(),
    # which promotes ComplexF16 to ComplexF32
    S = GenericSchur.gschur(A)
    # test 1: S.T is upper triangular
    @test all(tril(S.T, -1) .== 0)
    # test 2: norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    if verbosity[] > 1
        decomp_err = norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp)
        println("decomp. error: ", decomp_err)
        @test decomp_err < tol
    else
        @test norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    end
    # test 3: S.Z is unitary: norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - S.Z * S.Z') / (n * ulp) < tol
    # test 4: S.values are e.v. of T
    @test all(csort(S.values) .== csort(diag(S.T)))

    # It is tempting to check eigenvalues against LAPACK eigvals(A)
    # for suitable types, but the comparison is misleading without
    # detailed analysis because many of the test matrices are severly
    # non-normal.

    if normal
        # verify that Schur diagonalizes normal matrices
        @test norm(triu(S.T, 1)) / (n * norm(A) * ulp) < tol
    end
    vtol = tol
    vectest(A, S, tol, normal = normal)
    return
end

function hesstest(A::Matrix{T}, tol) where {T <: Complex}
    n = size(A, 1)
    ulp = eps(real(T))
    H = invoke(
        GenericSchur._hessenberg!,
        Tuple{StridedMatrix{Ty}} where {Ty},
        copy(A)
    )
    Q = GenericSchur._materializeQ(H)
    if VERSION < v"1.3"
        HH = triu(H.data, -1)
    else
        HH = H.H
        # test 1: H.H is upper triangular
        @test all(tril(HH, -2) .== 0)
    end
    # test 2: norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    decomp_err = norm(A - Q * HH * Q') / (n * norm(A) * ulp)
    @test decomp_err < tol
    # test 3: S.Z is orthogonal: norm(I - S.Z * S.Z') / (n * ulp) < tol
    orth_err = norm(I - Q * Q') / (n * ulp)
    @test orth_err < tol
    # test 4: subdiagonal is real
    @test all(isreal.(diag(HH, -1)))
    return
end

function hesstest(A::Hermitian{T}, tol) where {T <: Complex}
    n = size(A, 1)
    ulp = eps(real(T))
    H = invoke(
        GenericSchur._hessenberg!,
        Tuple{Hermitian{Ty}} where {Ty <: Complex},
        copy(A)
    )
    Q = GenericSchur._materializeQ(H)
    HH = H.H
    # test 1: H.H is formally symtridiagonal
    @test isa(HH, SymTridiagonal)
    @test eltype(HH) == real(eltype(A))
    # test 2: norm(A - S.Z * S.T * S.Z') / (n * norm(A) * ulp) < tol
    decomp_err = norm(A - Q * HH * Q') / (n * norm(A) * ulp)
    @test decomp_err < tol
    # test 3: S.Z is orthogonal: norm(I - S.Z * S.Z') / (n * ulp) < tol
    orth_err = norm(I - Q * Q') / (n * ulp)
    @test orth_err < tol
    return
end


Random.seed!(1234)

@testset "Hessenberg $T" for T in [ComplexF64, Complex{Float16}]
    n = 32
    tol = 10
    A = rand(T, n, n)
    hesstest(A, tol)
    s = 100 * floatmin(real(T))
    Asmall = s * A
    hesstest(Asmall, tol)
end

if VERSION >= v"1.3"
    @testset "Hermitian Hessenberg $T" for T in [ComplexF64, Complex{Float16}]
        n = 32
        tol = 10
        A = Hermitian(rand(T, n, n), :U)
        hesstest(A, tol)
        s = 100 * floatmin(real(T))
        Asmall = s * A
        hesstest(Asmall, tol)
        A = Hermitian(rand(T, n, n), :L)
        hesstest(A, tol)
        s = 100 * floatmin(real(T))
        Asmall = s * A
        hesstest(Asmall, tol)
    end
end

@testset "group $T" for T in [Complex{BigFloat}, Complex{Float16}]
    unfl = floatmin(real(T))
    ovfl = one(real(T)) / unfl
    ulp = eps(real(T))
    ulpinv = one(real(T)) / ulp
    rtulp = sqrt(ulp)
    rtulpi = one(real(T)) / rtulp

    ens = [4, 32]
    @testset "random general" begin
        for n in ens
            A = rand(T, n, n)
            schurtest(A, 10)
        end
    end
    @testset "random unitary" begin
        for n in ens
            A = randu(T, n)
            schurtest(A, 20, normal = true)
        end
    end

end # group testset

@testset "Godunov (complex)" begin
    # Set precision fine enough for eigval condition to apply,
    # but not fine enough to make it a slam-dunk.
    setprecision(BigFloat, 80) do
        A, v, econd = godunov(Complex{BigFloat})
        S = GenericSchur.gschur(A)
        δ = norm(S.Z * S.T * S.Z' - A)
        @test δ < 100 * eps(big(1.0)) * norm(A)
        t = 3 * δ * econd
        @test isapprox(csort(S.values), v, atol = t)
        if piracy
            vnew = eigvals(A)
            @test isapprox(csort(vnew), v, atol = t)
        end
    end
end

# v0.4.0 breaks on this matrix
function _example1(T = Complex{Float32})
    iseed = [4066, 2905, 502, 2389]
    ulpinv = 1 / eps(real(T))
    A, d, ds = latme!(zeros(T, 5, 5), 1.0, 4, ulpinv, 1.0, iseed = iseed)
    return A
end
@testset "short QR sweep" begin
    A = _example1(ComplexF32)
    schurtest(A, 20)
end

@testset "group $T" for T in [ComplexF64, ComplexF32]

    unfl = floatmin(real(T))
    ovfl = one(real(T)) / unfl
    ulp = eps(real(T))
    ulpinv = one(real(T)) / ulp
    rtulp = sqrt(ulp)
    rtulpi = one(real(T)) / rtulp

    # sizes of matrices to test
    ens = [4, 32]

    itypemax = 10
    # On author's dev system, tests pass with tol=5 for most and 6 for all,
    # but generalization is risky.
    # (LAPACK uses 20, FWIW.)
    tols = fill(20, itypemax)

    simrconds = [1.0, rtulpi, 0.0]
    magns = [1.0, ovfl * ulp, unfl * ulpinv]

    # test matrix from zdrves:
    # conds=0 means index 3 for simrconds (i.e. irrelevant)
    # type magn mode conds
    # 1 1 0 0
    # 2 1 0 0
    # 3 1 0 0
    # 4 1 4 0
    # 4 1 3 0
    # 4 1 1 0
    # 4 2 4 0
    # 4 3 4 0
    # 6 1 4 1
    # 6 1 3 1
    # 6 1 1 1
    # 6 1 5 1
    # 6 1 4 2
    # 6 1 3 2
    # 6 1 1 2
    # 6 1 5 2
    # 6 2 5 2
    # 6 3 5 2
    # 9 1 4 0
    # 9 2 3 0
    # 9 3 1 0


    # Other stuff in zdrves: pointless or not even used
    # 1- zero
    # 2- identity
    # 4- diagonal, ev specified
    # 5- symmetric, ev specified, not used in zdrves

    @testset "Jordan" begin
        itype = 3
        kmagn = [1]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                anorm = magns[kmagn[j]]
                A = diagm(1 => ones(T, n - 1)) + anorm * I
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "general, ev specified" begin
        itype = 6
        kmagn = [1, 1, 1, 1, 1, 1, 1, 1, 2, 3]
        kmode = [4, 3, 1, 5, 4, 3, 1, 5, 5, 5]
        kconds = [1, 1, 1, 1, 2, 2, 2, 2, 2, 2]
        nj = length(kmode)
        for n in ens
            for j in 1:nj
                #               CALL ZLATME( N, 'D', ISEED, WORK, IMODE, COND, CONE,
                #     $                      'T', 'T', 'T', RWORK, 4, CONDS, N, N, ANORM,
                #     $                      A, LDA, WORK( 2*N+1 ), IINFO )
                A = zeros(T, n, n)
                simrcond = simrconds[kconds[j]]
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = ulpinv
                verbosity[] > 1 &&
                    println("latme: n=$n $anorm, $imode, $rcond, $simrcond")
                latme!(A, anorm, imode, rcond, simrcond)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "diagonal, random ev" begin
        itype = 7
        kmode = [6]
        kmagn = [1]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                #           CALL ZLATMR( N, N, 'D', ISEED, 'N', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, 0, 0,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                A = zeros(T, n, n)
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = 1.0
                latmr!(A, anorm, imode, rcond, kl = 0, ku = 0)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "symmetric, random ev" begin
        itype = 8
        kmagn = [1]
        kmode = [6]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                # note sym='H'
                #           CALL ZLATMR( N, N, 'D', ISEED, 'H', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, N, N,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                A = zeros(T, n, n)
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = 1.0
                latmr!(A, anorm, imode, rcond, sym = 'H', kl = n, ku = n)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "general, random ev" begin
        itype = 9
        kmagn = [1, 2, 3]
        # kmode = [4,3,1] # data statement is a lie
        kmode = [6, 6, 6]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                #           CALL ZLATMR( N, N, 'D', ISEED, 'N', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, N, N,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                # zdrves zeros first 2 rows/cols & last row w/o explanation
                # presumably to test balancing, which we don't do, so skip it.
                A = zeros(T, n, n)
                imode = kmode[j]
                anorm = magns[kmagn[j]]
                rcond = 1.0
                (verbosity[] > 1) &&
                    println("latmr: n=$n $anorm, $imode, $rcond")
                latmr!(A, anorm, imode, rcond)
                schurtest(A, tols[itype])
            end
        end
    end

    @testset "triangular, specified ev" begin
        # This is done peculiarly to exercise branches in the eigenvector solver.
        # In particular, we stuff the UT directly into a Schur object so we know exactly
        # what's on the diagonal.
        # (Probably happens for normal schur(), but I didn't promise that anywhere.)
        kconds = [2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2]
        kmagn = [1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3]
        kmode = [5, 0, 0, 0, 5, 0, 0, 0, 5, 0, 0, 0]
        mydmodes = [0, 0, 1, 2, 0, 0, 1, 2, 0, 0, 1, 2]
        nj = length(kmagn)
        itype = 6
        for n in ens
            for j in 1:nj
                A = zeros(T, n, n)
                imode = kmode[j]
                rcond = ulpinv
                anorm = magns[kmagn[j]]
                d_mode = mydmodes[j]
                (verbosity[] > 1) &&
                    println("latmr: n=$n $anorm, $imode, $rcond")
                if imode == 0
                    d = rand(T, n)
                    if d_mode == 0
                        d[2] = d[n - 1]
                    elseif d_mode == 1
                        d[2] = d[n - 1] * nextfloat(one(real(T)))
                    else
                        d[2] = d[n - 1] * prevfloat(one(real(T)))
                    end
                    latmr!(A, anorm, imode, rcond, kl = 0, d = d)
                else
                    latmr!(A, anorm, imode, rcond, kl = 0)
                end
                S = LinearAlgebra.Schur(A, Diagonal(ones(T, n)), diag(A))
                vectest(A, S, tols[itype])
            end
        end
    end

    @testset "triangular, random ev" begin
        # trivial, not even run in zdrves
        itype = 10
        kconds = [1]
        kmagn = [1]
        kmode = [1]
        nj = length(kmagn)
        for n in ens
            for j in 1:nj
                # note: kl=0
                #           CALL ZLATMR( N, N, 'D', ISEED, 'N', WORK, 6, ONE, CONE,
                # $                      'T', 'N', WORK( N+1 ), 1, ONE,
                # $                      WORK( 2*N+1 ), 1, ONE, 'N', IDUMMA, N, 0,
                # $                      ZERO, ANORM, 'NO', A, LDA, IWORK, IINFO )
                #
                A = zeros(T, n, n)
                imode = 6
                anorm = magns[kmagn[j]]
                rcond = 1.0
                latmr!(A, anorm, imode, rcond, kl = 0)
                schurtest(A, tols[itype])
            end
        end
    end

end # group testset

@testset "eigvecs of nonfinite Schur" begin
    # for now we just make sure nothing throws
    S0 = GenericSchur.gschur(rand(ComplexF64, 5, 5))
    S0.T[2, 3] = Inf
    V = geigvecs(S0, left = false)
    @test true
    V = geigvecs(S0, left = true)
    @test true
    S0.T[2, 3] = NaN
    V = geigvecs(S0, left = false)
    @test true
    V = geigvecs(S0, left = true)
    @test true
end

# select algorithm used to estimate Sep for triangular generalized problems
abstract type TrGSepAlgo end
# look-ahead is standard in LAPACK
struct TrGSepLookAhead <: TrGSepAlgo end
# alternative is Higham's iterative 1-norm estimator
struct TrGSepIter <: TrGSepAlgo end

function _trgsep(
        A::StridedMatrix{T}, B::StridedMatrix{T},
        D::StridedMatrix{T}, E::StridedMatrix{T},
        algo::TrGSepAlgo = TrGSepLookAhead()
    ) where {T}
    m = checksquare(A)
    n = checksquare(B)

    # C and F are used to hold intermediate results
    C = zeros(T, m, n)
    F = zeros(T, m, n)

    m1 = checksquare(D)
    n1 = checksquare(E)
    (m1 == m && n1 == n) || throw(
        DimensionMismatch(
            "dimensions of D and E must match A and B"
        )
    )

    rtyone = one(real(T))
    rtyzero = zero(real(T))
    dif = rtyzero
    cone = one(T)
    rdsum = rtyone
    rdscale = rtyzero
    for j in 1:n
        for i in m:-1:1
            # build 2x2 problem
            Z = [A[i, i] -B[j, j]; D[i, i] -E[j, j]]
            fZ = lu(Z) # should be _getc2
            rhs = [C[i, j]; F[i, j]]
            if algo isa TrGSepLookAhead
                # from zlatdf
                # set up a RHS b s.t. solution x = Z \ b has large norm
                x = rhs[fZ.p] # ipiv if _getc2
                pmone = -one(T)
                bp = x[1] + cone
                bm = x[1] - cone
                # L-part
                splus = rtyone
                L21 = fZ.L[2, 1]
                splus += real(L21' * L21)
                sminu = real(L21' * x[2])
                splus *= real(x[1])
                if splus > sminu
                    x[1] = bp
                elseif sminu > splus
                    x[1] = bm
                else
                    x[1] += pmone
                    pmone = cone
                end
                x[2] -= x[1] * L21
                # U-part
                w = [x[1]; x[2] + cone]
                x[2] -= cone
                splus = zero(real(T))
                sminu = zero(real(T))
                for i in 2:-1:1
                    t = cone / fZ.U[i, i]
                    w[i] *= t
                    x[i] *= t
                    if i == 1
                        k = 2
                        U12 = fZ.U[i, k]
                        w[i] -= w[k] * (U12 * t)
                        x[i] -= x[k] * (U12 * t)
                    end
                    splus += abs(w[i])
                    sminu += abs(x[i])
                end
                if splus > sminu
                    x .= w
                end
                x = x[fZ.p] # jpiv if _getc2
                rdscale, rdsum = _ssq(x, rdscale, rdsum)
                if rdscale != 0
                    dif = sqrt(2 * rtyone * m * n) / (rdscale * sqrt(rdsum))
                end
            else
                error("missing logic for $algo")
            end

            C[i, j] = x[1]
            F[i, j] = x[2]
            # substitute R[i,j], L[i,j] into remaining eq
            if i > 1
                α = -x[1]
                C[1:(i - 1), j] .+= α * A[1:(i - 1), i]
                F[1:(i - 1), j] .+= α * D[1:(i - 1), i]
            end
            if j < n
                α = x[2]
                C[i, (j + 1):n] .+= α * B[j, (j + 1):n]
                F[i, (j + 1):n] .+= α * E[j, (j + 1):n]
            end
        end
    end
    return dif
end

# based on ztgsen
"""
    eigvalscond(S::GeneralizedSchur, nsub) => pl, pr

compute approx. reciprocal norms of projectors on left/right subspaces
associated w/ leading `nsub`×`nsub` block of `S`. Use `ordschur` to select
eigenvalues of interest.

An approximate bound on avg. absolute error of associated eigenvalues
is `ϵ * norm(vcat(A,B)) / pl`. See LAPACK documentation for further details.
"""
function eigvalscond(S::GeneralizedSchur{Ty}, nsub) where {Ty}
    # nsub is m in ztgsen
    n = size(S.T, 1)
    rtyone = one(real(Ty))
    rtyzero = zero(real(Ty))
    if nsub == 0 || nsub == n
        return rtyone, rtyone
    end
    # solve S₁₁ R - L S₂₂ = σ S₁₂
    #       T₁₁ R - L T₂₂ = σ T₁₂
    n1 = nsub
    n2 = n - nsub
    R = S.S[1:n1, (n1 + 1):n]
    L = S.T[1:n1, (n1 + 1):n]
    R, L, scale = trsylvester!(
        S.S[1:n1, 1:n1], S.S[(n1 + 1):n, (n1 + 1):n], R,
        S.T[1:n1, 1:n1], S.T[(n1 + 1):n, (n1 + 1):n], L
    )

    #=
    ## DEVNOTE: this has been taking MINUTES to compile on v1.1.1+
    ## so we live with the allocations for now

    R, L, scale = trsylvester!(view(S.S,1:n1,1:n1),view(S.S,n1+1:n,n1+1:n),R,
                               view(S.T,1:n1,1:n1),view(S.T,n1+1:n,n1+1:n),L)
    =#

    rdscale = rtyzero
    sumsq = rtyone
    rdscale, sumsq = _ssq(vec(R), rdscale, sumsq)
    pl = rdscale * sqrt(sumsq)
    if pl == 0
        pl = rtyone
    else
        pl = scale / (sqrt(scale * scale / pl + pl) * sqrt(pl))
    end
    rdscale = rtyzero
    sumsq = rtyone
    rdscale, sumsq = _ssq(vec(L), rdscale, sumsq)
    pr = rdscale * sqrt(sumsq)
    if pr == 0
        pr = rtyone
    else
        pr = scale / (sqrt(scale * scale / pr + pr) * sqrt(pr))
    end
    return pl, pr
end

function subspacesep(
        S::GeneralizedSchur{Ty}, nsub::Integer;
        pnorm::Union{Int, Symbol} = :F
    ) where {Ty}
    n = size(S.S, 1)
    rtyone = one(real(Ty))
    n2 = n - nsub
    sep = zeros(real(Ty), 2)
    # these could use views for all, but for now that takes minutes to compile
    function fu(X)
        # solve T₁₁ R - R T₂₂ = σ X
        R = reshape(X[1:(nsub * n2)], nsub, n2)
        L = reshape(X[(nsub * n2 + 1):(2 * nsub * n2)], nsub, n2)
        R, L, s = trsylvester!(
            S.S[1:nsub, 1:nsub],
            S.S[(nsub + 1):n, (nsub + 1):n],
            R,
            S.T[1:nsub, 1:nsub],
            S.T[(nsub + 1):n, (nsub + 1):n],
            L
        )
        scale = s
        return vcat(vec(R), vec(L))
    end
    function fuH(X)
        # solve T₁₁ᴴ R - R T₂₂ᴴ = σ X
        R = reshape(X[1:(nsub * n2)], nsub, n2)
        L = reshape(X[(nsub * n2 + 1):(2 * nsub * n2)], nsub, n2)
        R, L, s = adjtrsylvester!(
            S.S[1:nsub, 1:nsub],
            S.S[(nsub + 1):n, (nsub + 1):n],
            R,
            S.T[1:nsub, 1:nsub],
            S.T[(nsub + 1):n, (nsub + 1):n],
            L
        )
        scale = s
        return vcat(vec(R), vec(L))
    end
    function fl(X)
        # solve T₁₁ R - R T₂₂ = σ X
        R = reshape(X[1:(nsub * n2)], n2, nsub)
        L = reshape(X[(nsub * n2 + 1):(2 * nsub * n2)], n2, nsub)
        R, L, s = trsylvester!(
            S.S[(nsub + 1):n, (nsub + 1):n],
            S.S[1:nsub, 1:nsub],
            R,
            S.T[(nsub + 1):n, (nsub + 1):n],
            S.T[1:nsub, 1:nsub],
            L
        )
        scale = s
        return vcat(vec(R), vec(L))
    end
    function flH(X)
        # solve T₁₁ᴴ R - R T₂₂ᴴ = σ X
        R = reshape(X[1:(nsub * n2)], n2, nsub)
        L = reshape(X[(nsub * n2 + 1):(2 * nsub * n2)], n2, nsub)
        R, L, s = adjtrsylvester!(
            S.S[(nsub + 1):n, (nsub + 1):n],
            S.S[1:nsub, 1:nsub],
            R,
            S.T[(nsub + 1):n, (nsub + 1):n],
            S.T[1:nsub, 1:nsub],
            L
        )
        scale = s
        return vcat(vec(R), vec(L))
    end
    if pnorm == :F || pnorm == :Frobenius
        sep[1] = _trgsep(
            view(S.S, 1:nsub, 1:nsub),
            view(S.S, (nsub + 1):n, (nsub + 1):n),
            view(S.T, 1:nsub, 1:nsub),
            view(S.T, (nsub + 1):n, (nsub + 1):n)
        )
        sep[2] = _trgsep(
            view(S.S, (nsub + 1):n, (nsub + 1):n),
            view(S.S, 1:nsub, 1:nsub),
            view(S.T, (nsub + 1):n, (nsub + 1):n),
            view(S.T, 1:nsub, 1:nsub)
        )
    elseif pnorm == 1
        scale = rtyone
        estu = norm1est!(fu, fuH, zeros(Ty, 2 * nsub * n2))
        sep[1] = scale / estu
        scale = rtyone
        estl = norm1est!(fl, flH, zeros(Ty, 2 * nsub * n2))
        sep[2] = scale / estl
    else
        throw(ArgumentError("pnorm must be :Frobenius or 1"))
    end
    return sep
end

using LinearAlgebra: reflector!

function gordschur!(
        T::StridedMatrix{Ty},
        Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector}
    ) where {Ty <: Real}
    # suppress most checks since this is an internal function expecting
    # components of a Schur object
    n = size(T, 1)

    ks = 0
    pair = false
    for k in 1:n
        if pair
            pair = false
        else
            swap = select[k]
            if k < n
                if T[k + 1, k] != 0
                    pair = true
                    swap = swap || select[k + 1]
                end
            end
            if swap
                ks += 1
                if k != ks
                    _, ks, ok = _trexchange!(T, Z, k, ks)
                    ok || throw(IllConditionException(k))
                    @mydebug println("after swap ks=$ks")
                end
                if pair
                    ks += 1
                end
            end
        end
    end
    vals = complex.(diag(T))
    for k in 1:(n - 1)
        if T[k + 1, k] != 0
            y = sqrt(abs(T[k, k + 1])) * sqrt(abs(T[k + 1, k]))
            vals[k] += y * im
            vals[k + 1] -= y * im
        end
    end
    return T, Z, vals
end

"""
reorder the real Schur form `T` by an orthogonal similarity transformation so that
the block containing `T[iold,iold]` is moved to `T[inew,inew]`.
Also right-multiply `Z` by the same transformation.
"""
function _trexchange!(T::AbstractMatrix{Ty}, Z, iold, inew) where {Ty <: Real}

    n = size(T, 1)
    ok = true
    if (n <= 1) || (iold == inew)
        return iold, inew, ok
    end
    # find first rows of specified blocks and their sizes
    if (iold > 1) && (T[iold, iold - 1] != 0)
        iold -= 1
    end

    # function to get block size
    nbsize(j) = ((j < n) && (T[j + 1, j] != 0)) ? 2 : 1

    nbold = nbsize(iold)
    if (inew > 1) && (T[inew, inew - 1] != 0)
        inew -= 1
    end
    nbnew = nbsize(inew)
    if iold == inew
        return iold, inew, ok
    end

    if iold < inew
        @mydebug println("forward swap $iold to $inew sizes $nbold, $nbnew")
        if (nbold == 2) && (nbnew == 1)
            inew -= 1
        elseif (nbold == 1) && (nbnew == 2)
            inew += 1
        end
        ihere = iold
        while ihere < inew
            if nbold ∈ (1, 2)
                nbnext = nbsize(ihere + nbold)
                ok = _swap1or2(T, Z, ihere, nbold, nbnext)
                ok || return iold, ihere, ok
                ihere += nbnext
                if (nbold == 2) && (T[ihere + 1, ihere] == 0)
                    nbold = 3
                end
            else
                # two 1x1 blocks each of which must be swapped individually
                nbnext = nbsize(ihere + 1)
                ok = _swap1or2(T, Z, ihere + 1, 1, nbnext)
                ok || return iold, ihere, ok
                if nbnext == 1
                    ok = _swap1or2(T, Z, ihere, 1, nbnext)
                    ihere += 1
                else
                    # recompute nbnext in case 2x2 split
                    if T[ihere + 2, ihere + 1] == 0
                        nbnext = 1
                    end
                    if nbnext == 2
                        # no split
                        ok = _swap1or2(T, Z, ihere, 1, nbnext)
                        ok || return iold, ihere, ok
                        ihere += 2
                    else
                        # split
                        ok = _swap1or2(T, Z, ihere, 1, 1)
                        ok = _swap1or2(T, Z, ihere + 1, 1, 1)
                        ihere += 2
                    end
                end
            end
        end # forward ihere loop
    else
        @mydebug println("reverse swap $iold to $inew sizes $nbold, $nbnew")
        ihere = iold
        while ihere > inew
            if nbold ∈ (1, 2)
                nbnext = ((ihere >= 3) && (T[ihere - 1, ihere - 2] != 0)) ? 2 : 1
                ok = _swap1or2(T, Z, ihere - nbnext, nbnext, nbold)
                ok || return iold, ihere, ok
                ihere -= nbnext
                if (nbold == 2) && (T[ihere + 1, ihere] == 0)
                    nbold = 3
                end
            else
                # two 1x1 blocks each of which must be swapped individually
                nbnext = ((ihere >= 3) && (T[ihere - 1, ihere - 2] != 0)) ? 2 : 1
                ok = _swap1or2(T, Z, ihere - nbnext, nbnext, 1)
                ok || return iold, ihere, ok
                if nbnext == 1
                    ok = _swap1or2(T, Z, ihere, nbnext, 1)
                    ihere -= 1
                else
                    # recompute nbnext in case 2x2 split
                    if T[ihere, ihere - 1] == 0
                        nbnext = 1
                    end
                    if nbnext == 2
                        # no split
                        ok = _swap1or2(T, Z, ihere - 1, 2, 1)
                        ok || return iold, ihere, ok
                        ihere -= 2
                    else
                        # split
                        ok = _swap1or2(T, Z, ihere, 1, 1)
                        ok = _swap1or2(T, Z, ihere - 1, 1, 1)
                        ihere -= 2
                    end
                end
            end
        end # reverse ihere loop
    end
    inew = ihere

    return iold, inew, ok
end

# translation of dlaexc
function _swap1or2(T::AbstractMatrix{Ty}, Z, j1, n1, n2) where {Ty <: Real}
    @mydebug println(" at $j1 block sizes $n1, $n2")
    n = size(T, 1)
    j1 + n1 > n && return true
    j2, j3, j4 = j1 + 1, j1 + 2, j1 + 3
    if n1 == 1 && n2 == 1
        T11 = T[j1, j1]
        T22 = T[j2, j2]
        G, _ = givens(T[j1, j2], T22 - T11, j1, j2)
        if j3 <= n
            lmul!(G, view(T, :, j3:n))
        end
        rmul!(view(T, 1:(j1 - 1), :), adjoint(G))
        T[j1, j1] = T22
        T[j2, j2] = T11
        Z === nothing || rmul!(Z, adjoint(G))
    else
        # at least one 2x2 block
        # copy diagonal block n1+n2
        nd = n1 + n2
        jx = j1 + nd - 1
        D = T[j1:jx, j1:jx]
        dnorm = norm(D, Inf)
        smallnum = floatmin(Ty) / eps(Ty)
        thresh = max(10 * eps(Ty) * dnorm, smallnum)
        # solve T₁₁ X - X T₂₂ = scale T₁₂
        X, _, scale, _ = _syl1or2(
            view(D, 1:n1, 1:n1),
            view(D, (n1 + 1):nd, (n1 + 1):nd),
            view(D, 1:n1, (n1 + 1):nd)
        )

        if n1 == 1 && n2 == 2
            # reflector s.t. [scale, X₁₁ X₁₂] H = [0, 0, _]
            # note backwards ordering
            u = [X[1, 2], scale, X[1, 1]]
            τ = reflector!(u)
            T11 = T[j1, j1]
            _reflectorYappl!(u, τ, D) # lmul!
            _reflectorYlppa!(u, τ, D) # rmul!
            #lmul!(h',D)
            #rmul!(D,h)
            if max(abs(D[3, 1]), abs(D[3, 2]), abs(D[3, 3] - T11)) > thresh
                return false
            end
            _reflectorYappl!(u, τ, view(T, j1:(j1 + 2), j1:n)) # lmul!
            _reflectorYlppa!(u, τ, view(T, 1:j2, j1:(j1 + 2))) # rmul!
            #lmul!(h',view(T,j1:j1+2,j1:n))
            #rmul!(view(T,1:j2,j1:j1+2), h)
            T[j3, j1] = zero(Ty)
            T[j3, j2] = zero(Ty)
            T[j3, j3] = T11
            if !(Z === nothing)
                #rmul!(view(Z,1:n,j1:j1+2), h)
                _reflectorYlppa!(u, τ, view(Z, 1:n, j1:(j1 + 2)))
            end
        elseif n1 == 2 && n2 == 1
            # reflector s.t. H [ -X₁₁ -X₂₁, scale]ᵀ = [_, 0, 0]ᵀ
            u = [-X[1, 1], -X[2, 1], scale]
            τ = reflector!(u)
            u[1] = one(Ty)
            T33 = T[j3, j3]
            h = Householder(view(u, 2:3), τ)
            lmul!(h', D)
            rmul!(D, h)
            if max(abs(D[1, 1] - T33), abs(D[2, 1]), abs(D[3, 1])) > thresh
                return false
            end
            rmul!(view(T, 1:j3, j1:(j1 + 2)), h)
            lmul!(h', view(T, j1:(j1 + 2), j2:n))
            T[j1, j1] = T33
            T[j2, j1] = zero(Ty)
            T[j3, j1] = zero(Ty)
            Z === nothing || rmul!(view(Z, 1:n, j1:(j1 + 2)), h)
        else
            # n1 = 2 && n2 == 2
            # 2 reflectors s.t. H₂H₁ [-X; scale*I₂] is U.T.
            u1 = [-X[1, 1], -X[2, 1], scale]
            τ1 = reflector!(u1)
            t = -τ1 * (X[1, 2] + u1[2] * X[2, 2])
            u2 = [-t * u1[2] - X[2, 2], -t * u1[3], scale]
            τ2 = reflector!(u2)
            h1 = Householder(view(u1, 2:3), τ1)
            h2 = Householder(view(u2, 2:3), τ2)
            lmul!(h1', view(D, 1:3, :))
            rmul!(view(D, :, 1:3), h1)
            lmul!(h2', view(D, 2:4, :))
            rmul!(view(D, :, 2:4), h2)
            if maximum(abs.([D[3, 1], D[3, 2], D[4, 1], D[4, 2]])) > thresh
                return false
            end
            lmul!(h1', view(T, j1:(j1 + 2), j1:n))
            rmul!(view(T, 1:j4, j1:(j1 + 2)), h1)
            lmul!(h2', view(T, j2:(j2 + 2), j1:n))
            rmul!(view(T, 1:j4, j2:(j2 + 2)), h2)
            T[j3, j1] = zero(Ty)
            T[j3, j2] = zero(Ty)
            T[j4, j1] = zero(Ty)
            T[j4, j2] = zero(Ty)
            if !(Z === nothing)
                rmul!(view(Z, 1:n, j1:(j1 + 2)), h1)
                rmul!(view(Z, 1:n, j2:(j2 + 2)), h2)
            end
        end

        if n2 == 2
            # standardize new 2x2 block T₁₁
            Tx = T[j1:j2, j1:j2]
            G, _, _ = _gs2x2!(Tx, 2)
            lmul!(G, view(T, j1:j2, (j1 + 2):n))
            rmul!(view(T, 1:(j1 - 1), j1:j2), G')
            T[j1:j2, j1:j2] .= Tx
            (Z === nothing) || rmul!(view(Z, 1:n, j1:j2), G')
        end
        if n1 == 2
            # standardize new 2x2 block T₂₂
            j3 = j1 + n2
            j4 = j3 + 1
            Tx = T[j3:j4, j3:j4]
            G, _, _ = _gs2x2!(Tx, 2)
            lmul!(G, view(T, j3:j4, (j3 + 2):n))
            rmul!(view(T, 1:(j3 - 1), j3:j4), G')
            T[j3:j4, j3:j4] .= Tx
            (Z === nothing) || rmul!(view(Z, 1:n, j3:j4), G')
        end
    end

    return true
end

# solve Tl X - X Tr = scale * B where orders are 1 or 2
# translation of dlasy2
function _syl1or2(Tl::AbstractMatrix{T}, Tr, B) where {T}
    n1 = size(Tl, 1) # checksquare(Tl)
    n2 = size(Tr, 1) # checksquare(Tr)
    # B must be n1xn2
    # X is n1xn2
    epst = eps(T)
    smallnum = floatmin(T) / epst
    if n1 == 1 && n2 == 1
        τ1 = Tl[1, 1] - Tr[1, 1]
        β = abs(τ1)
        if β <= smallnum
            τ1 = smallnum
            β = smallnum
            perturbed = true
        else
            perturbed = false
        end
        scale = one(T)
        γ = abs(B[1, 1])
        if smallnum * γ > β
            scale = one(T) / γ
        end
        X = fill((B[1, 1] * scale) / τ1, 1, 1)
        xnorm = abs(X[1, 1])
    elseif n1 == 2 && n2 == 2
        # solve equivalent 4x4 w/ protected complete pivoting
        perturbed = false
        smin = max(maximum(abs.(Tr)), maximum(abs.(Tl)))
        smin = max(epst * smin, smallnum)
        TT = zeros(T, 4, 4)
        TT[1, 1] = Tl[1, 1] - Tr[1, 1]
        TT[2, 2] = Tl[2, 2] - Tr[1, 1]
        TT[3, 3] = Tl[1, 1] - Tr[2, 2]
        TT[4, 4] = Tl[2, 2] - Tr[2, 2]

        TT[1, 2] = Tl[1, 2]
        TT[2, 1] = Tl[2, 1]
        TT[3, 4] = Tl[1, 2]
        TT[4, 3] = Tl[2, 1]

        TT[1, 3] = -Tr[2, 1]
        TT[2, 4] = -Tr[2, 1]
        TT[3, 1] = -Tr[1, 2]
        TT[4, 2] = -Tr[1, 2]
        bv = [B[1, 1], B[2, 1], B[1, 2], B[2, 2]]
        # perform elimination
        ipsv, jpsv = 0, 0
        jpiv = [0, 0, 0, 0]
        for i in 1:3
            xmax = zero(T)
            for ip in i:4
                for jp in i:4
                    if abs(TT[ip, jp]) > xmax
                        xmax = abs(TT[ip, jp])
                        ipsv, jpsv = ip, jp
                    end
                end
            end
            if ipsv != i
                tmp = TT[ipsv, :]
                TT[ipsv, :] .= TT[i, :]
                TT[i, :] .= tmp
                bv[i], bv[ipsv] = bv[ipsv], bv[i]
            end
            if jpsv != i
                tmp = TT[:, jpsv]
                TT[:, jpsv] .= TT[:, i]
                TT[:, i] .= tmp
            end
            jpiv[i] = jpsv
            if abs(TT[i, i]) < smin
                perturbed = true
                TT[i, i] = smin
            end
            for j in (i + 1):4
                TT[j, i] /= TT[i, i]
                bv[j] -= TT[j, i] * bv[i]
                for k in (i + 1):4
                    TT[j, k] -= TT[j, i] * TT[i, k]
                end
            end
        end
        if abs(TT[4, 4]) < smin
            perturbed = true
            TT[4, 4] = smin
        end
        scale = one(T)
        a = 8smallnum
        if (
                (a * abs(bv[1]) > TT[1, 1]) ||
                    (a * abs(bv[2]) > TT[2, 2]) ||
                    (a * abs(bv[3]) > TT[3, 3]) ||
                    (a * abs(bv[4]) > TT[4, 4])
            )
            scale = (1 / T(8)) / maximum(abs.(bv))
            bv .*= scale
        end
        xt = zeros(T, 4)
        for i in 1:4
            k = 5 - i
            t = 1 / TT[k, k]
            xt[k] = bv[k] * t
            for j in (k + 1):4
                xt[k] -= (t * TT[k, j]) * xt[j]
            end
        end
        for i in 1:3
            jj = jpiv[4 - i]
            if jj != 4 - i
                xt[4 - i], xt[jj] = xt[jj], xt[4 - i]
            end
        end
        X = [xt[1] xt[3]; xt[2] xt[4]]
        xnorm = maximum(abs.(xt))
    else
        if n1 == 1 && n2 == 2
            smin = max(epst * max(abs(Tl[1, 1]), maximum(abs.(Tr))), smallnum)
            tmp = (Tl[1, 1] - Tr[1, 1], -Tr[1, 2], - Tr[2, 1], Tl[1, 1] - Tr[2, 2])
            btmp = (B[1, 1], B[1, 2])
        else # n2 == 2 && n2 == 1
            smin = max(epst * max(abs(Tr[1, 1]), maximum(abs.(Tl))), smallnum)
            tmp = (Tl[1, 1] - Tr[1, 1], Tl[2, 1], Tl[1, 2], Tl[2, 2] - Tr[1, 1])
            btmp = (B[1, 1], B[2, 1])
        end
        # solve 2x2 w/ protected complete pivoting
        a, ipiv = findmax(abs.(tmp))
        u11 = tmp[ipiv]
        perturbed = false
        if a <= smin
            perturbed = true
            u11 = smin
        end
        locu12, locl21, locu22 = _syl2x2_inds(ipiv)
        u12 = tmp[locu12]
        l21 = tmp[locl21] / u11
        u22 = tmp[locu22] - u12 * l21
        xswap, bswap = _syl2x2_swaps(ipiv)
        if abs(u22) <= smin
            perturbed = true
            u22 = smin
        end
        if bswap
            btmp = (btmp[2], btmp[1] - l21 * btmp[2])
        else
            btmp = (btmp[1], btmp[2] - l21 * btmp[1])
        end
        scale = one(T)
        if ((2 * smallnum) * abs(btmp[2]) > abs(u22)) ||
                ((2 * smallnum) * abs(btmp[1]) > abs(u11))
            scale = (1 / T(2)) / max(abs(btmp[1]), abs(btmp[2]))
            btmp = (scale * btmp[1], scale * btmp[2])
        end
        x22 = btmp[2] / u22
        X2 = (btmp[1] / u11 - (u12 / u11) * x22, x22)
        if xswap
            X2 = (X2[2], X2[1])
        end
        if n1 == 1
            X = [X2[1] X2[2]]
            xnorm = abs(X[1, 1]) + abs(X[1, 2])
        else
            X = [X2[1], X2[2]]
            xnorm = max(abs(X[1, 1]), abs(X[2, 1]))
        end
    end
    return X, xnorm, scale, perturbed
end
@inline function _syl2x2_inds(i)
    # locu12, locl21, locu22
    i == 1 && return (3, 2, 4)
    i == 2 && return (4, 1, 3)
    i == 3 && return (1, 4, 2)
    return (2, 3, 1)
end
@inline function _syl2x2_swaps(i)
    # xswap, bswap
    i == 1 && return (false, false)
    i == 2 && return (false, true)
    i == 3 && return (true, false)
    return (true, true)
end

# TODO: we only need these for order=3, so just write them out inline

# apply shifted reflector from right
@inline function _reflectorYlppa!(x::AbstractVector, τ::Number, A::StridedMatrix)
    require_one_based_indexing(x)
    m, n = size(A)
    if length(x) != n
        throw(DimensionMismatch("reflector has length $(length(x)), which must match the second dimension of matrix A, $n"))
    end
    @inbounds begin
        for j in 1:m
            # dot
            Ajv = A[j, n]
            for i in 1:(n - 1)
                Ajv += A[j, i] * x[i + 1]
            end

            Ajv = τ * Ajv

            # ger
            A[j, n] -= Ajv
            for i in 1:(n - 1)
                A[j, i] -= Ajv * x[i + 1]'
            end
        end
    end
    return A
end
# apply shifted reflector from left
@inline function _reflectorYappl!(x::AbstractVector, τ::Number, A::StridedMatrix)
    require_one_based_indexing(x)
    m, n = size(A)
    if length(x) != m
        throw(DimensionMismatch("reflector has length $(length(x)), which must match the first dimension of matrix A, $m"))
    end
    @inbounds begin
        for j in 1:n
            # dot
            vAj = A[m, j]
            for i in 1:(m - 1)
                vAj += x[i + 1]' * A[i, j]
            end

            vAj = conj(τ) * vAj

            # ger
            A[m, j] -= vAj
            for i in 1:(m - 1)
                A[i, j] -= x[i + 1] * vAj
            end
        end
    end
    return A
end

# Reordering generalized Schur decompositions, Real element type

# needed for delegated RQ
using MatrixFactorizations

function gordschur!(
        S::StridedMatrix{Ty}, T::StridedMatrix{Ty},
        Q::StridedMatrix{Ty}, Z::StridedMatrix{Ty},
        select::Union{Vector{Bool}, BitVector};
        scale::Bool = true
    ) where {Ty <: AbstractFloat}
    n = size(S, 1)
    if scale
        scaleA, cscale, anrm = _scale!(S)
        scaleB, cscaleb, bnrm = _scale!(T)
    else
        scaleA = false
        scaleB = false
        cscale = cscaleb = anrm = bnrm = one(Ty)
    end

    safmin = floatmin(Ty)
    # logic from dtgsen
    ks = 0
    inpair = false
    α = zeros(complex(Ty), n)
    β = zeros(Ty, n)
    for k in 1:n
        if inpair
            inpair = false
        else
            doswap = select[k]
            if k < n
                if S[k + 1, k] != 0
                    inpair = true
                    doswap = doswap | select[k + 1]
                end
            end
            if doswap
                ks += 1
                if k != ks
                    _, ks, ok = _trexchange!(S, T, Q, Z, k, ks)
                    ok || throw(IllConditionException(k))
                    @mydebug println("after swap ks=$ks")
                end
                if inpair
                    ks += 1
                end
            end
        end
    end
    if scaleA
        safescale!(S, cscale, anrm)
    end
    if scaleB
        safescale!(T, cscaleb, bnrm)
    end

    # in case of poor conditioning, eigvals may be significantly modified
    # so recomputation is advised and standardization may be needed
    inpair = false
    for k in 1:n
        if inpair
            inpair = false
        else
            if k < n
                if S[k + 1, k] != 0
                    inpair = true
                end
            end
            if inpair
                β1, β2, αr1, αr2, αi = _ggs_2x2(S[k:(k + 1), k:(k + 1)], T[k:(k + 1), k:(k + 1)], safmin)
                α[k] = αr1 + im * αi
                α[k + 1] = αr2 - im * αi
                β[k] = β1
                β[k + 1] = β2
            else
                if copysign(one(Ty), T[k, k]) < 0 # includes -0.0
                    S[k, :] .= -S[k, :]
                    T[k, :] .= -T[k, :]
                    if size(Q, 1) > 0
                        Q[:, k] .= -Q[:, k]
                    end
                end
                α[k] = S[k, k]
                β[k] = T[k, k]
            end
        end
    end
    return S, T, α, β, Q, Z
end

function _trexchange!(S::AbstractMatrix{Ty}, T, Q, Z, iold, inew) where {Ty <: Real}
    # based on dtgexc
    n = size(T, 1)
    ok = true
    if n <= 1
        return iold, inew, ok
    end
    # function to get block size
    nbsize(j) = ((j < n) && (S[j + 1, j] != 0)) ? 2 : 1
    # find first block size and location
    if (iold > 1) && (S[iold, iold - 1] != 0)
        iold -= 1
    end
    nbold = nbsize(iold)
    # find final block size and location
    if (inew > 1) && (S[inew, inew - 1] != 0)
        inew -= 1
    end
    nbnew = nbsize(inew)
    if iold == inew
        @mydebug println("no-op call to swap $iold,$inew")
        return iold, inew, true
    end

    if iold < inew
        # WARNING: this branch has not been tested yet
        @mydebug println(
            "forward swap $iold:$(iold + nbold - 1)"
                * " with $inew:$(inew + nbnew - 1)"
        )
        if nbold == 2 && nbnew == 1
            inew -= 1
        end
        if nbold == 1 && nbnew == 2
            inew += 1
        end
        ihere = iold
        while ihere < inew
            # swap with next one below
            if nbold ∈ (1, 2)
                nbnext = nbsize(ihere + nbold)
                ok = _swap1or2!(S, T, Q, Z, ihere, nbold, nbnext)
                ok || return iold, ihere, ok
                ihere += nbnext
                # test if 2x2 block breaks into two 1x1
                if nbold == 2 && S[ihere + 1, ihere] == 0
                    nbold = 3
                end
            else
                # current block is a pair of 1x1, each must be swapped individually
                nbnext = nbsize(ihere + 1)
                ok = _swap1or2!(S, T, Q, Z, ihere + 1, 1, nbnext)
                ok || return iold, ihere, ok
                if nbnext == 1
                    ok = _swap1or2!(S, T, Q, Z, ihere, 1, nbnext)
                    ihere += 1
                else
                    # recompute nbnext in case 2x2 split
                    if S[ihere + 2, ihere + 1] == 0
                        nbnext = 1
                    end
                    if nbnext == 2
                        # no split
                        ok = _swap1or2!(S, T, Q, Z, ihere, 1, nbnext)
                        ok || return iold, ihere, ok
                        ihere += 2
                    else
                        # split
                        ok = _swap1or2!(S, T, Q, Z, ihere, 1, 1)
                        ok || return iold, ihere, ok
                        ihere += 1
                        ok = _swap1or2!(S, T, Q, Z, ihere, 1, 1)
                        ok || return iold, ihere, ok
                        ihere += 1
                    end
                end
            end
        end # forward ihere loop
    else # inew < iold
        @mydebug println(
            "reverse swap $iold:$(iold + nbold - 1)"
                * " with $inew:$(inew + nbnew - 1)"
        )
        ihere = iold
        while ihere > inew
            if nbold ∈ (1, 2)
                nbnext = ((ihere >= 3) && (S[ihere - 1, ihere - 2] != 0)) ? 2 : 1
                ok = _swap1or2!(S, T, Q, Z, ihere - nbnext, nbnext, nbold)
                ok || return iold, ihere, ok
                ihere -= nbnext
                if nbold == 2 && S[ihere + 1, ihere] == 0
                    # 2x2 block breaks into pair of 1x1
                    nbold == 3
                    @mydebug println("2x2 block separated")
                end
            else
                # two 1x1 blocks
                nbnext = ((ihere >= 3) && (S[ihere - 1, ihere - 2] != 0)) ? 2 : 1
                ok = _swap1or2!(S, T, Q, Z, ihere - nbnext, nbnext, 1)
                ok || return iold, ihere, ok
                if nbnext == 1
                    # swap 2 1x1s
                    ok = _swap1or2!(S, T, Q, Z, ihere, nbnext, 1)
                    ok || return iold, ihere, ok
                    ihere -= 1
                else
                    # recompute in case of 2x2 split
                    if S[ihere, ihere - 1] == 0
                        nbnext = 1
                    end
                    if nbnext == 2
                        # no split
                        ok = _swap1or2!(S, T, Q, Z, ihere - 1, 2, 1)
                        ok || return iold, ihere, ok
                        ihere -= 2
                    else
                        # split
                        ok = _swap1or2!(S, T, Q, Z, ihere, 1, 1)
                        ok || return iold, ihere, ok
                        ihere -= 1
                        ok = _swap1or2!(S, T, Q, Z, ihere, 1, 1)
                        ok || return iold, ihere, ok
                        ihere -= 1
                    end
                end
            end
        end # reverse ihere loop
    end
    inew = ihere
    return iold, inew, ok
end

"""
`_swap1or2!(A,B,Q,Z,j1,n1,n2)`

Swap adjacent 1x1 or 2x2 blocks in real-Schur pair (A,B) via unitary equivalence transform.
Apply same transform to associated Q,Z.
Reference: Kågström & Poromaa LAWN 87 [K&P]
"""
function _swap1or2!(
        A::AbstractMatrix{Ty}, B, Q, Z, j1, n1, n2;
        require_strong = true
    ) where {Ty <: Real}
    # translation of dtgex2
    @mydebug println(" at $j1 block sizes $n1, $n2")

    n = size(B, 1)
    j1 + n1 > n && return true
    if n1 == 1 && n2 == 1
        # logic for this case should be the same as the Complex version
        ok = _rtrexch2!(A, B, Q, Z, j1)
        return ok
    else
        # at least one 2x2 block
        m = n1 + n2
        je = j1 + m - 1 # last index in working region
        # copy diagonal n1+n2 superblock
        S = A[j1:je, j1:je]
        T = B[j1:je, j1:je]

        dnorm = norm(S, Inf)
        smallnum = floatmin(Ty) / eps(Ty)
        thresh = max(20 * eps(Ty) * dnorm, smallnum)
        threshb = max(20 * eps(Ty) * norm(T, Inf), smallnum)

        # solve Sylvester system (signs follow LAPACK, not K&P)
        # S₁₁ R - L S₂₂ = γ S₁₂
        # T₁₁ R - L T₂₂ = γ T₁₂
        i2 = n1 + 1
        XR, XL, _, scale, pert = _syl1or2(
            view(S, 1:n1, 1:n1),
            view(S, i2:m, i2:m),
            view(S, 1:n1, i2:m),
            view(T, 1:n1, 1:n1),
            view(T, i2:m, i2:m),
            view(T, 1:n1, i2:m)
        )
        @mydebug pert && println("  numerically singular Sylvester was perturbed")

        # use solution to get swapping transformations
        LI = vcat(-XL, scale * I(n2))
        q_li, _ = qr!(LI)
        q_li = q_li * I(m) # materialization via `Matrix()` may give partial rank

        IR = hcat(scale * I(n1), XR)
        r_ir, z_ir = rq!(IR)
        z_ir = z_ir * I(m)
        # Note that z_ir is transposed wrt K&P

        # perform swap tentatively
        s1 = (q_li' * S) * z_ir'
        t1 = (q_li' * T) * z_ir'

        # Now we need to triangularize B again. Select the more accurate scheme,
        # based on weak stability criterion (posterior |S₂₁|)

        # triangularize B blocks by RQ, apply Q from left to A
        t2a, z_t1a = rq(t1)
        s2a = s1 * z_t1a'
        z2a = z_t1a * z_ir
        brq_a21 = _safe_fnorm(view(s2a, (n2 + 1):m, 1:n2))

        # triangularize B blocks by QR, apply Q from right to A
        q_t1b, t2b = qr(t1)
        s2b = q_t1b' * s1
        q2b = q_li * q_t1b
        bqr_a21 = _safe_fnorm(view(s2b, (n2 + 1):m, 1:n2))

        # weak stability test
        @mydebug println("  weak test: |A21| from qr(B): $bqr_a21: from rq(B): $brq_a21")
        if !(min(bqr_a21, brq_a21) <= thresh)
            @mydebug println("  failed weak stability test")
            return false
        end

        # decide which is preferable
        if (bqr_a21 <= brq_a21)
            s_new = s2b
            t_new = t2b
            z_new = z_ir
            q_new = q2b
        else
            s_new = s2a
            t_new = t2a
            z_new = z2a
            q_new = q_li
        end

        if require_strong
            resa = _safe_fnorm(A[j1:je, j1:je] - q_new * s_new * z_new)
            resb = _safe_fnorm(B[j1:je, j1:je] - q_new * t_new * z_new)
            @mydebug println("  strong test: resA=$resa resB=$resb [thresh $thresh, $threshb]")
            if !(resa <= thresh && resb <= threshb) # also catches NaN
                @mydebug println("  failed strong stability test")
                return false
            end
        end

        s_new[(n2 + 1):m, 1:n2] .= zero(Ty)
        # copy back the transformed blocks
        A[j1:je, j1:je] .= s_new
        B[j1:je, j1:je] .= t_new

        # find transformations to standardize the Schur form
        z_tmp = zeros(Ty, m, m)
        q_tmp = zeros(Ty, m, m)
        if n2 > 1
            j2 = j1 + 1
            _, _, csl, snl, csr, snr = _gqz_2x2!(
                view(A, j1:j2, j1:j2),
                view(B, j1:j2, j1:j2)
            )
            q_tmp[1, 1] = csl
            q_tmp[2, 1] = snl
            q_tmp[1, 2] = -snl
            q_tmp[2, 2] = csl
            z_tmp[1, 1] = csr
            z_tmp[2, 1] = snr
            z_tmp[1, 2] = -snr
            z_tmp[2, 2] = csr
        else
            z_tmp[1, 1] = one(Ty)
            q_tmp[1, 1] = one(Ty)
        end
        j3 = j1 + n2 # start of new trailing block
        if n1 > 1
            _, _, csl, snl, csr, snr = _gqz_2x2!(
                view(A, j3:je, j3:je),
                view(B, j3:je, j3:je)
            )
            q_tmp[m - 1, m - 1] = csl
            q_tmp[m, m - 1] = snl
            q_tmp[m - 1, m] = -snl
            q_tmp[m, m] = csl
            z_tmp[m - 1, m - 1] = csr
            z_tmp[m, m - 1] = snr
            z_tmp[m - 1, m] = -snr
            z_tmp[m, m] = csr
        else
            q_tmp[m, m] = one(Ty)
            z_tmp[m, m] = one(Ty)
        end
        # update other parts of active region in A, B (new A₁₂, B₁₂)

        # A[j1:j3-1,j3:je] .= q_tmp[1:n2,1:n2]' * A[j1:j3-1,j3:je]
        # B[j1:j3-1,j3:je] .= q_tmp[1:n2,1:n2]' * B[j1:j3-1,j3:je]
        # A[j1:j3-1,j3:je] .= A[j1:j3-1,j3:je] * z_tmp[n2+1:m,n2+1:m]
        # B[j1:j3-1,j3:je] .= B[j1:j3-1,j3:je] * z_tmp[n2+1:m,n2+1:m]

        ab_tmp = similar(q_tmp, n2, n1)
        mul!(ab_tmp, view(q_tmp', 1:n2, 1:n2), view(A, j1:(j3 - 1), j3:je))
        mul!(view(A, j1:(j3 - 1), j3:je), ab_tmp, view(z_tmp, (n2 + 1):m, (n2 + 1):m))
        mul!(ab_tmp, view(q_tmp', 1:n2, 1:n2), view(B, j1:(j3 - 1), j3:je))
        mul!(view(B, j1:(j3 - 1), j3:je), ab_tmp, view(z_tmp, (n2 + 1):m, (n2 + 1):m))

        # combine transformations
        q_new = q_new * q_tmp
        # z_new came from direct factorization(s), so take adjoint to make it like Z
        z_new = z_new' * z_tmp

        # accumulate into Q and Z
        wantQ = size(Q, 1) > 0
        wantZ = size(Z, 1) > 0
        if wantQ || wantZ
            qz_tmp = similar(q_new, n, m)
        end
        if wantQ
            # Q[:,j1:je] .= Q[:,j1:je] * q_new
            mul!(qz_tmp, view(Q, :, j1:je), q_new)
            copy!(view(Q, :, j1:je), qz_tmp)
        end
        if wantZ
            # Z[:,j1:je] .= Z[:,j1:je] * z_new
            mul!(qz_tmp, view(Z, :, j1:je), z_new)
            copy!(view(Z, :, j1:je), qz_tmp)
        end
        # update leading and trailing sections of A, B
        if je < n
            A[j1:je, (je + 1):n] .= q_new' * A[j1:je, (je + 1):n]
            B[j1:je, (je + 1):n] .= q_new' * B[j1:je, (je + 1):n]
        end
        if j1 > 0
            A[1:(j1 - 1), j1:je] .= A[1:(j1 - 1), j1:je] * z_new
            B[1:(j1 - 1), j1:je] .= B[1:(j1 - 1), j1:je] * z_new
        end
    end
    return true
end

"""
`_gqz_2x2!(A,B)`

inplace 2x2 real generalized Schur (QZ), assuming B is UT
returns eigenvalue terms and rotation coefficients
"""
function _gqz_2x2!(A::AbstractMatrix{Ty}, B) where {Ty <: Real}
    safmin = floatmin(Ty)
    ulp = eps(Ty)

    # scale A
    anorm = max(abs(A[1, 1]) + abs(A[2, 1]), abs(A[1, 2]) + abs(A[2, 2]), safmin)
    ascale = 1 / anorm
    A .*= ascale
    # scale B
    bnorm = max(abs(B[1, 1]), abs(B[1, 2]) + abs(B[2, 2]), safmin)
    bscale = 1 / bnorm
    B .*= bscale

    wi = zero(Ty)
    # check for early deflation
    if abs(A[2, 1]) < ulp
        csl = one(Ty)
        snl = zero(Ty)
        csr = one(Ty)
        snr = zero(Ty)
        A[2, 1] = zero(Ty)
        B[2, 1] = zero(Ty)
        # check for singular B
    elseif abs(B[1, 1]) < ulp
        csl, snl, _ = givensAlgorithm(A[1, 1], A[2, 1])
        G = Givens(1, 2, csl, snl)
        csr, snr = one(Ty), zero(Ty)
        rmul!(A, G)
        rmul!(B, G)
        A[2, 1] = 0
        B[1:2, 1] .= 0
    elseif abs(B[2, 2]) < ulp
        csr, snr, _ = givensAlgorithm(A[2, 2], A[2, 1])
        G = Givens(1, 2, csr, snr)
        lmul!(G', A)
        lmul!(G', B)
        A[2, 1] = 0
        B[2, 1:2] .= 0
    else
        scale1, scale2, wr1, wr2, wi = _ggs_2x2(A, B, floatmin(Ty))
        if wi == 0
            # two reals
            # compute H = s * A - w * B
            h1 = scale1 * A[1, 1] - wr1 * B[1, 1]
            h2 = scale1 * A[1, 2] - wr1 * B[1, 2]
            h3 = scale1 * A[2, 2] - wr1 * B[2, 2]
            rr = hypot(h2, h1)
            qq = hypot(scale1 * A[2, 1], h3)
            if rr > qq
                # find right rotation to zero H[1,1]
                csr, snr, _ = givensAlgorithm(h2, h1)
            else
                # zero H[2,1]
                csr, snr, _ = givensAlgorithm(h3, scale1 * A[2, 1])
            end
            G = Givens(1, 2, csr, snr)
            rmul!(A, G)
            rmul!(B, G)
            snr = -snr
            t1 = max(abs(A[1, 1]) + abs(A[1, 2]), abs(A[2, 1]) + abs(A[2, 2]))
            t2 = max(abs(A[1, 1]) + abs(A[1, 2]), abs(A[2, 1]) + abs(A[2, 2]))
            if scale1 * t1 >= abs(wr1) * t2
                # left rotation to zero B[2,1]
                csl, snl, _ = givensAlgorithm(B[1, 1], B[2, 1])
            else
                # left rotation to zero A[2,1]
                csl, snl, _ = givensAlgorithm(A[1, 1], A[2, 1])
            end
            G = Givens(1, 2, csl, snl)
            lmul!(G, A)
            lmul!(G, B)
            A[2, 1] = 0
            B[2, 1] = 0
        else
            # complex pair
            ssmin, ssmax, snr, csr, snl, csl = _gsvd_2x2(B)
            G = Givens(1, 2, csr, snr)
            rmul!(A, G')
            rmul!(B, G')
            G = Givens(1, 2, csl, snl)
            lmul!(G, A)
            lmul!(G, B)
            B[2, 1] = 0
            B[1, 2] = 0
        end
    end

    # undo scaling
    A .*= anorm
    B .*= bnorm
    if wi == 0
        α = [A[1, 1] + zero(Ty) * im, A[2, 2] + zero(Ty) * im]
        β = [B[1, 1], B[2, 2]]
    else
        α1 = anorm * (wr1 + wi * im) / scale1 / bnorm
        α = [α1, conj(α1)]
        β = ones(Ty, 2)
    end
    return α, β, csl, snl, csr, snr
end

"""
_syl1or2(A,B,C,D,E,F)

solve A R - L B = scale * C; D R - L E = scale * F
where orders are small and coeffts are generalized Schur forms
"""
function _syl1or2(A::AbstractMatrix{Ty}, B, C, D, E, F) where {Ty}
    # we may want to use a specific inline scheme (cf. dtgsy2)
    # use simpler explicit Kronecker scheme until we have reason to do so
    n1 = checksquare(A)
    n2 = checksquare(B)
    dimsok = (
        (size(F) == (n1, n2)) && (size(C) == (n1, n2))
            && (n1 == checksquare(D)) && (n2 == checksquare(E))
    )
    dimsok || throw(DimensionMismatch("args have incompatible dimensions"))

    K = [kron(I(n2), A) kron(-B', I(n1)); kron(I(n2), D) kron(-E', I(n1))]
    rl = vcat(vec(C), vec(F))
    rl, scale, perturbed = _safe_lu_solve!(K, rl)
    xnorm = maximum(abs, rl)
    nn = n1 * n2
    R = reshape(rl[1:nn], n1, n2)
    L = reshape(rl[(nn + 1):end], n1, n2)
    return R, L, xnorm, scale, perturbed
end

# this should not be needed (method used for complex should suffice)
# but LAPACK organizes the logic differently from complex, so we follow
# them for now
# TODO: figure out why simple call to general version failed
function _rtrexch2!(
        A::AbstractMatrix{Ty}, B, Q, Z, j1;
        require_strong = true, throws = false
    ) where {Ty <: AbstractFloat}
    # copy the block to try the swap
    S = A[j1:(j1 + 1), j1:(j1 + 1)]
    T = B[j1:(j1 + 1), j1:(j1 + 1)]
    # compute threshold for acceptance
    smlnum = safemin(Ty) / eps(Ty)
    W = hcat(S, T)
    sa = _safe_fnorm(vec(W))
    thresh = max(Ty(20) * eps(Ty) * sa, smlnum)

    # compute Givens rotations which would swap blocks
    # and tentatively do it
    f = S[2, 2] * T[1, 1] - T[2, 2] * S[1, 1]
    g = S[2, 2] * T[1, 2] - T[2, 2] * S[1, 2]
    sa = abs(S[2, 2]) * abs(T[1, 1])
    sb = abs(S[1, 1]) * abs(T[2, 2])
    cz, sz, _ = givensAlgorithm(f, g)
    sz, cz = cz, sz
    Gz1 = Givens(1, 2, Ty(cz), -sz)
    rmul!(S, adjoint(Gz1))
    rmul!(T, adjoint(Gz1))
    if sa >= sb
        fq, gq = S[1, 1], S[2, 1]
    else
        fq, gq = T[1, 1], T[2, 1]
    end
    if sz != 0 && fq == 0 && gq == 0
        # patch for continuity (edge case, not handled thus in LAPACK)
        # CHECKME: the condition may not be optimal
        cq, sq = zero(Ty), one(Ty)
    else
        cq, sq, _ = givensAlgorithm(fq, gq)
    end
    Gq1 = Givens(1, 2, Ty(cq), sq)
    lmul!(Gq1, S)
    lmul!(Gq1, T)
    # weak stability test: subdiags <= O( ϵ norm((S,T),"F"))
    ws = abs(S[2, 1]) + abs(T[2, 1])
    @mydebug println("  weak test: subdiag norm = $ws")
    if !(ws <= thresh)
        @mydebug println("  failed weak stability test")
        throws && throw(IllConditionException(j1))
        return false
    end

    if require_strong
        # Strong stability test
        # Supposedly equiv. to
        # |[A-Qᴴ*S*Z, B-Qᴴ*T*Z]| <= O(1) ϵ |[A,B]| in F-norm
        Ss = copy(S)
        Ts = copy(T)
        Gz2 = Givens(1, 2, Ty(cz), sz)
        rmul!(Ss, adjoint(Gz2))
        rmul!(Ts, adjoint(Gz2))
        Gq2 = Givens(1, 2, Ty(cq), -sq)
        lmul!(Gq2, Ss)
        lmul!(Gq2, Ts)
        Ss .-= A[j1:(j1 + 1), j1:(j1 + 1)]
        Ts .-= B[j1:(j1 + 1), j1:(j1 + 1)]
        W = hcat(Ss, Ts)
        ss = _safe_fnorm(vec(W))
        @mydebug println("  strong test resid=$ss [thresh=$thresh]")
        if !(ss <= thresh)
            @mydebug println("  failed strong stability test")
            throws && throw(IllConditionException(j1))
            return false
        end
    end
    Gz = Givens(j1, j1 + 1, Ty(cz), -sz)
    rmul!(A, adjoint(Gz))
    rmul!(B, adjoint(Gz))
    Gq = Givens(j1, j1 + 1, Ty(cq), sq)
    lmul!(Gq, A)
    lmul!(Gq, B)
    A[j1 + 1, j1] = zero(Ty)
    B[j1 + 1, j1] = zero(Ty)
    rmul!(Z, adjoint(Gz))
    rmul!(Q, adjoint(Gq))
    return true
end

# only push coverage from one bot
get(ENV, "TRAVIS_OS_NAME", nothing) == "linux" || exit(0)
get(ENV, "TRAVIS_JULIA_VERSION", nothing) == "1.0"   || exit(0)

using Coverage

cd(joinpath(@__DIR__, "..", "..")) do
    Codecov.submit(Codecov.process_folder())
end

function run_unbalanced(A::AbstractMatrix{T}) where {T}
    n = size(A, 1)
    fu = eigen(A, scale = false)
    if T <: BlasFloat
        # use our code for balancing since that's what we're testing
        Abal, B = balance!(copy(A))
        fb1 = eigen(Abal, scale = false)
        fb = LinearAlgebra.Eigen(fb1.values, lmul!(B, fb1.vectors))
    else
        fb = eigen(A, scale = true)
    end
    if VERSION < v"1.2-"
        # compensate for sometime uncontrolled order of eigenvalues
        ewu, vu = fu
        ewb, vb = fb
        p = sortperm(real.(ewu))
        ewu = ewu[p]
        vu = vu[:, p]
        fu = LinearAlgebra.Eigen(ewu, vu)
        p = sortperm(real.(ewb))
        ewb = ewb[p]
        vb = vb[:, p]
        fb = LinearAlgebra.Eigen(ewb, vb)
    end
    return fu, fb
end

# A badly-balanced matrix based on the literature.
function unbal_classic(::Type{T}) where {T}
    m = round(-2 * log2(eps(real(T))) / 5)
    x = 2.0^m
    A = T.([1 0 x^(-2); 1 1 x^(-1); x^2 x 1])
    rt2 = sqrt(T(2))
    rth = rt2 / 2
    # warning: these are only accurate to O(1/x^3) IIUC
    λ = [1 - rt2 + 1 / (4x), 1 - 1 / (2x), 1 + rt2 + 1 / (4x)]
    v1 = [-rth / (x^2), -rth / x + 3 / (8 * x^2), 1]
    v2 = [-2 / x, 2 - 1 / (x^2), 1]
    v3 = [rth / (x^2), rth / x + 3 / (8 * x^2), 1]
    V = hcat(v1, v2, v3)
    return A, λ, V
end

if piracy
    bal_test_types = (
        Float64, ComplexF64,
        BigFloat, Complex{BigFloat},
    )
else
    bal_test_types = (
        Float64, ComplexF64,
    )
end

# Note: to avoid fragility, we only require that the worst unbalanced error be
# much larger than the worst balanced one.
# Typically all unbalanced eigenvalues are poor.
@testset "balancing $T" for T in bal_test_types
    A, λ, V = unbal_classic(T)
    fu, fb = run_unbalanced(A)
    ru = maximum([abs(fu.values[j] - λ[j]) for j in 1:3])
    rb = maximum([abs(fb.values[j] - λ[j]) for j in 1:3])
    @test ru > 100rb

    if T <: Complex
        Abal, B = balance!(copy(A))
        sb = GenericSchur.gschur(copy(Abal))
        Vl = GenericSchur.geigvecs(sb, left = true)
        ldiv!(B, Vl)
        @test A' * Vl ≈ Vl * diagm(0 => conj.(sb.values))
    end
end
@testset "balancing sanity" begin
    for n1 in [0, 1, 2]
        for n2 in [0, 1, 2]
            for n3 in [0, 1, 2]
                n = n1 + n2 + n3
                n == 0 && continue
                A1 = triu(rand(n1, n1))
                A2 = rand(n2, n2)
                A3 = triu(rand(n3, n3))
                A = [A1 zeros(n1, n2 + n3); zeros(n2, n1) A2 zeros(n2, n3); zeros(n3, n1 + n2) A3]
                Pc = zeros(n, n)
                ic = randperm(n)
                for i in 1:n
                    Pc[i, ic[i]] = 1
                end
                Ax = Pc' * A * Pc
                C, B = balance!(copy(Ax))
                @test B.ilo <= B.ihi
                nsubdiag = 0
                for i in 1:n
                    for j in 1:(i - 1)
                        if (i < B.ilo) || (j > B.ihi)
                            if C[i, j] != 0
                                nsubdiag += 1
                            end
                        end
                    end
                end
                @test nsubdiag == 0
            end # for n3
        end
    end
end

# This file is part of GenericSchur.jl, released under the MIT "Expat" license

"""
    triangularize(S::Schur{T}) => Schur{complex{T})

convert a (standard-form) quasi-triangular real Schur factorization into a
triangular complex Schur factorization.
"""
function triangularize(S::Schur{Ty}) where {Ty <: Real}
    CT = complex(Ty)
    Tr = S.T
    T = CT.(Tr)
    Z = CT.(S.Z)
    n = size(T, 1)
    for j in n:-1:2
        if Tr[j, j - 1] != zero(CT)
            # We want a unitary similarity transform from
            # ┌   ┐      ┌     ┐
            # │a b│      │w₁  x│
            # │c a│ into │0  w₂│ where bc < 0 (a,b,c real)
            # └   ┘      └     ┘
            # If we write it as
            # ┌     ┐
            # │u  v'│
            # │-v u'│
            # └     ┘
            # and make the Ansatz that u is real (so v is imaginary),
            # we arrive at:
            # θ = atan(sqrt(-Tr[j,j-1]/Tr[j-1,j]))
            # s = sin(θ)
            # c = cos(θ)
            s = sqrt(abs(Tr[j, j - 1]))
            c = sqrt(abs(Tr[j - 1, j]))
            r = hypot(s, c)
            G = Givens(j - 1, j, complex(c / r), -im * (s / r))
            lmul!(G, T)
            rmul!(T, G')
            rmul!(Z, G')
        end
    end
    triu!(T)
    return Schur(T, Z, diag(T))
end

# This file is part of GenericSchur.jl, released under the MIT "Expat" license

# The methods in this file are derived from LAPACK's ztrsyl.
# LAPACK is released under a BSD license, and is
# Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.

function trsylvester!(
        A::UpperTriangular{T, S}, B::UpperTriangular{T, S},
        C::StridedVecOrMat{T};
        possign = false
    ) where {T, S <: StridedMatrix{T}}
    return trsylvester!(A.data, B.data, C, possign = possign)
end

"""
    trsylvester!(A,B,C) => X, σ

solve the Sylvester equation ``A X - X B = σ C``
for upper triangular and square `A` and `B`, overwriting `C`
and setting `σ` to avoid overflow.
"""
function trsylvester!(A::StridedMatrix{T}, B::StridedMatrix{T}, C::StridedVecOrMat{T}; possign = false) where {T}
    m = checksquare(A)
    n = checksquare(B)
    ((size(C, 1) == m) && (size(C, 2) == n)) || throw(
        DimensionMismatch(
            "dimensions of C $(size(C)) must match A, ($m,$m), and B, ($n,$n)"
        )
    )

    scale = one(real(T))

    tiny = eps(real(T))
    small = safemin(real(T)) * m * n / tiny
    bignum = one(real(T)) / small
    smin = max(small, tiny * norm(A, Inf) * norm(B, Inf))

    isgn = possign ? one(real(T)) : -one(real(T))
    perturbed = false
    for l in 1:n
        for k in m:-1:1
            # FIXME: these should be dotu(), but I can't find anything usable in stdlib::LA
            # WARNING: this relies on isempty() pass in checkindex() for view()
            suml = sum(view(A, k, (k + 1):m) .* view(C, (k + 1):m, l))
            sumr = sum(view(C, k, 1:(l - 1)) .* view(B, 1:(l - 1), l))
            v = C[k, l] - (suml + isgn * sumr)
            scaloc = one(real(T))
            a11 = A[k, k] + isgn * B[l, l]
            da11 = abs1(a11)
            if da11 <= smin
                a11 = smin
                da11 = smin
                perturbed = true
            end
            db = abs1(v)
            if (da11 < 1) && (db > 1)
                if (db > bignum * da11)
                    # println("scaling by $db")
                    scaloc = 1 / db
                end
            end
            x11 = (v * scaloc) / a11
            if scaloc != 1
                lmul!(scaloc, C)
                scale *= scaloc
            end
            C[k, l] = x11
        end
    end
    return C, scale, perturbed
end

function adjtrsylvester!(
        A::UpperTriangular{T, S}, B::UpperTriangular{T, S},
        C::StridedVecOrMat{T};
        possign = false
    ) where {T, S <: StridedMatrix{T}}
    return adjtrsylvester!(A.data, B.data, C, possign = possign)
end

"""
    adjtrsylvester!(A,B,C) => X, σ

solve the Sylvester equation ``Aᴴ X - X Bᴴ = σ C``,
for upper triangular `A` and `B`, overwriting `C`
and setting `σ` to avoid overflow.
"""
function adjtrsylvester!(A::StridedMatrix{T}, B::StridedMatrix{T}, C::StridedVecOrMat{T}; possign = false) where {T}
    m = checksquare(A)
    n = checksquare(B)
    ((size(C, 1) == m) && (size(C, 2) == n)) || throw(
        DimensionMismatch(
            "dimensions of C $(size(C)) must match A, ($m,$m), and B, ($n,$n)"
        )
    )

    scale = one(real(T))

    tiny = eps(real(T))
    small = safemin(real(T)) * m * n / tiny
    bignum = one(real(T)) / small
    smin = max(small, tiny * norm(A, Inf) * norm(B, Inf))

    perturbed = false
    isgn = possign ? one(real(T)) : -one(real(T))
    for l in n:-1:1
        for k in 1:m
            suml = dot(view(A, 1:(k - 1), k), view(C, 1:(k - 1), l))
            # WARNING: this relies on isempty() pass in checkindex() for view()
            sumr = dot(view(C, k, (l + 1):n), view(B, l, (l + 1):n))
            v = C[k, l] - (suml + isgn * conj(sumr))
            scaloc = one(real(T))
            a11 = conj(A[k, k] + isgn * B[l, l])
            da11 = abs1(a11)
            if da11 < smin
                a11 = smin
                da11 = smin
                perturbed = true
            end
            db = abs1(v)
            if (da11 < 1) && (db > 1)
                if (db > bignum * da11)
                    scaloc = 1 / db
                end
            end
            x11 = (v * scaloc) / a11
            if scaloc != 1
                lmul!(scaloc, C)
                scale *= scaloc
            end
            C[k, l] = x11
        end
    end
    return C, scale, perturbed
end

if VERSION <= v"1.12-"
    # name will be local
    struct RobustRepresentations <: LinearAlgebra.Algorithm end
else
    using LinearAlgebra: RobustRepresentations
end

const _HaveMRRR = Ref(false)
# allow another package to provide an implementation
function _registerMRRR()
    return _HaveMRRR[] = true
end

function gschur!(
        H::Hessenberg{Tq, S},
        Z::Union{AbstractMatrix, Nothing} = Matrix(H.Q),
        alg = QRIteration();
        kwargs...
    ) where {S <: SymTridiagonal{T}} where {Tq <: Union{RT, Complex{RT}}, T <: Real} where {RT <: AbstractFloat}
    if isa(alg, RobustRepresentations) && !_HaveMRRR[]
        @warn """GenericSchur does not currently provide `alg=RobustRepresentations`
        (LinearAlgebra default); falling back to `QRIteration`.
        This adjustment will (probably) proceed without future warnings in this session.
        """ maxlog = 1
        alg = QRIteration()
    end
    _gschur!(H.H, alg, Z; kwargs...)
    # aliasing might be a cruel trap, so don't.
    v = copy(H.H.dv)
    if Z === nothing
        return Schur(zeros(Tq, 0, 0), zeros(Tq, 0, 0), v)
    end
    # Schur form must have same type as Z
    n = length(v)
    Tschur = similar(Z, n, n)
    fill!(Tschur, zero(eltype(Z)))
    @inbounds for j in 1:n
        Tschur[j, j] = v[j]
    end
    return Schur(Tschur, Z, v)
end

maybe_sortby(::Nothing) = identity
maybe_sortby(sortby::Function) = sortby

function geigen!(A::SymTridiagonal{T}, alg = QRIteration(); sortby::Union{Function, Nothing} = eigsortby) where {T <: AbstractFloat}
    n = length(A.dv)
    V = Matrix{T}(I, n, n)
    _gschur!(A, alg, V)
    λ = copy(A.dv)
    return LinearAlgebra.Eigen(sorteig!(λ, V, maybe_sortby(sortby))...)
end

function geigvals!(A::SymTridiagonal{T}, alg = QRIteration(); sortby::Union{Function, Nothing} = nothing) where {T <: AbstractFloat}
    _gschur!(A, alg, nothing)
    λ = copy(A.dv)
    return sorteig!(λ, maybe_sortby(sortby))
end

# the rest are internal implementation methods

function _gschur!(
        A::SymTridiagonal{T},
        alg::Algorithm,
        Z::Union{Nothing, AbstractArray} = nothing;
        kwargs...
    ) where {T}
    throw(ArgumentError("Unsupported algorithm $alg"))
end

#translated from LAPACK::zsteqr
# LAPACK Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.
"""
     _gschur!(A::SymTridiagonal, ::QRIteration, Z)

    overwrites `A.dv` with eigenvalues, optionally applying orthogonal transforms to `Z`.
"""
function _gschur!(
        A::SymTridiagonal{T},
        alg::QRIteration,
        Z::Union{Nothing, AbstractArray} = nothing;
        maxiter = 30 * size(A, 1)
    ) where {T}
    d = A.dv
    e = A.ev
    n = length(d)
    wantZ = (Z !== nothing) && (size(Z, 1) > 0)
    if wantZ
        nz = size(Z, 2)
        (nz == n) || throw(DimensionMismatch("second dimension of Z must match tridiagonal A"))
    end

    epsT = eps(T)
    eps2 = epsT^2
    safmin = floatmin(T)
    safmax = 1 / safmin
    ssfmax = sqrt(safmax) / 3
    ssfmin = sqrt(safmin) / eps2

    niter = 0
    gvec = Vector{Givens{T}}(undef, wantZ ? n : 0)

    # Determine where matrix splits and choose QL or QR for each block,
    # according to whether top or bottom diagonal element is smaller.

    l1 = 1
    while l1 <= n
        if l1 > 1
            e[l1 - 1] = zero(T)
        end
        msplit = _st_findsplit_fwd!(d, e, l1, n)
        l = l1
        lsave = l
        lend = msplit
        lendsave = lend
        l1 = msplit + 1
        if lend == l
            @mydebug println("empty at $l, continuing")
            continue
        end
        # scale A[l:lend,l:lend]
        if VERSION > v"1.12-"
            # FIXME: workaround for stdlib bug
            if lend == l + 1
                anorm = opnorm([d[l] e[l]; e[l] d[l + 1]], Inf)
            else
                anorm = opnorm(SymTridiagonal(view(d, l:lend), view(e, l:(lend - 1))), Inf)
            end
        else
            anorm = opnorm(SymTridiagonal(view(d, l:lend), view(e, l:(lend - 1))), Inf)
        end
        iscale = 0
        if anorm == 0
            @mydebug println("null at $l:$lend, continuing")
            continue
        end
        if anorm > ssfmax
            iscale = 1
            safescale!(view(d, l:lend), anorm, ssfmax)
            safescale!(view(e, l:(lend - 1)), anorm, ssfmax)
        elseif anorm < ssfmin
            iscale = 2
            safescale!(view(d, l:lend), anorm, ssfmin)
            safescale!(view(e, l:(lend - 1)), anorm, ssfmin)
        end
        if abs(d[lend]) < abs(d[l])
            lend = lsave
            l = lendsave
        end

        if lend > l
            l, nit = _st_QLIter!(d, e, Z, l, lend, gvec)
        else
            l, nit = _st_QRIter!(d, e, Z, l, lend, gvec)
        end
        niter + - nit
        # undo scaling if necessary
        if iscale == 1
            safescale!(view(d, lsave:lendsave), ssfmax, anorm)
            safescale!(view(e, lsave:(lendsave - 1)), ssfmax, anorm)
        elseif iscale == 2
            safescale!(view(d, lsave:lendsave), ssfmin, anorm)
            safescale!(view(e, lsave:(lendsave - 1)), ssfmin, anorm)
        end

        # check for iteration limit
        if niter >= maxiter
            nbad = count(x -> !iszero(x), e)
            @warn "$nbad eigenvalues failed to converge in $maxiter iterations"
            return
        end
        @mydebug begin
            if l1 <= n
                println("iscale was $iscale; next: l1=$l1")
            else
                println("iscale was $iscale; done.")
            end
        end
    end # outer loop
    return nothing
end

# QL iteration
function _st_QLIter!(d::AbstractVector{T}, e, Z, l, lend, gvec) where {T}
    @mydebug println("QL $l:$lend")
    wantZ = Z !== nothing
    safmin = floatmin(T)
    eps2 = eps(T)^2
    niter = 0
    while l <= lend
        # find small subdiagonal
        msplit = lend
        for m in l:(lend - 1)
            if abs2(e[m]) <= (eps2 * abs(d[m])) * abs(d[m + 1]) + safmin
                msplit = m
                break
            end
        end
        if msplit < lend
            e[msplit] = zero(T)
        end
        p = d[l]
        if msplit != l
            # If remaining matrix is 2x2, diagonalize it
            if msplit == l + 1
                @mydebug println("deflating 2 at $l")
                if wantZ
                    rt1, rt2, cs, sn = _dgz_sym2x2(d[l], e[l], d[l + 1], true)
                    G = Givens(l, l + 1, cs, sn)
                    gvec[l] = G
                    rmul!(Z, G')
                else
                    rt1, rt2 = _dgz_sym2x2(d[l], e[l], d[l + 1], false)
                end
                d[l] = rt1
                d[l + 1] = rt2
                e[l] = zero(T)
                l += 2
                if l <= lend
                    continue # to top of QL loop
                end
                break
            end
            niter += 1
            # compute shift
            g = (d[l + 1] - p) / (2 * e[l])
            r = hypot(g, one(T))
            g = d[msplit] - p + (e[l] / (g + copysign(r, g)))
            s = one(T)
            c = one(T)
            p = zero(T)
            # inner loop
            for i in (msplit - 1):-1:l
                f = s * e[i]
                b = c * e[i]
                c, s, r = givensAlgorithm(g, f)
                if i < msplit - 1
                    e[i + 1] = r
                end
                g = d[i + 1] - p
                r = (d[i] - g) * s + 2 * c * b
                p = s * r
                d[i + 1] = g + p
                g = c * r - b
                if wantZ
                    gvec[i] = Givens(i, i + 1, c, -s)
                end
            end
            if wantZ
                # xlasr RVB
                for i in (msplit - 1):-1:l
                    rmul!(Z, gvec[i]')
                end
            end
            d[l] -= p
            e[l] = g
        else
            d[l] = p
            l += 1
        end
    end # l loop for QL
    @mydebug println("QL end")
    return l, niter
end

# QR iteration
function _st_QRIter!(d::AbstractVector{T}, e, Z, l, lend, gvec) where {T}
    @mydebug println("QR $lend:$l")
    wantZ = Z !== nothing
    safmin = floatmin(T)
    eps2 = eps(T)^2
    niter = 0
    while l >= lend
        msplit = lend
        for m in l:-1:(lend + 1)
            if abs2(e[m - 1]) <= (eps2 * abs(d[m])) * abs(d[m - 1]) + safmin
                msplit = m
                break
            end
        end
        if msplit > lend
            e[msplit - 1] = zero(T)
        end
        p = d[l]
        if msplit != l
            # If remaining matrix is 2x2, diagonalize it
            if msplit == l - 1
                @mydebug println("deflating 2 at $msplit")
                if wantZ
                    rt1, rt2, cs, sn = _dgz_sym2x2(d[l - 1], e[l - 1], d[l], true)
                    G = Givens(l - 1, l, cs, sn)
                    gvec[msplit] = G
                    # xlasr RVF
                    rmul!(Z, G')
                else
                    rt1, rt2, _, _ = _dgz_sym2x2(d[l - 1], e[l - 1], d[l], false)
                end
                d[l - 1] = rt1
                d[l] = rt2
                e[l - 1] = zero(T)
                l -= 2
                if l >= lend
                    continue # to top of QR loop
                end
                break
            end
            niter += 1
            # compute shift
            g = (d[l - 1] - p) / (2 * e[l - 1])
            r = hypot(g, one(T))
            g = d[msplit] - p + (e[l - 1] / (g + copysign(r, g)))
            s = one(T)
            c = one(T)
            p = zero(T)
            # inner loop
            for i in msplit:(l - 1)
                f = s * e[i]
                b = c * e[i]
                c, s, r = givensAlgorithm(g, f)
                if i != msplit
                    e[i - 1] = r
                end
                g = d[i] - p
                r = (d[i + 1] - g) * s + 2 * c * b
                p = s * r
                d[i] = g + p
                g = c * r - b
                if wantZ
                    gvec[i] = Givens(i, i + 1, c, s)
                end
            end
            if wantZ
                # xlasr RVF
                for i in msplit:(l - 1)
                    rmul!(Z, gvec[i]')
                end
            end
            d[l] -= p
            e[l - 1] = g
        else
            d[l] = p
            l -= 1
        end
    end # l loop for QR
    @mydebug println("QR end")
    return l, niter
end

@inline function _st_findsplit_fwd!(d::AbstractVector{T}, e, l1, n) where {T}
    msplit = n
    if l1 <= n - 1
        for m in l1:(n - 1)
            tst = abs(e[m])
            if iszero(tst)
                msplit = m
                break
            end
            if tst <= sqrt(abs(d[m])) * sqrt(abs(d[m + 1])) * eps(T)
                e[m] = zero(T)
                msplit = m
                break
            end
        end
    end
    return msplit
end


function _dgz_sym2x2(a::T, b, c, wantvec) where {T}
    sm = a + c
    df = a - c
    adf = abs(df)
    tb = 2b
    ab = abs(tb)
    (acmx, acmn) = (abs(a) > abs(c)) ? (a, c) : (c, a)
    rt = hypot(ab, adf)
    if sm < zero(T)
        rt1 = (sm - rt) / 2
        sgn1 = -1
        # order of execution important
        # for full accuracy, next line needs higher precision
        rt2 = (acmx / rt1) * acmn - (b / rt1) * b
    elseif sm > zero(T)
        rt1 = (sm + rt) / 2
        sgn1 = 1
        # order of execution important
        # for full accuracy, next line needs higher precision
        rt2 = (acmx / rt1) * acmn - (b / rt1) * b
    else
        rt1, rt2 = rt / 2, -rt / 2
        sgn1 = 1
    end
    if wantvec
        # compute eigenvector
        if df > 0
            cs = df + rt
            sgn2 = 1
        else
            cs = df - rt
            sgn2 = -1
        end
        acs = abs(cs)
        if acs > ab
            ct = -tb / cs
            sn1 = one(T) / sqrt(one(T) + ct^2)
            cs1 = ct * sn1
        else
            if iszero(ab)
                cs1 = one(T)
                sn1 = zero(T)
            else
                tn = -cs / tb
                cs1 = one(T) / sqrt(one(T) + tn^2)
                sn1 = tn * cs1
            end
        end
        if sgn1 == sgn2
            tn = cs1
            cs1 = -sn1
            sn1 = tn
        end
        return rt1, rt2, cs1, sn1
    else
        return rt1, rt2, zero(T), zero(T)
    end
end

# divide-and-conquer algorithm for real symmetric tridiagonals

using LinearAlgebra: DivideAndConquer

# based on LAPACK xSTEDC
function _gschur!(
        A::SymTridiagonal{T},
        alg::DivideAndConquer,
        Z::Union{Nothing, AbstractArray} = nothing;
        maxiter = 0, # for compatibility only
        nqrmax = 25
    ) where {T}
    n = size(A, 1)
    if n == 0
        return A
    end
    if n == 1
        if Z !== nothing
            Z[1, 1] = one(T)
        end
        return
    end
    # following STEDC, we could fall back to Pal-Walker-Kahan scheme for eigvals only

    small_size = nqrmax

    d = A.dv
    e = A.ev
    n = length(d)
    wantZ = (Z !== nothing) && (size(Z, 1) > 0)
    if wantZ
        nz = size(Z, 2)
        (nz == n) || throw(DimensionMismatch("second dimension of Z must match tridiagonal A"))
        Zwrk0 = similar(Z, n, n) # preallocate
    else
        Zwrk0 = zeros(T, n, n)
        Z = nothing # maybe help the compiler
    end

    epsT = eps(T)
    return if n <= small_size
        @mydebug println("QR fallback for (small) full problem")
        _gschur!(A, QRIteration(), Z)
    else
        # if any subdiagonals are negligible, we will
        # subdivide the matrix into independent problems
        istart = 1
        while (istart <= n)
            ifinish = istart
            while ifinish < n
                tiny = epsT * sqrt(abs(d[ifinish])) * sqrt(abs(d[ifinish + 1]))
                if abs(e[ifinish]) <= tiny
                    break
                end
                ifinish += 1
            end
            m = ifinish - istart + 1
            if m == 1
                istart = ifinish + 1
                continue
            end
            dvw = view(d, istart:ifinish)
            evw = view(e, istart:(ifinish - 1))
            if m > small_size
                # scale
                t1, _ = findmax(abs, dvw)
                t2, _ = findmax(abs, evw)
                orgnrm = max(t1, t2)
                dvw .*= (1 / orgnrm)
                evw .*= (1 / orgnrm)
                Zwrk = view(Zwrk0, 1:m, 1:m)
                Zwrk .= I(m)
                _dcschur_core!(dvw, evw, Zwrk, m, nqrmax)
                if Z != nothing
                    # multiply back into Z
                    Ztmp = copy(view(Z, 1:n, istart:ifinish))
                    mul!(view(Z, 1:n, istart:ifinish), Ztmp, Zwrk)
                end
                # unscale
                dvw .*= orgnrm
            else
                # solve subproblem
                # using workspace for Z
                # CHECKME: do we have the same constraint on column(?) dim as STEQR?
                #          otherwise maybe pass Z or a view directly
                if wantZ
                    Zwrk = view(Zwrk0, 1:m, 1:m)
                    Zwrk .= I(m)
                else
                    Zwrk = nothing
                end
                @mydebug println("QR for isolated problem $istart:$ifinish")
                _gschur!(SymTridiagonal(dvw, evw), QRIteration(), Zwrk)
                if Z !== nothing
                    # multiply back into Z
                    Ztmp = copy(view(Z, 1:n, istart:ifinish))
                    mul!(view(Z, 1:n, istart:ifinish), Ztmp, Zwrk)
                end
            end
            istart = ifinish + 1
        end
    end
end

# based on LAPACK.dlaed0
"the actual divide-and-conquer sym. tridiag. eigensolver"
function _dcschur_core!(d, e, Z, n, nqrmax)
    # to avoid index confusion we only allow for identity Z here
    # divide matrix into subproblems
    # build a size tree
    nsubprobs = 1 # SUBPBS
    itree = [n] # IWORK[1...]
    tlevels = 0 # TLVLS
    while itree[nsubprobs] > nqrmax
        resize!(itree, 2 * nsubprobs)
        for j in nsubprobs:-1:1
            itree[2 * j] = itree[j] >> 1
            itree[2 * j - 1] = (itree[j] + 1) >> 1
        end
        tlevels += 1
        nsubprobs *= 2
    end
    @mydebug println("nsubprobs = $nsubprobs itree = $itree")
    for j in 2:nsubprobs
        itree[j] = itree[j] + itree[j - 1]
    end

    # do the rank-1 cuts to separate the leaves
    for i in 1:(nsubprobs - 1)
        i1 = itree[i] + 1
        i2 = i1 - 1
        d[i2] -= abs(e[i2])
        d[i1] -= abs(e[i2])
    end

    indexq = zeros(Int, n)
    for i in 0:(nsubprobs - 1)
        if i == 0
            submat = 1
            matsize = itree[1]
        else
            submat = itree[i] + 1
            matsize = itree[i + 1] - itree[i]
        end
        Qwrk = similar(Z, matsize, matsize)
        Qwrk .= I(matsize)
        iend = submat + matsize - 1
        @mydebug println("QR for subproblem $submat:$iend")
        dvw = view(d, submat:iend)
        evw = view(e, submat:(iend - 1))
        _gschur!(SymTridiagonal(dvw, evw), QRIteration(), Qwrk)
        iend = submat + matsize - 1
        copy!(view(Z, submat:iend, submat:iend), Qwrk)
        # mul!(view(Qstore,1:qsiz,submat:iend), view(Z,1:qsiz,submat:iend), Qwrk)
        k = 1
        for j in submat:itree[i + 1]
            indexq[j] = k
            k += 1
        end
    end

    # successively merge up the tree
    curlevel = 1
    while nsubprobs > 1
        for i in 0:2:(nsubprobs - 2)
            if i == 0
                submat = 1
                matsize = itree[2]
                msd2 = itree[1]
                # curprob = 0
            else
                submat = itree[i] + 1
                matsize = itree[i + 2] - itree[i]
                # claim integer division rounds up in Fortran
                msd2 = (matsize + 1) >> 1
                # curprob += 1
            end
            iend = submat + matsize - 1
            dvw = view(d, submat:iend)
            # evw = view(e, submat:iend-1)
            Qvw = view(Z, submat:iend, submat:iend) # CHECKME
            ρ = e[submat + msd2 - 1]
            @mydebug println("merging submat $submat:$iend at ncut=$msd2")
            ok = _dcmerge!(dvw, Qvw, view(indexq, submat:iend), ρ, msd2)
            if !ok
                throw(UnconvergedException("unable to solve secular equation accurately"))
            end
            itree[i >> 1 + 1] = itree[i + 2]
        end
        nsubprobs = nsubprobs >> 1
        curlevel += 1
    end
    return
end

# based on DLAED1
"""
merge lower order eigensystems (`1:ncut` and `ncut+1:n)`
"""
function _dcmerge!(d, Q, indexq, ρ, ncut)
    n = size(d, 1)
    # last row of Q₁ and first row of Q₂
    zpp1 = ncut + 1
    z = vcat(view(Q, ncut:ncut, 1:ncut)', view(Q, zpp1:zpp1, zpp1:n)')
    k, w, ρmod, λ, indexc, colcounts, Q2 = _dcdeflate!(d, Q, indexq, ρ, z, ncut)
    if k != 0
        @mydebug println("after deflation k = $k colcounts = $(colcounts[1:4]) pairs $(colcounts[5])")
        # solve secular equation and update eigensystem
        ok = _dcsecular!(k, ncut, d, Q, ρmod, λ, Q2, indexc, colcounts, w)
        sortperm!(indexq, d)
        return ok
    else
        @mydebug println("trivial deflation")
        indexq .= 1:n
        return true
    end
end

# mutates d, Q, indexq,
# based on DLAED2
function _dcdeflate!(d::AbstractVector{T}, Q, indexq, ρ, z, n1) where {T}
    n = size(d, 1)
    n2 = n - n1
    n1p1 = n1 + 1

    # renormalize z
    t = 1 / sqrt(T(2))
    rmul!(z, t)
    if ρ < 0
        rmul!(view(z, n1p1:n), -1)
    end
    ρ = abs(2 * ρ)
    indexq[n1p1:n] .+= n1
    w = zeros(T, n)

    # re-integrate the deflated parts from last pass
    λ = d[indexq]
    indexc = sortperm(λ)
    index = indexq[indexc]
    # indexp will be used to keep track of deflated pairs: first k entries are not deflated
    indexp = zeros(Int, n)
    # calculate deflation tolerance
    zmax, _ = findmax(abs, z)
    dmax, _ = findmax(abs, d)
    tol = 8 * eps(T) * max(zmax, dmax)
    if ρ * zmax <= tol
        # if rank-1 modifier is tiny, just need to reorganize Q so columns correspond to d
        Qtmp = similar(Q)
        k = 0
        for j in 1:n
            i = index[j]
            copy!(view(Qtmp, 1:n, j), view(Q, 1:n, i))
            λ[j] = d[i]
        end
        copy!(Q, Qtmp)
        copy!(d, λ)
        return k, w, ρ, λ, indexc, Int[], [similar(Q, 0, 0)]
    end

    # coltype[j] indicates that column j is
    # 1) nonzero in upper part,
    # 2) dense
    # 3) nonzero in lower part
    # 4) deflated
    coltype = ones(Int, n)
    coltype[n1p1:n] .= 3

    # find the number of equal eigenvalues
    # compute reflector s.t. corresponding components of Z are 0 in new basis
    k = 0
    k2 = n + 1
    bdone = false
    nclose = 0
    jj = 0
    local pj
    for j in 1:n
        jj = j
        nj = index[j]
        if ρ * abs(z[nj]) <= tol
            # deflate because of small element in z
            k2 -= 1
            coltype[nj] = 4
            indexp[k2] = nj
            @mydebug println("deflate small z[$nj] to $k2")
            if j == n
                bdone = true
                break
            end
        else
            pj = nj
            break
        end
    end
    if !bdone
        while jj < n
            jj += 1
            nj = index[jj]
            if ρ * abs(z[nj]) <= tol
                # deflate because of small element in z
                k2 -= 1
                coltype[nj] = 4
                indexp[k2] = nj
                @mydebug println("deflate small z[$nj] to $k2")
            else
                # check if eigvals are close enough to deflate
                s = z[pj]
                c = z[nj]
                τ = hypot(c, s)
                t = d[nj] - d[pj]
                c /= τ
                s = -s / τ
                if abs(t * c * s) <= tol
                    nclose += 1
                    # deflation is possible
                    z[nj] = τ
                    z[pj] = 0
                    # reclass = false
                    if coltype[nj] != coltype[pj]
                        # reclass = true
                        coltype[nj] = 2
                    end
                    coltype[pj] = 4
                    g = LinearAlgebra.Givens(pj, nj, c, s)
                    rmul!(Q, g')
                    t = d[pj] * c^2 + d[nj] * s^2
                    d[nj] = d[pj] * s^2 + d[nj] * c^2
                    d[pj] = t
                    k2 -= 1
                    i = 1

                    @mydebug k2s = 0 # diagnostic only
                    if k2 + i > n
                        indexp[k2 + i - 1] = pj
                        @mydebug k2s = k2 + i - 1
                    else
                        while k2 + i <= n
                            if d[pj] < d[indexp[k2 + i]]
                                indexp[k2 + i - 1] = indexp[k2 + i]
                                indexp[k2 + i] = pj
                                @mydebug k2s = k2 + i
                                i += 1
                            else
                                indexp[k2 + i - 1] = pj
                                @mydebug k2s = k2 + i - 1
                                break
                            end
                        end
                    end
                    @mydebug println("deflate close z[$nj] z[$pj] to $k2s")
                    pj = nj
                else
                    k += 1
                    λ[k] = d[pj]
                    w[k] = z[pj]
                    indexp[k] = pj
                    pj = nj
                end # if deflating
            end
        end
    end

    # record last eigenvalue
    k += 1
    λ[k] = d[pj]
    w[k] = z[pj]
    indexp[k] = pj
    colcounts = [count(x -> x == j, coltype) for j in 1:4]
    push!(colcounts, nclose)
    psm = cumsum([1, colcounts[1:3]...])
    k = n - colcounts[4]

    # fill out indexc to sort by type
    for j in 1:n
        js = indexp[j]
        ct = coltype[js]
        index[psm[ct]] = js
        indexc[psm[ct]] = j
        psm[ct] += 1
    end

    # sort eigenvalues and eigenvectors
    i = 1
    Q2 = [
        similar(Q, n1, colcounts[1]), similar(Q, n1, colcounts[2]), similar(Q, n2, colcounts[2]),
        similar(Q, n2, colcounts[3]), similar(Q, n, colcounts[4]),
    ]
    #  iq2 = n1*(c1+c2)
    for j in 1:colcounts[1]
        js = index[i]
        copy!(view(Q2[1], :, j), view(Q, 1:n1, js))
        z[i] = d[js]
        i += 1
    end
    # iq1 = n1*c1+1
    for j in 1:colcounts[2]
        js = index[i]
        copy!(view(Q2[2], :, j), view(Q, 1:n1, js))
        copy!(view(Q2[3], :, j), view(Q, (n1 + 1):(n1 + n2), js))
        z[i] = d[js]
        i += 1
    end
    # iq1 = n1*(c1+c2)
    for j in 1:colcounts[3]
        js = index[i]
        copy!(view(Q2[4], :, j), view(Q, (n1 + 1):(n1 + n2), js))
        z[i] = d[js]
        i += 1
    end
    for j in 1:colcounts[4]
        js = index[i]
        copy!(view(Q2[5], :, j), view(Q, 1:n, js))
        z[i] = d[js]
        i += 1
    end

    if k < n
        # put sorted, deflated eigenpairs in last n-k slots of Q and d
        for j in 1:colcounts[4]
            copy!(view(Q, :, k + j), view(Q2[5], :, j))
            d[k + j] = z[k + j]
        end
    end
    return k, w, ρ, λ, indexc, colcounts, Q2
end

# based on DLAED3
"""
find roots of secular equation defined by `(d, w, ρ)`
also update eigvals [1:k] in `d` and eigvecs in `Q`
"""
function _dcsecular!(k, n1, d::AbstractVector{T}, Q, ρ, λ, Q2, indexc, colcounts, w) where {T}
    n = size(d, 1)
    # we assume IEEE765 so skip the missing guard digit patch
    if k == 0
        return true
    end
    for j in 1:k
        # stores eigvec info in column of Q
        d[j], converged = _dcroot!(k, j, view(λ, 1:k), view(w, 1:k), view(Q, 1:k, j), ρ)
        converged || return false
    end
    s0 = similar(w, k)
    if k == 2
        for j in 1:k
            w[1] = Q[1, j]
            w[2] = Q[2, j]
            Q[1, j] = w[indexc[1]]
            Q[2, j] = w[indexc[2]]
        end
    elseif k > 1
        copy!(view(s0, 1:k, 1), view(w, 1:k))
        for j in 1:k
            w[j] = Q[j, j]
        end
        for j in 1:k
            for i in 1:(j - 1)
                w[i] = w[i] * (Q[i, j] / (λ[i] - λ[j]))
            end
            for i in (j + 1):k
                w[i] = w[i] * (Q[i, j] / (λ[i] - λ[j]))
            end
        end
        for i in 1:k
            w[i] = sign(s0[i]) * sqrt(-w[i])
        end
        # compute eigenvectors of modified rank-1
        for j in 1:k
            for i in 1:k
                s0[i] = w[i] / Q[i, j]
            end
            t = norm(s0)
            for i in 1:k
                Q[i, j] = s0[indexc[i]] / t
            end
        end
    end
    # compute updated eigenvectors
    n2 = n - n1
    n12 = colcounts[1] + colcounts[2] # components in first part
    n23 = colcounts[2] + colcounts[3] # components in second part
    S = copy(view(Q, (colcounts[1] + 1):(colcounts[1] + n23), 1:k))
    if n23 > 0
        mul!(view(Q, (n1 + 1):n, 1:k), Q2[3], view(S, 1:colcounts[2], :))
        mul!(view(Q, (n1 + 1):n, 1:k), Q2[4], view(S, (colcounts[2] + 1):n23, :), true, true)
    else
        Q[(n1 + 1):n, 1:k] .= 0
    end
    S = copy(view(Q, 1:n12, 1:k))
    if n12 > 0
        mul!(view(Q, 1:n1, 1:k), Q2[1], view(S, 1:colcounts[1], :))
        mul!(view(Q, 1:n1, 1:k), Q2[2], view(S, (colcounts[1] + 1):n12, :), true, true)
    else
        Q[1:n1, 1:k] .= 0
    end
    return true
end

#=
# solve for a single root of the secular equation
# based on DLAED4
# reference: R-C. Li, LAWN89 (1993)
# stores eigvec info in δ, returns eigval and convergence flag
function _dcroot!(n,i,d,z,δ,ρ)
    maxit = 30
    if n == 1
        λ = d[1] + ρ * z[1]^2
        δ[1] = 1
        return λ, true
    elseif n == 2
        λ = _dcroot2!(i,d,z,δ,ρ)
        return λ, true
    end
    T = eltype(d)
    epsT = eps(T)
    ρinv = 1 / ρ
    local dltlb, dltub
=#
# subfunctions for case i == n
function _initialize_n(ii, midpt, d::AbstractVector{T}, z, δ, ρ) where {T}
    ρinv = 1 / ρ
    n = length(d)
    ψ = zero(T)
    for j in 1:(n - 2)
        ψ += z[j]^2 / δ[j]
    end
    c = ρinv + ψ
    w = c + z[ii]^2 / δ[ii] + z[n]^2 / δ[n]
    if w <= 0
        t = z[n - 1]^2 / (d[n] - d[n - 1] + ρ) + z[n]^2 / ρ
        if c <= t
            τ = ρ
        else
            Δ = d[n] - d[n - 1]
            a = -c * Δ + z[n - 1]^2 + z[n]^2
            b = z[n]^2 * Δ
            if a < 0
                τ = 2 * b / (sqrt(a^2 + 4 * b * c) - a)
            else
                τ = (a + sqrt(a^2 + 4 * b * c)) / (2 * c)
            end
        end
        # it can be proved that d[n] + ρ/2 <= λ[n] < d[n] + τ <= d[n] + ρ
        dltlb = midpt
        dltub = ρ
    else
        Δ = d[n] - d[n - 1]
        a = -c * Δ + z[n - 1]^2 + z[n]^2
        b = z[n]^2 * Δ
        if a < 0
            τ = 2 * b / (sqrt(a^2 + 4 * b * c) - a)
        else
            τ = (a + sqrt(a^2 + 4 * b * c)) / (2 * c)
        end
        # it can be proved that d[n] < d[n] + τ < d[n] + ρ / 2
        dltlb = zero(T)
        dltub = midpt
    end
    return w, τ, dltlb, dltub
end

function _update_w_n(ii, τ, d::AbstractVector{T}, z, δ, ρinv) where {T}
    n = length(d)
    # evaluate ψ and derivative
    dψ = zero(T)
    ψ = zero(T)
    erretm = zero(T)
    for j in 1:ii
        t = z[j] / δ[j]
        ψ += z[j] * t
        dψ += t^2
        erretm += ψ
    end
    erretm = abs(erretm)
    # evaluate ϕ and derivative
    t = z[n] / δ[n]
    ϕ = z[n] * t
    dϕ = t^2

    erretm = 8 * (-ϕ - ψ) + erretm - ϕ + ρinv + abs(τ) * (dψ + dϕ)
    w = ρinv + ϕ + ψ
    parts_n = (; dψ, dϕ)
    return w, erretm, parts_n
end

function _next_step_n(w, τ, parts, d::AbstractVector{T}, δ, dltlb, dltub, iter) where {T}
    n = length(d)
    dψ, dϕ = parts.dψ, parts.dϕ
    c = w - δ[n - 1] * dψ - δ[n] * dϕ
    if iter <= 2
        # c < 0 would step below the lower bound.
        # Normally this would be caught by the logic below (falling back to Newton).
        # Following LAPACK we set c = abs(c) only for the first iteration.
        # This seems to be a heuristic to jump-start some difficult cases
        # where Newton is excessively slow without it.
        c = abs(c)
    end
    a = (δ[n - 1] + δ[n]) * w - δ[n - 1] * δ[n] * (dψ + dϕ)
    b = δ[n - 1] * δ[n] * w
    if c == 0
        η = dltub - τ
    elseif a >= 0
        η = (a + sqrt(abs(a^2 - 4 * b * c))) / (2 * c)
    else
        η = 2 * b / (a - sqrt(abs(a^2 - 4 * b * c)))
    end
    # η should have opposite sign from w;
    # if violated by roundoff error take a Newton step to fix
    if w * η > 0
        η = -w / (dψ + dϕ)
    end
    t = τ + η
    if t > dltub || t < dltlb
        if w < 0
            η = (dltub - τ) / 2
        else
            η = (dltlb - τ) / 2
        end
    end
    return η
end

# subfunctions for general i
function _initialize(i, midpt, Δ, d::AbstractVector{T}, z, δ, ρinv) where {T}
    n = length(d)
    ip1 = i + 1
    ψ = zero(T)
    for j in 1:(i - 1)
        ψ = ψ + z[j]^2 / δ[j]
    end
    ϕ = zero(T)
    for j in n:-1:(i + 2)
        ϕ = ϕ + z[j]^2 / δ[j]
    end
    c = ρinv + ψ + ϕ
    w = c + z[i]^2 / δ[i] + z[ip1]^2 / δ[ip1]

    origin_at_i = w > 0
    if origin_at_i
        # i-th eigval is in (d[i], (d[i]+d[i+1])/2) dᵢ₊₁
        a = c * Δ + z[i]^2 + z[ip1]^2
        b = z[i]^2 * Δ
        if a > 0
            τ = 2 * b / (a + sqrt(abs(a^2 - 4 * b * c)))
        else
            τ = (a - sqrt(abs(a^2 - 4 * b * c))) / (2 * c)
        end
        dltlb = zero(T)
        dltub = midpt
    else
        # i-th eigval is in ((d[i] + d[i+1]) / 2, d[i+1])
        # origin is at d[i+1]
        a = c * Δ - z[i]^2 - z[ip1]^2
        b = z[ip1]^2 * Δ
        if a < 0
            τ = 2 * b / (a - sqrt(abs(a^2 + 4 * b * c)))
        else
            τ = -(a + sqrt(abs(a^2 + 4 * b * c))) / (2 * c)
        end
        dltlb = -midpt
        dltub = zero(T)
    end
    return w, τ, dltlb, dltub, origin_at_i
end

function _update_w(ii, τ, ηq, d, z::AbstractVector{T}, δ, ρ) where {T}
    n = length(d)
    ρinv = 1 / ρ
    iip1 = ii + 1
    iim1 = ii - 1
    # evaluate ψ and derivative
    dψ = zero(T)
    ψ = zero(T)
    erretm = zero(T)
    for j in 1:iim1
        t = z[j] / δ[j]
        ψ += z[j] * t
        dψ += t^2
        erretm += ψ
    end
    erretm = abs(erretm)
    # evaluate ϕ and derivative
    ϕ = zero(T)
    dϕ = zero(T)
    for j in n:-1:iip1
        t = z[j] / δ[j]
        ϕ += z[j] * t
        dϕ += t^2
        erretm += ϕ
    end
    w0 = ρinv + ϕ + ψ
    t = z[ii] / δ[ii]
    dw = dψ + dϕ + t^2
    t = z[ii] * t
    w = ρinv + ϕ + ψ + t
    erretm = 8 * (ϕ - ψ) + erretm + 2 * ρinv + 3 * abs(t) + abs(τ + ηq) * dw
    parts = (; ψ, ϕ, dψ, dϕ, dw)
    return w, erretm, parts, w0
end

function _next_step(i, ii, niter, w, τ, parts, switch3, origin_at_i, switch, d, z, δ, ρ, dltlb, dltub)
    ρinv = 1 / ρ
    dψ, dϕ = parts.dψ, parts.dϕ
    ψ, ϕ = parts.ψ, parts.ϕ
    dw = parts.dw
    ip1 = i + 1
    iip1 = ii + 1
    iim1 = ii - 1
    zz = similar(d, 3)
    if !switch3
        if !switch
            if origin_at_i
                c = w - δ[ip1] * dw - (d[i] - d[ip1]) * (z[i] / δ[i])^2
            else
                c = w - δ[i] * dw - (d[ip1] - d[i]) * (z[ip1] / δ[ip1])^2
            end
        else
            t = z[ii] / δ[ii]
            if origin_at_i
                dψ += t^2
            else
                dϕ += t^2
            end
            c = w - δ[i] * dψ - δ[ip1] * dϕ
        end
        a = (δ[i] + δ[ip1]) * w - δ[i] * δ[ip1] * dw
        b = δ[i] * δ[ip1] * w
        if c == 0
            if a == 0
                if origin_at_i
                    a = z[i]^2 + δ[ip1]^2 * (dψ + dϕ)
                else
                    a = z[ip1]^2 + δ[i]^2 * (dψ + dϕ)
                end
            end
            η = b / a
        elseif a <= 0
            η = (a - sqrt(abs(a^2 - 4 * b * c))) / (2 * c)
        else
            η = 2 * b / (a + sqrt(abs(a^2 - 4 * b * c)))
        end
    else
        # interpolation using 3 most relevant poles
        t = ρinv + ψ + ϕ
        if origin_at_i
            t1 = (z[iim1] / δ[iim1])^2
            c = t - δ[iip1] * (dψ + dϕ) - (d[iim1] - d[iip1]) * t1
            zz[1] = z[iim1]^2
            zz[3] = δ[iip1]^2 * ((dψ - t1) + dϕ)
        else
            t1 = (z[iip1] / δ[iip1])^2
            c = t - δ[iim1] * (dψ + dϕ) - (d[iip1] - d[iim1]) * t1
            zz[1] = δ[iim1]^2 * (dψ + (dϕ - t1))
            zz[3] = z[iip1]^2
        end
        zz[2] = z[ii]^2
        η, _ = _dcnewton(niter, origin_at_i, c, view(δ, iim1:iip1), zz, w)
    end
    if w * η > 0
        # fall back to Newton if misled by roundoff
        η = -w / dw
    end
    t = τ + η
    if t > dltub || t < dltlb
        if w < 0
            η = (dltub - τ) / 2
        else
            η = (dltlb - τ) / 2
        end
    end
    return η
end

# solve for a single root of the secular equation
# based on DLAED4
# reference: R-C. Li, LAWN89 (1993)
# stores eigvec info in δ, returns eigval and convergence flag
function _dcroot!(n, i, d, z, δ, ρ)
    maxit = 30
    if n == 1
        λ = d[1] + ρ * z[1]^2
        δ[1] = 1
        return λ, true
    elseif n == 2
        λ = _dcroot2!(i, d, z, δ, ρ)
        return λ, true
    end
    T = eltype(d)
    epsT = eps(T)
    ρinv = 1 / ρ
    local dltlb, dltub


    if i == n
        ii = n - 1
        niter = 1
        midpt = ρ / 2
        δ .= (d .- d[i]) .- midpt

        w, τ, dltlb, dltub = _initialize_n(ii, midpt, d, z, δ, ρ)
        δ .= (d .- d[i]) .- τ

        w, erretm, parts_n = _update_w_n(ii, τ, d, z, δ, ρinv)

        # test for convergence
        if abs(w) < epsT * erretm
            λ = d[i] + τ
            return λ, true
        end

        if w <= 0
            dltlb = max(dltlb, τ)
        else
            dltub = min(dltub, τ)
        end

        niter += 1

        η = _next_step_n(w, τ, parts_n, d, δ, dltlb, dltub, niter)
        δ .= δ .- η
        τ += η
        w, erretm, parts_n = _update_w_n(ii, τ, d, z, δ, ρinv)
        iter = niter + 1
        for niter in iter:maxit
            # test for convergence
            if abs(w) < epsT * erretm
                λ = d[i] + τ
                return λ, true
            end

            if w <= 0
                dltlb = max(dltlb, τ)
            else
                dltub = min(dltub, τ)
            end
            η = _next_step_n(w, τ, parts_n, d, δ, dltlb, dltub, niter)
            δ .= δ .- η
            τ += η
            w, erretm, parts_n = _update_w_n(ii, τ, d, z, δ, ρinv)
        end
        # if we get here, convergence failed
        λ = d[i] + τ
        return λ, false
    else
        # i ∈ [3..n-1]
        niter = 1
        ip1 = i + 1
        # initial guess
        Δ = d[ip1] - d[i]
        midpt = Δ / 2
        δ .= (d .- d[i]) .- midpt
        w, τ, dltlb, dltub, origin_at_i = _initialize(i, midpt, Δ, d, z, δ, ρinv)
        ii = origin_at_i ? i : i + 1
        dorg = d[ii]
        δ .= (d .- dorg) .- τ
        w, erretm, parts, w0 = _update_w(ii, τ, zero(T), d, z, δ, ρ)
        switch3 = false
        if origin_at_i
            if w0 < 0
                switch3 = true
            end
        else
            if w0 > 0
                switch3 = true
            end
        end
        if ii == 1 || ii == n
            # not enough points for 3
            switch3 = false
        end

        # test for convergence
        if abs(w) < epsT * erretm
            λ = dorg + τ
            return λ, true
        end

        if w <= 0
            dltlb = max(dltlb, τ)
        else
            dltub = min(dltub, τ)
        end

        niter += 1
        η = _next_step(i, ii, niter, w, τ, parts, switch3, origin_at_i, false, d, z, δ, ρ, dltlb, dltub)
        prev_w = w
        δ .= δ .- η
        w, erretm, parts = _update_w(ii, τ, η, d, z, δ, ρ)
        switch = false
        if origin_at_i
            if -w > abs(prev_w) / 10
                switch = true
            end
        else
            if w > abs(prev_w) / 10
                switch = true
            end
        end
        τ += η
        iter = niter + 1
        for niter in iter:maxit
            # test for convergence
            if abs(w) < epsT * erretm
                λ = dorg + τ
                return λ, true
            end

            if w <= 0
                dltlb = max(dltlb, τ)
            else
                dltub = min(dltub, τ)
            end
            η = _next_step(i, ii, niter, w, τ, parts, switch3, origin_at_i, switch, d, z, δ, ρ, dltlb, dltub)
            δ .= δ .- η
            τ += η
            prev_w = w
            w, erretm, parts = _update_w(ii, τ, zero(T), d, z, δ, ρ)
            if (w * prev_w > 0) && (abs(w) > abs(prev_w) / 10)
                switch = !switch
            end
        end
        # if we get here, convergence failed
        λ = dorg + τ
        return λ, false
    end
end

# root of secular equation for n=2
# based on DLAED5
function _dcroot2!(i, d::AbstractVector{T}, z, δ, ρ) where {T}
    Δ = d[2] - d[1]
    if i == 1
        w = one(T) + 2 * ρ * (z[2]^2 - z[1]^2) / Δ
        if w > 0
            b = Δ + ρ * (z[1]^2 + z[2]^2)
            c = ρ * z[1]^2 * Δ
            τ = 2 * c / (b + sqrt(b^2 - 4 * c))
            λ = d[1] + τ
            δ[1] = -z[1] / τ
            δ[2] = z[2] / (Δ - τ)
        else
            b = -Δ + ρ * (z[1]^2 + z[2]^2)
            c = ρ * z[2]^2 * Δ
            if b > 0
                τ = -2 * c / (b + sqrt(b^2 + 4 * c))
            else
                τ = (b - sqrt(b^2 + 4 * c)) / 2
            end
            λ = d[2] + τ
            δ[1] = -z[1] / (Δ + τ)
            δ[2] = -z[2] / τ
        end
        t = sqrt(δ[1]^2 + δ[2]^2)
        δ[1] = δ[1] / t
        δ[2] = δ[2] / t
    else
        # i == 2
        b = -Δ + ρ * (z[1]^2 + z[2]^2)
        c = ρ * z[2]^2 * Δ
        if b > 0
            τ = (b + sqrt(b^2 + 4 * c)) / 2
        else
            τ = 2 * c / (-b + sqrt(b^2 + 4 * c))
        end
        λ = d[2] + τ
        δ[1] = -z[1] / (Δ + τ)
        δ[2] = -z[2] / τ
        t = sqrt(δ[1]^2 + δ[2]^2)
        δ[1] = δ[1] / t
        δ[2] = δ[2] / t
    end
    return λ
end

# Newton iteration for step in solution of secular equation
# based on DLAED6
function _dcnewton(kniter, origin_at_i, ρ, d::AbstractVector{T}, z, f_init) where {T}
    maxit = 40
    if origin_at_i
        lbd = d[2]
        ubd = d[3]
    else
        lbd = d[1]
        ubd = d[2]
    end
    if f_init < 0
        lbd = zero(T)
    else
        ubd = zero(T)
    end
    niter = 1
    τ = zero(T)
    if kniter == 2
        if origin_at_i
            t = (d[3] - d[2]) / 2
            c = ρ + z[1] / ((d[1] - d[2]) - t)
            a = c * (d[2] + d[3]) + z[2] + z[3]
            b = c * d[2] * d[3] + z[2] * d[3] + z[3] * d[2]
        else
            t = (d[1] - d[2]) / 2
            c = ρ + z[3] / ((d[3] - d[2]) - t)
            a = c * (d[1] + d[2]) + z[1] + z[2]
            b = c * d[1] * d[2] + z[1] * d[2] + z[2] * d[1]
        end
        t = max(abs(a), abs(b), abs(c))
        a /= t
        b /= t
        c /= t
        if c == 0
            τ = b / a
        elseif a < 0
            τ = (a - sqrt(abs(a^2 - 4 * b * c)))
        else
            τ = 2 * b / (a + sqrt(abs(a^2 - 4 * b * c)))
        end
        if τ < lbd || τ > ubd
            τ = (lbd + ubd) / 2
        end
        if d[1] == τ || d[2] == τ || d[3] == τ
            τ = zero(T)
        else
            t = (
                f_init
                    + τ * z[1] / (d[1] * (d[1] - τ))
                    + τ * z[2] / (d[2] * (d[2] - τ))
                    + τ * z[3] / (d[3] * (d[3] - τ))
            )
            if t <= 0
                lbd = τ
            else
                ubd = τ
            end
            if abs(f_init) <= abs(t)
                τ = zero(T)
            end
        end
    end # kniter == 2

    epsT = eps(T)
    small1 = T(2)^(Int(round(log2(floatmin(T)) / 3)))
    sminv1 = 1 / small1
    small2 = small1^2
    sminv2 = sminv1^2
    if origin_at_i
        t = min(abs(d[2] - τ), abs(d[3] - τ))
    else
        t = min(abs(d[1] - τ), abs(d[2] - τ))
    end
    scale = t <= small1
    if scale
        if t <= small2
            sclfac = sminv2
            sclinv = small2
        else
            sclfac = sminv1
            sclinv = small2
        end
        dscale = d * sclfac
        zscale = z * sclfac
        τ *= sclfac
        lbd *= sclfac
        ubd *= sclfac
    else
        dscale = d
        zscale = z
        sclinv = one(T)
    end
    fc = zero(T)
    df = zero(T)
    ddf = zero(T)
    for i in 1:3
        t = one(T) / (dscale[1] - τ)
        t1 = zscale[i] * t
        t2 = t1 * t
        t3 = t2 * t
        fc += t1 / dscale[i]
        df += t2
        ddf += t3
    end
    f = f_init + τ * fc
    if abs(f) <= 0
        if scale
            τ *= sclinv
        end
        return τ, true
    end
    if f <= 0
        lbd = τ
    else
        ubd = τ
    end

    # Gragg-Thornton-Warner cubic convergent iteration
    iter = niter + 1
    converged = false
    for _ in iter:maxit
        if origin_at_i
            t1 = dscale[2] - τ
            t2 = dscale[3] - τ
        else
            t1 = dscale[1] - τ
            t2 = dscale[2] - τ
        end
        a = (t1 + t2) * f - t1 * t2 * df
        b = t1 * t2 * f
        c = f - (t1 + t2) * df + t1 * t2 * ddf
        t = max(abs(a), abs(b), abs(c))
        a /= t
        b /= t
        c /= t
        if c == 0
            η = b / a
        elseif a <= 0
            η = (a - sqrt(abs(a^2 - 4 * b * c))) / (2 * c)
        else
            η = 2 * b / (a + sqrt(abs(a^2 - 4 * b * c)))
        end
        if f * η >= 0
            η = -f / df
        end
        τ += η
        if τ < lbd || τ > ubd
            τ = (lbd + ubd) / 2
        end
        fc = zero(T)
        erretm = zero(T)
        df = zero(T)
        ddf = zero(T)
        for i in 1:3
            if (dscale[i] - τ) != 0
                t = 1 / (dscale[i] - τ)
                t1 = zscale[i] * t
                t2 = t1 * t
                t3 = t2 * t
                t4 = t1 / dscale[i]
                fc += t4
                erretm += abs(t4)
                df += t2
                ddf += t3
            else
                converged = true
                break
            end
        end
        if converged
            break
        end
        f = f_init + τ * fc
        erretm = 8 * (abs(f_init) + abs(τ) * erretm) + abs(τ) * df
        if (abs(f) <= 4 * epsT * erretm) || ((ubd - lbd) <= 4 * epsT * abs(τ))
            converged = true
            break
        end
        if f <= 0
            lbd = τ
        else
            ubd = τ
        end
    end

    if scale
        τ *= sclinv
    end
    return τ, converged
end

import Base: *, eltype, size
import LinearAlgebra: adjoint, lmul!, mul!, rmul!

# The reflector! code in stdlib has no underflow or accuracy protection

# These are translations of xLARFG from LAPACK
# LAPACK Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.
function _reflector!(x::AbstractVector{T}) where {T <: Real}
    require_one_based_indexing(x)
    n = length(x)
    n <= 1 && return zero(T)
    sfmin = 2floatmin(T) / eps(T)
    @inbounds begin
        α = x[1]
        xnorm = _norm2(view(x, 2:n))
        if iszero(xnorm)
            return zero(T)
        end
        β = -copysign(hypot(α, xnorm), α)
        kount = 0
        smallβ = abs(β) < sfmin
        if smallβ
            # recompute xnorm and β if needed for accuracy
            rsfmin = one(T) / sfmin
            while smallβ
                kount += 1
                for j in 2:n
                    x[j] *= rsfmin
                end
                β *= rsfmin
                α *= rsfmin
                # CHECKME: is 20 adequate for BigFloat?
                smallβ = (abs(β) < sfmin) && (kount < 20)
            end
            # now β ∈ [sfmin,1]
            xnorm = _norm2(view(x, 2:n))
            β = -copysign(hypot(α, xnorm), α)
        end
        τ = (β - α) / β
        t = one(T) / (α - β)
        for j in 2:n
            x[j] *= t
        end
        for j in 1:kount
            β *= sfmin
        end
        x[1] = β
    end
    return τ
end

function _reflector!(x::AbstractVector{T}) where {T <: Complex}
    require_one_based_indexing(x)
    n = length(x)
    # we need to make subdiagonals real so the n=1 case is nontrivial for complex eltype
    n < 1 && return zero(T)
    RT = real(T)
    sfmin = floatmin(RT) / eps(RT)
    @inbounds begin
        α = x[1]
        αr, αi = reim(α)
        xnorm = _norm2(view(x, 2:n))
        if iszero(xnorm) && iszero(αi)
            return zero(T)
        end
        β = -copysign(_hypot3(αr, αi, xnorm), αr)
        kount = 0
        smallβ = abs(β) < sfmin
        if smallβ
            # recompute xnorm and β if needed for accuracy
            rsfmin = one(real(T)) / sfmin
            while smallβ
                kount += 1
                for j in 2:n
                    x[j] *= rsfmin
                end
                β *= rsfmin
                αr *= rsfmin
                αi *= rsfmin
                smallβ = (abs(β) < sfmin) && (kount < 20)
            end
            # now β ∈ [sfmin,1]
            xnorm = _norm2(view(x, 2:n))
            α = complex(αr, αi)
            β = -copysign(_hypot3(αr, αi, xnorm), αr)
        end
        τ = complex((β - αr) / β, -αi / β)
        t = one(T) / (α - β)
        for j in 2:n
            x[j] *= t
        end
        for j in 1:kount
            β *= sfmin
        end
        x[1] = β
    end
    return τ
end

# copied from Andreas Noack's GenericLinearAlgebra.jl, with trivial mods

"""
a Householder reflection represented as the essential part of the
vector and the normalizing factor
"""
struct Householder{T, S <: StridedVector}
    v::S
    τ::T
end

# warning; size -> length(v) in GLA, but this makes more sense to us:
size(H::Householder) = (length(H.v) + 1, length(H.v) + 1)
size(H::Householder, i::Integer) = i <= 2 ? length(H.v) + 1 : 1

Base.eltype(_H::Householder{T}) where {T} = T

LinearAlgebra.adjoint(H::Householder{T}) where {T} = Adjoint{T, typeof(H)}(H)

function lmul!(H::Householder, A::StridedMatrix)
    m, n = size(A)
    size(H, 1) == m || throw(DimensionMismatch(""))
    v = view(H.v, 1:(m - 1))
    τ = H.τ
    for j in 1:n
        va = A[1, j]
        Aj = view(A, 2:m, j)
        va += dot(v, Aj)
        va = τ * va
        A[1, j] -= va
        axpy!(-va, v, Aj)
    end
    return A
end

# x is workspace which one can preallocate
function rmul!(
        A::StridedMatrix{T}, H::Householder,
        x = Vector{T}(undef, size(A, 1))
    ) where {T}
    _, n = size(A)
    size(H, 1) == n || throw(DimensionMismatch(""))
    v = view(H.v, :)
    τ = H.τ
    a1 = view(A, :, 1)
    A1 = view(A, :, 2:n)
    mul!(x, A1, v)
    axpy!(one(τ), a1, x)
    axpy!(-τ, x, a1)
    rankUpdate!(-τ, x, v, A1)
    return A
end

function lmul!(adjH::Adjoint{<:Any, <:Householder}, A::StridedMatrix)
    H = parent(adjH)
    m, n = size(A)
    size(H, 1) == m || throw(DimensionMismatch("A: $m,$n H: $(size(H))"))
    v = view(H.v, 1:(m - 1))
    τ = H.τ
    for j in 1:n
        va = A[1, j]
        Aj = view(A, 2:m, j)
        va += dot(v, Aj)
        va = τ'va
        A[1, j] -= va
        axpy!(-va, v, Aj)
    end
    return A
end

Base.convert(::Type{Matrix}, H::Householder{T}) where {T} = lmul!(H, Matrix{T}(I, size(H, 1), size(H, 1)))
Base.convert(::Type{Matrix{T}}, H::Householder{T}) where {T} = lmul!(H, Matrix{T}(I, size(H, 1), size(H, 1)))

cplxord = t -> (real(t), imag(t))
csort(v) = sort(v, by = cplxord)

# isolate eigvec tests for use with special cases
function vectest(A::Matrix{T}, S::Schur{T2}, vtol; normal = false) where {T, T2}
    n = size(A, 1)
    ulp = eps(real(T))
    tiny = floatmin(real(T))
    if norm(A) < 16 * n * tiny / ulp
        # The numerical analysis in the eigenvector code (LAPACK and ours)
        # is shaky for very small numbers.
        # Normally this is obviated by balancing.
        fac = 1 / sqrt(tiny)
        Ss = LinearAlgebra.Schur(fac * S.T, S.Z, fac * S.values)
        VR = geigvecs(Ss)
        VL = geigvecs(Ss, left = true)
    else
        VR = geigvecs(S)
        VL = geigvecs(S, left = true)
    end
    if verbosity[] > 1
        vec_err = norm(A * VR - VR * diagm(0 => S.values)) / (n * norm(A) * ulp)
        println("r.eigenvector error: $vec_err, vtol = $vtol")
        @test vec_err < 1000
    else
        @test norm(A * VR - VR * diagm(0 => S.values)) / (n * norm(A) * ulp) < vtol
    end
    if verbosity[] > 1
        vec_err = norm(A' * VL - VL * diagm(0 => conj.(S.values))) / (n * norm(A) * ulp)
        println("l.eigenvector error: $vec_err, vtol = $vtol")
        @test vec_err < 1000
    else
        @test norm(A' * VL - VL * diagm(0 => conj.(S.values))) / (n * norm(A) * ulp) < vtol
    end
    if normal
        # check orthonormality of vectors where appropriate
        if verbosity[] > 1 && real(T) == Float16
            trt = norm(VR * VR' - I) / (n * ulp)
            tlt = norm(VL * VL' - I) / (n * ulp)
            @info "Float16 vec orth errors for n=$n: $tlt, $trt"
        end
        if (T == ComplexF16) && (n > 10)
            # is this simply too many ops for this type?
            @test_broken norm(VR * VR' - I) / (n * ulp) < vtol
            @test_broken norm(VL * VL' - I) / (n * ulp) < vtol
        else
            # CHECKME: real ones are not as good for some reason
            votol = (T <: Complex) ? vtol : (T == Float16 ? 10 : 5) * vtol
            @test norm(VR * VR' - I) / (n * ulp) < votol
            @test norm(VL * VL' - I) / (n * ulp) < votol
        end
    end
    return
end

# This only applies to standard forms w/ co-sorted eigenvals
function checkeigvals(
        A::StridedMatrix{T}, w::StridedVector, tol; debug = false
    ) where {T <: Real}
    n = size(A, 1)
    ulp = eps(T)
    tiny = GenericSchur.safemin(T)
    isok = true
    for j in 1:n
        isok &= (A[j, j] == real(w[j]))
    end
    if n > 1
        if A[2, 1] == 0
            isok &= (imag(w[1]) == 0)
        end
        if A[n, n - 1] == 0
            isok &= (imag(w[n]) == 0)
        end
    end
    for j in 1:(n - 1)
        if A[j + 1, j] != 0
            t = sqrt(abs(A[j + 1, j])) * sqrt(abs(A[j, j + 1]))
            cmp = max(ulp * t, tiny)
            isok &= (abs(imag(w[j]) - t) / cmp < tol)
            isok &= (abs(imag(w[j + 1]) + t) / cmp < tol)
        elseif (j > 1) && (A[j + 1, j] == 0) && (A[j, j - 1] == 0)
            isok &= (imag(w[j]) == 0)
        end
    end
    return isok
end

"""
generate a random unitary matrix

Unitary matrices are normal, so Schur decomposition is diagonal for them.
(This is not only another test, but sometimes actually useful.)
"""
function randu(::Type{T}, n) where {T <: Complex}
    if real(T) ∈ [Float16, Float32, Float64]
        A = randn(T, n, n)
        F = qr(A)
        return Matrix(F.Q) * Diagonal(sign.(diag(F.R)))
    else
        # don't have normal deviates for other types, but need appropriate QR
        A = randn(ComplexF64, n, n)
        F = qr(convert.(T, A))
        return Matrix(F.Q) * Diagonal(sign.(diag(F.R)))
    end
end

# random orthogonal matrix
function rando(::Type{T}, n) where {T <: Real}
    if T ∈ [Float16, Float32, Float64]
        A = randn(T, n, n)
        F = qr(A)
        return Matrix(F.Q)
    else
        # don't have normal deviates for other types, but need appropriate QR
        A = randn(Float64, n, n)
        F = qr(convert.(T, A))
        return Matrix(F.Q)
    end
end

"""
Generate Godunov's strongly non-normal matrix with known eigenvalues.

One needs to retain at least 70 bits of precision to have any confidence in
computing the eigenvalues here.
"""
function godunov(T)
    A = convert.(
        T, [
            289 2064 336 128 80 32 16;
            1152 30 1312 512 288 128 32;
            -29 -2000 756 384 1008 224 48;
            512 128 640 0 640 512 128;
            1053 2256 -504 -384 -756 800 208;
            -287 -16 1712 -128 1968 -30 2032;
            -2176 -287 -1565 -512 -541 -1152 -289
        ]
    )
    vals = [-4, -2, -1, 0, 1, 2, 4]
    econd = 7.0e16 # condition of the worst ones
    return A, vals, econd
end

using GenericSchur: trsylvester!, adjtrsylvester!
using GenericSVD

Random.seed!(1234)

function checkgsyl(m = 4, n = 2, Ty = Float64)
    rctr = Ty(0.5) * ((Ty <: Complex) ? (1 + 1im) : 1)
    A = triu(rand(Ty, m, m) .- rctr) + 2I
    B = triu(rand(Ty, n, n) .- rctr) + I
    X = rand(Ty, m, n)

    # separate spectra so problem is not too hard
    D = triu(rand(Ty, m, m) .- rctr) + 4I
    E = triu(rand(Ty, n, n) .- rctr) + I
    Y = rand(Ty, m, n)
    C = A * X - Y * B
    C2 = copy(C)
    F = D * X - Y * E
    F2 = copy(F)

    X2, Y2, scale = trsylvester!(A, B, C2, D, E, F2)
    fwd2a = norm(scale * X - X2) / norm(X)
    fwd2b = norm(scale * Y - Y2) / norm(Y)
    bwd2a = norm(A * X2 - Y2 * B - scale * C) / ((norm(A) + norm(B)) * norm(X))
    bwd2b = norm(D * X2 - Y2 * E - scale * F) / ((norm(D) + norm(E)) * norm(X))
    if verbosity[] > 0
        println("our    scale $scale error norms fwd: ", fwd2a, " ", fwd2b)
        println("                                bwd: ", bwd2a, " ", bwd2b)
    end
    tol = 2
    stol = tol * max(m, n) * eps(real(Ty))
    # forward errors for Sylvester are fiddly
    if max(m, n) < 10
        @test fwd2a < sqrt(stol)
        @test fwd2b < sqrt(stol)
    end
    @test bwd2a < tol
    @test bwd2b < tol
    return
end

function checkgasyl(m = 4, n = 2, Ty = Float64)
    A = triu(rand(Ty, m, m) .- 0.5) + 2I
    B = triu(rand(Ty, n, n) .- 0.5) + I
    X = rand(Ty, m, n)

    # separate spectra so problem is not too hard
    D = triu(rand(Ty, m, m) .- 0.5) + 4I
    E = triu(rand(Ty, n, n) .- 0.5) + I
    Y = rand(Ty, m, n)
    C = A' * X + D' * Y
    C2 = copy(C)
    F = -X * B' - Y * E'
    F2 = copy(F)

    X2, Y2, scale = adjtrsylvester!(A, B, C2, D, E, F2)
    fwd2a = norm(scale * X - X2) / norm(X)
    fwd2b = norm(scale * Y - Y2) / norm(Y)
    bwd2a = norm(A' * X2 + D' * Y2 - scale * C) / ((norm(A) + norm(B)) * norm(X))
    bwd2b = norm(X2 * B' + Y2 * E' + scale * F) / ((norm(D) + norm(E)) * norm(X))
    if verbosity[] > 0
        println("our    scale $scale error norms fwd: ", fwd2a, " ", fwd2b)
        println("                                bwd: ", bwd2a, " ", bwd2b)
    end

    tol = 2
    stol = tol * max(m, n) * eps(real(Ty))
    if max(m, n) < 10
        @test fwd2a < sqrt(stol)
        @test fwd2b < sqrt(stol)
    end
    @test bwd2a < tol
    @test bwd2b < tol
    return
end

for Ty in [ComplexF64, Float64, Complex{BigFloat}]
    @testset "gen. sylvester $Ty" begin
        checkgsyl(2, 4, Ty)
        checkgsyl(4, 2, Ty)
        checkgsyl(24, 24, Ty)
    end
    @testset "gen. adj. sylvester $Ty" begin
        checkgasyl(2, 4, Ty)
        checkgasyl(4, 2, Ty)
        checkgasyl(24, 24, Ty)
    end
end

function checkord(A::Matrix{Ty}, B::Matrix{Ty}, tol = 10) where {Ty <: Real}
    n = size(A, 1)
    ulp = eps(Ty)

    GS = GenericSchur.ggschur!(copy(A), copy(B))
    S2 = copy(GS.S)
    Q2 = copy(GS.Q)
    T2 = copy(GS.T)
    Z2 = copy(GS.Z)
    select = fill(true, n)
    for i in 1:(n >> 1)
        select[i] = false
    end
    # we extend the LinearAlgebra function, but want to test
    # our version with BLAS types:
    S2, T2, a, b, Q2, Z2 = GenericSchur.gordschur!(S2, T2, Q2, Z2, select)

    # usual tests for Schur
    @test norm(tril(S2, -2)) / (n * norm(A) * ulp) < tol
    @test norm(tril(T2, -1)) / (n * norm(A) * ulp) < tol
    # @test all(tril(S.S,-2) .== 0)
    # @test all(tril(S.T,-1) .== 0)
    # test 2: norm(A - S.Q * S.T * S.Z') / (n * norm(A) * ulp) < tol
    @test norm(A - Q2 * S2 * Z2') / (n * norm(A) * ulp) < tol
    @test norm(B - Q2 * T2 * Z2') / (n * norm(B) * ulp) < tol
    # test 3: S.Z is unitary: norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - Z2 * Z2') / (n * ulp) < tol
    @test norm(I - Q2 * Q2') / (n * ulp) < tol

    # make sure we got the ones we asked for
    # WARNING: this test may fail if selected ev are ill-conditioned
    wwanted = similar(GS.values, 0)
    for j in 1:n
        if select[j] || (j < n && select[j + 1] && imag(GS.values[j]) != 0)
            push!(wwanted, GS.values[j])
        end
    end
    nwanted = length(wwanted)
    errs = zeros(nwanted)
    for i in 1:nwanted
        w = a[i] / b[i]
        t, j = findmin(abs.(wwanted .- w))
        errs[i] = t / (ulp + abs(w))
        wwanted = deleteat!(wwanted, j)
    end
    @test all(errs .< tol)
    return
end

function checkord(A::Matrix{Ty}, B::Matrix{Ty}, tol = 10) where {Ty <: Complex}
    n = size(A, 1)
    ulp = eps(real(Ty))

    GS = GenericSchur.ggschur!(copy(A), copy(B))
    S2 = copy(GS.S)
    Q2 = copy(GS.Q)
    T2 = copy(GS.T)
    Z2 = copy(GS.Z)
    select = fill(true, n)
    for i in 1:(n >> 1)
        select[i] = false
    end
    # we extend the LinearAlgebra function, but want to test
    # our version with BLAS types:
    S2, T2, a, b, Q2, Z2 = GenericSchur.gordschur!(S2, T2, Q2, Z2, select)

    # usual tests for Schur
    @test norm(tril(S2, -1)) / (n * norm(A) * ulp) < tol
    @test norm(tril(T2, -1)) / (n * norm(A) * ulp) < tol
    # @test all(tril(S.S,-1) .== 0)
    # @test all(tril(S.T,-1) .== 0)
    # test 2: norm(A - S.Q * S.T * S.Z') / (n * norm(A) * ulp) < tol
    @test norm(A - Q2 * S2 * Z2') / (n * norm(A) * ulp) < tol
    @test norm(B - Q2 * T2 * Z2') / (n * norm(B) * ulp) < tol
    # test 3: S.Z is unitary: norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - Z2 * Z2') / (n * ulp) < tol
    @test norm(I - Q2 * Q2') / (n * ulp) < tol

    # make sure we got the ones we asked for
    # WARNING: this test may fail if selected ev are ill-conditioned
    nwanted = count(select)
    wwanted = [GS.values[j] for j in 1:n if select[j]]
    errs = zeros(nwanted)
    for i in 1:nwanted
        w = a[i] / b[i]
        t, j = findmin(abs.(wwanted .- w))
        errs[i] = t / (ulp + abs(w))
        wwanted = deleteat!(wwanted, j)
    end
    @test all(errs .< tol)
    return
end

for Ty in [Float64, BigFloat, ComplexF64, Complex{BigFloat}]
    @testset "gen. ordschur $Ty" begin
        n = 16
        A = rand(Ty, n, n)
        rctr = Ty(0.5) * ((Ty <: Complex) ? (1 + 1im) : 1)
        B = rand(Ty, n, n) .- rctr + I
        checkord(A, B)
    end
end

if piracy
    # it would be too ugly to rewrite using un-pirated functions

    # WARNING: KPTest was adapted from a more thorough validation study.
    # For interesting arguments the tests don't pass as written, but results
    # agree with LAPACK. With benign arguments, however, it is a good
    # test of functionality.

    # Test with CHK4 matrices from Kågström and Poromaa, LAWN 87, 1994.
    function KPTest(α, β, x, y, dtype, Ty = ComplexF64)
        Db = I
        if dtype == 1
            Da = diagm(0 => Ty.([1, 2, 3, 4, 5])) + α * I
            atrue = [1, 2, 3, 4, 5] .+ α
        else
            Da = diagm(
                0 => Ty.([1, 1, 1, 1 + α, 1 + α]), 1 => Ty.([-1, 0, 0, 1 + β]),
                -1 => Ty.([1, 0, 0, -1 - β])
            )
            atrue = [1 - 1im, 1 + 1im, 1, 1 + α - (1 + β) * im, 1 + α + (1 + β) * im]
        end
        YH = diagm(
            0 => ones(Ty, 5), 1 => Ty.([0, -y, 0, 0]), 2 => Ty.([-y, y, 0]),
            3 => Ty.([y, -y]), 4 => Ty.([-y])
        )
        X = diagm(
            0 => ones(Ty, 5), 1 => Ty.([0, x, 0, 0]), 2 => Ty.([-x, -x, 0]),
            3 => Ty.([-x, -x]), 4 => Ty.([x])
        )
        A = YH \ (Da / X)
        B = YH \ (Db / X)
        S = GenericSchur.ggschur!(copy(A), copy(B))
        aest = S.α ./ S.β
        for j in 1:5
            λtrue = atrue[j]
            _, idx = findmin(abs.(aest .- λtrue))
            sel = falses(5)
            sel[idx] = true
            if idx == 1
                S2 = S
            else
                S2 = ordschur(S, sel)
            end
            pl, pr = eigvalscond(S2, 1)
            sep = subspacesep(S2, 1)

            # known values from construction
            if dtype == 1 || j == 3
                y = YH[j, :] # a column vector!
                x = X[:, j]
            else
                if j == 1
                    y = YH[1, :] + im * YH[2, :]
                    x = X[:, 1] + im * X[:, 2]
                elseif j == 2
                    y = YH[1, :] - im * YH[2, :]
                    x = X[:, 1] - im * X[:, 2]
                elseif j == 4
                    y = YH[4, :] - im * YH[5, :]
                    x = X[:, 4] - im * X[:, 5]
                elseif j == 5
                    y = YH[4, :] + im * YH[5, :]
                    x = X[:, 4] + im * X[:, 5]
                end
            end

            rcond = (
                sqrt(abs(dot(y, (A * x)))^2 + abs(dot(y, (B * x)))^2)
                    / (norm(x) * norm(y'))
            ) / sqrt(3.0)

            n = 5
            Inm1 = Matrix{Ty}(I, n - 1, n - 1)
            Zl = hcat(
                vcat(λtrue * Inm1, Inm1),
                vcat(-S2.S[2:n, 2:n], -S2.T[2:n, 2:n])
            )
            difl = minimum(svdvals(Zl))
            if verbosity[] > 0
                println("λ true $λtrue error $(λtrue - aest[idx])")
                println("ours   pl $(pl) pr $(pr) sep $(sep)")
                println("true rcond $rcond fudged $(rcond)  Difl $(difl)")
            end

            @test abs(log10(pl / rcond)) < 2
            @test abs(log10(pr / rcond)) < 2
            @test abs(log10(sep[1] / difl)) < 2
            @test abs(log10(sep[2] / difl)) < 2

        end
        return
    end

    for Ty in [ComplexF64, Complex{BigFloat}]
        @testset "gen. condition $Ty" begin
            α = 1.0
            β = 1.0
            x = 1.0
            y = 1.0
            dtype = 2
            KPTest(α, β, x, y, dtype, Ty)
        end
    end

end

module TGST
# routine tests for the Symmetric Tridiagonal eigensolvers in GenericSchur

using LinearAlgebra
using Test
using GenericSchur
using GenericSchur: geigen!, geigvals!, QRIteration, DivideAndConquer

# some interesting examples from the LAPACK papers

function wilkinson(n, ::Type{T}) where {T}
    if mod(n, 2) == 1
        nh = (n - 1) >>> 1
        D = T.(vcat(nh:-1:1, [0], 1:nh))
    else
        D = abs.(T.(collect(-(n - 1):2:(n - 1))) / 2)
    end
    E = fill(T(1), n - 1)
    return D, E
end

function clement(n, ::Type{T}) where {T}
    D = zeros(T, n)
    E = [sqrt(T(i * (n + 1 - i))) for i in 1:(n - 1)]
    return D, E
end

function legendre(n, ::Type{T}) where {T}
    D = zeros(T, n)
    E = [T(i) / sqrt(T((2i - 1) * (2i) + 1)) for i in 2:n]
    return D, E
end

function laguerre(n, ::Type{T}) where {T}
    D = T.(collect(3:2:(2 * n + 1)))
    E = T.(collect(2:n))
    return D, E
end

function hermite(n, ::Type{T}) where {T}
    D = zeros(T, n)
    E = [sqrt(T(i)) for i in 1:(n - 1)]
    return D, E
end

# LAPACK-style classes
function st_testmat1(n, itype, ::Type{T} = Float64; dtype = :normal) where {T}
    dtype ∈ [:normal, :unif, :uniform] || throw(ArgumentError("incomprehensible dtype"))
    λ = zeros(T, n)
    ulp = eps(real(T))
    kpar = 1 / ulp
    if itype == 1
        λ[1] = 1
        for j in 2:n
            λ[j] = 1 / T(j)
        end
    elseif itype == 2
        λ[1:(n - 1)] .= 1
        λ[n] = T(1) / n
    elseif itype == 3
        for j in 1:n
            λ[j] = 1 / (kpar^((j - 1) / (n - 1)))
        end
    elseif itype == 4
        for j in 1:n
            λ[j] = T(1) - (T(j - 1) / T(n - 1)) * (1 - 1 / kpar)
        end
    elseif itype == 5
        λ .= exp.(-log(n) * rand(n))
    elseif itype == 6
        if dtype == :normal
            λ .= randn(n)
        else
            λ .= rand(dtype, n)
        end
    elseif itype == 7
        λ[1:(n - 1)] .= (1:(n - 1)) * ulp
        λ[n] = 1
    elseif itype == 8
        λ[1] = ulp
        for j in 2:(n - 1)
            λ[j] = 1 + sqrt(ulp) * j
        end
        λ[n] = 2
    elseif itype == 9
        λ[1] = 1
        for j in 2:n
            λ[j] = λ[j - 1] + 100 * ulp
        end
    end
    Q, r = qr(randn(n, n))
    Q = T.(Matrix(Q)) # until LinearAlgebra is fixed
    # FIXME: sign adjustment
    A = Q' * diagm(λ) * Q

    F = GenericSchur._hessenberg!(A)
    S = F.H
    return S, λ
end
const itypes1 = 1:9
# downselect so subsetting is reasonable
const itypes1a = [1, 3, 4, 5, 6]

function st_testmat2(n, itype, ::Type{T} = Float64; dtype = :normal) where {T <: Real}
    dtype ∈ [:normal, :unif, :uniform] || throw(ArgumentError("incomprehensible dtype"))
    λ = zeros(T, n)
    ulp = eps(real(T))
    if itype == 0
        S = SymTridiagonal(zeros(T, n), zeros(T, n - 1))
        λ = zeros(T, n)
    elseif itype == 1
        S = SymTridiagonal(ones(T, n), zeros(T, n - 1))
        λ = ones(T, n)
    elseif itype == 2
        S = SymTridiagonal(fill(T(2), n), ones(T, n - 1))
        λ = nothing
    elseif itype == 3
        S = SymTridiagonal(wilkinson(n, T)...)
        λ = nothing
    elseif itype == 4
        S = SymTridiagonal(clement(n, T)...)
        λ = T.(collect(-n:2:n))
    elseif itype == 5
        S = SymTridiagonal(legendre(n, T)...)
        λ = nothing
    elseif itype == 6
        S = SymTridiagonal(laguerre(n, T)...)
        λ = nothing
    elseif itype == 7
        S = SymTridiagonal(hermite(n, T)...)
        λ = nothing
    elseif itype == 8
        # exercise the scaling logic, all at once
        small = floatmin(T) / ulp
        large = floatmax(T) * ulp
        S1 = SymTridiagonal(wilkinson(n, T)...)
        S = gluemats(small * S1, S1, large * S1)
    else
        throw(ArgumentError("unimplemented itype"))
    end
    return S, λ
end
const itypes2 = 1:8
const broken_cases2 = [(BigFloat, QRIteration(), 8)]

function gluemats(mat1::SymTridiagonal{T}, mats...; gval = zero(T)) where {T}
    D = diag(mat1)
    E = diag(mat1, 1)
    for mat in mats
        append!(D, diag(mat))
        push!(E, gval)
        append!(E, diag(mat, 1))
    end
    return SymTridiagonal(D, E)
end

function batch(n, alg, ::Type{T} = Float64; thresh = 50, quiet = true) where {T}
    dmax = 0.0; vmax = 0.0
    for itype in itypes1
        @testset "class 1 type $itype" begin
            A, _ = st_testmat1(n, itype, T)
            de, ve = runtest(diag(A), diag(A, 1), alg)
            dmax = max(dmax, de)
            vmax = max(vmax, ve)
            @test de < thresh
            @test ve < thresh
        end
    end
    quiet || println("peak errors: $dmax $vmax")
    dmax = 0.0; vmax = 0.0
    for itype in itypes2
        @testset "class 2 type $itype" begin
            A, _ = st_testmat2(n, itype, T)
            de, ve = runtest(diag(A), diag(A, 1), alg)
            dmax = max(dmax, de)
            vmax = max(vmax, ve)
            if (T, alg, itype) in broken_cases2
                @test_broken de < thresh
            else
                @test de < thresh
            end
            @test ve < thresh
        end
    end
    quiet || println("peak errors: $dmax $vmax")
    return nothing
end


maxnorm(A) = maximum(abs.(vec(A)))

function runtest(D::AbstractVector{T}, E, alg; λ = nothing, V = nothing) where {T <: Real}
    if λ === nothing
        λ, V = geigen!(SymTridiagonal(copy(D), copy(E)), alg)
    end
    n = length(D)
    m = size(V, 2)
    ntol = min(m, n)
    myeps = eps(T)
    if m == n
        resnorm = maxnorm(V * Diagonal(λ) * V' - SymTridiagonal(D, E))
    else
        resnorm = maxnorm(Diagonal(λ) - V' * SymTridiagonal(D, E) * V)
    end
    Tnorm = max(opnorm(SymTridiagonal(D, E), 1), floatmin(T))
    if resnorm < Tnorm
        d_err = (resnorm / Tnorm) / (myeps * ntol)
    elseif Tnorm < 1
        d_err = (min(resnorm, Tnorm * ntol) / Tnorm) / (myeps * ntol)
    else
        d_err = min(resnorm / Tnorm, ntol) / (myeps * ntol)
    end
    if m == n
        v_err = maxnorm(V * V' - I) / (myeps * ntol)
    else
        v_err = maxnorm(V' * V - I) / (myeps * ntol)
    end
    return d_err, v_err
end

for T in [Float32, Float64, BigFloat], alg in [DivideAndConquer(), QRIteration()]
    @testset "SymTridiagonal $T $alg" begin
        batch(32, alg, T)
    end
end

end # module

# This file is part of GenericSchur.jl, released under the MIT "Expat" license
# Portions derived from LAPACK, see below.

# Schur decomposition (QZ algorithm) for generalized eigen-problems
# decomposition is A = Q S Z', B = Q T Z'

# Developer notes:
# We don't currently implement GeneralizedHessenberg types so anyone else
# using internal functions is doomed to confusion.

# ggschur! is similar to LAPACK zgges:
# Q is Vsl, Z is Vsr
# T overwrites B
# S overwrites A

"""
ggschur!(A, B) -> S::GeneralizedSchur

Computes the generalized Schur factorization of matrix pair `A,B` using a generic
implementation. Overwrites `A` and `B`.
"""
function ggschur!(
        A::StridedMatrix{Ty}, B::StridedMatrix{Ty};
        wantQ::Bool = true, wantZ::Bool = true,
        scale::Bool = true,
        kwargs...
    ) where {Ty <: Complex}

    n = checksquare(A)
    nb = checksquare(B)
    if nb != n
        throw(ArgumentError("matrices must have the same sizes"))
    end

    if scale
        scaleA, cscale, anrm = _scale!(A)
        scaleB, cscaleb, bnrm = _scale!(B)
        @mydebug if cscale != 1 || cscaleb != 1
            println("ggschur! scaling by $cscale $cscaleb")
        end
    else
        scaleA = false
        scaleB = false
        cscale = cscaleb = anrm = bnrm = one(real(Ty))
    end
    # maybe balance here

    bqr = qr!(B)
    # apply bqr.Q to A
    lmul!(bqr.Q', A)
    if wantQ
        Q = Matrix(bqr.Q)
    else
        Q = Matrix{Ty}(undef, 0, 0)
    end
    if wantZ
        Z = Matrix{Ty}(I, n, n)
    else
        Z = Matrix{Ty}(undef, 0, 0)
    end

    # materializing R may waste memory; can we rely on storage in modified B?
    A, B, Q, Z = _hessenberg!(A, bqr.R, Q, Z)
    α, β, S, T, Q, Z = _gqz!(A, B, Q, Z, true; kwargs...)

    # TODO if balancing, unbalance Q, Z

    if scaleA
        safescale!(S, cscale, anrm)
        # checkme: is this always correct?
        α = diag(S)
    end
    if scaleB
        safescale!(T, cscaleb, bnrm)
        # checkme: is this always correct?
        β = diag(T)
    end

    return GeneralizedSchur(S, T, α, β, Q, Z)
end

# B temporarily loses triangularity, so is not specially typed.
# compare to zgghrd
function _hessenberg!(
        A::StridedMatrix{T}, B::StridedMatrix{T}, Q, Z;
        ilo = 1, ihi = size(A, 1)
    ) where {T}
    wantQ = !isempty(Q)
    wantZ = !isempty(Z)

    triu!(B)

    for jc in ilo:(ihi - 2)
        for jr in ihi:-1:(jc + 2)
            # rotate rows jr-1,jr to null A[jr,jc]
            Gq, _ = givens(A, jr - 1, jr, jc)
            lmul!(Gq, A)
            lmul!(Gq, B)
            if wantQ
                rmul!(Q, Gq')
            end
            # rotate cols jr,jr-1 to null B[jr,jr-1]
            Gz, _ = givens(B', jr, jr - 1, jr)
            rmul!(A, Gz')
            rmul!(B, Gz')
            if wantZ
                rmul!(Z, Gz')
            end
        end
    end

    return triu!(A, -1), triu!(B), Q, Z
end

@enum _DeflateCase begin
    _deflatec_unknown
    _deflatec_none # i.e. advance to QZ
    _deflatec_normal # negligible subdiagonal in H
    _deflatec_inf # zero in B at ilast, could also be a singularity
end

# single-shift QZ algorithm
#
# translated from LAPACK's zhgeqz (pretty close to Moler & Stewart)
# LAPACK is released under a BSD license, and is
# Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.
#
# H is Hessenberg
# B is upper-triangular
# This is an internal routine so we don't check.
function _gqz!(
        H::StridedMatrix{T}, B::StridedMatrix{T}, Q, Z, wantSchur;
        ilo = 1, ihi = size(H, 1), maxiter = 100 * (ihi - ilo + 1)
    ) where {T <: Complex}
    n = checksquare(H)
    wantQ = !isempty(Q)
    wantZ = !isempty(Z)

    α = Vector{T}(undef, n)
    β = Vector{T}(undef, n)

    RT = real(T)
    ulp = eps(RT)
    safmin = safemin(RT)
    anorm = norm(view(H, ilo:ihi, ilo:ihi), 2) # Frobenius
    bnorm = norm(view(B, ilo:ihi, ilo:ihi), 2) # Frobenius
    atol = max(safmin, ulp * anorm)
    btol = max(safmin, ulp * bnorm)
    ascale = one(RT) / max(safmin, anorm)
    bscale = one(RT) / max(safmin, bnorm)
    half = 1 / RT(2)

    # set trivial trailing eigvals
    for j in (ihi + 1):n
        α[j] = H[j, j]
        β[j] = B[j, j]
    end

    ifirst = ilo
    ilast = ihi

    if wantSchur
        ifirstm, ilastm = 1, n
    else
        ifirstm, ilastm = ilo, ihi
    end

    shiftcount = 0
    eshift = zero(T)

    niter = 0
    while true
        niter += 1
        if niter > maxiter
            throw(UnconvergedException("iteration limit $maxiter reached"))
        end
        @mydebug println("iteration $niter ilast=$ilast")

        # Split H if possible
        # Use 2 tests:
        # 1: H[j,j-1] == 0 || j=ilo
        # 2: B[j,j] = 0

        br = _deflatec_unknown

        # specialize for j==ilast
        if ilast == ilo
            br = _deflatec_normal
        elseif abs1(H[ilast, ilast - 1]) < max(
                safmin,
                ulp * (
                    abs1(H[ilast, ilast])
                        + abs1(H[ilast - 1, ilast - 1])
                )
            )
            H[ilast, ilast - 1] = 0
            br = _deflatec_normal
            @mydebug println("trivial split at $ilast")
        end
        # For now, we follow LAPACK quite closely.
        if br == _deflatec_unknown
            if abs(B[ilast, ilast]) <= btol
                B[ilast, ilast] = 0
                br = _deflatec_inf
                @mydebug println("split on singular entry in B at $ilast")
            else
                # general case
                for j in (ilast - 1):-1:ilo
                    # Test 1
                    split_test1 = false
                    if j == ilo
                        split_test1 = true
                    else
                        # once had <= atol here
                        if abs1(H[j, j - 1]) <= max(
                                safmin,
                                ulp * (abs1(H[j, j]) + abs1(H[j - 1, j - 1]))
                            )
                            H[j, j - 1] = 0
                            split_test1 = true
                        end
                    end
                    # Test 2
                    split_test2 = abs(B[j, j]) < btol
                    if split_test2
                        B[j, j] = 0
                        # Test 1a: check for 2 consec. small subdiags in H
                        split_test1a = !split_test1 &&
                            (
                            abs1(H[j, j - 1]) * (ascale * abs1(H[j + 1, j]))
                                <= abs1(H[j, j]) * (ascale * atol)
                        )
                        # if both tests pass, split 1x1 block off top
                        # if remaining leading diagonal elt vanishes, iterate
                        if split_test1 || split_test1a
                            @mydebug println("splitting 1x1 at top (j=$j), singular B")
                            for jch in j:(ilast - 1)
                                G, r = givens(H[jch, jch], H[jch + 1, jch], jch, jch + 1)
                                H[jch, jch] = r
                                H[jch + 1, jch] = 0
                                lmul!(G, view(H, :, (jch + 1):ilastm))
                                lmul!(G, view(B, :, (jch + 1):ilastm))
                                if wantQ
                                    rmul!(Q, G')
                                end
                                if split_test1a
                                    H[jch, jch - 1] *= G.c
                                end
                                split_test1a = false
                                if abs1(B[jch + 1, jch + 1]) > btol
                                    if jch + 1 >= ilast
                                        br = _deflatec_normal
                                        break
                                    else
                                        ifirst = jch + 1
                                        br = _deflatec_none
                                        break
                                    end
                                end
                                B[jch + 1, jch + 1] = 0
                            end # jch loop
                            if br == _deflatec_unknown
                                br = _deflatec_inf
                            end
                            break
                        else
                            # only test 2 passed: chase 0 to B[ilast,ilast]
                            # then process as above
                            @mydebug println("chasing diag 0 in B from $j to $ilast")
                            for jch in j:(ilast - 1)
                                G, r = givens(
                                    B[jch, jch + 1], B[jch + 1, jch + 1],
                                    jch, jch + 1
                                )
                                B[jch, jch + 1] = r
                                B[jch + 1, jch + 1] = 0
                                if jch < ilastm - 1
                                    lmul!(G, view(B, :, (jch + 2):ilastm))
                                end
                                lmul!(G, view(H, :, (jch - 1):ilastm))
                                if wantQ
                                    rmul!(Q, G')
                                end
                                G, r = givens(
                                    conj(H[jch + 1, jch]), conj(H[jch + 1, jch - 1]),
                                    jch, jch - 1
                                )
                                H[jch + 1, jch] = r'
                                H[jch + 1, jch - 1] = 0
                                rmul!(view(H, ifirstm:jch, :), G')
                                rmul!(view(B, ifirstm:(jch + 1), :), G')
                                if wantZ
                                    rmul!(Z, G')
                                end
                            end # jch loop
                            br = _deflatec_inf
                            break
                        end # if split_test1 || split_test1a
                    elseif split_test1 # but not split_test2, i.e. B[j,j] is not tiny
                        ifirst = j
                        @mydebug (ifirst > ilo) && println("nonsingular split at $ifirst")
                        br = _deflatec_none
                        break
                    end # if B[j,j] tiny
                    # neither test passed; try next j
                end # j loop
                if br == _deflatec_unknown
                    error("dev error: drop-through assumed impossible")
                end
            end # B[ilast,ilast] is/is-not tiny branches
            if br == _deflatec_inf
                # B[ilast,ilast] is 0; clear H[ilast,ilast-1] to split
                G, r = givens(conj(H[ilast, ilast]), conj(H[ilast, ilast - 1]), ilast, ilast - 1)
                H[ilast, ilast] = r'
                H[ilast, ilast - 1] = 0
                rmul!(view(H, ifirstm:(ilast - 1), :), G')
                rmul!(view(B, ifirstm:(ilast - 1), :), G')
                if wantZ
                    rmul!(Z, G')
                end
                br = _deflatec_normal
            end
        end # if trivial split
        if br == _deflatec_normal
            # H[ilast, ilast-1] == 0: standardize B, set α,β
            absb = abs(B[ilast, ilast])
            @mydebug println("deflating $ilast, |B_tail|=$absb")
            if absb > safmin
                signbc = conj(B[ilast, ilast] / absb)
                B[ilast, ilast] = absb
                if wantSchur
                    B[ifirstm:(ilast - 1), ilast] .*= signbc
                    H[ifirstm:ilast, ilast] .*= signbc
                else
                    H[ilast, ilast] *= signbc
                end
                if wantZ
                    Z[:, ilast] .*= signbc
                end
            else
                B[ilast, ilast] = 0
            end
            α[ilast] = H[ilast, ilast]
            β[ilast] = B[ilast, ilast]
            ilast -= 1
            if ilast < ilo
                # we are done; exit outer loop
                break
            end
            shiftcount = 0
            eshift = zero(T)
            if !wantSchur
                ilastm = ilast
                if ifirstm > ilast
                    ifirstm = ilo
                end
            end
            continue # iteration loop
        end # normal deflation branch

        @mydebug begin
            @assert br == _deflatec_none
        end

        # QZ step
        # This iteration involves block ifirst:ilast, assumed nonempty
        if !wantSchur
            ifirstm = ifirst
        end

        # Compute shift
        shiftcount += 1
        # At this point ifirst < ilast and diagonal elts of B in that block
        # are all nontrivial.
        if shiftcount % 10 != 0
            # Wilkinson shift, i.e. eigenvalue of last 2x2 block of
            # A B⁻¹ nearest to last elt

            # factor B as U D where U has unit diagonal, compute A D⁻¹ U⁻¹
            b11 = (bscale * B[ilast - 1, ilast - 1])
            b22 = (bscale * B[ilast, ilast])
            u12 = (bscale * B[ilast - 1, ilast]) / b22
            ad11 = (ascale * H[ilast - 1, ilast - 1]) / b11
            ad21 = (ascale * H[ilast, ilast - 1]) / b11
            ad12 = (ascale * H[ilast - 1, ilast]) / b22
            ad22 = (ascale * H[ilast, ilast]) / b22
            abi22 = ad22 - u12 * ad21
            abi12 = ad12 - u12 * ad11
            shift = abi22
            t = sqrt(abi12) * sqrt(ad21)
            t1 = abs1(t)
            if t != 0
                x = half * (ad11 - shift)
                t2 = abs1(x)
                t1 = max(t1, t2)
                y = t1 * sqrt((x / t1)^2 + (t / t1)^2)
                if t2 > 0 && (real(x / t2) * real(y) + imag(x / t2) * imag(y) < 0)
                    y = -y
                end
                shift -= t * (t / (x + y))
            end
        else
            # exceptional shifts
            # "Chosen for no particularly good reason" (LAPACK)
            if shiftcount % 20 == 0 && bscale * abs1(B[ilast, ilast]) > safmin
                eshift += (ascale * H[ilast, ilast]) / (bscale * B[ilast, ilast])
            else
                eshift += (ascale * H[ilast, ilast - 1]) / (bscale * B[ilast - 1, ilast - 1])
            end
            shift = eshift
        end
        @assert !isnan(shift)

        # local f1, _istart # replaced by dummy initialization
        f1 = one(T)
        _istart = -1

        # check for two consecutive small subdiagonals
        gotit = false
        for j in (ilast - 1):-1:(ifirst + 1)
            _istart = j
            f1 = ascale * H[j, j] - shift * (bscale * B[j, j])
            t1 = abs1(f1)
            t2 = ascale * abs1(H[j + 1, j])
            tr = max(t1, t2)
            if tr < one(RT) && tr != zero(RT)
                t1 /= tr
                t2 /= tr
            end
            if abs1(H[j, j - 1]) * t2 <= t1 * atol
                gotit = true
                break
            end
        end
        if !gotit
            _istart = ifirst
            f1 = (
                ascale * H[ifirst, ifirst]
                    - shift * (bscale * B[ifirst, ifirst])
            )
        end

        # qz sweep
        @mydebug println("QZ sweep range $(_istart):$ilast shift=$shift")
        # initial contribution to Q
        g2 = ascale * H[_istart + 1, _istart]
        c, s, _ = givensAlgorithm(f1, g2)

        for j in _istart:(ilast - 1)
            if j > _istart
                c, s, r = givensAlgorithm(H[j, j - 1], H[j + 1, j - 1])
                H[j, j - 1] = r
                H[j + 1, j - 1] = 0
            end
            G = Givens(j, j + 1, T(c), s)
            lmul!(G, view(H, :, j:ilastm))
            lmul!(G, view(B, :, j:ilastm))
            if wantQ
                rmul!(Q, G')
            end
            c, s, r = givensAlgorithm(B[j + 1, j + 1], B[j + 1, j])
            B[j + 1, j + 1] = r
            B[j + 1, j] = 0
            G = Givens(j, j + 1, T(c), s)
            rmul!(view(H, ifirstm:min(j + 2, ilast), :), G)
            rmul!(view(B, ifirstm:j, :), G)
            if wantZ
                rmul!(Z, G)
            end
        end
    end # iteration loop
    @mydebug println("ggschur! done in $niter iters")

    # set eigenvalues for trivial leading part
    for j in 1:(ilo - 1)
        α[j] = H[j, j]
        β[j] = B[j, j]
    end

    return α, β, H, B, Q, Z
end

"""
    _canonicalize!(S::GeneralizedSchur)

rescale the fields of `S` so that `S.β` and the diagonal of `S.T` are real.
"""
function _canonicalize!(S::GeneralizedSchur{Ty}) where {Ty}
    n = size(S.S, 1)
    sf = safemin(real(Ty))
    for k in 1:n
        scale = abs(S.T[k, k])
        if scale > sf
            t1 = conj(S.T[k, k] / scale)
            t2 = S.T[k, k] / scale
            S.T[k, (k + 1):n] .*= t1
            S.S[k, k:n] .*= t1
            if !(S.Q === nothing) && !isempty(S.Q)
                S.Q[:, k] .*= t2
            end
        else
            S.T[k, k] = zero(Ty)
        end
        S.α[k] = S.S[k, k]
        S.β[k] = S.T[k, k]
    end
    return S
end

# This file is part of GenericSchur.jl, released under the MIT "Expat" license

# The method in this file is derived from LAPACK's zlacon.
# LAPACK is released under a BSD license, and is
# Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.


# Hager's one-norm estimator, with modifications by N.J. Higham
"""
    norm1est!(applyA!,applyAH!,y::Vector) => γ

Estimate the 1-norm of a linear operator `A` expressed as functions which
apply `A` and `adjoint(A)` to a vector such as `y`.

cf. N.J. Higham, SIAM J. Sci. Stat. Comp. 11, 804 (1990)
"""
function norm1est!(applyA!, applyAH!, y::AbstractVector{Ty}; maxiter = 5) where {Ty}
    n = length(y)
    x = fill(one(Ty) / n, n)
    y .= zero(Ty)
    applyA!(x)
    (n == 1) && return abs(x[1])
    γ = norm(x, 1)
    tiny = safemin(real(Ty))
    for i in 1:n
        absxi = abs(x[i])
        if absxi > tiny
            x[i] /= absxi
        else
            x[i] = one(Ty)
        end
    end
    applyAH!(x)
    ax0, j0 = _findamax(x)
    for iter in 1:maxiter
        x .= zero(Ty)
        x[j0] = one(Ty)
        applyA!(x)
        y .= x
        oldγ = γ
        γ = norm(y, 1)
        if γ <= oldγ
            break
        end
        for i in 1:n
            absxi = abs(x[i])
            if absxi > tiny
                x[i] /= absxi
            else
                x[i] = one(Ty)
            end
        end
        applyAH!(x)
        jlast = j0
        ax0, j0 = _findamax(x)
        if abs(x[jlast]) == ax0
            break
        end
    end
    # alternative estimate for tricky cases (see Higham 1990)
    v = x # reuse workspace
    isign = 1
    for i in 1:n
        v[i] = isign * (1 + (i - 1) / (n - 1))
        isign = -isign
    end
    applyA!(v)
    t = 2 * norm(v, 1) / (3 * n)
    return max(t, γ)
end

function _findamax(x::AbstractVector{T}) where {T}
    ax0 = abs(x[1])
    i0 = 1
    for i in 2:length(x)
        ax = abs(x[i])
        if ax > ax0
            ax0 = ax
            i0 = i
        end
    end
    return ax0, i0
end

function _findamax(x::AbstractVector{T}) where {T <: Complex}
    ax0 = abs2(x[1])
    i0 = 1
    for i in 2:length(x)
        ax = abs2(x[i])
        if ax > ax0
            ax0 = ax
            i0 = i
        end
    end
    return sqrt(ax0), i0
end

# This file is part of GenericSchur.jl, released under the MIT "Expat" license

struct Balancer{T}
    ilo::Int
    ihi::Int
    prow::Vector{Int}
    pcol::Vector{Int}
    D::Vector{T}
    trivial::Bool
end

# intended to be a translation of xGEBAL from LAPACK
# Copyright:
# Univ. of Tennessee
# Univ. of California Berkeley
# Univ. of Colorado Denver
# NAG Ltd.
# w/ some allowance for scheme from R.James et al. 2014 arxiv 1401.5766
"""
    balance!(A; scale=true, permute=true) => Abal, B::Balancer

Balance a square matrix so that various operations are more stable.

If `permute`, then row and column permutations are found such
that `Abal` has the block form `[T₁ X Y; 0 C Z; 0 0 T₂]` where
`T₁` and `T₂` are upper-triangular.
If `scale`, then a diagonal similarity transform using powers of 2
is found such that the 1-norm of the `C` block (or the whole of `Abal`,
if not permuting) is near unity. The transformations
are encoded into `B` so that they can be inverted for eigenvectors, etc.
Balancing typically improves the accuracy of eigen-analysis.
"""
function balance!(
        A::AbstractMatrix{T}; scale = true, permute = true,
        p::Int = 1, algo = :pr
    ) where {T <: Number}
    n = checksquare(A)
    RT = real(T)
    β = RT(2)
    factor = RT(0.95)

    sfmin1 = floatmin(RT) / eps(RT)
    sfmax1 = one(RT) / sfmin1
    sfmin2 = sfmin1 * β
    sfmax2 = one(RT) / sfmin2

    D = ones(T, n)
    ilo = 1
    ihi = n
    trivial = true
    sp = fill(0, n)

    if permute
        # look for row permutations which make the lower portion UT
        ihi = n + 1
        js = 0
        @inbounds while ihi > 1
            ihi -= 1
            exch = false
            ms = 0
            for j in ihi:-1:1
                exch = true
                js = j
                for i in 1:ihi
                    (i == j) && continue
                    if A[j, i] != 0
                        exch = false
                    end
                end
                if exch
                    ms = ihi
                    break
                end
            end
            if exch
                sp[ms] = js
                if js != ms
                    trivial = false
                    for i in 1:ihi
                        A[i, js], A[i, ms] = A[i, ms], A[i, js]
                    end
                    for i in ilo:n
                        A[js, i], A[ms, i] = A[ms, i], A[js, i]
                    end
                end
            else
                break
            end
        end
        # if ihi == 1, no more permutations
        if ihi > 1
            # look for column permutations which make the left portion UT
            ilo = 0
            @inbounds while ilo < n
                ilo += 1
                exch = false
                ms = 0
                js = 0
                for j in ilo:ihi
                    js = j
                    exch = true
                    for i in ilo:ihi
                        (i == j) && continue
                        if A[i, j] != 0
                            exch = false
                        end
                    end
                    if exch
                        ms = ilo
                        break
                    end
                end
                if exch
                    sp[ms] = js
                    if ms != js
                        trivial = false
                        for i in 1:ihi
                            A[i, js], A[i, ms] = A[i, ms], A[i, js]
                        end
                        for i in ilo:n
                            A[js, i], A[ms, i] = A[ms, i], A[js, i]
                        end
                    end
                else
                    break
                end
            end
        end
    end

    sf(c, r) = (p == 1) ? (c + r) : c * c + r * r
    # abs(c) + abs(r), but args always nonneg

    if scale
        converged = false
        while !converged
            converged = true
            for i in ilo:ihi
                if algo == :pr
                    # LAPACK mixes norms
                    c = norm(view(A, ilo:ihi, i), 2)
                    r = norm(view(A, i, ilo:ihi), 2)
                else
                    c = norm(view(A, ilo:ihi, i), p)
                    r = norm(view(A, i, ilo:ihi), p)
                end
                ca, _ = _findamax(view(A, ilo:ihi, i))
                ra, _ = _findamax(view(A, i, ilo:ihi))
                if c == 0 || r == 0
                    continue
                end
                g = r / β
                s = sf(c, r)
                f = one(RT)
                while c < r / β
                    if c >= g || (max(f, c, ca) >= sfmax2) || (min(r, g, ra) <= sfmin2)
                        break
                    end
                    if isnan(c + f + ca + r + g + ra)
                        error("NaN encountered while balancing")
                    end
                    f *= β
                    c *= β
                    ca *= β
                    r /= β
                    g /= β
                    ra /= β
                end
                g = c / β
                while r <= c / β
                    if (g < r) || (max(r, ra) >= sfmax2) || (min(f, c, g, ca) <= sfmin2)
                        break
                    end
                    f /= β
                    c /= β
                    g /= β
                    ca /= β
                    r *= β
                    ra *= β
                end
                if f != one(RT)
                    trivial = false
                end
                (sf(c, r) >= factor * s) && continue
                # TODO: continue on [uo]flow
                converged = false
                D[i] *= f
                A[i, ilo:n] .*= (one(T) / f)
                A[1:ihi, i] .*= f
            end
        end # while !converged
    end # if scale
    prow = sp[1:(ilo - 1)]
    pcol = sp[(ihi + 1):n]
    B = Balancer(ilo, ihi, prow, pcol, D, trivial)
    return A, B
end

# this is the appropriate transformation for right eigenvectors
# stored as columns of a matrix
function LinearAlgebra.lmul!(B::Balancer, A::StridedMatrix{T}) where {T}
    n = checksquare(A)
    if B.trivial
        return A
    end
    ilo, ihi = B.ilo, B.ihi
    if ilo != ihi
        lmul!(Diagonal(B.D), A)
    end
    for j in (ilo - 1):-1:1
        m = B.prow[j]
        if m == j
            continue
        end
        for i in 1:n
            A[j, i], A[m, i] = A[m, i], A[j, i]
        end
    end
    for j in (ihi + 1):n
        m = B.pcol[j - ihi]
        if m == j
            continue
        end
        for i in 1:n
            A[j, i], A[m, i] = A[m, i], A[j, i]
        end
    end
    return A
end

# this should be the appropriate transformation for left eigenvectors
# stored as columns of a matrix
function LinearAlgebra.ldiv!(B::Balancer, A::StridedMatrix{T}) where {T}
    n = checksquare(A)
    if B.trivial
        return A
    end
    ilo, ihi = B.ilo, B.ihi
    if ilo != ihi
        lmul!(Diagonal(one(T) ./ B.D), A)
    end
    for j in (ilo - 1):-1:1
        m = B.prow[j]
        if m == j
            continue
        end
        for i in 1:n
            A[j, i], A[m, i] = A[m, i], A[j, i]
        end
    end
    for j in (ihi + 1):n
        m = B.pcol[j - ihi]
        if m == j
            continue
        end
        for i in 1:n
            A[j, i], A[m, i] = A[m, i], A[j, i]
        end
    end
    return A
end

function gschurtest(
        A::Matrix{T}, B::Matrix{T}, tol;
        normal = false, commuting = false
    ) where {T <: Complex}
    n = size(A, 1)
    ulp = eps(real(T))
    S = GenericSchur.ggschur!(copy(A), copy(B))
    # test 1: S.T is upper triangular
    @test norm(tril(S.S, -1)) / (n * norm(A) * ulp) < tol
    @test norm(tril(S.T, -1)) / (n * norm(A) * ulp) < tol
    # @test all(tril(S.S,-1) .== 0)
    # @test all(tril(S.T,-1) .== 0)
    # test 2: norm(A - S.Q * S.T * S.Z') / (n * norm(A) * ulp) < tol
    @test norm(A - S.Q * S.S * S.Z') / (n * norm(A) * ulp) < tol
    @test norm(B - S.Q * S.T * S.Z') / (n * norm(A) * ulp) < tol
    # test 3: S.Z is unitary: norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - S.Q * S.Q') / (n * ulp) < tol
    # test 4: S.values are e.v. of T
    #    @test all(csort(S.values) .== csort(diag(S.T)))

    # It is tempting to check eigenvalues against LAPACK eigvals(A)
    # for suitable types, but the comparison is misleading without
    # detailed analysis because many of the test matrices are severly
    # non-normal.

    if normal && commuting
        # verify that Schur diagonalizes normal commuting matrices
        @test norm(triu(S.S, 1)) / (n * norm(B) * ulp) < tol
        @test norm(triu(S.T, 1)) / (n * norm(A) * ulp) < tol
    end

    VR = geigvecs(S)
    evcheck = norm((A * VR) * diagm(0 => S.β) - (B * VR) * diagm(0 => S.α))
    @test evcheck / (n * norm(A) * ulp) < tol
    VL = geigvecs(S, left = true)
    evcheck = norm((A' * VL) * diagm(0 => conj.(S.β)) - (B' * VL) * diagm(0 => conj.(S.α)))
    @test evcheck / (n * norm(A) * ulp) < tol
    return
end

function gschurtest(
        A::Matrix{T}, B::Matrix{T}, tol;
        normal = false, commuting = false
    ) where {T <: Real}
    n = size(A, 1)
    ulp = eps(real(T))
    S = GenericSchur.ggschur!(copy(A), copy(B))
    # test 1: S.S is quasi-triangular and S.T is upper triangular
    @test norm(tril(S.S, -2)) / (n * norm(A) * ulp) < tol
    @test norm(tril(S.T, -1)) / (n * norm(A) * ulp) < tol
    # @test all(tril(S.S,-2) .== 0)
    # @test all(tril(S.T,-1) .== 0)
    # test 2: factorization residuals are small
    @test norm(A - S.Q * S.S * S.Z') / (n * norm(A) * ulp) < tol
    @test norm(B - S.Q * S.T * S.Z') / (n * norm(A) * ulp) < tol
    # test 3: S.Z and S.Q are unitary
    @test norm(I - S.Z * S.Z') / (n * ulp) < tol
    @test norm(I - S.Q * S.Q') / (n * ulp) < tol

    VR = geigvecs(S)
    evcheck = norm((A * VR) * diagm(0 => S.β) - (B * VR) * diagm(0 => S.α))
    @test evcheck / (n * norm(A) * ulp) < tol
    VL = geigvecs(S, left = true)
    evcheck = norm(diagm(0 => S.β) * (VL' * A) - diagm(0 => S.α) * (VL' * B))
    @test evcheck / (n * norm(A) * ulp) < tol
    return
end

@testset "generalized basic sanity $T" for T in [
        ComplexF64,
        Complex{BigFloat}, Float64, BigFloat,
    ]

    unfl = floatmin(real(T))
    ovfl = one(real(T)) / unfl
    ulp = eps(real(T))
    ulpinv = one(real(T)) / ulp
    rtulp = sqrt(ulp)
    rtulpi = one(real(T)) / rtulp

    # sizes of matrices to test
    ens = [4, 32]

    for n in ens
        A = rand(T, n, n)
        B = rand(T, n, n)
        gschurtest(A, B, 20)
    end
end # testset

using SparseArrays
include("psjmats.jl")
@testset "generalized examples from Q.M." begin
    gschurtest(Array(psj_1_A), Array(psj_1_B), 100)
    gschurtest(Array(psj_2_A), Array(psj_2_B), 100)
    gschurtest(Array(psj_3_A), Array(psj_3_B), 100)
end

@testset "generalized challenging $T" for T in [ComplexF64, Complex{BigFloat}]
    # sizes of matrices to test
    n = 32
    n1 = n >> 2
    n2 = n - 2 * n1
    A0 = triu(rand(T, n, n) .- 0.5)
    B0 = triu(rand(T, n, n) .- 0.5)
    # stuff in some degenerate singularity
    for j in 1:n1
        A0[j, j] = zero(T)
    end
    for j in (n1 + 1):n2
        B0[j, j] = zero(T)
    end
    Qa, _ = qr!(T.(randn(n, n) + 1im * randn(n, n)))
    Qb, _ = qr!(T.(randn(n, n) + 1im * randn(n, n)))
    A = Qa * A0 * Qa'
    B = Qb * B0 * Qb'

    gschurtest(A, B, 20)

end # testset

using LinearAlgebra: BlasReal
"""
a "safe" version of `floatmin`, such that `1/sfmin` does not overflow.
"""
function safemin(T)
    sfmin = floatmin(T)
    small = one(T) / floatmax(T)
    if small >= sfmin
        sfmin = small * (one(T) + eps(T))
    end
    return sfmin
end

function _scale!(A::AbstractArray{T}) where {T}
    smlnum = sqrt(safemin(real(T))) / eps(real(T))
    bignum = 1 / smlnum
    anrm = norm(A, Inf)
    scaleA = false
    cscale = one(real(T))
    if anrm > 0 && anrm < smlnum
        scaleA = true
        cscale = smlnum
    elseif anrm > bignum
        scaleA = true
        cscale = bignum
    end
    scaleA && safescale!(A, anrm, cscale)
    return scaleA, cscale, anrm
end

abs1(z) = abs(z)
abs1(z::T) where {T <: Complex} = abs(real(z)) + abs(imag(z))

# translated from xLASCL (LAPACK)
"""
multiply an array `A` by a real number `cto/cfrom` expressed as a ratio,
computing without over/underflow where possible.

`cfrom` must not be zero.
"""
function safescale!(A::AbstractArray{T}, cfrom::Real, cto::Real) where {T}
    # CHECKME: what are correct type constraints on cfrom,cto?
    isnan(cto) && throw(ArgumentError("cto must be a valid number"))
    (isnan(cfrom) || (cfrom == 0)) && throw(ArgumentError("cfrom must be a valid nonzero number"))
    smlnum = safemin(real(T))
    bignum = 1 / smlnum
    cfromc = cfrom
    ctoc = cto
    done = false
    while !done
        cfrom1 = cfromc * smlnum
        if cfrom1 == cfromc
            # cfromc is ±∞; multiplier is signed 0 or NaN
            mul = ctoc / cfromc
            done = true
            cto1 = ctoc
        else
            cto1 = ctoc / bignum
            if cto1 == ctoc
                # ctoc is 0 or ±∞, so is correct multiplier
                mul = cto
                done = true
                cfromc = one(real(T))
            elseif abs(cfrom1) > abs(ctoc) && (ctoc != 0)
                mul = smlnum
                done = false
                cfromc = one(real(T))
            elseif abs(cto1) > abs(cfromc)
                mul = bignum
                done = false
                cfromc = cfrom1
            else
                mul = ctoc / cfromc
                done = true
            end
        end
        A .= A .* mul
    end
    return
end

"compute Frobenius norm, avoiding overflow"
function _safe_fnorm(A::AbstractMatrix{Ty}) where {Ty}
    dscale, dsum = zero(real(Ty)), one(real(Ty))
    for i in 1:size(A, 2)
        dscale, dsum = _ssq(view(A, :, i), dscale, dsum)
    end
    return dscale * sqrt(dsum)
end
function _safe_fnorm(A::AbstractVector{Ty}) where {Ty}
    dscale, dsum = zero(real(Ty)), one(real(Ty))
    dscale, dsum = _ssq(A, dscale, dsum)
    return dscale * sqrt(dsum)
end

# Rank one update

## General
### BLAS
rankUpdate!(α::T, x::StridedVector{T}, y::StridedVector{T}, A::StridedMatrix{T}) where {T <: BlasReal} = BLAS.ger!(α, x, y, A)

### Generic
function rankUpdate!(α::Number, x::StridedVector, y::StridedVector, A::StridedMatrix)
    m, n = size(A, 1), size(A, 2)
    m == length(x) || throw(DimensionMismatch("x vector has wrong length"))
    n == length(y) || throw(DimensionMismatch("y vector has wrong length"))
    for j in 1:n
        yjc = y[j]'
        for i in 1:m
            A[i, j] += x[i] * α * yjc
        end
    end
    return
end

# Actually solves A[1:n,1:n] * x = s * b and returns s, a scaling factor
# such that components of x are manageable.
# NB: works with leading n×n block of A and leading n terms of b, x
# Hence all the loops must be explicit.
# This is a translation of (part of) LAPACK::zlatrs, q.v. for details.
# index-unsafe
# Provide `b` in argument `x`; note that `cnorm` may be updated.
"""
scale = _usolve!(A, n, x, cnorms)

Upper triangular solve with scaling to prevent overflow
"""
function _usolve!(A::StridedMatrix{T}, n, x, cnorm) where {T}

    cabs1half(z) = abs(real(z) / 2) + abs(imag(z) / 2)

    RT = real(T)
    half = one(RT) / 2
    smallnum = safemin(RT) / eps(RT)
    bignum = one(RT) / smallnum
    xscale = one(RT)

    tmax = abs(cnorm[1])
    @inbounds for j in 2:n
        tmax = max(tmax, abs(cnorm[j]))
    end

    if tmax <= bignum * half
        tscale = one(RT)
    else
        tscale = half / (smallnum * tmax)
        cnorm[1:n] .*= tscale
    end
    # bound on solution vector:
    xmax = cabs1half(x[1])
    @inbounds for j in 2:n
        xmax = max(xmax, cabs1half(x[j]))
    end
    xbound = xmax
    if tscale != one(RT)
        grow = zero(RT)
    else
        # compute grow
        grow = half / max(xbound, smallnum)
        xbound = grow
        toosmall = false
        for j in n:-1:1
            # give up if too small
            toosmall = (grow <= smallnum)
            toosmall && break
            tjjs = A[j, j]
            tjj = abs1(tjjs)
            if tjj >= smallnum
                xbound = min(xbound, min(one(RT), tjj) * grow)
            else
                # M[j] could overflow
                xbound = zero(RT)
            end
            if tjj + cnorm[j] >= smallnum
                grow *= (tjj / (tjj + cnorm[j]))
            else
                # grow could overflow, clamp
                grow = zero(RT)
            end
        end
        if !toosmall
            grow = xbound
        end
    end

    if grow * tscale > smallnum
        # bound is ok; use standard arithmetic
        @inbounds for j in n:-1:1
            xj = x[j] = A[j, j] \ x[j]
            for i in (j - 1):-1:1
                x[i] -= A[i, j] * xj
            end
        end
    else
        if xmax > bignum * half
            # scale so all(abs.(x) .<= bignum)
            xscale = (bignum * half) / xmax
            @inbounds for i in 1:n
                x[i] *= xscale
            end
            xmax = bignum
        else
            xmax *= 2
        end
        for j in n:-1:1
            # compute x[j] = b[j] / A[j,j], scaling if necessary
            xj = abs1(x[j])
            tjjs = A[j, j] * tscale
            tjj = abs1(tjjs)
            if tjj > smallnum
                # abs(A[j,j] > smallnum):
                if tjj < one(RT)
                    if xj > tjj * bignum
                        # scale x by 1/b[j]
                        rec = one(RT) / xj
                        @inbounds for i in 1:n
                            x[i] *= rec
                        end
                        xscale *= rec
                        xmax *= rec
                    end
                end
                x[j] = x[j] / tjjs
                xj = abs1(x[j])
            elseif tjj > 0
                # 0 < abs(A[j,j]) <= smallnum
                if xj > tjj * bignum
                    # scale by (1/abs(x[j]))*abs(A[j,j]))*bignum
                    # to avoid overflow when dividing by A[j,j]
                    rec = (tjj * bignum) / xj
                    if cnorm[j] > one(RT)
                        # scale by 1/cnorm[j] to avoid overflow
                        # when multiplying x[j] by column j
                        rec /= cnorm[j]
                    end
                    @inbounds for i in 1:n
                        x[i] *= rec
                    end
                    xscale *= rec
                    xmax *= rec
                end
                # CHECKME: may want zladiv scheme
                x[j] = x[j] / tjjs
                xj = abs1(x[j])
            else
                # A[j,j] = 0; set x to eⱼ, xscale to 0
                # and compute a null vector.
                @inbounds for i in 1:n
                    x[i] = zero(T)
                end
                x[j] = one(T)
                xscale = zero(RT)
                xmax = zero(RT)
            end
            # scale x if necc. to avoid overflow when adding multiple of A[:,j]
            if xj > one(RT)
                rec = one(RT) / xj
                if cnorm[j] > (bignum - xmax) * rec
                    # scale by 1/(2abs(x[j]))
                    rec *= half
                    @inbounds for i in 1:n
                        x[i] *= rec
                    end
                    xscale *= rec
                end
            elseif (xj * cnorm[j] > bignum - xmax)
                # scale by 1/2
                @inbounds for i in 1:n
                    x[i] *= half
                end
                xscale *= half
            end
            if j > 1
                # compute update
                xjt = x[j] * tscale
                @inbounds for i in 1:(j - 1)
                    x[i] -= xjt * A[i, j]
                end
                xmax = abs1(x[1])
                @inbounds for i in 2:(j - 1)
                    xmax = max(xmax, abs1(x[i]))
                end
            end
        end
        xscale /= tscale
    end
    if tscale != one(RT)
        @inbounds for i in 1:n
            cnorm[i] *= one(RT) / tscale
        end
    end
    return xscale
end

# conjugate transpose version
"""
scale = _cusolve!(A, n, x, cnorms)

Transpose-of-upper-triangular solve with scaling to prevent overflow
"""
function _cusolve!(A::StridedMatrix{T}, n, x, cnorm) where {T}

    cabs1half(z) = abs(real(z) / 2) + abs(imag(z) / 2)

    RT = real(T)
    half = one(RT) / 2
    #    smallnum = safemin(RT) / (2*eps(RT)) # WARNING: assumes base 2
    smallnum = safemin(RT) / eps(RT)
    bignum = one(RT) / smallnum
    xscale = one(RT)

    tmax = abs(cnorm[1])
    @inbounds for j in 2:n
        tmax = max(tmax, abs(cnorm[j]))
    end

    if tmax <= bignum * half
        tscale = one(RT)
    else
        tscale = half / (smallnum * tmax)
        cnorm[1:n] .*= tscale
    end
    # bound on solution vector:
    xmax = cabs1half(x[1])
    @inbounds for j in 2:n
        xmax = max(xmax, cabs1half(x[j]))
    end
    xbound = xmax
    if tscale != one(RT)
        grow = zero(RT)
    else
        # compute grow
        grow = half / max(xbound, smallnum)
        xbound = grow
        toosmall = false
        for j in 1:n
            # give up if too small
            toosmall = (grow <= smallnum)
            toosmall && break
            # G[j] = max(G[j-1], M[j-1]*(1+cnorm[j]))
            xj = one(RT) + cnorm[j]
            grow = min(grow, xbound / xj)
            tjjs = A[j, j]
            tjj = abs1(tjjs)
            if tjj >= smallnum
                if xj > tjj
                    xbound *= (tjj / xj)
                end
            else
                # M[j] could overflow
                xbound = zero(RT)
            end
        end
        if !toosmall
            grow = min(grow, xbound)
        end
    end

    if grow * tscale > smallnum
        # bound is ok; use standard arithmetic
        @inbounds for j in 1:n
            z = x[j]
            for i in 1:(j - 1)
                z -= conj(A[i, j]) * x[i]
            end
            x[j] = conj(A[j, j]) \ z
        end
    else
        if xmax > bignum * half
            # scale so all(abs.(x) .<= bignum)
            xscale = (bignum * half) / xmax
            @inbounds for i in 1:n
                x[i] *= xscale
            end
            xmax = bignum
        else
            xmax *= 2
        end
        for j in 1:n
            # compute x[j] = b[j] - Σ_(k≠j) A[k,j] x[k]
            xj = abs1(x[j])
            uscale = complex(tscale)
            rec = one(RT) / max(xmax, one(RT))
            if cnorm[j] > (bignum - xj) * rec
                # if x[j] could overflow scale x by 1/(2 xmax)
                rec *= half
                tjjs = conj(A[j, j]) * tscale
                tjj = abs1(tjjs)
                if tjj > one(RT)
                    # divide by A[j,j] when scaling if A[j,j] > 1
                    rec = min(one(RT), rec * tjj)
                    uscale /= tjjs
                end
                if rec < one(RT)
                    @inbounds for i in 1:n
                        x[i] *= rec
                    end
                    xscale *= rec
                    xmax *= rec
                end
            end
            csumj = zero(T)
            @inbounds for i in 1:(j - 1)
                csumj += (conj(A[i, j]) * uscale) * x[i]
            end
            if uscale == complex(tscale) || isnan(uscale)
                # if diagonal wasn't used to scale
                # compute x[j] = (x[j] - csumj) / A[j,j]
                x[j] -= csumj
                xj = abs1(x[j])
                tjjs = conj(A[j, j]) * tscale

                # compute x[j] /= A[j,j], scaling if necessary
                tjj = abs1(tjjs)
                if tjj > smallnum
                    if tjj < one(RT)
                        if xj > tjj * bignum
                            rec = one(RT) / xj
                            @inbounds for i in 1:n
                                x[i] *= rec
                            end
                            xscale *= rec
                            xmax *= rec
                        end
                    end
                    x[j] = x[j] / tjjs
                elseif tjj > zero(RT)
                    # tiny diag
                    if xj > tjj * bignum
                        rec = (tjj * bignum) / xj
                        @inbounds for i in 1:n
                            x[i] *= rec
                        end
                        xscale *= rec
                        xmax *= rec
                    end
                    x[j] = x[j] / tjjs
                else
                    # zero diag: compute a null vector of Aᴴ
                    x[1:n] .= zero(T)
                    x[j] = one(T)
                    xscale = zero(RT)
                    xmax = zero(RT)
                end
            else
                # if dot product was already divided by A[j,j]
                # compute x[j] = x[j] / A[j,j] - csumj
                # CHECKME: tjjs may not be defined here
                x[j] = x[j] / tjjs - csumj
            end
            xmax = max(xmax, abs1(x[j]))
        end
        xscale /= tscale
    end
    if tscale != one(RT)
        @inbounds for i in 1:n
            cnorm[i] *= one(RT) / tscale
        end
    end
    return xscale
end

# update scale and sumsq s.t. (scale^2 * sumsq) is increased by ∑ |x[j]|^2
# scale is a running quasi-inf-norm.
# based on LAPACK::zlassq
function _ssq(x::AbstractVector{T}, scale, sumsq) where {T}
    rone = one(real(T))
    rzero = zero(real(T))
    if isnan(scale) || isnan(sumsq)
        return scale, sumsq
    end
    if sumsq == 0
        scale = rone
    elseif scale == 0
        scale = rone
        sumsq = rzero
    end
    n = length(x)
    n > 0 || return scale, sumsq
    for ix in 1:n
        t1 = abs(real(x[ix]))
        if t1 > 0 || isnan(t1)
            if scale < t1
                sumsq = rone + sumsq * (scale / t1)^2
                scale = t1
            else
                sumsq += (t1 / scale)^2
            end
        end
        if T <: Complex
            t1 = abs(imag(x[ix]))
            if t1 > 0 || isnan(t1)
                if scale < t1
                    sumsq = rone + sumsq * (scale / t1)^2
                    scale = t1
                else
                    sumsq += (t1 / scale)^2
                end
            end
        end
    end
    return scale, sumsq
end

# stdlib norm2 uses a poorly implemented generic scheme for short vectors.
function _norm2(x::AbstractVector{T}) where {T <: Real}
    require_one_based_indexing(x)
    n = length(x)
    n < 1 && return zero(T)
    n == 1 && return abs(x[1])
    scale = zero(T)
    ssq = zero(T)
    for xi in x
        if !iszero(xi)
            a = abs(xi)
            if scale < a
                ssq = one(T) + ssq * (scale / a)^2
                scale = a
            else
                ssq += (a / scale)^2
            end
        end
    end
    return scale * sqrt(ssq)
end

function _norm2(x::AbstractVector{T}) where {T <: Complex}
    require_one_based_indexing(x)
    n = length(x)
    RT = real(T)
    n < 1 && return zero(RT)
    n == 1 && return abs(x[1])
    scale = zero(RT)
    ssq = zero(RT)
    for xx in x
        xr, xi = reim(xx)
        if !iszero(xr)
            a = abs(xr)
            if scale < a
                ssq = one(RT) + ssq * (scale / a)^2
                scale = a
            else
                ssq += (a / scale)^2
            end
        end
        if !iszero(xi)
            a = abs(xi)
            if scale < a
                ssq = one(RT) + ssq * (scale / a)^2
                scale = a
            else
                ssq += (a / scale)^2
            end
        end
    end
    return scale * sqrt(ssq)
end

# As of v1.5, Julia hypot() w/ >2 args is unprotected (the documentation lies),
# so we need this.
# translation of dlapy3, assuming NaN propagation
function _hypot3(x::T, y::T, z::T) where {T}
    xa = abs(x)
    ya = abs(y)
    za = abs(z)
    w = max(xa, ya, za)
    rw = one(real(T)) / w
    r::real(T) = w * sqrt((rw * xa)^2 + (rw * ya)^2 + (rw * za)^2)
    return r
end

function _enormalize!(v::AbstractMatrix{T}) where {T <: STypes}
    n = size(v, 1)
    for j in 1:n
        s = one(real(T)) / norm(v[:, j], 2)
        t = abs2(v[1, j])
        i0 = 1
        for i in 2:n
            u = abs2(v[i, j])
            if u > t
                i0 = i
                t = u
            end
        end
        t = s * conj(v[i0, j]) / sqrt(t)
        for i in 1:n
            v[i, j] *= t
        end
        v[i0, j] = real(v[i0, j])
    end
    return
end

"""
`x, scale, perturbed = _safe_lu_solve!(A,b)`

solve a linear algebraic problem `A * x = b` for a single vector `b`
using LU decomposition with complete pivoting, scaling to mitigate overflow,
and perturbation to circumvent singularity.
Destroys `A` and overwrites `b` with the solution `x`.

"""
function _safe_lu_solve!(A::AbstractMatrix{T}, b::AbstractVector{T}) where {T}
    n = checksquare(A)
    perturbed = false
    RT = real(T)
    smallnum = floatmin(RT) / eps(RT)
    smin = maximum(abs, A)
    smin = max(eps(RT) * smin, smallnum)
    # perform elimination
    ipsv, jpsv = 0, 0
    jpiv = fill(0, n)
    # ipiv = fill(0,n)
    for i in 1:(n - 1)
        xmax = zero(RT)
        for ip in i:n
            for jp in i:n
                if abs(A[ip, jp]) >= xmax
                    xmax = abs(A[ip, jp])
                    ipsv, jpsv = ip, jp
                end
            end
        end
        if ipsv != i
            for j in 1:n
                t1, t2 = A[ipsv, j], A[i, j]
                A[ipsv, j] = t2
                A[i, j] = t1
            end
            b[i], b[ipsv] = b[ipsv], b[i]
        end
        # ipiv[i] = ipsv
        if jpsv != i
            for j in 1:n
                t1, t2 = A[j, jpsv], A[j, i]
                A[j, jpsv] = t2
                A[j, i] = t1
            end
        end
        jpiv[i] = jpsv
        if abs(A[i, i]) < smin
            perturbed = true
            A[i, i] = smin
        end
        for j in (i + 1):n
            A[j, i] /= A[i, i]
            b[j] -= A[j, i] * b[i]
            for k in (i + 1):n
                A[j, k] -= A[j, i] * A[i, k]
            end
        end
    end
    if abs(A[n, n]) < smin
        perturbed = true
        A[n, n] = smin
    end
    jpiv[n] = n
    # ipiv[n] = n
    scale = one(RT)
    a = 8smallnum
    needscl = false
    for i in 1:n
        if a * abs(b[i]) > abs(A[i, i])
            needscl = true
            break
        end
    end
    if needscl
        scale = (1 / RT(8)) / maximum(abs, b)
        b .*= scale
    end
    for i in 1:n
        k = n + 1 - i
        t = 1 / A[k, k]
        b[k] *= t
        for j in (k + 1):n
            b[k] -= (t * A[k, j]) * b[j]
        end
    end
    for i in 1:(n - 1)
        jj = jpiv[n - i]
        if jj != n - i
            b[n - i], b[jj] = b[jj], b[n - i]
        end
    end
    return b, scale, perturbed
end

# Triangular solver used by real eigvecs() (standard and generalized).
"""
    scale, x, xnorm, perturbed = _xsolve(a,A,d,b,B)

Solve `(a * A - b * D) * X = s * B`
where `A` and `D` are `na×na` real matrices, `D` is `Diagonal(d)`, `a` is real, `b` complex.
`X` and `B` are complex vectors of length `na`; compute `s` to avoid overflow.
Perturb if necessary to escape singularity.
"""
function _xsolve(a, A::AbstractMatrix{Ty}, d::AbstractVector{Ty}, b, B, smin) where {Ty}
    # Note: currently may delegate to more general routine, overwriting B
    one_t = one(Ty)
    zero_t = zero(Ty)
    s = one_t
    na = size(A, 1)
    small = 2 * safemin(Ty)
    bignum = s / small
    smin = max(smin, small)
    perturbed = false
    if na == 1
        csr = a * A[1, 1] - real(b) * d[1]
        csi = -imag(b) * d[1]
        cnorm = abs(csr) + abs(csi)
        if cnorm < smin
            perturbed = true
            csr = smin
            csi = zero_t
            cnorm = smin
        end
        bnorm = abs1(B[1])
        if (cnorm < 1) && (bnorm > 1) && (bnorm > bignum * cnorm)
            s = one_t / bnorm
        end
        x = B[1] * s / (csr + im * csi)
        xnorm = abs1(x[1])
        B[1] = x
        return s, B, xnorm, perturbed
    end
    cmax = zero_t
    for j in 1:na
        for i in 1:na
            z = a * A[i, j] + 0im
            if i == j
                z -= b * d[i]
            end
            cmax = max(cmax, abs1(z))
        end
    end
    if cmax < smin
        perturbed = true
        bnorm = maximum(abs1, B)
        if (smin < 1) && (bnorm > 1) && (bnorm > bignum * smin)
            s = one_t / bnorm
        end
        t1 = s / smin
        rmul!(B, t1)
        x = B
    else
        x, s, _ = _safe_lu_solve!(a * A - Diagonal(complex(b) * d), B)
    end
    xnorm = norm(x)
    return s, x, xnorm, perturbed
end

# GenericSchur

GenericSchur is a Julia package for eigen-analysis of dense
real and complex matrices of generic numeric type, i.e. those
not supported by the LAPACK-based routines in the standard LinearAlgebra
library. Examples are `BigFloat`, `Float128`, and `DoubleFloat`.

Normally, the `schur!`, `eigvals!`, `eigen!`, and `ordschur!` functions
in the `LinearAlgebra`
standard library are overloaded here, and may be accessed through the usual
`schur`, `eigvals`, `eigen`, and `ordschur` wrappers.

!!! note "Type piracy"
	Most users will enjoy the convenience of the functions from `LinearAlgebra`,
	but these piratical methods may be omitted; see the [Preferences](@ref) section
	for details.

## Complex Schur decomposition

The Schur decomposition is the workhorse for eigensystem analysis of
dense non-symmetric matrices.

This package provides a full Schur decomposition of complex square matrices:
```julia
A::StridedMatrix{C} where {C <: Complex} == Z * T * adjoint(Z)
```
where `T` is upper-triangular and `Z` is unitary, both with the same element
type as `A`.

```julia
A = your_matrix_generator() .+ 0im # in case you start with a real matrix
S = schur(A)
```
The result `S` is a `LinearAlgebra.Schur` object, with the properties `T`,
`Z=vectors`, and `values`.

The unexported [`GenericSchur.gschur`](@ref) and [`GenericSchur.gschur!`](@ref)
functions are available
for use when type piracy is suppressed, and for types
normally handled by the LAPACK wrappers in `LinearAlgebra`.

The algorithm is essentially the unblocked, serial, single-shift Francis (QR)
scheme used in the complex LAPACK routines. Scaling is enabled for balancing,
but currently permutation (which would reduce the work) is not.

## Hermitian matrices

The Schur decomposition of a Hermitian (or real symmetric) matrix is identical to
diagonalization, i.e.
the upper-triangular factor is diagonal. This package provides such decompositions
for real-symmetric and complex-Hermitian matrices via `eigen!`
(and [`GenericSchur.geigen!`](@ref)) etc.
In these cases, an `alg` argument
may be used to select a `LinearAlgebra.QRIteration` or `LinearAlgebra.DivideAndConquer`
algorithm. The divide-and-conquer scheme takes a long time to compile, but execution
is significantly faster than QR iteration for large matrices.

## Real decompositions

A quasi-triangular "real Schur" decomposition of real matrices is also
provided:
```julia
A::StridedMatrix{R} where {R <: Real} == Z * T * transpose(Z)
```
where `T` is quasi-upper-triangular and `Z` is orthogonal, both with the
same element type as `A`.  This is what you get by invoking the above-mentioned
functions with matrix arguments whose element type `T <: Real`.
By default, the result is in standard form, so
pair-blocks (and therefore rank-2 invariant subspaces) should be fully resolved.
(This differs from the original version in GenericLinearAlgebra.jl.)

If the optional keyword `standardized` is set to `false` in `gschur`, a
non-standard (but less expensive) form is produced.

## Eigenvectors

Right and left eigenvectors are available from Schur factorizations,
using

```julia
S = schur(A)
VR = eigvecs(S)
VL = eigvecs(S,left=true)
```
or [`GenericSchur.geigvecs`](@ref).
The results are currently unreliable if the Frobenius norm of `A` is extremely
small or large, so scale if necessary (also see Balancing, below).

## Balancing

The accuracy of eigenvalues and eigenvectors may be improved for some
matrices by use of a similarity transform which reduces the matrix
norm.  This is done by default in the `eigen!` method, and may also be
handled explicitly via the [`balance!`](@ref) function provided here:
```julia
Ab, B = balance!(copy(A))
S = schur(Ab)
v = eigvecs(S)
lmul!(B, v) # to get the eigenvectors of A
```
More details are in the function docstring. Although the balancing function
also does permutations to isolate trivial subspaces, the Schur routines do not
yet exploit this opportunity for reduced workload.

## Generalized problems

The generalized Schur decomposition of matrix pencils is provided via `schur(A,B)`, or
[`GenericSchur.ggschur!(A,B)`](@ref), for real and complex element types. No specific
implementations are currently provided for Hermitian/Symmetric problems.

Note that although many nearly singular matrix pencils can be factored and reordered
with our implementations, accuracy may suffer; for such problems it is best to
extract the regular part with a Kronecker-like decomposition (see the `MatrixPencils`
package).

Right and left eigenvectors are available for generalized problems, via
`eigvecs(S::GeneralizedSchur)` and `geigvecs(S::GeneralizedSchur)`.

## Reordering
An invariant (viz. deflating) subspace may be extracted via methods of the
`LinearAlgebra.ordschur` function; see the documentation in the LinearAlgebra stdlib.
(The [`GenericSchur.gordschur!`](@ref) function may also be used, especially if type
piracy is disabled.)  This package provides reordering methods for ordinary and
generalized Schur factorizations, both real and complex element types.

## Preferences
The runtime behavior can be adjusted by use of the
[Preferences](https://github.com/JuliaPackaging/Preferences.jl) package.

The `piracy` preference may be set to "true" (the default) or "false" to determine
whether methods are added to functions such as `LinearAlgebra.schur!`.

## Acknowledgements

This package includes translations from [LAPACK](http://www.netlib.org/lapack/index.html)
code, and incorporates or elaborates several methods from Andreas Noack's
[GenericLinearAlgebra.jl](http://github.com/JuliaLinearAlgebra/GenericLinearAlgebra.jl)
package.

# API
Most of the user-facing methods are extensions of functions declared in
LinearAlgebra: `eigen!`, `schur!`, `ordschur!`, `eigvals!`.

Additional public functions are as follows.

## Balancing

```@docs
balance!
```

## Converting a real quasi-Schur to a true complex Schur object

```@docs
triangularize
```

## Obtaining eigenvectors from a decomposition

```@docs
LinearAlgebra.eigvecs(::Schur{Complex{T}}) where {T <: AbstractFloat}

```

## Eigenvalue condition numbers

```@docs
eigvalscond
```

## Subspace conditioning

```@docs
subspacesep
```

## Non-piratical functions
If one opts out of type piracy, the implementations in `GenericSchur` are available
via the following functions. (Several are not currently exported, but *are*
considered public API.)

Mainly for testing purposes, one can also invoke the generic methods implemented
here for LAPACK-compatible matrix types with these.

### Schur decomposition
```@docs
GenericSchur.gschur!

GenericSchur.gschur

GenericSchur.ggschur!
```

### Eigenvectors
```@docs
GenericSchur.geigen!

GenericSchur.geigvecs
```

### Reordering a Schur factorization
```@docs
GenericSchur.gordschur!
```

## Locally defined exceptions
Note: these are currently peculiar to this package but replacement by upstream analogues
will not be considered breaking.
```@docs
GenericSchur.IllConditionException

GenericSchur.UnconvergedException
```

## Preference handling
```@docs
GenericSchur.set_piracy!
```
